/*
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF
 * for the full copyright text.
 * 
 */
/*
 * HISTORY
 * $Log: AccColorT.h,v $
 * Revision 1.1.6.1  1994/05/04  19:55:31  drk
 * 	Document trait version numbers.
 * 	[1994/05/04  19:52:45  drk]
 *
 * Revision 1.1.4.3  1994/03/07  15:18:59  drk
 * 	Fix NO_PROTO errors.
 * 	[1994/03/07  15:18:47  drk]
 * 
 * Revision 1.1.4.2  1994/03/04  22:20:42  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  21:54:17  drk]
 * 
 * Revision 1.1.4.1  1993/12/29  21:08:38  daniel
 * 	change valid in valueMask in trait rec
 * 	[1993/12/29  21:07:15  daniel]
 * 
 * Revision 1.1.2.5  1993/10/25  22:41:56  drk
 * 	Terminate to-do comment so #endif is processed.
 * 	[1993/10/25  22:41:42  drk]
 * 
 * Revision 1.1.2.4  1993/10/25  21:32:40  daniel
 * 	new color trait
 * 	[1993/10/25  21:27:55  daniel]
 * 
 * Revision 1.1.2.3  1993/10/18  17:07:33  daniel
 * 	add accessColors trait
 * 	[1993/10/18  17:05:56  daniel]
 * 
 * Revision 1.1.2.2  1993/10/18  14:55:29  daniel
 * 	change signature to void
 * 	[1993/10/18  14:55:18  daniel]
 * 
 * Revision 1.1.2.1  1993/10/17  19:53:44  daniel
 * 	new trait
 * 	[1993/10/17  19:53:29  daniel]
 * 
 * $EndLog$
 */

#ifndef _XmAccessColorsT_H
#define _XmAccessColorsT_H

#include <Xm/Xm.h>
#include <X11/Xresource.h>

#ifdef __cplusplus
extern "C" {
#endif

externalref XrmQuark XmQTaccessColors;

/* this one can be expanded in the future */
typedef struct _XmAccessColorDataRec {
    Mask  valueMask ;
    Pixel foreground  ;
    Pixel background  ;
    Pixel highlight_color  ;
    Pixel top_shadow_color  ;
    Pixel bottom_shadow_color ;
    Pixel select_color ;
} XmAccessColorDataRec, *XmAccessColorData;

#ifdef _NO_PROTO
typedef void (*XmAccessColorsGetProc)();
typedef void (*XmAccessColorsSetProc)();
#else
typedef void (*XmAccessColorsGetProc)(Widget widget, 
				      XmAccessColorData color_data);
typedef void (*XmAccessColorsSetProc)(Widget widget, 
				      XmAccessColorData color_data);
#endif /* _NO_PROTO */

/* Trait structures and typedefs, place typedefs first */

/* Version 0: initial release. */

typedef struct _XmAccessColorsTraitRec {
  int			version;	/* 0 */
  XmAccessColorsGetProc getColors;
  XmAccessColorsGetProc setColors;
} XmAccessColorsTraitRec, *XmAccessColorsTrait;

#define AccessColorInvalid         0L
#define AccessForeground           (1L<<0)  
#define AccessBackgroundPixel      (1L<<1)   
#define AccessHighlightColor       (1L<<2)   
#define AccessTopShadowColor       (1L<<3)   
#define AccessBottomShadowColor    (1L<<4)   
#define AccessSelectColor          (1L<<5)   

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

/* to do:

 add it to PushB/G and ToggleB/G so that they can report their
   select color
 implement the setValues ?

*/

#endif /* _XmAccessColorsT_H */
