/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: AccTextT.h,v $
 * Revision 1.1.8.1  1994/05/04  19:55:34  drk
 * 	Document trait version numbers.
 * 	[1994/05/04  19:52:46  drk]
 *
 * Revision 1.1.6.3  1994/03/14  23:24:30  drand
 * 	Update accessTextual method names
 * 	[1994/03/14  23:23:42  drand]
 * 
 * Revision 1.1.6.2  1994/03/07  15:19:02  drk
 * 	Fix NO_PROTO errors.
 * 	[1994/03/07  15:18:48  drk]
 * 
 * Revision 1.1.6.1  1994/03/04  22:20:44  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  21:54:18  drk]
 * 
 * Revision 1.1.4.2  1993/09/14  21:15:39  inca
 * 	VMS-ify (externaldef/externalref) traits
 * 	[1993/09/14  21:06:44  inca]
 * 
 * Revision 1.1.2.4  1993/07/23  02:44:41  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:09:08  yak]
 * 
 * Revision 1.1.2.3  1993/04/16  13:54:51  drand
 * 	Fix build problem for _NO_PROTO.
 * 	[1993/04/16  13:45:41  drand]
 * 
 * Revision 1.1.2.2  1993/04/15  17:55:00  drand
 * 	Changed name of AccessXmString to AccessTextual,  also changes to
 * 	the method parameters.  Added version field.
 * 	[1993/04/15  17:52:02  drand]
 * 
 * Revision 1.1.2.2  1993/03/31  22:41:29  drand
 * 	Renamed CStringT.h to AccXmStrT.h.
 * 	[1993/03/31  22:40:03  drand]
 * 
 * $EndLog$
 */
#ifndef _XmAccessTextualT_H
#define _XmAccessTextualT_H

#include <Xm/Xm.h>

#ifdef __cplusplus
extern "C" {
#endif

externalref XrmQuark XmQTaccessTextual;

#ifdef _NO_PROTO
typedef XtPointer (*XmAccessTextualGetValuesProc)();
typedef int       (*XmAccessTextualPreferredProc)();
typedef void      (*XmAccessTextualSetValuesProc)();
#else
typedef XtPointer (*XmAccessTextualGetValuesProc)(Widget, int);
typedef int       (*XmAccessTextualPreferredProc)(Widget);
typedef void      (*XmAccessTextualSetValuesProc)(Widget, XtPointer, int);
#endif /* _NO_PROTO */

enum { XmFORMAT_XmSTRING, XmFORMAT_MBYTE, XmFORMAT_WCS };

/* Trait structures and typedefs, place typedefs first */

/* Version 0: initial release. */

typedef struct _XmAccessTextualTraitRec {
  int				version;	 /* 0 */
  XmAccessTextualGetValuesProc	getValue;
  XmAccessTextualSetValuesProc	setValue;
  XmAccessTextualPreferredProc	preferredFormat;
} XmAccessTextualTraitRec, *XmAccessTextualTrait;

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmAccessTextualT_H */
