/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: ActivatableT.h,v $
 * Revision 1.1.8.1  1994/05/04  19:55:36  drk
 * 	Document trait version numbers.
 * 	[1994/05/04  19:52:47  drk]
 *
 * Revision 1.1.6.2  1994/03/07  15:19:04  drk
 * 	Fix NO_PROTO errors.
 * 	[1994/03/07  15:18:49  drk]
 * 
 * Revision 1.1.6.1  1994/03/04  22:20:46  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  21:54:20  drk]
 * 
 * Revision 1.1.4.2  1993/09/14  21:15:43  inca
 * 	VMS-ify (externaldef/externalref) traits
 * 	[1993/09/14  21:06:49  inca]
 * 
 * Revision 1.1.2.3  1993/07/23  02:44:43  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:09:14  yak]
 * 
 * Revision 1.1.2.2  1993/04/27  21:28:59  daniel
 * 	put in activatable trait
 * 	[1993/04/27  21:28:35  daniel]
 * 
 * $EndLog$
 */
#ifndef _XmActivatableT_H
#define _XmActivatableT_H

#ifdef __cplusplus
extern "C" {
#endif

#include <Xm/Xm.h>

externalref XrmQuark XmQTactivatable;

/* Trait structures and typedefs, place typedefs first */

#ifdef _NO_PROTO
typedef void (*XmActivatableCallBackProc)();
#else
typedef void (*XmActivatableCallBackProc)(Widget w, 
					  XtCallbackProc activCB,
					  XtPointer closure,
					  Boolean setunset);
#endif /* _NO_PROTO */

/* Version 0: initial release. */

typedef struct _XmActivatableTraitRec {
  int 			    version;	/* 0 */
  XmActivatableCallBackProc changeCB;
} XmActivatableTraitRec, *XmActivatableTrait;


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmActivatableT_H */
