/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: BaseClassP.h,v $
 * Revision 1.5.12.1  1994/05/16  21:19:13  daniel
 * 	cleanup BaseClass
 * 	[1994/05/16  18:14:20  daniel]
 *
 * Revision 1.5.10.1  1994/03/04  22:20:58  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  21:54:30  drk]
 * 
 * Revision 1.5.7.2  1993/08/02  17:09:00  drk
 * 	Fixes from Motif1.2.3. Rev. 1.5.5.2, ancestor 1.5.2.4, file BaseClassP.h.
 * 	CR 5803: Use init_depth field to detect nested calls from
 * 	CallConstraintInitialize.  This isn't a complete solution to the
 * 	problem, but fixes this CR and should tide us over until R6 when the
 * 	intrinsics will provide these hooks.
 * 	[1993/08/02  17:08:37  drk]
 * 
 * Revision 1.5.4.2  1993/07/23  02:46:02  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:10:36  yak]
 * 
 * Revision 1.5.2.4  1992/11/24  17:46:29  daniel
 * 	make XmIsFastClass work for non Motif class
 * 	[1992/11/24  17:45:51  daniel]
 * 
 * Revision 1.5.2.3  1992/11/23  15:33:08  daniel
 * 	cr 5311: remove new gcc warnings
 * 	[1992/11/20  22:48:04  daniel]
 * 
 * Revision 1.5.2.2  1992/11/12  19:35:31  daniel
 * 	check *_XmGetBaseClassExtPt up front for non Motif classes
 * 	[1992/11/12  19:35:02  daniel]
 * 
 * Revision 1.5  1992/03/13  16:23:54  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/* $RCSfile: BaseClassP.h,v $ $Revision: 1.5.12.1 $ $Date: 1994/05/16 21:19:13 $ */
/* (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */
/* (c) Copyright 1989, 1990 DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS. */
/* (c) Copyright 1988 MASSACHUSETTS INSTITUTE OF TECHNOLOGY  */
#ifndef _XmBaseClassP_h
#define _XmBaseClassP_h

#ifndef _XmNO_BC_INCL
#define _XmNO_BC_INCL
#endif

#include <Xm/XmP.h>

#ifdef __cplusplus
extern "C" {
#endif


#define _XmBCEPTR(wc)	((XmBaseClassExt *)(&(((WidgetClass)(wc))\
					      ->core_class.extension)))
#define _XmBCE(wc)	((XmBaseClassExt)(((WidgetClass)(wc))\
					  ->core_class.extension))

#define _XmGetBaseClassExtPtr(wc, owner) \
    ((_XmBCE(wc) && (((_XmBCE(wc))->record_type) == owner)) ? \
     _XmBCEPTR(wc) :  \
     ((XmBaseClassExt *) _XmGetClassExtensionPtr( \
						 ((XmGenericClassExt *)  \
						  _XmBCEPTR( wc)),  \
						 owner)))

/* defines for 256 bit (at least) bit field
 */
#define _XmGetFlagsBit(field, bit) \
	(field[ (bit >> 3) ]) & (1 << (bit & 0x07))

#define _XmSetFlagsBit(field, bit) \
	    (field[ (bit >> 3) ] |= (1 << (bit & 0x07)))


#define _XmFastSubclassInit(wc, bit_field) { \
	if((_Xm_fastPtr = _XmGetBaseClassExtPtr( wc, XmQmotif)) && \
	   (*_Xm_fastPtr)) \
		_XmSetFlagsBit((*_Xm_fastPtr)->flags, bit_field) ; \
   }

/* _XmGetBaseClassExtPtr can return NULL or a pointer to a NULL extension,
 * for non Motif classes in particular, so we check that up front.
 * We use the global _Xm_fastPtr for that purpose, this variable exists
 * already in BaseClass.c for apparently no other use.
 */

#define _XmIsFastSubclass(wc, bit) \
	((_Xm_fastPtr = _XmGetBaseClassExtPtr((wc),XmQmotif)) && \
         (*_Xm_fastPtr)) ? \
	     (_XmGetFlagsBit(((*_Xm_fastPtr)->flags), bit) ? TRUE : FALSE) \
		 : FALSE

#define XmBaseClassExtVersion 2L
#define XmBaseClassExtVersion 2L


#ifdef _NO_PROTO
typedef Cardinal (*XmGetSecResDataFunc) ();
#else
typedef Cardinal (*XmGetSecResDataFunc)( WidgetClass,
					    XmSecondaryResourceData **);
#endif

typedef struct _XmObjectClassExtRec{
    XtPointer 		next_extension;	
    XrmQuark 		record_type;	
    long 		version;	
    Cardinal 		record_size;	
} XmObjectClassExtRec, *XmObjectClassExt;

typedef struct _XmGenericClassExtRec{
    XtPointer 		next_extension;	
    XrmQuark 		record_type;	
    long 		version;	
    Cardinal 		record_size;	
} XmGenericClassExtRec, *XmGenericClassExt;

typedef struct _XmWrapperDataRec{
    struct _XmWrapperDataRec *next;
    WidgetClass		widgetClass;
    XtInitProc		initializeLeaf;
    XtSetValuesFunc	setValuesLeaf;
    XtArgsProc		getValuesLeaf;
    XtRealizeProc	realize;
    XtWidgetClassProc	classPartInitLeaf;
    XtWidgetProc	resize;
    XtGeometryHandler   geometry_manager;
    Cardinal		init_depth;
} XmWrapperDataRec, *XmWrapperData;

typedef struct _XmBaseClassExtRec{
    XtPointer 		next_extension;	
    XrmQuark 		record_type;	
    long 		version;	
    Cardinal 		record_size;	
    XtInitProc		initializePrehook;
    XtSetValuesFunc 	setValuesPrehook;
    XtInitProc		initializePosthook;
    XtSetValuesFunc 	setValuesPosthook;
    WidgetClass		secondaryObjectClass;
    XtInitProc		secondaryObjectCreate;
    XmGetSecResDataFunc	getSecResData;
    unsigned char	flags[32];
    XtArgsProc		getValuesPrehook;
    XtArgsProc		getValuesPosthook;
    XtWidgetClassProc	classPartInitPrehook;
    XtWidgetClassProc	classPartInitPosthook;
    XtResourceList	ext_resources;
    XtResourceList	compiled_ext_resources;
    Cardinal		num_ext_resources;
    Boolean		use_sub_resources;
    XmWidgetNavigableProc widgetNavigable;
    XmFocusChangeProc	focusChange;
    XmWrapperData	wrapperData;
} XmBaseClassExtRec, *XmBaseClassExt;


typedef struct _XmWidgetExtDataRec{
    Widget		widget;
    Widget		reqWidget;
    Widget		oldWidget;
} XmWidgetExtDataRec, *XmWidgetExtData;

externalref XrmQuark	     XmQmotif;
externalref int		     _XmInheritClass;
externalref XmBaseClassExt * _Xm_fastPtr;
  
/********    Private Function Declarations    ********/
#ifdef _NO_PROTO

extern XmGenericClassExt * _XmGetClassExtensionPtr() ;
extern Boolean _XmIsSubclassOf();
#else


extern XmGenericClassExt * _XmGetClassExtensionPtr( 
                        XmGenericClassExt *listHeadPtr,
                        XrmQuark owner) ;
extern Boolean _XmIsSubclassOf(WidgetClass wc, WidgetClass sc);


#endif /* _NO_PROTO */
/********    End Private Function Declarations    ********/

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmBaseClassP_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
