/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: BitmapsI.h,v $
 * Revision 1.2.15.1  1994/06/17  18:22:50  drk
 * 	New dynamic bitmaps for collapsed state.
 * 	[1994/06/17  18:04:24  drk]
 *
 * Revision 1.2.13.3  1994/03/21  19:40:13  drk
 * 	Use XmConst where possible.
 * 	[1994/03/21  19:39:57  drk]
 * 
 * Revision 1.2.13.2  1994/03/15  18:19:22  daniel
 * 	new 3.4 Xpm upgrade
 * 	[1994/03/15  18:05:15  daniel]
 * 
 * Revision 1.2.13.1  1994/03/02  17:00:16  daniel
 * 	Make the Container button bitmap smaller
 * 	[1994/03/02  16:59:47  daniel]
 * 
 * Revision 1.2.7.4  1993/10/20  17:48:15  daniel
 * 	put back the tile builtins
 * 	[1993/10/20  17:47:59  daniel]
 * 
 * Revision 1.2.7.3  1993/10/17  19:44:01  daniel
 * 	put icong color in cache
 * 	[1993/10/17  19:43:38  daniel]
 * 
 * Revision 1.2.7.2  1993/07/30  15:13:18  shobana
 * 	Fixes from Motif1.2.3. Rev. 1.2.5.2, ancestor 1.2.2.2, file BitmapsI.h.
 * 	[1993/07/30  15:12:53  shobana]
 * 
 * Revision 1.2.4.6  1993/07/23  02:46:05  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:10:41  yak]
 * 
 * Revision 1.2.4.5  1993/06/28  23:07:28  inca
 * 	Cleaning up Right-to-left layout
 * 	[1993/06/28  20:46:34  inca]
 * 
 * Revision 1.2.4.4  1993/06/18  17:58:35  daniel
 * 	back to 1.2 ImageCache
 * 	[1993/06/18  17:55:48  daniel]
 * 
 * Revision 1.2.4.3  1993/06/02  18:15:53  daniel
 * 	more pixmap support
 * 	[1993/06/02  15:58:50  daniel]
 * 
 * Revision 1.2.4.2  1993/03/16  18:44:15  motifdec
 * 	DEC checkin 1: RtoL extensions
 * 	[1993/03/15  21:54:14  motifdec]
 * 
 * Revision 1.2.2.2  1992/03/25  18:56:35  daniel
 * 	INtegrate change from HP
 * 	[1992/03/25  18:17:23  daniel]
 * 
 * Revision 1.2  1992/03/13  16:23:59  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/*   $RCSfile: BitmapsI.h,v $ $Revision: 1.2.15.1 $ $Date: 1994/06/17 18:22:50 $ */
/* (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */

/*************************************<+>*************************************
 *****************************************************************************
 **
 **   File:        BitmapsI.h
 **
 **   Description: This file contains a set of predefines bitmaps
 **		   which are used by the image caching functions.
 **
 ****************************************************************************
 ************************************<+>*************************************/

#ifndef _XmBitmapsI_h
#define _XmBitmapsI_h

#include <Xm/Xm.h>

#ifdef __cplusplus
extern "C" {
#endif

static XmConst unsigned char bitmaps [20][32] =
{
   {  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /*  Solid Background  */
      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00  },

   {  0x88, 0x88, 0x22, 0x22, 0x88, 0x88, 0x22, 0x22,	/*  25 percent  */
      0x88, 0x88, 0x22, 0x22, 0x88, 0x88, 0x22, 0x22,
      0x88, 0x88, 0x22, 0x22, 0x88, 0x88, 0x22, 0x22,
      0x88, 0x88, 0x22, 0x22, 0x88, 0x88, 0x22, 0x22  },

   {  0x55, 0x55, 0xAA, 0xAA, 0x55, 0x55, 0xAA, 0xAA,	/*  50 percent  */
      0x55, 0x55, 0xAA, 0xAA, 0x55, 0x55, 0xAA, 0xAA,
      0x55, 0x55, 0xAA, 0xAA, 0x55, 0x55, 0xAA, 0xAA,
      0x55, 0x55, 0xAA, 0xAA, 0x55, 0x55, 0xAA, 0xAA  },

   {  0x55, 0x55, 0xFF, 0xFF, 0xAA, 0xAA, 0xFF, 0xFF,	/*  75 percent  */
      0x55, 0x55, 0xFF, 0xFF, 0xAA, 0xAA, 0xFF, 0xFF,
      0x55, 0x55, 0xFF, 0xFF, 0xAA, 0xAA, 0xFF, 0xFF,
      0x55, 0x55, 0xFF, 0xFF, 0xAA, 0xAA, 0xFF, 0xFF  },

   {  0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,	/*  Vertical tile  */
      0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
      0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
      0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55  },

   {  0xff, 0xff, 0x00, 0x00, 0xff, 0xff, 0x00, 0x00,	/*  Horizontal tile */ 
      0xff, 0xff, 0x00, 0x00, 0xff, 0xff, 0x00, 0x00, 
      0xff, 0xff, 0x00, 0x00, 0xff, 0xff, 0x00, 0x00, 
      0xff, 0xff, 0x00, 0x00, 0xff, 0xff, 0x00, 0x00  },

   {  0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,	/*  Vertical  */
      0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
      0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55,
      0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55  },

   {  0xff, 0xff, 0x00, 0x00, 0xff, 0xff, 0x00, 0x00,	/*  Horizontal  */ 
      0xff, 0xff, 0x00, 0x00, 0xff, 0xff, 0x00, 0x00, 
      0xff, 0xff, 0x00, 0x00, 0xff, 0xff, 0x00, 0x00, 
      0xff, 0xff, 0x00, 0x00, 0xff, 0xff, 0x00, 0x00  },

   {  0x77, 0x77, 0xbb, 0xbb, 0xdd, 0xdd, 0xee, 0xee,	/*  Slant Left  */
      0x77, 0x77, 0xbb, 0xbb, 0xdd, 0xdd, 0xee, 0xee, 
      0x77, 0x77, 0xbb, 0xbb, 0xdd, 0xdd, 0xee, 0xee, 
      0x77, 0x77, 0xbb, 0xbb, 0xdd, 0xdd, 0xee, 0xee  },

   {  0xee, 0xee, 0xdd, 0xdd, 0xbb, 0xbb, 0x77, 0x77,	/*  Slant Right  */
      0xee, 0xee, 0xdd, 0xdd, 0xbb, 0xbb, 0x77, 0x77, 
      0xee, 0xee, 0xdd, 0xdd, 0xbb, 0xbb, 0x77, 0x77, 
      0xee, 0xee, 0xdd, 0xdd, 0xbb, 0xbb, 0x77, 0x77  },

   {  						
     0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  /*  Default Cascade  */ 
     0x00, 0x03, 0x00, 0x06, 0x00, 0x0c, 0x00, 0x18,  
     0xff, 0x3f, 0x00, 0x18, 0x00, 0x0c, 0x00, 0x06,  
     0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00   },

   {  						
     0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /* Default RtoL Cascade*/ 
     0xc0, 0x00, 0x60, 0x00, 0x30, 0x00, 0x18, 0x00,
     0xfc, 0xff, 0x18, 0x00, 0x30, 0x00, 0x60, 0x00,
     0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00   },

   {
      0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  /* Default CheckMark */
      0x00, 0x00, 0x00, 0x60, 0x00, 0x30, 0x00, 0x18, 
      0x00, 0x0c, 0x08, 0x06, 0x18, 0x03, 0xb0, 0x01, 
      0xe0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00  }, 
   {  						
     0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  /*  Default menu dash */ 
     0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  
     0xff, 0x3f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  
     0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00   },
   {
     0x00, 0x00, 0x00, 0x00, 0x0c, 0x00, 0x3c, 0x00,  /* collapsed */  
     0xfc, 0x00, 0xfc, 0x03, 0xfc, 0x0f, 0xfc, 0x3f, 
     0xfc, 0x3f, 0xfc, 0x0f, 0xfc, 0x03, 0xfc, 0x00,
     0x3c, 0x00, 0x0c, 0x00, 0x00, 0x00, 0x00, 0x00   },
   {
     0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x00, 0x3c,  /* collapsed_rtol */  
     0x00, 0x3f, 0xc0, 0x3f, 0xf0, 0x3f, 0xfc, 0x3f, 
     0xfc, 0x3f, 0xf0, 0x3f, 0xc0, 0x3f, 0x00, 0x3f,
     0x00, 0x3c, 0x00, 0x30, 0x00, 0x00, 0x00, 0x00   },
   {
     0x00, 0x00, 0x00, 0x00, 0xfc, 0x3f, 0xfc, 0x3f,  /* expanded */ 
     0xf8, 0x1f, 0xf8, 0x1f, 0xf0, 0x0f, 0xf0, 0x0f, 
     0xe0, 0x07, 0xe0, 0x07, 0xc0, 0x03, 0xc0, 0x03,
     0x80, 0x01, 0x80, 0x01, 0x00, 0x00, 0x00, 0x00   }
};


static XmConst char *XmConst bitmap_name_set[] =
{
   "background",
   "25_foreground",
   "50_foreground",
   "75_foreground",
   "vertical_tile",
   "horizontal_tile",
   /* for bc reason with 1.2.2, we have to put back the old names,
      but we also need to keep the new ones, for 1.2.3 users */
   "vertical",
   "horizontal",
   "slant_right",
   "slant_left",
   "menu_cascade",
   "menu_cascade_rtol",
   "menu_checkmark",
   "menu_dash",
   "collapsed",
   "collapsed_rtol",
   "expanded",
};

#define MAX_BUILTIN_IMAGES	17

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmBitmapsI_h */
/* DON'T ADD STUFF AFTER THIS #endif */
