/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: BulletinBP.h,v $
 * Revision 1.8.11.2  1994/03/10  21:52:48  drk
 * 	Remove unsupported #ifdefs.
 * 	[1994/03/10  21:46:51  drk]
 *
 * Revision 1.8.11.1  1994/03/04  22:21:05  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  21:54:35  drk]
 * 
 * Revision 1.8.9.2  1993/09/01  21:50:26  inca
 * 	Added layoutDirection to Manager, Primitive & Gadget, added a layout trait
 * 	[1993/08/31  20:48:00  inca]
 * 
 * Revision 1.8.4.6  1993/07/23  02:46:18  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:10:59  yak]
 * 
 * Revision 1.8.4.5  1993/06/30  23:48:11  rgcote
 * 	Removed declarations for _Xm functions which have become
 * 	Xme functions.
 * 	[1993/06/30  23:45:25  rgcote]
 * 
 * Revision 1.8.4.4  1993/05/13  13:56:15  daniel
 * 	put in the takesDefault trait
 * 	[1993/05/13  13:54:05  daniel]
 * 
 * Revision 1.8.4.3  1993/03/30  14:18:48  rgcote
 * 	Fixes from Motif1.2.3. Rev. 1.8.5.2, ancestor 1.8.2.4, file BulletinBP.h.
 * 	[1993/03/29  18:21:50  rgcote]
 * 
 * Revision 1.8.4.2  1993/02/24  21:10:46  daniel
 * 	implement _XmCreateClassDialog
 * 	[1993/02/24  21:06:34  daniel]
 * 
 * Revision 1.8.2.4  1992/03/25  19:52:47  daniel
 * 	Integrate HP diffs
 * 	[1992/03/25  19:51:52  daniel]
 * 
 * Revision 1.8.2.3  1992/03/25  19:01:07  daniel
 * 	*** empty log message ***
 * 	[1992/03/25  18:29:24  daniel]
 * 
 * Revision 1.8.2.2  1992/03/19  19:17:49  tomm
 * 	Acceptance fix from HP for Pir4545.
 * 	[1992/03/19  18:56:14  tomm]
 * 
 * Revision 1.8  1992/03/13  16:24:30  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/*   $RCSfile: BulletinBP.h,v $ $Revision: 1.8.11.2 $ $Date: 1994/03/10 21:52:48 $ */
/* (c) Copyright 1989, DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS. */
/* (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */
#ifndef _XmBulletinBoardP_h
#define _XmBulletinBoardP_h

#include <Xm/BulletinB.h>
#include <Xm/ManagerP.h>

#ifdef __cplusplus
extern "C" {
#endif


/****************************************************************************
 * this suffix is added to dialog shells created by Xm convenience routines *
 * so that, for example, a call to create a form dialog named f generates a *
 * dialog shell named f_popup in addition to a form named f                 *
 ****************************************************************************/

#define XmDIALOG_SUFFIX		"_popup"
#define XmDIALOG_SUFFIX_SIZE	6



typedef struct _XmBulletinBoardConstraintPart
{
   char unused;
} XmBulletinBoardConstraintPart, * XmBulletinBoardConstraint;


/*  New fields for the BulletinBoard widget class record  */

typedef struct
{
  Boolean		always_install_accelerators;
  XmGeoCreateProc       geo_matrix_create;
  XmFocusMovedProc	focus_moved_proc;
  XtPointer		extension;
} XmBulletinBoardClassPart;


/* Full class record declaration */

typedef struct _XmBulletinBoardClassRec
{
  CoreClassPart			core_class;
  CompositeClassPart		composite_class;
  ConstraintClassPart		constraint_class;
  XmManagerClassPart		manager_class;
  XmBulletinBoardClassPart	bulletin_board_class;
} XmBulletinBoardClassRec;

externalref XmBulletinBoardClassRec xmBulletinBoardClassRec;


/* New fields for the BulletinBoard widget record */

typedef struct
{
  Dimension	margin_width;		/*  margins		*/
  Dimension	margin_height;

  Widget	default_button;		/*  widgets		*/
  Widget	dynamic_default_button;	/*  widgets		*/
  Widget	cancel_button;
  Widget	dynamic_cancel_button;

  XtCallbackList focus_callback;	/*  callback lists	*/
  XtCallbackList map_callback;
  XtCallbackList unmap_callback;

  XtTranslations text_translations;

  XmFontList	button_font_list;	/*  font lists		*/
  XmFontList	label_font_list;
  XmFontList	text_font_list;

  Boolean	allow_overlap;		/*  policies		*/
  Boolean	default_position;
  Boolean	auto_unmanage;
  unsigned char	resize_policy;
  
  Dimension	old_width;		/*  shadow resources	*/
  Dimension	old_height;
  Dimension	old_shadow_thickness;
  unsigned char	shadow_type;

  Boolean	in_set_values;		/*  internal flag	*/
  Boolean	initial_focus;

  Boolean	no_resize;		/*  dialog resources	*/
  unsigned char	dialog_style;
  XmString	dialog_title;
  Widget	shell;
  Widget	_UNUSED;

  XmGeoMatrix   geo_cache;		/* Cache for geometry management. */
} XmBulletinBoardPart;


/****************************************************************
 *
 * Full instance record declaration
 *
 ****************************************************************/

typedef struct _XmBulletinBoardRec
{
  CorePart		core;
  CompositePart		composite;
  ConstraintPart	constraint;
  XmManagerPart		manager;
  XmBulletinBoardPart	bulletin_board;
} XmBulletinBoardRec;


/* Access macros */
#define BB_CancelButton(w) \
	(((XmBulletinBoardWidget) w)->bulletin_board.cancel_button)
#define BB_DynamicCancelButton(w) \
	(((XmBulletinBoardWidget) w)->bulletin_board.dynamic_cancel_button)
#define BB_DefaultButton(w) \
	(((XmBulletinBoardWidget) w)->bulletin_board.default_button)
#define BB_DynamicDefaultButton(w) \
	(((XmBulletinBoardWidget) w)->bulletin_board.dynamic_default_button)
#define BB_MarginHeight(w) \
	(((XmBulletinBoardWidget) w)->bulletin_board.margin_height)
#define BB_MarginWidth(w) \
	(((XmBulletinBoardWidget) w)->bulletin_board.margin_width)
#define BB_ButtonFontList(w) \
	(((XmBulletinBoardWidget) w)->bulletin_board.button_font_list)
#define BB_LabelFontList(w) \
	(((XmBulletinBoardWidget) w)->bulletin_board.label_font_list)
#define BB_TextFontList(w) \
	(((XmBulletinBoardWidget) w)->bulletin_board.text_font_list)
#define BB_StringDirection(w) (XmDirectionToStringDirection\
	(((XmBulletinBoardWidget) w)->manager.string_direction))
#define BB_ResizePolicy(w) \
	(((XmBulletinBoardWidget) w)->bulletin_board.resize_policy)
#define BB_InSetValues(w) \
	(((XmBulletinBoardWidget) w)->bulletin_board.in_set_values)
#define BB_InitialFocus(w) \
	(((XmBulletinBoardWidget) w)->bulletin_board.initial_focus)


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmBulletinBoardP_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
