/*
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF
 * for the full copyright text.
 * 
 */
/*
 * HISTORY
 * $Log: CSTextOutI.h,v $
 * Revision 1.1.2.7  1994/04/15  21:17:46  drk
 * 	CR 8601: Misc. gcc warnings.
 * 	[1994/04/15  20:59:38  drk]
 *
 * Revision 1.1.2.6  1994/04/11  15:41:46  inca
 * 	Move getting rendition to after setting clip origin in
 * 	togglecursorGC
 * 	[1994/04/11  14:53:48  inca]
 * 
 * Revision 1.1.2.5  1994/04/06  21:53:37  inca
 * 	Update rowcolumn layout to allow new widgets to take part in
 * 	entry alignment procedure
 * 	[1994/04/05  22:36:47  inca]
 * 
 * Revision 1.1.2.4  1994/03/24  15:44:05  mryan
 * 	Change ToggleCursorGC prototype.
 * 	[1994/03/24  15:43:51  mryan]
 * 
 * Revision 1.1.2.3  1994/03/23  16:14:22  mryan
 * 	Redesign of CSText cursor handling.
 * 	[1994/03/23  16:09:22  mryan]
 * 
 * Revision 1.1.2.2  1994/03/18  21:04:51  mryan
 * 	Support added for using ScrollFrame trait like XmText
 * 	[1994/03/18  20:58:36  mryan]
 * 
 * Revision 1.1.2.1  1994/03/04  22:21:20  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  21:54:57  drk]
 * 
 * $EndLog$
 */
/* $RCSfile: CSTextOutI.h,v $ $Revision: 1.1.2.7 $ $Date: 1994/04/15 21:17:46 $ */
#ifndef _XmCSTextOutI_h
#define _XmCSTextOutI_h

#include <Xm/XmP.h>
#include <Xm/CSTextOutP.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifdef _NO_PROTO

extern void _XmCSTextMarkRedraw ();
extern int _XmCSTextPosToLine();
extern void _XmCSTextOutputGetSecResData();
extern void _XmCSTextResetClipOrigin() ;
extern void _XmCSTextAdjustGC() ;
extern Boolean _XmCSTextGetDisplayRect() ;
extern void _XmCSTextMarginsProc() ;
extern void _XmCSTextChangeHOffset() ;
extern void _XmCSTextRedisplayHBar() ;
extern void _XmCSTextChangeVSB() ;
extern void _XmCSTextChangeBlinkBehavior() ;
extern void _XmCSTextToggleCursorGC() ;
extern void _XmCSTextMovingCursorPosition() ;

#else

extern void _XmCSTextMarkRedraw(XmCSTextWidget widget,
			  	XmTextPosition left,
			  	XmTextPosition right);
/*
 * Return the line number containing the given position.  If text currently
 * knows of no line containing that position, returns NOLINE.
 */
extern int _XmCSTextPosToLine(XmCSTextWidget widget,
			      XmTextPosition position);
extern void _XmCSTextOutputGetSecResData(
                        XmSecondaryResourceData *secResDataRtn) ;
extern void _XmCSTextResetClipOrigin( 
                        XmCSTextWidget tw,
                        XmTextPosition position,
#if NeedWidePrototypes
                        int clip_mask_reset) ;
#else
                        Boolean clip_mask_reset) ;
#endif /* NeedWidePrototypes */
extern void _XmCSTextAdjustGC( 
                        XmCSTextWidget tw) ;
extern Boolean _XmCSTextGetDisplayRect( 
                        Widget w,
                        XRectangle *display_rect) ;
extern void _XmCSTextMarginsProc(
			Widget w,
			XmBaselineMargins *margins_rec) ;
extern void _XmCSTextChangeHOffset( 
                        XmCSTextWidget widget,
                        int length) ;
extern void _XmCSTextRedisplayHBar(XmCSTextWidget widget) ;
extern void _XmCSTextChangeVSB(XmCSTextWidget widget) ;
extern void _XmCSTextChangeBlinkBehavior( 
                        XmCSTextWidget widget,
#if NeedWidePrototypes
                        int newvalue) ;
#else
                        Boolean newvalue) ;
#endif /* NeedWidePrototypes */
extern void _XmCSTextToggleCursorGC( 
                        Widget widget) ;
extern void _XmCSTextMovingCursorPosition(
			XmCSTextWidget	csw,
			XmTextPosition	position) ;

#endif /* _NO_PROTO */

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmCSTextOutI_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
