/*
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF
 * for the full copyright text.
 * 
 */
/*
 * HISTORY
 * $Log: CSTextSrcI.h,v $
 * Revision 1.1.2.3  1994/04/29  20:40:51  mryan
 * 	CR 8957 - add start_location argument to _XmCSTextSourceLocate.
 * 	[1994/04/29  20:35:24  mryan]
 *
 * Revision 1.1.2.2  1994/04/26  21:48:57  dick
 * 	Change over to using _XmStringEntry as the segment data type
 * 	[1994/04/26  21:25:59  dick]
 * 
 * Revision 1.1.2.1  1994/03/04  22:21:37  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  21:55:11  drk]
 * 
 * $EndLog$
 */
/* $RCSfile: CSTextSrcI.h,v $ $Revision: 1.1.2.3 $ $Date: 1994/04/29 20:40:51 $ */
#ifndef _XmCSTextSrcI_h
#define _XmCSTextSrcI_h

#include <Xm/XmP.h>
#include <Xm/CSTextSrcP.h>

#ifdef __cplusplus
extern "C" {
#endif


/********    Private Function Declarations    ********/
#ifdef _NO_PROTO

extern XmCSTextSource _XmCSTextSourceCreate();
extern void _XmCSTextLoseSelection();
extern XmTextStatus _XmCSTextSourceInsertString ();
extern XmTextPosition _XmCSTextSourceGetPosition ();
extern void _XmCSTextSourceLocate ();
extern XmTextStatus _XmCSTextSourceReadString ();
extern XmTextStatus _XmCSTextSourceReplaceString ();
extern void _XmCSTextSourceDestroy ();
extern XmString _XmCSTextSourceGetValue ();
extern XmTextStatus _XmCSTextSourceSetValue ();
#else

extern XmCSTextSource _XmCSTextSourceCreate ( XmCSTextSource src );

extern void _XmCSTextLoseSelection	( Widget	w ,
					  Atom 		*selection );
extern XmTextStatus _XmCSTextSourceInsertString (
					XmCSTextWidget	widget,
					XmTextPosition	start,
					XmString	string,
					int		alloc,
#if NeedWidePrototypes
					int 		reposition );
#else
					Boolean		reposition );
#endif
extern XmTextPosition _XmCSTextSourceGetPosition (
					XmCSTextWidget	widget,
					XmCSTextLine	line,
					_XmStringEntry	segment,
					XmTextPosition	offset );
extern void _XmCSTextSourceLocate (	XmCSTextWidget 	widget,
					XmTextPosition 	position,
				        CSTextLocation  start_location,
					CSTextLocation 	location );
extern XmTextStatus _XmCSTextSourceReadString (
					XmCSTextWidget 	widget,
					XmTextPosition 	start,
					XmTextPosition 	end,
					XmString 	*string );
extern XmTextStatus _XmCSTextSourceReplaceString (
					XmCSTextWidget 	widget,
                                        XEvent        * event,
					XmTextPosition 	start,
					XmTextPosition 	end,
					XmString 	string,
#if NeedWidePrototypes
					int 		extra,
					int 		reposition );
#else
					Boolean 	extra,
					Boolean		reposition );
#endif /* NeedWidePrototypes */
extern void _XmCSTextSourceDestroy (	XmCSTextWidget 	widget );
extern XmString _XmCSTextSourceGetValue (XmCSTextWidget	widget );
extern XmTextStatus _XmCSTextSourceSetValue (
					XmCSTextWidget 	widget,
					XmString 	value,
#if NeedWidePrototypes
					int 		reposition );
#else
					Boolean		reposition );
#endif /* NeedWidePrototypes */

#endif /* _NO_PROTO */


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmCSTextSrcI_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
