/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */ 
/* 
 * HISTORY
 * $Log: CallbackI.h,v $
 * Revision 1.3.9.1  1994/02/02  20:49:27  drk
 * 	Reindent and misc. cleanup.
 * 	[1994/02/02  20:35:20  drk]
 *
 * Revision 1.3.7.2  1993/09/16  16:24:40  jwiele
 * 	Changed declaration of internalCallbackRec to include the first
 * 	XtCallbackRec so that each compiler could handle any alignment
 * 	requirements.  (Digital 64-bit fix SC16202)
 * 	[1993/09/16  16:21:21  jwiele]
 * 
 * Revision 1.3.3.2  1993/07/23  02:47:41  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:12:57  yak]
 * 
 * Revision 1.3  1992/03/13  16:24:57  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
 */ 
/*   $RCSfile: CallbackI.h,v $ $Revision: 1.3.9.1 $ $Date: 1994/02/02 20:49:27 $ */
/* (c) Copyright 1989, 1990  DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS. */
/* (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */
/* (c) Copyright 1988 MASSACHUSETTS INSTITUTE OF TECHNOLOGY  */
/* (c) Copyright 1988 MICROSOFT CORPORATION */
#ifndef _XmCallbackI_h
#define _XmCallbackI_h

#include "XmI.h"

#ifdef __cplusplus
extern "C" {
#endif


#define _XtCBCalling		1
#define _XtCBFreeAfterCalling	2

/* The internal callback list is a little header followed by an array of
 * XtCallbackRec structs.  Declaring the first element of the array with 
 * the header allows the compiler to take care of any alignment required.
 */
typedef struct internalCallbackRec {
  unsigned short count;
  char           is_padded;	/* contains NULL padding for external form */
  char           call_state;	/* combination of _XtCB{FreeAfter}Calling */
  XtCallbackRec  callbacks;	/* first XtCallback record declared here */
} InternalCallbackRec, *InternalCallbackList;


/********    Private Function Declarations    ********/
#ifdef _NO_PROTO

extern void _XmAddCallback();
extern void _XmRemoveCallback();
extern void _XmCallCallbackList();
extern void _XmRemoveAllCallbacks();

#else

extern void _XmAddCallback(InternalCallbackList *callbacks,
			   XtCallbackProc callback,
			   XtPointer closure);
extern void _XmRemoveCallback(InternalCallbackList *callbacks,
			      XtCallbackProc callback,
			      XtPointer closure);
extern void _XmCallCallbackList(Widget widget,
				XtCallbackList callbacks,
				XtPointer call_data);
extern void _XmRemoveAllCallbacks(InternalCallbackList *callbacks);

#endif /* _NO_PROTO */
/********    End Private Function Declarations    ********/


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmCallbackI_h */
/* DON'T ADD STUFF AFTER THIS #endif */
