/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: CareVisualT.h,v $
 * Revision 1.1.8.1  1994/05/04  19:55:38  drk
 * 	Document trait version numbers.
 * 	[1994/05/04  19:52:48  drk]
 *
 * Revision 1.1.6.3  1994/03/25  00:00:53  drk
 * 	Null change
 * 	[1994/03/24  23:54:49  drk]
 * 
 * 	Create the traversal control trait.
 * 	[1994/03/24  23:05:36  drk]
 * 
 * Revision 1.1.6.2  1994/03/24  23:11:57  drk
 * 	Create the traversal control trait.
 * 	[1994/03/24  23:05:36  drk]
 * 
 * Revision 1.1.6.2  1994/03/24  23:11:57  drk
 * 	Create the traversal control trait.
 * 	[1994/03/24  23:05:36  drk]
 * 
 * Revision 1.1.6.1  1994/03/07  15:24:09  drk
 * 	Fix missing includes.
 * 	[1994/03/07  15:23:47  drk]
 * 
 * Revision 1.1.4.4  1993/10/18  17:03:29  daniel
 * 	add _XmNotifyChildrenVisual
 * 	[1993/10/18  17:02:10  daniel]
 * 
 * Revision 1.1.4.3  1993/10/15  18:23:26  daniel
 * 	add select color
 * 	[1993/10/15  18:23:15  daniel]
 * 
 * Revision 1.1.4.2  1993/09/14  21:15:48  inca
 * 	VMS-ify (externaldef/externalref) traits
 * 	[1993/09/14  21:06:53  inca]
 * 
 * Revision 1.1.2.3  1993/07/23  02:47:43  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:13:02  yak]
 * 
 * Revision 1.1.2.2  1993/04/27  21:31:35  daniel
 * 	put in carevisual trait
 * 	[1993/04/27  21:29:29  daniel]
 * 
 * $EndLog$
 */
#ifndef _XmCareVisualT_H
#define _XmCareVisualT_H

#include <Xm/Xm.h>

#ifdef __cplusplus
extern "C" {
#endif

externalref XrmQuark XmQTcareParentVisual;

/* Trait structures and typedefs, place typedefs first */

#ifdef _NO_PROTO
typedef Boolean (*XmCareVisualRedrawProc)();
#else
typedef Boolean (*XmCareVisualRedrawProc)(Widget kid, 
					  Widget cur_parent,
					  Widget new_parent,
					  Mask visual_flag);
#endif /* _NO_PROTO */

/* Version 0: initial release. */

typedef struct _XmCareVisualTraitRec {
  int 			 version;	/* 0 */
  XmCareVisualRedrawProc redraw;
} XmCareVisualTraitRec, *XmCareVisualTrait;


#define NoVisualChange                    0L
#define VisualForeground                  (1L<<0)  
#define VisualHighlightPixmap             (1L<<1)                              
#define VisualHighlightColor              (1L<<2)   
#define VisualBottomShadowPixmap          (1L<<3)   
#define VisualBottomShadowColor           (1L<<4)   
#define VisualTopShadowPixmap             (1L<<5)   
#define VisualTopShadowColor              (1L<<6)   
#define VisualBackgroundPixel             (1L<<7)   
#define VisualBackgroundPixmap            (1L<<8)   
#define VisualSelectColor                 (1L<<9)   


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmCareVisualT_H */
