/*
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF
 * for the full copyright text.
 * 
 */
/*
 * HISTORY
 * $Log: ColorI.h,v $
 * Revision 1.1.2.3  1994/03/07  22:22:07  daniel
 * 	static moved to extern for _XmAddColorToCache
 * 	[1994/03/07  22:21:57  daniel]
 *
 * Revision 1.1.2.2  1994/03/07  22:04:43  daniel
 * 	put back _XmAddToColorCache in Color.c
 * 	[1994/03/07  22:04:09  daniel]
 * 
 * Revision 1.1.2.1  1994/03/04  22:22:01  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  21:55:32  drk]
 * 
 * $EndLog$
 */
/* $RCSfile: ColorI.h,v $ $Revision: 1.1.2.3 $ $Date: 1994/03/07 22:22:07 $ */
#ifndef _XmColorI_h
#define _XmColorI_h

#include <Xm/ColorP.h>

#ifdef __cplusplus
extern "C" {
#endif

/********    Private Function Declarations for Color.c    ********/
#ifdef _NO_PROTO

extern void _XmForegroundColorDefault() ;
extern void _XmHighlightColorDefault() ;
extern void _XmBackgroundColorDefault() ;
extern void _XmTopShadowColorDefault() ;
extern void _XmBottomShadowColorDefault() ;
extern void _XmSelectColorDefault() ;
extern Boolean _XmSearchColorCache() ;
extern XmColorData * _XmAddToColorCache() ;

#else

extern void _XmForegroundColorDefault( 
                        Widget widget,
                        int offset,
                        XrmValue *value) ;
extern void _XmHighlightColorDefault( 
                        Widget widget,
                        int offset,
                        XrmValue *value) ;
extern void _XmBackgroundColorDefault( 
                        Widget widget,
                        int offset,
                        XrmValue *value) ;
extern void _XmTopShadowColorDefault( 
                        Widget widget,
                        int offset,
                        XrmValue *value) ;
extern void _XmBottomShadowColorDefault( 
                        Widget widget,
                        int offset,
                        XrmValue *value) ;
extern void _XmSelectColorDefault( 
                        Widget widget,
                        int offset,
                        XrmValue *value) ;
extern Boolean _XmSearchColorCache(
                        unsigned int which,
                        XmColorData *values,
                        XmColorData **ret) ;
extern XmColorData * _XmAddToColorCache( 
                        XmColorData *new_rec) ;
#endif /* _NO_PROTO */
/********    End Private Function Declarations    ********/

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmColorI_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
