/*
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF
 * for the full copyright text.
 * 
 */
/*
 * HISTORY
 * $Log: ColorObjI.h,v $
 * Revision 1.1.4.1  1994/05/13  14:37:28  daniel
 * 	remove dependency between ColorObj and Menu
 * 	[1994/05/12  21:10:57  daniel]
 *
 * Revision 1.1.2.1  1994/03/09  19:03:25  daniel
 * 	integrate CDE color object
 * 	[1994/03/09  18:57:20  daniel]
 * 
 * $EndLog$
 */
#ifndef _XmColorObjI_h
#define _XmColorObjI_h

#include <Xm/ColorObjP.h>

#ifdef __cplusplus
extern "C" {
#endif

#define  DitherTopShadow(display, screen, pixelSet) \
                        ((pixelSet)->bs == BlackPixel((display), (screen)))

#define  DitherBottomShadow(display, screen, pixelSet) \
                        ((pixelSet)->ts == WhitePixel((display), (screen)))

#define  DITHER     "50_foreground"
#define  NO_DITHER  "unspecified_pixmap"

/* defines for color usage */
#define B_W           0
#define LOW_COLOR     1
#define MEDIUM_COLOR  2
#define HIGH_COLOR    3

#define COLOR_SRV_NAME "ColorServer"

/* defines for palette.c */
#define VALUE_THRESHOLD 225

/* defines for Atom strings */
#define PIXEL_SET        "Pixel Sets"
#define PALETTE_NAME     "DefaultPalette Name"
#define TYPE_OF_MONITOR  "Type Of Monitor"
#define UPDATE_FILE      "Update Default File"
#define CUST_DATA        "Customize Data:"

externalref XmColorObj _XmDefaultColorObj;
externalref XContext _XmColorObjCache;
externalref Display  *_XmColorObjCacheDisplay;

/********    Private Function Declarations    ********/
#ifdef _NO_PROTO

extern void _XmColorObjCreate() ;

#else

extern void _XmColorObjCreate( 
                        Widget w,
                        ArgList al,
                        Cardinal *acPtr) ;

#endif /* _NO_PROTO */
/********    End Private Function Declarations    ********/


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmColorObjI_h */

