/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: ComboBox.h,v $
 * Revision 1.1.4.3  1993/11/09  18:11:25  drk
 * 	CR 6839: Created XmComboBoxUpdate.
 * 	[1993/11/09  18:09:16  drk]
 *
 * Revision 1.1.4.2  1993/09/29  15:57:27  drk
 * 	Cleanup old resources, misc.
 * 	[1993/09/29  15:56:23  drk]
 * 
 * Revision 1.1.2.4  1993/07/23  02:48:41  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:14:21  yak]
 * 
 * Revision 1.1.2.3  1993/07/08  20:35:31  rgcote
 * 	Latest code drop from Cindy.
 * 	[1993/07/08  20:33:39  rgcote]
 * 
 * Revision 1.1.2.2  1993/03/30  22:48:11  motiflotus
 * 	Initial integration.
 * 	[1993/03/30  21:15:51  motiflotus]
 * 
 * $EndLog$
 */
/* ComboBox.h */

#ifndef _XmComboBox_h
#define _XmComboBox_h

#ifdef __cplusplus
extern "C" {
#endif

externalref WidgetClass xmComboBoxWidgetClass;

typedef struct _XmComboBoxClassRec	* XmComboBoxWidgetClass;
typedef struct _XmComboBoxRec 		* XmComboBoxWidget;


/* XmIsComboBox may already be defined for Fast Subclassing  */
#ifndef XmIsComboBox
#define XmIsComboBox(w)		XtIsSubclass(w, xmComboBoxWidgetClass)
#endif  /* XmIsComboBox */

/********    Public Function Declarations    ********/
#ifdef _NO_PROTO

extern Widget XmCreateComboBox ();
extern Widget XmCreateDropDownComboBox ();
extern Widget XmCreateDropDownList ();

extern void XmComboBoxUpdate ();

#else /* _NO_PROTO */

extern Widget XmCreateComboBox (Widget parent, 
				char *name, 
				ArgList args, 
				Cardinal argCount);
extern Widget XmCreateDropDownComboBox (Widget parent, 
					char *name, 
					ArgList args, 
					Cardinal argCount);
extern Widget XmCreateDropDownList (Widget parent, 
				    char *name, 
				    ArgList args, 
				    Cardinal argCount);

extern void XmComboBoxUpdate (Widget widget);

#endif /* _NO_PROTO */
/********    End Public Function Declarations    ********/


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmComboBox_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */

