/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: ContItemT.h,v $
 * Revision 1.1.9.1  1994/05/04  19:55:41  drk
 * 	Document trait version numbers.
 * 	[1994/05/04  19:52:49  drk]
 *
 * Revision 1.1.7.2  1994/03/07  15:24:11  drk
 * 	Fix missing includes.
 * 	[1994/03/07  15:23:48  drk]
 * 
 * Revision 1.1.7.1  1993/12/29  21:08:42  daniel
 * 	change valid in valueMask in trait rec
 * 	[1993/12/29  21:07:19  daniel]
 * 
 * Revision 1.1.5.4  1993/09/24  19:00:57  daniel
 * 	still fighting bco problem
 * 	[1993/09/24  18:59:55  daniel]
 * 
 * Revision 1.1.5.3  1993/09/17  02:02:02  daniel
 * 	fix OxFFF typo
 * 	[1993/09/17  02:00:30  daniel]
 * 
 * 	check point
 * 	[1993/09/10  20:22:04  daniel]
 * 
 * Revision 1.1.5.2  1993/09/14  21:15:51  inca
 * 	VMS-ify (externaldef/externalref) traits
 * 	[1993/09/14  21:06:59  inca]
 * 
 * Revision 1.1.2.4  1993/07/23  02:49:05  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:14:51  yak]
 * 
 * Revision 1.1.2.3  1993/07/02  19:31:14  daniel
 * 	tmp fix for multiple define
 * 	[1993/07/02  19:30:08  daniel]
 * 
 * Revision 1.1.2.2  1993/07/02  18:52:23  daniel
 * 	add containerItem trait
 * 	[1993/07/02  18:49:31  daniel]
 * 
 * $EndLog$
 */
#ifndef _XmContainerItemT_H
#define _XmContainerItemT_H

#include <Xm/Xm.h>

#ifdef __cplusplus
extern "C" {
#endif

externalref XrmQuark XmQTcontainerItem;

/* Trait structures and typedefs, place typedefs first */

/* this one can be expanded in the future */
typedef struct _XmContainerItemDataRec {
    Mask valueMask ;        /* on setValues, give the information on
			     what to change in the Icon, on getValues,
			     on what to put in the record returned */
    unsigned char view_type;
    unsigned char visual_emphasis;
    Dimension icon_width ;    /* get value */
    Cardinal detail_count;   /* get value */
} XmContainerItemDataRec, *XmContainerItemData;

#define ContItemAllValid             (0xFFFF)
#define ContItemViewType	     (1L<<0)
#define ContItemVisualEmphasis	     (1L<<1)
#define ContItemIconWidth            (1L<<2)
#define ContItemDetailCount          (1L<<3)


#ifdef _NO_PROTO
typedef void (*XmContainerItemSetValuesProc)();
typedef void (*XmContainerItemGetValuesProc)();
#else
typedef void (*XmContainerItemSetValuesProc)(Widget w, 
					XmContainerItemData contItemData);
typedef void (*XmContainerItemGetValuesProc)(Widget w, 
					XmContainerItemData contItemData);
#endif /* _NO_PROTO */

/* Version 0: initial release. */

typedef struct _XmContainerItemTraitRec {
  int			       version;		/* 0 */
  XmContainerItemSetValuesProc setValues;
  XmContainerItemGetValuesProc getValues;
} XmContainerItemTraitRec, *XmContainerItemTrait;


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmContainerItemT_H */
