/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: Container.h,v $
 * Revision 1.1.6.8  1993/10/29  19:39:17  msr
 * 	Integrated Anthony's drop with some 'cosmetic' fixes
 * 	[1993/10/29  17:34:58  msr]
 *
 * Revision 1.1.6.7  1993/10/21  14:47:16  daniel
 * 	CR's addressed in this drop
 * 		CR 5868
 * 		CR 5967
 * 		CR 6428
 * 		CR 6518
 * 		CR 6520
 * 		CR 6542
 * 		CR 6589
 * 	[1993/10/21  14:46:27  daniel]
 * 
 * Revision 1.1.6.6  1993/10/12  17:58:08  daniel
 * 	new drop from Anthony
 * 	[1993/10/12  17:57:44  daniel]
 * 
 * Revision 1.1.6.5  1993/09/24  17:11:58  daniel
 * 	back to real version
 * 	[1993/09/24  17:11:39  daniel]
 * 
 * Revision 1.1.6.4  1993/09/15  15:08:19  motifibm
 * 	extern to externalref
 * 	[1993/09/15  15:07:42  motifibm]
 * 
 * Revision 1.1.6.3  1993/09/14  23:13:42  motifibm
 * 	IBM Drop 9/14
 * 	[1993/09/14  23:10:47  motifibm]
 * 
 * Revision 1.1.6.2  1993/08/19  18:03:47  deblois
 * 	Integrated changes from IBM.
 * 	[1993/08/19  18:03:27  deblois]
 * 
 * Revision 1.1.2.13  1993/07/23  02:49:18  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:15:12  yak]
 * 
 * Revision 1.1.2.12  1993/06/30  15:29:45  rgcote
 * 	Moved the widget specific resource defines to XmStrDefs.
 * 	[1993/06/30  15:24:28  rgcote]
 * 
 * Revision 1.1.2.11  1993/06/23  18:28:50  msr
 * 	Integrated IBM's fix for CR5931
 * 	[1993/06/23  18:27:51  msr]
 * 
 * Revision 1.1.2.10  1993/06/15  22:13:58  msr
 * 	Integrated fixes from IBM for code inspection CRs
 * 	[1993/06/15  21:50:16  msr]
 * 
 * Revision 1.1.2.9  1993/05/26  20:10:08  motifibm
 * 	IBM Alpha drop - Anthony
 * 	[1993/05/25  14:09:37  motifibm]
 * 
 * Revision 1.1.2.8  1993/05/19  20:16:55  meeks
 * 	Moved XmRTabList to Xm.h.
 * 	[1993/05/19  20:07:47  meeks]
 * 
 * Revision 1.1.2.7  1993/04/26  22:11:36  msr
 * 	Integrated new code from IBM
 * 	[1993/04/26  22:08:59  msr]
 * 
 * Revision 1.1.2.6  1993/04/06  00:53:09  motifibm
 * 	remove duplicate XmNstring defines - Anthony
 * 	[1993/04/06  00:51:49  motifibm]
 * 
 * Revision 1.1.2.5  1993/04/05  23:54:42  motifibm
 * 	IBM Drop 3 - Anthony
 * 	[1993/04/05  23:51:17  motifibm]
 * 
 * Revision 1.1.2.4  1993/04/01  16:18:30  daniel
 * 	remove some string macros already defined in Xm.h
 * 	[1993/04/01  16:17:47  daniel]
 * 
 * Revision 1.1.2.3  1993/03/11  21:08:51  motifibm
 * 	IBM Code Drop 2 - Anthony
 * 	[1993/03/11  17:48:16  motifibm]
 * 
 * Revision 1.1.2.2  1993/02/18  20:50:03  qauser
 * 	Initial drop from Anthony
 * 	[1993/02/18  18:37:06  qauser]
 * 
 * 	first drop from Anthony
 * 	[1993/02/18  15:06:11  qauser]
 * 
 * $EndLog$
 */
#ifndef	_XmContainer_h
#define _XmContainer_h

#include <Xm/Xm.h>
#include <Xm/Manager.h>

#ifdef __cplusplus
extern "C" {
#endif



/* Class record constants */
externalref	WidgetClass	xmContainerWidgetClass;

typedef	struct	_XmContainerClassRec	*XmContainerWidgetClass;
typedef struct  _XmContainerRec	*XmContainerWidget;

#ifndef XmIsContainer
#define XmIsContainer(w) XtIsSubclass(w, xmContainerWidgetClass)
#endif /* XmIsContainer */


/********    Public Function Declarations    ********/
#ifdef _NO_PROTO
extern	Widget		XmCreateContainer();
extern	int		XmContainerGetItemChildren();
extern	void		XmContainerRelayout();
extern	void		XmContainerReorder();
extern	Boolean         XmContainerCut();
extern  Boolean         XmContainerCopy();
extern	Boolean		XmContainerPaste();
extern	Boolean		XmContainerCopyLink();
extern	Boolean		XmContainerPasteLink();
#else
extern	Widget	XmCreateContainer(
			Widget parent,
			String name,
			ArgList arglist,
			Cardinal argcount);
extern	int	XmContainerGetItemChildren(
			Widget		wid,
			Widget		item,
			WidgetList	*item_children);
extern	void	XmContainerRelayout(
			Widget	wid);
extern	void	XmContainerReorder(
			Widget		wid,
			WidgetList	cwid_list,
			int		cwid_count);	
extern  Boolean XmContainerCut(
                        Widget  wid,
                        Time    timestamp);
extern  Boolean XmContainerCopy(
                        Widget  wid,
                        Time    timestamp);
extern  Boolean XmContainerPaste(
                        Widget  wid);
extern  Boolean XmContainerCopyLink(
                        Widget  wid,
                        Time    timestamp);
extern  Boolean XmContainerPasteLink(
                        Widget  wid);
#endif /* _NO_PROTO */
/********    End Public Function Declarations    ********/

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmContainer_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
