/*
 * @OSF_COPYRIGHT@
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 * the full copyright text.
 */
/*
 * HISTORY
 * $Log: ContainerT.h,v $
 * Revision 1.1.7.1  1994/05/04  19:55:43  drk
 * 	Document trait version numbers.
 * 	[1994/05/04  19:52:50  drk]
 *
 * Revision 1.1.5.2  1994/03/04  22:22:16  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  21:55:49  drk]
 * 
 * Revision 1.1.5.1  1993/12/29  21:08:55  daniel
 * 	change valid in valueMask in trait rec
 * 	[1993/12/29  21:07:35  daniel]
 * 
 * Revision 1.1.2.4  1993/09/30  15:34:55  daniel
 * 	add select_color
 * 	[1993/09/30  15:34:39  daniel]
 * 
 * Revision 1.1.2.3  1993/09/24  18:08:13  daniel
 * 	change traversal mode flag
 * 	[1993/09/24  18:07:55  daniel]
 * 
 * Revision 1.1.2.2  1993/09/24  18:00:41  daniel
 * 	new version
 * 	[1993/09/24  18:00:14  daniel]
 * 
 * 	stable version
 * 	[1993/09/22  02:20:36  daniel]
 * 
 * 	check point
 * 	[1993/09/10  20:22:09  daniel]
 * 
 * $EndLog$
 */

#ifndef _XmContainerT_H
#define _XmContainerT_H

#ifdef __cplusplus
extern "C" {
#endif

#include <Xm/Xm.h>

extern XrmQuark XmQTcontainer;

/* Trait structures and typedefs, place typedefs first */

/* this one can be expanded in the future */
typedef struct _XmContainerDataRec {
    Mask valueMask ;

    Cardinal * detail_order ;
    Cardinal detail_order_count ;
    XmTabList detail_tablist ;
    Dimension first_column_width ;
    XtEnum  selection_mode ;    /* XmNORMAL_MODE,	XmADD_MODE */
    Pixel   select_color ;

} XmContainerDataRec, *XmContainerData;

#define ContAllValid             (0xFFFF)
#define ContDetailOrder	         (1L<<0)
#define ContDetailTabList        (1L<<1)
#define ContFirstColumnWidth     (1L<<2)
#define ContSelectionMode        (1L<<3)
#define ContSelectColor          (1L<<4)


#ifdef _NO_PROTO
typedef void (*XmContainerGetValuesProc)();
#else
typedef void (*XmContainerGetValuesProc)(Widget w, 
					XmContainerData contData);
#endif /* _NO_PROTO */

/* Version 0: initial release. */

typedef struct _XmContainerTraitRec {
  int			   version;	/* 0 */
  XmContainerGetValuesProc getValues;
} XmContainerTraitRec, *XmContainerTrait;


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmContainerT_H */
