/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: DialogSavvyT.h,v $
 * Revision 1.1.59.1  1994/05/04  19:55:46  drk
 * 	Document trait version numbers.
 * 	[1994/05/04  19:52:51  drk]
 *
 * Revision 1.1.57.3  1994/03/26  21:05:21  daniel
 * 	change Xm_DIALOG.. in XmDIALOG_SAVVY_FOR..
 * 	[1994/03/26  21:05:01  daniel]
 * 
 * Revision 1.1.57.2  1994/03/07  15:24:12  drk
 * 	Fix missing includes.
 * 	[1994/03/07  15:23:49  drk]
 * 
 * Revision 1.1.57.1  1993/12/29  22:07:22  daniel
 * 	mv to use new DIALOG_SAVVY_FORCE_ORIGIN macro
 * 	[1993/12/29  22:07:03  daniel]
 * 
 * Revision 1.1.4.2  1993/09/14  21:15:56  inca
 * 	VMS-ify (externaldef/externalref) traits
 * 	[1993/09/14  21:07:04  inca]
 * 
 * Revision 1.1.2.3  1993/07/23  02:50:33  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:16:29  yak]
 * 
 * Revision 1.1.2.2  1993/04/29  21:17:19  daniel
 * 	put in dialog shell savvy
 * 	[1993/04/29  21:15:27  daniel]
 * 
 * $EndLog$
 */
#ifndef _XmDialogSavvyT_H
#define _XmDialogSavvyT_H

#include <Xm/Xm.h>

#ifdef __cplusplus
extern "C" {
#endif

externalref XrmQuark XmQTdialogShellSavvy;
/* This trait also requires a resource named "defaultPosition".
   If the child has the trait, the resource will be get and set by 
   the DialogShell ChangeManaged */
   
/* Trait structures and typedefs, place typedefs first */

#ifdef _NO_PROTO
typedef void (*XmDialogSavvyMapUnmapProc)();
#else
typedef void (*XmDialogSavvyMapUnmapProc)(Widget wid, 
					  Boolean map_unmap);

#endif /* _NO_PROTO */

/* Version 0: initial release. */

typedef struct _XmDialogSavvyTraitRec	 {
  int			    version;		/* 0 */
  XmDialogSavvyMapUnmapProc callMapUnmapCB;
} XmDialogSavvyTraitRec,*XmDialogSavvyTrait;


/* This macro is part of the trait and is used for the following situation
   DialogShells always mimic the child position on themselves.
   If the SetValues on a bb child position was 0,
   which is always the _current_ position of the bb in a DialogShell,
   Xt does not see a change and therefore not trigerred a geometry request.
   So BB (or any dialogShellSavvy child) has to catch this case
   and change the position request to use a special value in its
   SetValues method, XmDIALOG_SAVVY_FORCE_ORIGIN, to notify the Dialog that 
   it really wants to move in 0 */

#define XmDIALOG_SAVVY_FORCE_ORIGIN ((Position)~0L)

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmDialogSavvyT_H */
