/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: Display.h,v $
 * Revision 1.5.11.1  1994/03/04  22:40:19  drand
 * 	New CDE Resources
 * 	[1994/03/04  22:34:37  drand]
 *
 * Revision 1.5.8.2  1993/08/03  01:55:09  inca
 * 	Fixes from Motif1.2.3. Rev. 1.5.6.2, ancestor 1.5.2.2, file Display.h.
 * 	[1993/08/02  22:37:28  inca]
 * 
 * Revision 1.5.5.2  1993/07/23  02:50:40  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:16:40  yak]
 * 
 * Revision 1.5.2.2  1992/08/07  14:56:58  dbl
 * 	CR 2403 summary: partial fixes for this problem.
 * 	  Together, the patches fix many areas in Motif which keep per-display
 * 	  information. When closing a display, and re-opening it, it is
 * 	  possible (likely) that the same display id will be returned (it is just
 * 	  an address returned by malloc). In this case, Motif tries to use
 * 	  various Atoms, Pixmaps, GCs, and random data for the old display. The
 * 	  results are Protocol errors, core dumps, strange behaviour.
 * 	  Also done: unrelated fixes to ImageCache.c (_XmUninstallImage)
 * 	             unrelated fixes to MenuUtil.c (_XmGrabKeyboard)
 * 	             update to CR 2788
 * 	             various cleanups to satisfy "gcc -ansi"
 * 	[1992/08/07  14:48:31  dbl]
 * 
 * Revision 1.5  1992/03/13  16:28:02  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/*   $RCSfile: Display.h,v $ $Revision: 1.5.11.1 $ $Date: 1994/03/04 22:40:19 $ */
/*
*  (c) Copyright 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */

#ifndef _XmDisplay_h
#define _XmDisplay_h

#include <Xm/Xm.h>
#include <X11/Shell.h>
#include <Xm/DragC.h>
#include <Xm/DropSMgr.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifndef XmIsDisplay
#define XmIsDisplay(w) (XtIsSubclass(w, xmDisplayClass))
#endif /* XmIsXmDisplay */

enum {
	XmDRAG_NONE,
	XmDRAG_DROP_ONLY,
	XmDRAG_PREFER_PREREGISTER,
	XmDRAG_PREREGISTER,
	XmDRAG_PREFER_DYNAMIC,
	XmDRAG_DYNAMIC,
	XmDRAG_PREFER_RECEIVER
};

/* Class record constants */

typedef struct _XmDisplayRec *XmDisplay;
typedef struct _XmDisplayClassRec *XmDisplayClass;
externalref 	WidgetClass xmDisplayClass;

#define XmGetDisplay(w) XmGetXmDisplay(XtDisplayOfObject(w))

/********    Public Function Declarations    ********/
#ifdef _NO_PROTO

extern Widget XmGetDragContext() ;
extern Widget XmGetXmDisplay() ;

#else

extern Widget XmGetDragContext( 
                        Widget w,
                        Time time) ;
extern Widget XmGetXmDisplay( 
                        Display *display) ;

#endif /* _NO_PROTO */
/********    End Public Function Declarations    ********/

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmDisplay_h */


