/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: DisplayP.h,v $
 * Revision 1.5.152.5  1994/03/25  16:33:59  drand
 * 	Finish adding XmREnableBtn1Transfer reptype
 * 	[1994/03/25  16:33:22  drand]
 *
 * Revision 1.5.152.4  1994/03/04  22:40:22  drand
 * 	Merged with changes from 1.5.152.3
 * 	[1994/03/04  22:40:04  drand]
 * 
 * 	New CDE Resources
 * 	[1994/03/04  22:34:38  drand]
 * 
 * Revision 1.5.152.3  1994/03/04  22:22:30  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  21:56:03  drk]
 * 
 * Revision 1.5.152.2  1994/01/31  20:26:10  drk
 * 	Make _XmVirtKeysHandler and associated XmDisplay fields obsolete.
 * 	[1994/01/31  20:25:47  drk]
 * 
 * Revision 1.5.152.1  1993/12/16  22:15:55  drand
 * 	Added SHAPE extension code
 * 	[1993/12/16  22:15:26  drand]
 * 
 * Revision 1.5.14.2  1993/08/03  01:55:14  inca
 * 	Fixes from Motif1.2.3. Rev. 1.5.12.2, ancestor 1.5.10.2, file DisplayP.h.
 * 	[1993/08/02  22:38:14  inca]
 * 
 * Revision 1.5.6.9  1993/07/23  02:50:48  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:16:51  yak]
 * 
 * Revision 1.5.6.8  1993/07/08  18:26:12  drk
 * 	Use XmKeyBinding publically, and XmVKeyBinding internally.
 * 	[1993/07/08  18:22:55  drk]
 * 
 * 	Removed aux_bindings field.
 * 	[1993/07/08  17:00:09  drk]
 * 
 * Revision 1.5.6.7  1993/06/28  20:12:58  drk
 * 	Add num_bindings and aux_bindings to handle multiple actual keysyms
 * 	per virtual keysym without changing the existing bindings field.
 * 	[1993/06/28  17:18:56  drk]
 * 
 * Revision 1.5.6.6  1993/06/21  22:21:53  meeks
 * 	2.0 4.2.2: Added noFontCallback and noRenditionCallback to XmDisplayPart.
 * 	[1993/06/21  21:42:29  meeks]
 * 
 * Revision 1.5.6.5  1993/06/18  15:19:21  drand
 * 	Integrate HP 2.0 Drag and Drop enhancements.
 * 	[1993/06/18  15:14:23  drand]
 * 
 * Revision 1.5.6.4  1993/05/20  20:52:15  rgcote
 * 	Fixes from Motif1.2.3. Rev. 1.5.9.2, ancestor 1.5.4.3, file DisplayP.h.
 * 	[1993/05/20  20:51:59  rgcote]
 * 
 * Revision 1.5.6.3  1993/04/30  17:39:51  daniel
 * 	add motifVersion and enableWarp
 * 	[1993/04/30  17:38:15  daniel]
 * 
 * Revision 1.5.6.2  1993/03/03  20:22:37  daniel
 * 	put in the userData resource
 * 	[1993/03/03  20:14:33  daniel]
 * 
 * Revision 1.5.4.3  1992/08/07  14:57:02  dbl
 * 	CR 2403 summary: partial fixes for this problem.
 * 	  Together, the patches fix many areas in Motif which keep per-display
 * 	  information. When closing a display, and re-opening it, it is
 * 	  possible (likely) that the same display id will be returned (it is just
 * 	  an address returned by malloc). In this case, Motif tries to use
 * 	  various Atoms, Pixmaps, GCs, and random data for the old display. The
 * 	  results are Protocol errors, core dumps, strange behaviour.
 * 	  Also done: unrelated fixes to ImageCache.c (_XmUninstallImage)
 * 	             unrelated fixes to MenuUtil.c (_XmGrabKeyboard)
 * 	             update to CR 2788
 * 	             various cleanups to satisfy "gcc -ansi"
 * 	[1992/08/07  14:48:43  dbl]
 * 
 * Revision 1.5.4.2  1992/07/22  15:08:20  al
 * 	HP Drop 76
 * 	[1992/07/22  15:05:13  al]
 * 
 * Revision 1.5.2.4  1992/04/04  21:12:02  al
 * 	Destroy XmDisplay when all VendorShells have gone away
 * 	[1992/04/04  21:05:44  al]
 * 
 * Revision 1.5.2.3  1992/03/31  22:17:32  al
 * 	Add hook for per-display data, to allow XtCloseDisplay fix in 1.2 patch
 * 	[1992/03/31  22:15:48  al]
 * 
 * Revision 1.5.2.2  1992/03/31  01:32:12  al
 * 	Move defaultVirtualBindings to XmDisplay
 * 	[1992/03/31  01:30:10  al]
 * 
 * Revision 1.5  1992/03/13  16:28:17  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/*   $RCSfile: DisplayP.h,v $ $Revision: 1.5.152.5 $ $Date: 1994/03/25 16:33:59 $ */
/* (c) Copyright 1989, 1990  DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS. */
/* (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */
/* (c) Copyright 1988 MASSACHUSETTS INSTITUTE OF TECHNOLOGY  */
/* (c) Copyright 1988 MICROSOFT CORPORATION */
#ifndef _XmDisplayP_h
#define _XmDisplayP_h

#include <Xm/DesktopP.h>
#include <Xm/VendorSEP.h>
#include <Xm/DropSMgr.h>
#include <Xm/Display.h>
#include <Xm/ScreenP.h>

/* A little incest */
#include <Xm/DragCP.h>
#include <Xm/VirtKeysP.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifdef _NO_PROTO
typedef Widget (*XmDisplayGetDisplayProc)();
#else
typedef Widget (*XmDisplayGetDisplayProc)(Display *);
#endif


typedef struct {
    XmDisplayGetDisplayProc GetDisplay;
    XtPointer               extension;
} XmDisplayClassPart;

/* 
 * we make it a appShell subclass so it can have it's own instance
 * hierarchy
 */
typedef struct _XmDisplayClassRec{
    CoreClassPart      		core_class;
    CompositeClassPart 		composite_class;
    ShellClassPart  		shell_class;
    WMShellClassPart   		wm_shell_class;
    VendorShellClassPart 	vendor_shell_class;
    TopLevelShellClassPart 	top_level_shell_class;
    ApplicationShellClassPart 	application_shell_class;
    XmDisplayClassPart		display_class;
} XmDisplayClassRec;

typedef struct _XmModalDataRec{
    Widget                      wid;
    XmVendorShellExtObject	ve;
    XmVendorShellExtObject	grabber;
    Boolean			exclusive;
    Boolean			springLoaded;
} XmModalDataRec, *XmModalData;

typedef struct {
    unsigned char		dragInitiatorProtocolStyle;
    unsigned char		dragReceiverProtocolStyle;

    unsigned char		userGrabbed; /* flag for menu vs dnd */

    WidgetClass			dragContextClass;
    WidgetClass			dropTransferClass;
    WidgetClass			dropSiteManagerClass;
    XmDragContext		activeDC;
    XmDropSiteManagerObject	dsm;
    Time			lastDragTime;
    Window			proxyWindow;

    XmModalData			modals;
    Cardinal			numModals;
    Cardinal			maxModals;
    XtPointer			xmim_info;

    String			bindingsString;
    XmVKeyBindingRec		*bindings;
    XKeyEvent			*lastKeyEvent;			 /* unused */
    unsigned char		keycode_tag[XmKEYCODE_TAG_SIZE]; /* unused */

    int				shellCount;
    XtPointer			displayInfo;	/* extension */
    XtPointer                   user_data;
    int                         motif_version ;
    XtEnum                      enable_warp ;
    Cardinal			num_bindings;
    XtCallbackList		dragStartCallback;
    XtCallbackList		noFontCallback;
    XtCallbackList		noRenditionCallback;
    Boolean			displayHasShapeExtension;

    XtEnum			enable_btn1_transfer ;
    Boolean			enable_button_tab ;
    Boolean			enable_etched_in_menu;
    Boolean			default_button_emphasis;
    Boolean			enable_toggle_color;
    Boolean			enable_toggle_visual;
    Boolean			enable_drag_icon;
    Boolean			enable_unselectable_drag;
} XmDisplayPart, *XmDisplayPartPtr;

typedef struct _XmDisplayInfo {
  /* so much for information hiding */
  Cursor	SashCursor;		/* Sash.c */
  Widget	destinationWidget;	/* Dest.c */
  Cursor	TearOffCursor;		/* TearOff.c */
  XtPointer	UniqueStamp;		/* UniqueEvnt.c */
} XmDisplayInfo;

typedef struct _XmDisplayRec{
    CorePart 		core;
    CompositePart 	composite;
    ShellPart 		shell;
    WMShellPart		wm;
    VendorShellPart	vendor;
    TopLevelShellPart 	topLevel;
    ApplicationShellPart application;
    XmDisplayPart	display;
} XmDisplayRec;

externalref XmDisplayClassRec 	xmDisplayClassRec;

externalref String _Xm_MOTIF_DRAG_AND_DROP_MESSAGE ;


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmDisplayP_h */
/* DON'T ADD STUFF AFTER THIS #endif */

