/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: DragIconP.h,v $
 * Revision 1.6.8.1  1994/03/04  22:22:43  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  21:56:19  drk]
 *
 * Revision 1.6.6.3  1993/07/23  02:51:55  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:18:11  yak]
 * 
 * Revision 1.6.6.2  1993/06/30  23:48:45  rgcote
 * 	Removed declarations for _Xm functions which have become
 * 	Xme functions.
 * 	[1993/06/30  23:45:45  rgcote]
 * 
 * Revision 1.6.4.3  1993/06/29  23:13:06  rgcote
 * 	Integrated changes from Joe Whitty (HP) dated 5/24/93.
 * 	[1993/06/29  22:38:54  rgcote]
 * 
 * Revision 1.6.4.2  1993/05/21  18:19:51  drand
 * 	HP Drop 149 (whitty):  Added region from mask instance fields.
 * 	[1993/05/21  14:57:31  drand]
 * 
 * Revision 1.6.2.2  1992/04/10  21:02:23  daniel
 * 	change the drag icons
 * 	[1992/04/10  20:38:27  daniel]
 * 
 * Revision 1.6  1992/03/13  16:29:57  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/* $RCSfile: DragIconP.h,v $ $Revision: 1.6.8.1 $ $Date: 1994/03/04 22:22:43 $ */
/* (c) Copyright 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */

#ifndef _XmDragIconP_h
#define _XmDragIconP_h

#include <Xm/VendorSEP.h>
#include <Xm/DragIcon.h>

#ifdef __cplusplus
extern "C" {
#endif


#ifdef _NO_PROTO
typedef void (*XmCloneVisualProc)();
typedef void (*XmMovePixmapProc)();
#else
typedef void (*XmCloneVisualProc) (XmDragIconObject, Widget, Widget);
typedef void (*XmMovePixmapProc)  (XmDragIconObject, 
				   XmDragIconObject, 
				   XmDragIconObject,
#if NeedWidePrototypes
				   int, int);
#else
				   Position, Position);
#endif /* NeedWidePrototypes */
#endif /* _NO_PROTO */

typedef struct {
  XtPointer		extension;
} XmDragIconClassPart;

typedef struct _XmDragIconClassRec{
  RectObjClassPart		rectangle_class;
  XmDragIconClassPart		dragIcon_class;
} XmDragIconClassRec;

typedef struct {
  Cardinal	depth;
  Pixmap	pixmap;
  Dimension	width, height;
  Pixmap	mask;
  Position	hot_x, hot_y;
  Position	offset_x, offset_y;
  unsigned char	attachment;
  Boolean	isDirty;
  Region        region;
  Region        restore_region;
  Position	x_offset, y_offset;
} XmDragIconPart, *XmDragIconPartPtr;

externalref XmDragIconClassRec 	xmDragIconClassRec;

typedef struct _XmDragIconRec{
  ObjectPart		object;
  RectObjPart		rectangle;
  XmDragIconPart	drag;
} XmDragIconRec;

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmDragIconP_h */
