/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: DragUnderI.h,v $
 * Revision 1.6.8.1  1994/06/01  21:42:21  drand
 * 	Fix 8588: Broken DragUnder effects when using the shaped dynamic window
 * 	[1994/06/01  21:41:59  drand]
 *
 * Revision 1.6.6.1  1994/03/04  22:22:53  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  21:56:28  drk]
 * 
 * Revision 1.6.4.2  1993/07/23  02:52:22  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:18:40  yak]
 * 
 * Revision 1.6.2.2  1992/12/07  19:04:28  gilles
 * 	Add close 'extern "C" { ... }' for compilation in C++
 * 	[1992/12/07  18:52:34  gilles]
 * 
 * Revision 1.6  1992/03/13  16:30:48  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/* $RCSfile: DragUnderI.h,v $ $Revision: 1.6.8.1 $ $Date: 1994/06/01 21:42:21 $ */
/* (c) Copyright 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */

#ifndef _XmDragUnderI_h
#define _XmDragUnderI_h

#include <Xm/XmP.h>
#include <Xm/Screen.h>		/* for XmScreen */

#ifdef __cplusplus
extern "C" {
#endif

/* Structure describing a pixmap */

typedef struct _DragPixmapData {
    Pixmap		pixmap;
    int			x, y;
    unsigned int	width, height;
} DragPixmapData;

typedef struct _XmAnimationSaveData {
    Display		*display;
    XmScreen		xmScreen;
    Window		window;
    Position		windowX;
    Position		windowY;
    unsigned int	windowDepth;
    XmRegion		clipRegion;
    XmRegion		dropSiteRegion;
    Dimension		shadowThickness;
    Dimension		highlightThickness;
    Pixel		background;
    Pixel		foreground;
    Pixel		highlightColor;
    Pixmap		highlightPixmap;
    Pixel		topShadowColor;
    Pixmap		topShadowPixmap;
    Pixel		bottomShadowColor;
    Pixmap		bottomShadowPixmap;

    Dimension		borderWidth;
    Pixmap		animationMask;
    Pixmap		animationPixmap;
    unsigned int	animationPixmapDepth;
    unsigned char	animationStyle;
    Widget		dragOver;

    GC			highlightGC;
    GC			topShadowGC;
    GC			bottomShadowGC;
    GC			drawGC;
    DragPixmapData	*savedPixmaps;
    Cardinal		numSavedPixmaps;
    Widget		dragUnder;
    unsigned char	activeMode;
} XmAnimationSaveDataRec, *XmAnimationSaveData;


/********    Private Function Declarations for DragUnder.c    ********/
#ifdef _NO_PROTO

extern void _XmDragUnderAnimation() ;

#else

extern void _XmDragUnderAnimation( 
                        Widget w,
                        XtPointer clientData,
                        XtPointer callData) ;

#endif /* _NO_PROTO */
/********    End Private Function Declarations    ********/

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmDragUnderI_h */
