/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: DrawP.h,v $
 * Revision 1.5.8.2  1994/05/17  21:06:11  daniel
 * 	remove warning
 * 	[1994/05/17  14:23:31  daniel]
 *
 * Revision 1.5.8.1  1994/05/16  21:19:45  daniel
 * 	split Draw.c
 * 	[1994/05/16  21:06:04  daniel]
 * 
 * Revision 1.5.6.4  1994/03/10  21:53:15  drk
 * 	Remove unsupported #ifdefs.
 * 	[1994/03/10  21:47:16  drk]
 * 
 * Revision 1.5.6.3  1994/03/10  16:00:58  drk
 * 	Rename XmeDrawRadioButton to XmeDrawCircle.
 * 	[1994/03/10  15:57:39  drk]
 * 
 * Revision 1.5.6.2  1994/03/08  23:47:56  drk
 * 	Support enable_toggle_visual.
 * 	[1994/03/08  23:46:54  drk]
 * 
 * Revision 1.5.6.1  1994/03/04  22:22:59  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  21:56:33  drk]
 * 
 * Revision 1.5.4.11  1993/07/23  21:34:37  yak
 * 	Fixed problem with XmeDrawIndicator. CR 6053.
 * 	[1993/07/23  21:34:16  yak]
 * 
 * Revision 1.5.4.10  1993/07/23  02:52:29  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:18:53  yak]
 * 
 * Revision 1.5.4.9  1993/07/20  17:23:23  daniel
 * 	fix sgi compiler errors
 * 	[1993/07/20  17:21:56  daniel]
 * 
 * Revision 1.5.4.8  1993/06/30  23:49:13  rgcote
 * 	Removed declarations for _Xm functions which have become
 * 	Xme functions.
 * 	[1993/06/30  23:45:56  rgcote]
 * 
 * Revision 1.5.4.7  1993/06/11  13:51:08  rgcote
 * 	XmeDrawHighlight used to replace _XmDrawHightlight; it now replaces _XmDrawSimpleHightlight instead.
 * 	[1993/06/10  19:25:45  rgcote]
 * 
 * Revision 1.5.4.6  1993/05/28  20:57:13  motifics
 * 	ToggleButton visual changes
 * 	[1993/05/28  20:50:45  motifics]
 * 
 * Revision 1.5.4.5  1993/04/27  13:57:00  rgcote
 * 	Changed a number of _Xm functions to be Xme functions.
 * 	[1993/04/26  15:51:12  rgcote]
 * 
 * Revision 1.5.4.4  1993/04/11  19:09:50  daniel
 * 	add DrawIndicator stub
 * 	[1993/04/11  18:18:43  daniel]
 * 
 * Revision 1.5.4.3  1993/03/26  19:34:51  daniel
 * 	typo in my last submission
 * 	[1993/03/26  19:34:34  daniel]
 * 
 * Revision 1.5.4.2  1993/03/26  19:28:01  daniel
 * 	implement _XmDrawPolygonShadow
 * 	[1993/03/26  19:27:18  daniel]
 * 
 * Revision 1.5.2.5  1992/10/06  15:55:00  daniel
 * 	syntax error in my last submit
 * 	[1992/10/06  15:54:41  daniel]
 * 
 * Revision 1.5.2.4  1992/10/06  15:51:22  daniel
 * 	syntax error in my last submit
 * 	[1992/10/06  15:51:02  daniel]
 * 
 * Revision 1.5.2.3  1992/10/06  15:42:15  daniel
 * 	cr 4730: DrawHighlight & readonly gc
 * 	[1992/10/06  15:38:18  daniel]
 * 
 * Revision 1.5.2.2  1992/09/17  19:38:19  daniel
 * 	fix the remaining _cplusplus problems
 * 	[1992/09/17  19:37:07  daniel]
 * 
 * Revision 1.5  1992/03/13  16:31:04  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/* $RCSfile: DrawP.h,v $ $Revision: 1.5.8.2 $ $Date: 1994/05/17 21:06:11 $ */
/* (c) Copyright 1989, DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS. */
/* (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */
#ifndef _XmDrawP_h
#define _XmDrawP_h

#include <Xm/XmP.h>

#ifdef __cplusplus
extern "C" {
#endif

/*---------------------------------------------------------------*/
/*   Functions used by Xm widgets for the Motif visual drawing   */
/*---------------------------------------------------------------*/
/* All these functions have an Xlib draw like API: 
      a Display*, a Drawable, then GCs, Positions and Dimensions 
      and finally some specific paramaters */

/******** The Draw.c file has been split in several module for
          a better link profile *********/

/*---------------------------------------------------------------
  XmeDrawShadows, 
       use in place of the 1.1 _XmDrawShadow and _XmDrawShadowType
       with changes to the interface (widget vs window, offsets, new order)
       and in the implementation (uses XSegments instead of XRectangles).
       Both etched and regular shadows use now a single private routine
       xmDrawSimpleShadow.
    XmeDrawHighlight.
       Implementation using FillRectangles, for solid highlight only. 
    _XmDrawHighlight.
       Highlight using wide lines, so that dash mode works. 
    XmeClearBorder,    
       new name for _XmEraseShadow  (_XmClearShadowType, which clear half a 
       shadow with a 'widget' API stays in Manager.c ) 
       XmClearBorder is only usable on window, not on drawable.
    XmeDrawSeparator, 
       use in place of the duplicate redisplay method of both separator and 
       separatorgadget (highlight_thickness not used, must be incorporated
       in the function call parameters). use xmDrawSimpleShadow.
       Has 2 new separator types for dash shadowed lines.
    XmeDrawDiamond, 
       new interface for _XmDrawDiamondButton (_XmDrawSquareButton is
       really a simple draw shadow and will be in the widget file as is).
    XmeDrawArrow, 
       same algorithm as before but in one function that re-uses the malloced
       rects and does not store anything in the wigdet instance.
    XmeDrawPolygonShadow,
       new one that use the RegionDrawShadow API to implement an Xme call 
    XmeDrawCircle,
       new one for toggle visual
    XmeDrawIndicator
       new one for toggle drawing
---------------------------------------------------------------------------*/


/********    Private Function Declarations    ********/
#ifdef _NO_PROTO

extern void XmeDrawShadows();
extern void XmeClearBorder();
extern void XmeDrawSeparator();
extern void XmeDrawDiamond();
extern void XmeDrawCircle();
extern void XmeDrawHighlight();
extern void XmeDrawArrow();
extern void XmeDrawPolygonShadow();
extern void XmeDrawIndicator();

#else

extern void XmeDrawShadows( 
                        Display *display,
                        Drawable d,
                        GC top_gc,
                        GC bottom_gc,
#if NeedWidePrototypes
                        int x,
                        int y,
                        int width,
                        int height,
                        int shad_thick,
#else
                        Position x,
                        Position y,
                        Dimension width,
                        Dimension height,
                        Dimension shad_thick,
#endif /* NeedWidePrototypes */
                        unsigned int shad_type);
extern void XmeClearBorder( 
                        Display *display,
                        Window w,
#if NeedWidePrototypes
                        int x,
                        int y,
                        int width,
                        int height,
                        int shadow_thick);
#else
                        Position x,
                        Position y,
                        Dimension width,
                        Dimension height,
                        Dimension shadow_thick);
#endif /* NeedWidePrototypes */
extern void XmeDrawSeparator( 
                        Display *display,
                        Drawable d,
                        GC top_gc,
                        GC bottom_gc,
                        GC separator_gc,
#if NeedWidePrototypes
                        int x,
                        int y,
                        int width,
                        int height,
                        int shadow_thick,
                        int margin,
                        unsigned int orientation,
                        unsigned int separator_type);
#else
                        Position x,
                        Position y,
                        Dimension width,
                        Dimension height,
                        Dimension shadow_thick,
                        Dimension margin,
                        unsigned char orientation,
                        unsigned char separator_type);
#endif /* NeedWidePrototypes */
extern void XmeDrawDiamond( 
                        Display *display,
                        Drawable d,
                        GC top_gc,
                        GC bottom_gc,
                        GC center_gc,
#if NeedWidePrototypes
                        int x,
                        int y,
                        int width,
                        int height,
                        int shadow_thick,
                        int margin);
#else
                        Position x,
                        Position y,
                        Dimension width,
                        Dimension height,
                        Dimension shadow_thick,
                        Dimension margin);
#endif /* NeedWidePrototypes */

extern void XmeDrawCircle( 
                        Display *display,
                        Drawable d,
                        GC top_gc,
                        GC bottom_gc,
                        GC center_gc,
#if NeedWidePrototypes
                        int x,
                        int y,
                        int width,
                        int height,
                        int shadow_thick,
                        int margin);
#else
                        Position x,
                        Position y,
                        Dimension width,
                        Dimension height,
                        Dimension shadow_thick,
                        Dimension margin);
#endif /* NeedWidePrototypes */

extern void XmeDrawHighlight( 
                        Display *display,
                        Drawable d,
                        GC gc,
#if NeedWidePrototypes
                        int x,
                        int y,
                        int width,
                        int height,
                        int highlight_thick
#else
                        Position x,
                        Position y,
                        Dimension width,
                        Dimension height,
                        Dimension highlight_thick
#endif /* NeedWidePrototypes */
                        );
extern void XmeDrawArrow( 
                        Display *display,
                        Drawable d,
                        GC top_gc,
                        GC bot_gc,
                        GC cent_gc,
#if NeedWidePrototypes
                        int x,
                        int y,
                        int width,
                        int height,
                        int shadow_thick,
                        unsigned int direction);
#else
                        Position x,
                        Position y,
                        Dimension width,
                        Dimension height,
                        Dimension shadow_thick,
                        unsigned char direction);
#endif /* NeedWidePrototypes */

extern void XmeDrawPolygonShadow(
		      Display *dpy,
		      Drawable d,
		      GC topGC,
		      GC bottomGC,
		      XPoint *points,
		      int n_points,
#if NeedWidePrototypes
		      int shadowThickness,
		      unsigned int shadowType);
#else
		      Dimension shadowThickness,
		      unsigned char shadowType);
#endif /* NeedWidePrototypes */

extern void XmeDrawIndicator(Display *display, 
		 Drawable d, 
		 GC gc, 
#if NeedWidePrototypes
		 int x, int y, 
		 int width, int height, 
		 int margin,
		 int type);
#else
                 Position x, Position y, 
                 Dimension width, Dimension height,
		 Dimension margin, 
                 XtEnum type);
#endif /* NeedWidePrototypes */

#endif /* _NO_PROTO */
/********    End Private Function Declarations    ********/


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmDrawP_h */
