/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: DrawingAP.h,v $
 * Revision 1.8.7.1  1994/03/04  22:23:05  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  21:56:38  drk]
 *
 * Revision 1.8.2.4  1993/07/23  02:52:41  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:19:11  yak]
 * 
 * Revision 1.8.2.3  1993/03/30  14:20:02  rgcote
 * 	Fixes from Motif1.2.3. Rev. 1.8.3.2, ancestor 1.8, file DrawingAP.h.
 * 	[1993/03/29  19:54:27  rgcote]
 * 
 * Revision 1.8.2.2  1993/03/17  22:06:11  drand
 * 	Added XmNconvertCallback and XmNdestinationCallback to
 * 	DrawingArea.
 * 	[1993/03/17  22:05:40  drand]
 * 
 * Revision 1.8  1992/03/13  16:31:21  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/*   $RCSfile: DrawingAP.h,v $ $Revision: 1.8.7.1 $ $Date: 1994/03/04 22:23:05 $ */
/*
*  (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */
#ifndef _XmDrawingAreaP_h
#define _XmDrawingAreaP_h

#include <Xm/ManagerP.h>
#include <Xm/DrawingA.h>

#ifdef __cplusplus
extern "C" {
#endif

#define XmRESIZE_SWINDOW	10


/* Constraint part record for DrawingArea widget */

typedef struct _XmDrawingAreaConstraintPart
{
   char unused;
} XmDrawingAreaConstraintPart, * XmDrawingAreaConstraint;

/*  New fields for the DrawingArea widget class record  */

typedef struct
{
   XtPointer extension;   /* Pointer to extension record */
} XmDrawingAreaClassPart;


/* Full class record declaration */

typedef struct _XmDrawingAreaClassRec
{
  CoreClassPart		core_class;
  CompositeClassPart	composite_class;
  ConstraintClassPart	constraint_class;
  XmManagerClassPart	manager_class;
  XmDrawingAreaClassPart	drawing_area_class;
} XmDrawingAreaClassRec;

externalref XmDrawingAreaClassRec xmDrawingAreaClassRec;


/* New fields for the DrawingArea widget record */

typedef struct
{
  Dimension		margin_width;
  Dimension		margin_height;

  XtCallbackList	resize_callback;
  XtCallbackList	expose_callback;
  XtCallbackList	input_callback;

  unsigned char		resize_policy;
  
  XtCallbackList	convert_callback;
  XtCallbackList	destination_callback;
} XmDrawingAreaPart;


/****************************************************************
 *
 * Full instance record declaration
 *
 ****************************************************************/

typedef struct _XmDrawingAreaRec
{
  CorePart		core;
  CompositePart		composite;
  ConstraintPart	constraint;
  XmManagerPart		manager;
  XmDrawingAreaPart	drawing_area;
} XmDrawingAreaRec;


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmDrawingAreaP_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
