/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: DropSMgrP.h,v $
 * Revision 1.6.13.1  1994/03/04  22:23:14  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  21:56:48  drk]
 *
 * Revision 1.6.5.11  1993/12/09  16:38:09  drand
 * 	Changed UnregisterInfo back
 * 	[1993/12/09  16:36:28  drand]
 * 
 * Revision 1.6.5.10  1993/12/07  21:01:18  drand
 * 	Changed UnregisterInfo to used a widget (again)
 * 	[1993/12/07  20:53:56  drand]
 * 
 * Revision 1.6.5.9  1993/09/10  16:05:24  yak
 * 	Fixes from Motif1.2.4. Rev. 1.6.12.2, ancestor 1.6.11.2, file DropSMgrP.h.
 * 	Changed the type of updateInfo in XmDropSiteManagerPart
 * 	from XtPointer to _XmDropSiteUpdateInfo.
 * 	[1993/09/10  16:04:52  yak]
 * 
 * Revision 1.6.5.8  1993/08/26  19:32:16  drand
 * 	Fixes from Motif1.2.4. Rev. 1.6.10.2, ancestor 1.6.8.6, file DropSMgrP.h.
 * 	cosmetic changes.  Change next member of _XmDropSiteUpdateRec.
 * 	[1993/08/26  19:31:44  drand]
 * 
 * Revision 1.6.5.7  1993/08/23  22:09:40  yak
 * 	Expanded copyright marker
 * 	[1993/08/23  21:18:09  yak]
 * 
 * Revision 1.6.5.6  1993/08/03  01:55:56  inca
 * 	Fixes from Motif1.2.3. Rev. 1.6.10.2, ancestor 1.6.8.5, file DropSMgrP.h.
 * 	[1993/08/02  22:56:10  inca]
 * 
 * Revision 1.6.5.5  1993/07/29  18:35:19  drand
 * 	More work on the sync tree delay code.  Forgot to maintain level
 * 	count (preventing all updating) and also needed to deal with the
 * 	possibility that more than one root might need updating.
 * 	[1993/07/29  18:33:53  drand]
 * 
 * Revision 1.6.5.4  1993/07/28  22:01:27  drand
 * 	Fixes from Motif1.2.3. Rev. 1.6.10.2, ancestor 1.6.8.3, file DropSMgrP.h.
 * 	Removed delayed update in DYNAMIC case (too risky),  changed
 * 	from a work proc to a timer.
 * 	[1993/07/28  22:01:13  drand]
 * 
 * Revision 1.6.5.3  1993/07/26  22:00:10  drand
 * 	Fixes from Motif1.2.3. Rev. 1.6.10.2, ancestor 1.6.8.2, file DropSMgrP.h.
 * 	DnD performance improvements,  reduce the number of SyncTree's
 * 	performed by waiting until a workProc is run in preregister or
 * 	a top-level-enter in dynamic.
 * 	[1993/07/26  21:59:52  drand]
 * 
 * Revision 1.6.5.2  1993/07/20  16:45:03  drand
 * 	Changed API to UnregisterInfo to take the information record instead
 * 	of a widget.  In this way,  we guarantee consistency in the
 * 	widget to info database.
 * 	[1993/07/20  16:44:11  drand]
 * 
 * Revision 1.6.2.2  1992/04/13  18:28:23  yak
 * 	Integrated diffs from HP
 * 	[1992/04/13  18:19:34  yak]
 * 
 * Revision 1.6  1992/03/13  16:32:13  devsrc
 * 	Revision 1.41  92/04/11  22:16:35  22:16:35  ben (Benjamin Ellsworth)
 * 	Removed infinite recursion while sync'ing tree for dynamic clients.
 * 
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/*   $RCSfile: DropSMgrP.h,v $ $Revision: 1.6.13.1 $ $Date: 1994/03/04 22:23:14 $ */
/*
*  (c) Copyright 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */

#ifndef _XmDropSMgrP_h
#define _XmDropSMgrP_h

#include <Xm/XmP.h>
#include <Xm/DropSMgr.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifdef _NO_PROTO
typedef void (*XmDSMCreateInfoProc)();
typedef void (*XmDSMDestroyInfoProc)();
typedef void (*XmDSMStartUpdateProc)();
typedef void (*XmDSMRetrieveInfoProc)();
typedef void (*XmDSMUpdateInfoProc)();
typedef void (*XmDSMEndUpdateProc)();
typedef void (*XmDSMUpdateProc)();
typedef void (*XmDSMProcessMotionProc)();
typedef void (*XmDSMProcessDropProc)();
typedef void (*XmDSMOperationChangedProc)();
typedef void (*XmDSMChangeRootProc)();
typedef void (*XmDSMInsertInfoProc)();
typedef void (*XmDSMRemoveInfoProc)();
typedef void (*XmDSMSyncTreeProc)();
typedef int  (*XmDSMGetTreeFromDSMProc)();
typedef void (*XmDSMCreateDSInfoTable)();
typedef void (*XmDSMDestroyDSInfoTable)();
typedef void (*XmDSMRegisterInfoProc)();
typedef XtPointer (*XmDSMWidgetToInfoProc)();
typedef void (*XmDSMUnregisterInfoProc)();
#else
typedef void (*XmDSMCreateInfoProc)
	(XmDropSiteManagerObject, Widget, ArgList, Cardinal);
typedef void (*XmDSMDestroyInfoProc)
	(XmDropSiteManagerObject, Widget);
typedef void (*XmDSMStartUpdateProc)
	(XmDropSiteManagerObject, Widget);
typedef void (*XmDSMRetrieveInfoProc)
	(XmDropSiteManagerObject, Widget, ArgList, Cardinal);
typedef void (*XmDSMUpdateInfoProc)
	(XmDropSiteManagerObject, Widget, ArgList, Cardinal);
typedef void (*XmDSMEndUpdateProc)
	(XmDropSiteManagerObject, Widget);
typedef void (*XmDSMUpdateProc)
	(XmDropSiteManagerObject, XtPointer, XtPointer);
typedef void (*XmDSMProcessMotionProc)
	(XmDropSiteManagerObject, XtPointer, XtPointer);
typedef void (*XmDSMProcessDropProc)
	(XmDropSiteManagerObject, XtPointer, XtPointer);
typedef void (*XmDSMOperationChangedProc)
	(XmDropSiteManagerObject, XtPointer, XtPointer);
typedef void (*XmDSMChangeRootProc)
	(XmDropSiteManagerObject, XtPointer, XtPointer);
typedef void (*XmDSMInsertInfoProc)
	(XmDropSiteManagerObject, XtPointer, XtPointer);
typedef void (*XmDSMRemoveInfoProc)
	(XmDropSiteManagerObject, XtPointer);
typedef void (*XmDSMSyncTreeProc)
	(XmDropSiteManagerObject, Widget);
typedef int  (*XmDSMGetTreeFromDSMProc)
	(XmDropSiteManagerObject, Widget, XtPointer);
typedef void (*XmDSMCreateDSInfoTable)
	(XmDropSiteManagerObject);
typedef void (*XmDSMDestroyDSInfoTable)
	(XmDropSiteManagerObject);
typedef void (*XmDSMRegisterInfoProc)
	(XmDropSiteManagerObject, Widget, XtPointer);
typedef XtPointer (*XmDSMWidgetToInfoProc)
	(XmDropSiteManagerObject, Widget);
typedef void (*XmDSMUnregisterInfoProc)
	(XmDropSiteManagerObject, XtPointer);
#endif

typedef struct {
    XmDSMCreateInfoProc		createInfo;
    XmDSMDestroyInfoProc	destroyInfo;
    XmDSMStartUpdateProc	startUpdate;
    XmDSMRetrieveInfoProc	retrieveInfo;
    XmDSMUpdateInfoProc		updateInfo;
    XmDSMEndUpdateProc		endUpdate;
    
    /* Used by DragController Object */
    
    XmDSMUpdateProc		updateDSM;
    
    /* Used by update proc */
    
    XmDSMProcessMotionProc	processMotion;
    XmDSMProcessDropProc	processDrop;
    XmDSMOperationChangedProc	operationChanged;
    XmDSMChangeRootProc		changeRoot;
    
    /* Used to manage DropSites */
    
    XmDSMInsertInfoProc		insertInfo;
    /* Need a get and a put function for update? */
    XmDSMRemoveInfoProc		removeInfo;

	/* Used to manage the pre-register information */

    XmDSMSyncTreeProc		syncTree;
    XmDSMGetTreeFromDSMProc	getTreeFromDSM;
    
    /* Used to hash between widgets and info */
    
    XmDSMCreateDSInfoTable	createTable;
    XmDSMDestroyDSInfoTable 	destroyTable;
    XmDSMRegisterInfoProc	registerInfo;
    XmDSMWidgetToInfoProc	widgetToInfo;
    XmDSMUnregisterInfoProc 	unregisterInfo;
    
    XtPointer			extension;
} XmDropSiteManagerClassPart;

/*  Full class record declaration for dropSite class  */

typedef struct _XmDropSiteManagerClassRec{
    ObjectClassPart		object_class;
    XmDropSiteManagerClassPart		dropManager_class;
} XmDropSiteManagerClassRec;

externalref XmDropSiteManagerClassRec 	xmDropSiteManagerClassRec;

/* Macros for calling methods */

#define DSMCreateInfo(dsm, widget, args, numArgs) \
	(((XmDropSiteManagerObjectClass) XtClass(dsm))-> \
		dropManager_class.createInfo) \
		((dsm), (widget), (args), (numArgs))

#define DSMDestroyInfo(dsm, widget) \
	(((XmDropSiteManagerObjectClass) XtClass(dsm))-> \
		dropManager_class.destroyInfo) \
		((dsm), (widget))

#define DSMStartUpdate(dsm, widget) \
	(((XmDropSiteManagerObjectClass) XtClass(dsm))-> \
		dropManager_class.startUpdate) \
		((dsm), (widget))

#define DSMRetrieveInfo(dsm, widget, args, numArgs) \
	(((XmDropSiteManagerObjectClass) XtClass(dsm))-> \
		dropManager_class.retrieveInfo) \
		((dsm), (widget), (args), (numArgs))

#define DSMUpdateInfo(dsm, widget, args, numArgs) \
	(((XmDropSiteManagerObjectClass) XtClass(dsm))-> \
		dropManager_class.updateInfo) \
		((dsm), (widget), (args), (numArgs))

#define DSMEndUpdate(dsm, widget) \
	(((XmDropSiteManagerObjectClass) XtClass(dsm))-> \
		dropManager_class.endUpdate) \
		((dsm), (widget))

#define DSMUpdate(dsm, clientData, callData) \
	(((XmDropSiteManagerObjectClass) XtClass(dsm))-> \
		dropManager_class.updateDSM) \
		((dsm), (clientData), (callData))

#define DSMProcessMotion(dsm, clientData, callData) \
	(((XmDropSiteManagerObjectClass) XtClass(dsm))-> \
		dropManager_class.processMotion) \
		((dsm), (clientData), (callData))

#define DSMProcessDrop(dsm, clientData, callData) \
	(((XmDropSiteManagerObjectClass) XtClass(dsm))-> \
		dropManager_class.processDrop) \
		((dsm),(clientData), (callData))

#define DSMOperationChanged(dsm, clientData, callData) \
	(((XmDropSiteManagerObjectClass) XtClass(dsm))-> \
		dropManager_class.operationChanged) \
		((dsm),(clientData), (callData))

#define DSMChangeRoot(dsm, clientData, callData) \
	(((XmDropSiteManagerObjectClass) XtClass(dsm))-> \
		dropManager_class.changeRoot) \
		((dsm), (clientData), (callData))

#define DSMInsertInfo(dsm, info, call_data) \
	(((XmDropSiteManagerObjectClass) XtClass(dsm))-> \
		dropManager_class.insertInfo) \
		((dsm), (info), (call_data))

#define DSMRemoveInfo(dsm, info) \
	(((XmDropSiteManagerObjectClass) XtClass(dsm))-> \
		dropManager_class.removeInfo) \
		((dsm), (info))

#define DSMSyncTree(dsm, shell) \
	(((XmDropSiteManagerObjectClass) XtClass(dsm))-> \
		dropManager_class.syncTree) \
		((dsm), (shell))

#define DSMGetTreeFromDSM(dsm, shell, dataPtr) \
	(((XmDropSiteManagerObjectClass) XtClass(dsm))-> \
		dropManager_class.getTreeFromDSM) \
		((dsm), (shell), (dataPtr))

#define DSMCreateTable(dsm) \
	(((XmDropSiteManagerObjectClass) XtClass(dsm))-> \
		dropManager_class.createTable) \
		((dsm))

#define DSMDestroyTable(dsm) \
	(((XmDropSiteManagerObjectClass) XtClass(dsm))-> \
		dropManager_class.destroyTable) \
		((dsm))

#define DSMRegisterInfo(dsm, widget, info) \
	(((XmDropSiteManagerObjectClass) XtClass(dsm))-> \
		dropManager_class.registerInfo) \
		((dsm), (widget), (info))

#define DSMWidgetToInfo(dsm, widget) \
	(XtPointer) ((((XmDropSiteManagerObjectClass) XtClass(dsm))-> \
		dropManager_class.widgetToInfo) \
		((dsm), (widget)))

#define DSMUnregisterInfo(dsm, info) \
	(((XmDropSiteManagerObjectClass) XtClass(dsm))-> \
		dropManager_class.unregisterInfo) \
		  ((dsm), (info))

/* Internal update struct */

typedef struct __XmDropSiteUpdateInfoRec {
  XmDropSiteManagerObject		dsm;
  Widget				refWidget;
  struct __XmDropSiteUpdateInfoRec	*next;
} _XmDropSiteUpdateInfoRec, *_XmDropSiteUpdateInfo;

/* DropSiteManager instance record */

typedef struct _XmDropSiteManagerPart{
    XtCallbackProc	notifyProc;
    XtCallbackProc	treeUpdateProc;
    XtPointer		client_data;
    XtPointer		dragUnderData;
    XtPointer		curInfo;
    Time		curTime;
    Position		curX, curY, oldX, oldY;
    unsigned char	curDropSiteStatus;
    Widget		curDragContext;
    Boolean		curAnimate;
    unsigned char	curOperations;
    unsigned char	curOperation;
    XmRegion		curAncestorClipRegion;
    XmRegion		newAncestorClipRegion;
    XtPointer		dsTable;
    XtPointer		dsRoot;
    Position		rootX, rootY;
    Dimension		rootW, rootH;
    XtPointer		clipperList;
    _XmDropSiteUpdateInfo	updateInfo;
} XmDropSiteManagerPart, *XmDropSiteManagerPartPtr;

/* Full instance record declaration */

typedef struct _XmDropSiteManagerRec{
    ObjectPart			object;
    XmDropSiteManagerPart	dropManager;
} XmDropSiteManagerRec;

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmDropSMgrP_h */
