/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */ 
/* 
 * HISTORY
 * $Log: ExtObjectP.h,v $
 * Revision 1.7.322.5  1994/04/08  20:07:04  drk
 * 	CR 5385: Create XmLOGICAL_PARENT_RESOURCE flag.
 * 	[1994/04/08  19:58:26  drk]
 *
 * Revision 1.7.322.4  1994/03/04  22:23:18  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  21:56:53  drk]
 * 
 * Revision 1.7.322.3  1994/02/02  22:12:32  drk
 * 	Reindent, misc. cleanup
 * 	[1994/02/02  20:14:56  drk]
 * 
 * Revision 1.7.322.2  1993/12/30  22:11:18  daniel
 * 	cleanup name space
 * 	[1993/12/30  22:09:43  daniel]
 * 
 * Revision 1.7.322.1  1993/12/14  23:31:19  drk
 * 	CR 7531: Increase XmNUM_BYTES to handle new gadget sizes.
 * 	[1993/12/14  23:30:08  drk]
 * 
 * Revision 1.7.2.2  1993/07/23  02:53:47  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:20:28  yak]
 * 
 * Revision 1.7  1992/03/13  16:32:59  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
 */ 
/*   $RCSfile: ExtObjectP.h,v $ $Revision: 1.7.322.5 $ $Date: 1994/04/08 20:07:04 $ */
/* (c) Copyright 1989, 1990  DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS. */
/* (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */
/* (c) Copyright 1988 MASSACHUSETTS INSTITUTE OF TECHNOLOGY  */
/* (c) Copyright 1988 MICROSOFT CORPORATION */
#ifndef _XmExtObjectP_h
#define _XmExtObjectP_h

#include <Xm/XmP.h>

#ifdef __cplusplus
extern "C" {
#endif

enum {
  XmCACHE_EXTENSION = 1,		XmDESKTOP_EXTENSION,
  XmSHELL_EXTENSION,			XmPROTOCOL_EXTENSION,
  XmDEFAULT_EXTENSION
};

#ifndef XmIsExtObject
#define XmIsExtObject(w)	XtIsSubclass(w, xmExtObjectClass)
#endif /* XmIsExtObject */

#define XmLOGICAL_PARENT_RESOURCE	(0x80 << sizeof(Cardinal))

/* Class record constants */

typedef struct _XmExtRec *XmExtObject;
typedef struct _XmExtClassRec *XmExtObjectClass;

externalref WidgetClass xmExtObjectClass;

/* Class Extension definitions */

typedef struct _XmExtClassPart {
  XmSyntheticResource *syn_resources;   
  int		       num_syn_resources;   
  XtPointer	       extension;
} XmExtClassPart, *XmExtClassPartPtr;

typedef struct _XmExtClassRec {
  ObjectClassPart object_class;
  XmExtClassPart  ext_class;
} XmExtClassRec;

typedef struct {
  Widget	logicalParent;
  unsigned char	extensionType;
} XmExtPart, *XmExtPartPtr;

externalref XmExtClassRec xmExtClassRec;

typedef struct _XmExtRec {
  ObjectPart object;
  XmExtPart  ext;
} XmExtRec;


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif  /* _XmExtObjectP_h */
