/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: GadgetP.h,v $
 * Revision 1.5.13.4  1994/04/06  21:53:44  inca
 * 	Update rowcolumn layout to allow new widgets to take part in
 * 	entry alignment procedure
 * 	[1994/04/05  22:36:58  inca]
 *
 * Revision 1.5.13.3  1994/03/10  21:53:22  drk
 * 	Remove unsupported #ifdefs.
 * 	[1994/03/10  21:47:25  drk]
 * 
 * Revision 1.5.13.2  1994/03/04  22:23:35  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  21:57:12  drk]
 * 
 * Revision 1.5.13.1  1994/01/10  23:14:25  drk
 * 	Remove dead VisualChange procedures.
 * 	[1994/01/10  23:13:48  drk]
 * 
 * Revision 1.5.8.3  1993/10/06  20:00:20  jwiele
 * 	New definition of XmGadgetCacheRef for portable alignment.
 * 	(Digital SC#16207)
 * 	[1993/10/05  22:25:10  jwiele]
 * 
 * Revision 1.5.8.2  1993/09/01  21:50:34  inca
 * 	Added layoutDirection to Manager, Primitive & Gadget, added a layout trait
 * 	[1993/08/31  20:48:10  inca]
 * 
 * Revision 1.5.4.6  1993/07/23  02:54:49  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:21:55  yak]
 * 
 * Revision 1.5.4.5  1993/06/04  16:53:56  drand
 * 	Remove XmNconvertCallback.
 * 	[1993/06/04  16:51:40  drand]
 * 
 * Revision 1.5.4.4  1993/06/01  19:00:29  drand
 * 	Added XmNconvertCallback callback list for UTM.
 * 	[1993/06/01  18:55:33  drand]
 * 
 * Revision 1.5.4.3  1992/10/13  19:41:23  drand
 * 	Removed trait support from Gadget.c and GadgetP.h
 * 	[1992/10/13  19:36:03  drand]
 * 
 * Revision 1.5.2.2  1992/03/27  21:41:31  yak
 * 	Restored HP Copyright, which was lost during conversion to ODE.
 * 	[1992/03/27  21:40:02  yak]
 * 
 * Revision 1.5  1992/03/13  16:34:37  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/* $RCSfile: GadgetP.h,v $ $Revision: 1.5.13.4 $ $Date: 1994/04/06 21:53:44 $ */
/* (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */
/* (c) Copyright 1989, 1990 DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS. */
/* (c) Copyright 1988 MASSACHUSETTS INSTITUTE OF TECHNOLOGY  */
#ifndef _XmGadgetP_h
#define _XmGadgetP_h

#ifndef _XmNO_BC_INCL
#define _XmNO_BC_INCL
#endif

#include <Xm/XmP.h>

#ifdef __cplusplus
extern "C" {
#endif


/*  Masks to define input the gadget is interested in  */

#define XmNO_EVENT              0x000
#define XmENTER_EVENT           0x001
#define XmLEAVE_EVENT           0x002
#define XmFOCUS_IN_EVENT        0x004
#define XmFOCUS_OUT_EVENT       0x008
#define XmMOTION_EVENT          0x010
#define XmARM_EVENT             0x020
#define XmACTIVATE_EVENT        0x040
#define XmHELP_EVENT            0x080
#define XmKEY_EVENT             0x100
#define XmMULTI_ARM_EVENT       0x200
#define XmMULTI_ACTIVATE_EVENT  0x400
#define XmBDRAG_EVENT		0x800
#define XmALL_EVENT             0xFFF


/* Gadget access Macros */
#define G_ShadowThickness(g) \
	(((XmGadget)(g))->gadget.shadow_thickness)
#define G_HighlightThickness(g) \
	(((XmGadget)(g))->gadget.highlight_thickness)

#define GCEPTR(wc)  ((XmGadgetClassExt *)(&(((XmGadgetClass)(wc))->gadget_class.extension)))
#define _XmGetGadgetClassExtPtr(wc, owner) \
  ((*GCEPTR(wc) && (((*GCEPTR(wc))->record_type) == owner))\
   ? GCEPTR(wc) \
   :((XmGadgetClassExt *) _XmGetClassExtensionPtr(((XmGenericClassExt *)GCEPTR(wc)), owner)))

#define XmGadgetClassExtVersion 2L


/* Gadget cache header for each gadget's Cache Part */

typedef struct _XmGadgetCache
{
   struct _XmGadgetCache	*next;
   struct _XmGadgetCache	*prev;
   int				ref_count;
} XmGadgetCache, *XmGadgetCachePtr;


/* A cache entry for each class which desires gadget caching */

typedef struct _XmCacheClassPart 
{
   XmGadgetCache	cache_head;
   XmCacheCopyProc	cache_copy;
   XmGadgetCacheProc	cache_delete;
   XmCacheCompareProc   cache_compare;
} XmCacheClassPart, *XmCacheClassPartPtr;

/* A struct for properly aligning the data part of the cache entry. */

typedef struct _XmGadgetCacheRef
{
   XmGadgetCache	cache;
   XtArgVal		data;
} XmGadgetCacheRef, *XmGadgetCacheRefPtr;

/*  Gadget class structure  */

typedef struct _XmGadgetClassExtRec{
    XtPointer           next_extension;
    XrmQuark            record_type;
    long                version;
    Cardinal            record_size;
    XmWidgetBaselineProc widget_baseline;
    XmWidgetDisplayRectProc  widget_display_rect;
    XmWidgetMarginsProc widget_margins;
}XmGadgetClassExtRec, *XmGadgetClassExt;

typedef struct _XmGadgetClassPart
{
   XtWidgetProc         border_highlight;
   XtWidgetProc         border_unhighlight;
   XtActionProc         arm_and_activate;
   XmWidgetDispatchProc input_dispatch;
   XmVisualChangeProc   visual_change;		/* unused in Motif 2.0 */
   XmSyntheticResource * syn_resources;   
   int                  num_syn_resources;   
   XmCacheClassPartPtr	cache_part;
   XtPointer		extension;
} XmGadgetClassPart;


/*  Full class record declaration for Gadget class  */

typedef struct _XmGadgetClassRec
{
   RectObjClassPart  rect_class;
   XmGadgetClassPart gadget_class;
} XmGadgetClassRec;

externalref XmGadgetClassRec xmGadgetClassRec;


/*  The Gadget instance record  */

typedef struct _XmGadgetPart
{
   Dimension shadow_thickness;
   Dimension highlight_thickness;

   XtCallbackList help_callback;
   XtPointer      user_data;

   Boolean traversal_on;
   Boolean highlight_on_enter;
   Boolean have_traversal;

   unsigned char unit_type;
   XmNavigationType navigation_type;

   Boolean highlight_drawn;
   Boolean highlighted;
   Boolean visible;

   Mask event_mask;
   XmDirection layout_direction;
} XmGadgetPart;

/*  Full instance record declaration  */

typedef struct _XmGadgetRec
{
   ObjectPart   object;
   RectObjPart  rectangle;
   XmGadgetPart gadget;
} XmGadgetRec;


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmGadgetP_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */





