/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: GrabShellP.h,v $
 * Revision 1.1.8.3  1994/08/01  16:20:10  drk
 * 	CR 9920: shell.popped_up does not imply mapped.
 * 	[1994/08/01  16:15:42  drk]
 *
 * Revision 1.1.8.2  1994/07/29  14:27:00  drand
 * 	Fix 9888: Timing problem in unpost focus change
 * 	[1994/07/29  14:11:18  drand]
 * 
 * Revision 1.1.8.1  1994/05/19  20:13:10  drand
 * 	Fix 6763 - Focus race problems,  also replay repost problem
 * 	[1994/05/19  20:12:45  drand]
 * 
 * Revision 1.1.6.1  1994/01/11  20:27:53  drand
 * 	Fix bad class def
 * 	[1994/01/11  20:27:04  drand]
 * 
 * Revision 1.1.4.2  1993/10/21  19:58:51  drand
 * 	Changed grab style to Async grab
 * 	[1993/10/21  19:30:28  drand]
 * 
 * 	Fixed grab behavior,  but not currently CUA compliant.
 * 	[1993/10/21  19:14:35  drand]
 * 
 * Revision 1.1.4.1  1993/10/19  20:23:59  drk
 * 	CR 6547: Removed throwaway field.
 * 	[1993/10/19  20:22:34  drk]
 * 
 * Revision 1.1.2.4  1993/07/23  02:55:04  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:22:25  yak]
 * 
 * Revision 1.1.2.3  1993/04/22  21:49:03  rgcote
 * 	Integration from second code drop.
 * 	[1993/04/20  20:33:40  rgcote]
 * 
 * Revision 1.1.2.2  1993/03/30  22:47:55  motiflotus
 * 	Initial integration.
 * 	[1993/03/30  21:18:53  motiflotus]
 * 
 * 	Initial integration
 * 	[1993/03/30  21:10:51  motiflotus]
 * 
 * $EndLog$
 */
#ifndef _XmGrabShellP_h
#define _XmGrabShellP_h

#include <Xm/GrabShell.h>
#include <Xm/XmP.h>
#include <X11/ShellP.h>

#ifdef __cplusplus
extern "C" {
#endif

/* The GrabShell instance record */

typedef struct 
{
  Cursor	cursor;
  Dimension	shadow_thickness;
  Pixel		top_shadow_color;
  Pixmap  	top_shadow_pixmap;
  Pixel   	bottom_shadow_color;
  Pixmap  	bottom_shadow_pixmap;
  GC      	top_shadow_GC;
  GC      	bottom_shadow_GC;
  Boolean	owner_events;
  int		grab_style;
  /* Internal fields */
  Time		post_time;
  Time		unpost_time;
  Boolean	mapped;
  Window	old_focus;
  int		old_revert_to;
} XmGrabShellPart;


/* Full instance record declaration */

typedef  struct _XmGrabShellRec 
{
  CorePart		core;
  CompositePart		composite;
  ShellPart		shell;
  WMShellPart		wm_shell;
  VendorShellPart	vendor_shell;
  XmGrabShellPart	grab_shell;
} XmGrabShellRec;

typedef  struct _XmGrabShellWidgetRec /* OBSOLETE (for compatibility only).*/
{
  CorePart		core;
  CompositePart		composite;
  ShellPart		shell;
  WMShellPart		wm_shell;
  VendorShellPart	vendor_shell;
  XmGrabShellPart	grab_shell;
} XmGrabShellWidgetRec;



/* GrabShell class structure */

typedef struct 
{
  XtPointer		extension;	 /* Pointer to extension record */
} XmGrabShellClassPart;


/* Full class record declaration */

typedef struct _XmGrabShellClassRec 
{
  CoreClassPart	    	core_class;
  CompositeClassPart	composite_class;
  ShellClassPart	shell_class;
  WMShellClassPart	wm_shell_class;
  VendorShellClassPart	vendor_shell_class;
  XmGrabShellClassPart  grab_shell_class;
} XmGrabShellClassRec;


externalref XmGrabShellClassRec  xmGrabShellClassRec;

/********    Private Function Declarations    ********/
#ifdef _NO_PROTO

#else

#endif /* _NO_PROTO */
/********    End Private Function Declarations    ********/


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmGrabShellP_h */
/* DON'T ADD STUFF AFTER THIS #endif */
