/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: HashI.h,v $
 * Revision 1.1.4.1  1994/05/16  21:19:59  daniel
 * 	error in my last change
 * 	[1994/05/16  19:48:19  daniel]
 *
 * 	put PrintHashTable under DEBUG
 * 	[1994/05/16  19:46:08  daniel]
 *
 * Revision 1.1.2.7  1993/09/07  21:05:51  drk
 * 	Change XmHashMapProc to return an abort boolean.
 * 	[1993/09/07  21:05:14  drk]
 * 
 * Revision 1.1.2.6  1993/08/23  22:10:07  yak
 * 	Expanded copyright marker
 * 	[1993/08/23  21:19:06  yak]
 * 
 * Revision 1.1.2.5  1993/08/18  17:51:04  drand
 * 	Performance enhancement.  Allocate buckets in blocks of 256.  Added
 * 	two internal functions NewBucket and FreeBucket for management.
 * 	This should reduce the possible memory fragmentation of allocating
 * 	on demand.
 * 	[1993/08/18  17:48:43  drand]
 * 
 * Revision 1.1.2.4  1993/08/17  19:20:34  drand
 * 	Added _XmMapHashTable function.
 * 	[1993/08/17  19:20:07  drand]
 * 
 * Revision 1.1.2.3  1993/08/16  19:33:36  drand
 * 	Added _XmFreeHashTable and _XmHashTableSize
 * 	[1993/08/16  19:32:40  drand]
 * 
 * Revision 1.1.2.2  1993/08/16  18:53:22  drand
 * 	Initial checkin.
 * 	[1993/08/16  18:52:15  drand]
 * 
 * $EndLog$
 */

#ifdef REV_INFO
#ifndef lint
static char SCCSID[] = "OSF/Motif: @(#)_HashP.h	4.16 91/09/12";
#endif /* lint */
#endif /* REV_INFO */

#ifndef _XmHashI_h
#define _XmHashI_h
 
#include <Xm/XmP.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef int	                XmHashValue;
typedef XtPointer               XmHashKey;
typedef struct _XmHashTableRec  *XmHashTable;

#ifdef _NO_PROTO
typedef Boolean (*XmHashCompareProc)();
typedef XmHashValue (*XmHashFunction)();
typedef Boolean (*XmHashMapProc)();
#else
typedef Boolean (*XmHashCompareProc)(XmHashKey, XmHashKey);
typedef XmHashValue (*XmHashFunction)(XmHashKey);
typedef Boolean (*XmHashMapProc)(XmHashKey, XtPointer value, XtPointer data);
#endif /* _NO_PROTO */

#ifdef _NO_PROTO
XmHashTable _XmAllocHashTable();
void _XmResizeHashTable();
void _XmFreeHashTable();
XtPointer _XmGetHashEntryIterate();
void _XmAddHashEntry();
XtPointer _XmRemoveHashEntry();
XtPointer _XmRemoveHashIterator();
Cardinal _XmHashTableCount();
Cardinal _XmHashTableSize();
void _XmMapHashTable();
#ifdef DEBUG
void _XmPrintHashTable();
#endif
#else
XmHashTable _XmAllocHashTable(Cardinal, XmHashCompareProc, XmHashFunction);
void _XmResizeHashTable(XmHashTable, Cardinal);
void _XmFreeHashTable(XmHashTable);
XtPointer _XmGetHashEntryIterate(XmHashTable, XmHashKey, XtPointer*);
void _XmAddHashEntry(XmHashTable, XmHashKey, XtPointer);
XtPointer _XmRemoveHashEntry(XmHashTable, XmHashKey);
XtPointer _XmRemoveHashIterator(XmHashTable, XtPointer*);
Cardinal _XmHashTableCount(XmHashTable);
Cardinal _XmHashTableSize(XmHashTable);
void _XmMapHashTable(XmHashTable, XmHashMapProc, XtPointer);
#ifdef DEBUG
void _XmPrintHashTable(XmHashTable);
#endif
#endif /* _NO_PROTO */

#define _XmGetHashEntry(table, key) _XmGetHashEntryIterate(table, key, NULL)

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmHashI_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
