/*
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF
 * for the full copyright text.
 * 
 */
/*
 * HISTORY
 * $Log: ImageCachI.h,v $
 * Revision 1.1.2.3  1994/03/15  18:36:27  daniel
 * 	add support for DIRECT_PIXMAP_CACHED
 * 	[1994/03/15  18:35:56  daniel]
 *
 * Revision 1.1.2.2  1994/03/10  15:31:51  daniel
 * 	more ImageCache CDE compliance
 * 	[1994/03/10  15:28:42  daniel]
 * 
 * Revision 1.1.2.1  1994/03/04  22:23:49  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  21:57:29  drk]
 * 
 * $EndLog$
 */
/* $RCSfile: ImageCachI.h,v $ $Revision: 1.1.2.3 $ $Date: 1994/03/15 18:36:27 $ */
#ifndef _XmImageCacheI_h
#define _XmImageCacheI_h

#include <Xm/XmP.h>

/* this name is used by XmeGetPixmapData to cache a pixmap in the
   pixmap cache with no associated name. _XmCachePixmap knows about it
   and will not add this one in the pixmap_data cache because it is a
   _name_ based pixmap cache used during conversion */
#define DIRECT_PIXMAP_CACHED ""

#ifdef __cplusplus
extern "C" {
#endif

/********    Private Function Declarations for ImageCache.c    ********/
#ifdef _NO_PROTO

extern Boolean _XmInstallImage() ;
extern Boolean _XmGetImage() ;
extern Boolean _XmCachePixmap() ;
extern Pixmap  _XmGetColoredPixmap() ;
extern Boolean _XmGetPixmapData() ;
extern Boolean _XmInImageCache() ;

#else

extern Boolean _XmInstallImage( 
                        XImage *image,
                        char *image_name,
                        int hot_x,
                        int hot_y) ;
extern Boolean _XmGetImage( 
                        Screen *screen,
                        char *image_name,
                        XImage **image) ;
extern Boolean _XmCachePixmap( 
			      Pixmap pixmap,
			      Screen *screen,
			      char *image_name,
			      Pixel foreground,
			      Pixel background,
			      int depth,
			      Dimension width,
			      Dimension height) ;
extern Pixmap _XmGetColoredPixmap(Screen *screen,
				  char *image_name,
				  XmAccessColorData acc_color,
				  int depth,
#if NeedWidePrototypes
				  int only_if_exists) ;
#else
				  Boolean only_if_exists) ;
#endif /* NeedWidePrototypes */

extern Boolean _XmGetPixmapData(
		   Screen *screen,
		   Pixmap pixmap,
		   char **image_name,
		   int *depth,
		   Pixel *foreground,
		   Pixel *background,
		   int *hot_x,
		   int *hot_y,
		   unsigned int *width,
		   unsigned int *height) ;
extern Boolean _XmInImageCache(
			       String image_name);

#endif /* _NO_PROTO */
/********    End Private Function Declarations    ********/

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmImageCacheI_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
