/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: JoinSideT.h,v $
 * Revision 1.1.8.4  1994/05/20  14:30:22  daniel
 * 	oops
 * 	[1994/05/20  14:30:07  daniel]
 *
 * Revision 1.1.8.3  1994/05/20  14:18:21  daniel
 * 	change XmNONE
 * 	[1994/05/20  14:18:11  daniel]
 * 
 * Revision 1.1.8.2  1994/05/20  14:15:07  daniel
 * 	add XmNONE
 * 	[1994/05/20  14:14:56  daniel]
 * 
 * Revision 1.1.8.1  1994/05/04  19:55:48  drk
 * 	Document trait version numbers.
 * 	[1994/05/04  19:52:52  drk]
 * 
 * Revision 1.1.6.1  1994/03/07  15:24:14  drk
 * 	Fix missing includes.
 * 	[1994/03/07  15:23:50  drk]
 * 
 * Revision 1.1.4.2  1993/09/14  21:16:01  inca
 * 	VMS-ify (externaldef/externalref) traits
 * 	[1993/09/14  21:07:09  inca]
 * 
 * Revision 1.1.2.4  1993/07/23  02:55:27  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:23:16  yak]
 * 
 * Revision 1.1.2.3  1993/05/03  15:19:54  daniel
 * 	put in join side trait
 * 	[1993/05/03  15:18:50  daniel]
 * 
 * Revision 1.1.2.2  1993/04/27  21:34:32  daniel
 * 	creation of join side trait
 * 	[1993/04/27  21:33:03  daniel]
 * 
 * $EndLog$
 */
#ifndef _XmJoinSideT_H
#define _XmJoinSideT_H

#include <Xm/Xm.h>

#ifdef __cplusplus
extern "C" {
#endif

externalref XrmQuark XmQTjoinSide;

/* Trait structures and typedefs, place typedefs first */

#ifdef _NO_PROTO
typedef void (*XmJoinSideSetValueProc)();
typedef unsigned char (*XmJoinSideGetValueProc)();
#else
typedef void (*XmJoinSideSetValueProc)(Widget tab,
				       unsigned char join_side, 
				       Dimension join_thickness) ;
typedef unsigned char (*XmJoinSideGetValueProc)(Widget tab,
						Dimension * join_thickness);

#endif /* _NO_PROTO */

/* Version 0: initial release. */

typedef struct _XmJoinSideTraitRec {
  int			 version;	/* 0 */
  XmJoinSideSetValueProc setValue;
  XmJoinSideGetValueProc getValue;
} XmJoinSideTraitRec, *XmJoinSideTrait;

enum {/* XmNONE already defined in Xm.h */ 
	 XmLEFT = 1, XmRIGHT, XmTOP, XmBOTTOM} ;

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmJoinSideT_H */
