/*
 * @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: LayoutT.h,v $
 * Revision 1.1.4.1  1994/05/04  19:55:50  drk
 * 	Document trait version numbers.
 * 	[1994/05/04  19:52:54  drk]
 *
 * Revision 1.1.2.2  1993/09/01  21:50:49  inca
 * 	LayoutDirection trait renamed
 * 	[1993/08/31  21:20:37  inca]
 * 
 * 	New layout trait
 * 	[1993/08/31  20:56:50  inca]
 * 
 * $EndLog$
 */
#ifndef _XmLayoutT_H
#define _XmLayoutT_H

#include <Xm/Xm.h>

#ifdef __cplusplus
extern "C" {
#endif

externalref XrmQuark XmQTspecifyLayoutDirection;

/* Trait structures and typedefs, place typedefs first */

#ifdef _NO_PROTO
typedef XmDirection (*XmGetLayoutDirectionProc)();
#else
typedef XmDirection (*XmGetLayoutDirectionProc)(Widget);
#endif

/* Version 0: initial release. */

typedef struct {
  int			   version;		/* 0 */
  XmGetLayoutDirectionProc get_direction;
} XmSpecifyLayoutDirectionTraitRec, *XmSpecifyLayoutDirectionTrait;

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmLayoutT_H */
