/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: ListP.h,v $
 * Revision 1.8.12.2  1994/06/13  21:07:21  drk
 * 	CR 9408: Rationalize XmRAutoSelection enumeration.
 * 	[1994/06/13  20:48:13  drk]
 *
 * Revision 1.8.12.1  1994/05/03  18:29:51  drk
 * 	Cleanup unused/unwanted fields.
 * 	[1994/05/03  18:29:26  drk]
 * 
 * Revision 1.8.10.1  1994/03/28  20:48:30  drk
 * 	Support enableBtn1Transfer in XmList.
 * 	[1994/03/28  20:46:51  drk]
 * 
 * Revision 1.8.8.3  1993/11/09  15:04:59  rgcote
 * 	Merged with changes from 1.8.8.2
 * 	[1993/11/09  15:04:30  rgcote]
 * 
 * 	Added a field to the list widget structure to fix CR 5644.
 * 	[1993/11/08  23:35:41  rgcote]
 * 
 * Revision 1.8.8.2  1993/10/25  14:10:54  drk
 * 	Reorder new fields to be backward compatible with Motif 1.2.x.
 * 	[1993/10/25  14:10:40  drk]
 * 
 * Revision 1.8.8.1  1993/10/19  21:13:30  meeks
 * 	I 160: Added scratchRend and selectColor instance variables.
 * 	[1993/10/19  20:59:50  meeks]
 * 
 * Revision 1.8.5.10  1993/07/23  02:56:10  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:24:22  yak]
 * 
 * Revision 1.8.5.9  1993/06/01  19:00:23  drand
 * 	Added XmNdestinationCallback callback list for UTM.
 * 	[1993/06/01  18:56:20  drand]
 * 
 * Revision 1.8.5.8  1993/05/28  18:51:29  motifics
 * 	add XmNmatchBehavior resource
 * 	[1993/05/28  18:50:39  motifics]
 * 
 * Revision 1.8.5.7  1993/05/13  18:21:03  rgcote
 * 	Added an instance field for the primary ownership resource.
 * 	[1993/05/13  18:20:06  rgcote]
 * 
 * Revision 1.8.5.6  1993/04/29  19:52:18  rgcote
 * 	Added the AutoSelectionType field to the widget
 * 	instance structure. This is used to keep track of
 * 	what auto selection type value should be used
 * 	the next time a browse or extended selection
 * 	callback is invoked while auto selection is true.
 * 	[1993/04/29  17:28:03  rgcote]
 * 
 * Revision 1.8.5.5  1993/04/13  21:17:45  motifics
 * 	Added QuickNavigate functionality
 * 	[1993/04/13  21:16:43  motifics]
 * 
 * Revision 1.8.5.4  1993/04/13  20:55:51  motifics
 * 	Added new resources -- XmNselectionMode and XmNselectedPositions
 * 	[1993/04/13  20:54:02  motifics]
 * 
 * Revision 1.8.5.3  1993/04/06  21:00:18  daniel
 * 	work Navigator/ScrollFrame work
 * 	[1993/04/06  20:59:27  daniel]
 * 
 * Revision 1.8.5.2  1993/04/01  20:58:36  daniel
 * 	add scrollFrame to Text and List
 * 	[1993/04/01  20:53:00  daniel]
 * 
 * Revision 1.8.2.2  1993/03/29  20:14:07  rgcote
 * 	Changed the "int foo" field of the List class part
 * 	to be an "XtPointer extension" field for future
 * 	extensibility.
 * 	[1993/03/29  15:25:15  rgcote]
 * 
 * Revision 1.8  1992/03/13  16:37:20  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/* $RCSfile: ListP.h,v $ $Revision: 1.8.12.2 $ $Date: 1994/06/13 21:07:21 $ */
/* (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */
#ifndef _XmListP_h
#define _XmListP_h

#include <Xm/List.h>
#include <Xm/PrimitiveP.h>
#include <Xm/ScrollBar.h>
#include <Xm/ScrolledW.h>
#include <Xm/XmosP.h>

#ifdef __cplusplus
extern "C" {
#endif

/* List struct passed to Convert proc for drag and drop */
typedef struct _XmListDragConvertStruct
{
  Widget    w;
  XmString *strings;
  int       num_strings;
} XmListDragConvertStruct;

/* List class structure */
typedef struct _XmListClassPart
{
  XtPointer extension;		/* Pointer to extension record */
} XmListClassPart;


/* Full class record declaration for List class */
typedef struct _XmListClassRec
{
  CoreClassPart        core_class;
  XmPrimitiveClassPart primitive_class;
  XmListClassPart      list_class;
} XmListClassRec;

externalref XmListClassRec xmListClassRec;

/* Internal form of the list elements. */
typedef	struct {
  Dimension	 height;
  Dimension	 width;
  Boolean	 selected;
  Boolean	 last_selected;
  Boolean	 LastTimeDrawn;
  int		 length;
  wchar_t	 first_char;
} Element, *ElementPtr;

/* The List instance record */
typedef struct _XmListPart
{
  Dimension	    spacing;
  short             ItemSpacing;
  Dimension         margin_width;
  Dimension    	    margin_height;
  XmFontList 	    font;
  XmString	   *items;
  int		    itemCount;
  XmString	   *selectedItems;
  int              *selectedPositions;	/* "selectedIndices" in Motif 1.2 */
  int		    selectedItemCount;
  int 		    visibleItemCount;
  int 		    LastSetVizCount;
  unsigned char	    SelectionPolicy;
  unsigned char	    ScrollBarDisplayPolicy;
  unsigned char	    SizePolicy;
  XmStringDirection StrDir;

  XtEnum	    AutoSelect;
  Boolean	    DidSelection;
  Boolean	    FromSetSB;
  Boolean	    FromSetNewSize;
  unsigned char	    SelectionMode;	/* "Boolean AddMode" in Motif 1.2 */
  unsigned char	    LeaveDir;
  unsigned char	    HighlightThickness;
  int 		    ClickInterval;
  XtIntervalId	    DragID;
  XtCallbackList    SingleCallback;
  XtCallbackList    MultipleCallback;
  XtCallbackList    ExtendCallback;
  XtCallbackList    BrowseCallback;
  XtCallbackList    DefaultCallback;
  
  
  GC		NormalGC;	
  GC		InverseGC;
  GC		HighlightGC;
  Pixmap        DashTile;	/* unused in Motif 1.2 */
  ElementPtr   *InternalList;
  int		LastItem;	/* position of last item in list */
  int		FontHeight;	/* unused in Motif 1.2 */
  int		top_position;
  char		Event;
  int		LastHLItem;

  /* These fields specify the boundaries of the selection (i.e.
   * the current selection) as specified by the "selected" field
   * of the InternalList elements and the boundaries of the 
   * last_selected selection (i.e. the previous selection) as
   * specified by the "last_selected" field of the InternalList
   * elements.
   */
  int		StartItem;
  int		OldStartItem;
  int		EndItem;
  int		OldEndItem;

  Position	BaseX;
  Position	BaseY;
  Boolean	MouseMoved;	/* unused in Motif 1.2 */
  Boolean	AppendInProgress;
  Boolean	Traversing;
  Boolean	KbdSelection;
  short		DownCount;
  Time		DownTime;
  int		CurrentKbdItem;	/* position of location cursor */
  unsigned char	SelectionType;
  GC		InsensitiveGC;
  
  int vmin;			/* unused in Motif 1.2 */
  int vmax;			/* unused in Motif 2.0 */
  int vOrigin;			/* unused in Motif 2.0 */
  int vExtent;			/* unused in Motif 2.0 */
  
  int hmin;			/* slider minimum coordiate position */
  int hmax;			/* slider maximum coordiate position */
  int hOrigin;			/* slider edge location              */
  int hExtent;			/* slider size                       */

  Dimension	MaxWidth;
  Dimension	CharWidth;	/* unused in Motif 1.2 */
  Position	XOrigin;
	
  XmScrollBarWidget	  hScrollBar;
  XmScrollBarWidget	  vScrollBar;
  XmScrolledWindowWidget  Mom;
  Dimension		  MaxItemHeight;

  /*--- New fields in Motif 2.0. ---*/
  int		selectedPositionCount;

  unsigned char	matchBehavior;

  /* The AutoSelectionType is used to designate where in the selection
   * process the user currently is when auto select is enabled. For
   * instance, during an extended select, there is a beginning to
   * the selection, possible mouse motions and finally a button release
   * resulting in either a selection identical to what was selected
   * before the beginning or to a selection that is different.
   */
  unsigned char	AutoSelectionType;

  /* PrimaryOwnership is used to describe how the list show take
   * ownership of the primary selection when the user selects list
   * items, with a possible value of NEVER.
   */
  unsigned char	PrimaryOwnership;

  XtCallbackList DestinationCallback;

  /* Selection rendition fields */
  XmRendition	scratchRend;
  Pixel		selectColor;

  /* This field is used to house the top position of the list before a
   * scrolling action begins. If the scrolling action is cancelled, then
   * we restore the list top position by using this field. When scrolling
   * by directly using the scroll bar, we don't need this field since the
   * scroll frame trait handles the reset. When scrolling by selecting
   * items and dragging off the edge of the list, we need to use this
   * field to reset the list position when a user presses the cancel key.
   */
  int		previous_top_position;

  XtIntervalId	drag_start_timer;
  char *	drag_abort_action;
  XEvent	drag_event;
} XmListPart;


/* Full instance record declaration */
typedef struct _XmListRec
{
  CorePart	  core;
  XmPrimitivePart primitive;
  XmListPart	  list;
} XmListRec;


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmListP_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
