/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: ManagerP.h,v $
 * Revision 1.5.12.5  1994/04/20  14:36:33  daniel
 * 	build issue with XmObjectAtPoint return type
 * 	[1994/04/20  14:31:50  daniel]
 *
 * Revision 1.5.12.4  1994/04/19  21:10:10  daniel
 * 	fix for 8583: XmObjectAtPoint return Widget
 * 	[1994/04/19  21:09:14  daniel]
 * 
 * Revision 1.5.12.3  1994/04/13  21:59:53  drand
 * 	Changed XmGadgetAtPoint to XmObjectAtPoint
 * 	[1994/04/13  21:53:04  drand]
 * 
 * Revision 1.5.12.2  1994/03/10  21:53:30  drk
 * 	Remove unsupported #ifdefs.
 * 	[1994/03/10  21:47:31  drk]
 * 
 * Revision 1.5.12.1  1994/03/04  22:24:19  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  21:58:03  drk]
 * 
 * Revision 1.5.9.2  1993/09/09  20:28:27  drk
 * 	Fixes from Motif1.2.4. Rev. 1.5.7.2, ancestor 1.5.4.2, file ManagerP.h.
 * 	Use XmP.h's XtParent macro rather than hardwiring it into our macros.
 * 	[1993/09/09  20:28:00  drk]
 * 
 * Revision 1.5.6.9  1993/07/23  02:56:30  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:24:59  yak]
 * 
 * Revision 1.5.6.8  1993/07/02  18:14:37  daniel
 * 	put in Xm.c
 * 	[1993/07/02  18:10:48  daniel]
 * 
 * Revision 1.5.6.7  1993/07/01  21:17:32  daniel
 * 	implement XmGadgetAtPoint
 * 	[1993/07/01  21:16:15  daniel]
 * 
 * Revision 1.5.6.6  1993/03/15  20:06:41  drand
 * 	Changed Trait mechanism to use XContext manager.
 * 	[1993/03/15  20:04:40  drand]
 * 
 * Revision 1.5.6.5  1992/10/29  23:07:18  drand
 * 	Added popupHandlerCallback field in XmManager instance part
 * 	[1992/10/29  23:04:01  drand]
 * 
 * Revision 1.5.6.4  1992/10/13  18:14:02  daniel
 * 	syntax error in my last submit (prototype case)
 * 	[1992/10/13  18:12:44  daniel]
 * 
 * Revision 1.5.6.3  1992/10/13  17:45:32  daniel
 * 	Experimenting CtrlBtn1 take focus
 * 	[1992/10/13  17:44:30  daniel]
 * 
 * Revision 1.5.6.2  1992/09/17  20:23:32  drand
 * 	Added traits field to instance record.
 * 	[1992/09/17  20:10:57  drand]
 * 
 * Revision 1.5.4.2  1992/07/24  21:24:59  daniel
 * 	clean up Manager
 * 	[1992/07/24  21:23:22  daniel]
 * 
 * Revision 1.5.2.2  1992/03/27  21:54:25  yak
 * 	Restored HP Copyright, which was lost during the conversion to ODE.
 * 	[1992/03/27  21:53:42  yak]
 * 
 * Revision 1.5  1992/03/13  16:38:11  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/* $RCSfile: ManagerP.h,v $ $Revision: 1.5.12.5 $ $Date: 1994/04/20 14:36:33 $ */
/* (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */
/* (c) Copyright 1989, 1990 DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS. */
/* (c) Copyright 1988 MASSACHUSETTS INSTITUTE OF TECHNOLOGY  */
#ifndef _XmManagerP_h
#define _XmManagerP_h

#ifndef _XmNO_BC_INCL
#define _XmNO_BC_INCL
#endif

#include <Xm/XmP.h>

#ifdef __cplusplus
extern "C" {
#endif

/*  Access Macros  */

#define XmParentTopShadowGC(w) 		\
	(((XmManagerWidget) XtParent(w))->manager.top_shadow_GC)

#define XmParentBottomShadowGC(w)	\
	(((XmManagerWidget) XtParent(w))->manager.bottom_shadow_GC)

#define XmParentHighlightGC(w)		\
	(((XmManagerWidget) XtParent(w))->manager.highlight_GC)

#define XmParentBackgroundGC(w)		\
	(((XmManagerWidget) XtParent(w))->manager.background_GC)


#define MGR_KeyboardList(m)		\
			(((XmManagerRec *) (m))->manager.keyboard_list)
#define MGR_NumKeyboardEntries(m)	\
			(((XmManagerRec *) (m))->manager.num_keyboard_entries)
#define MGR_SizeKeyboardList(m)		\
			(((XmManagerRec *) (m))->manager.size_keyboard_list)
#define MGR_ShadowThickness(m)		\
			(((XmManagerRec *) (m))->manager.shadow_thickness)


#define XmInheritTraversalChildrenProc ((XmTraversalChildrenProc) _XtInherit)
#define XmInheritObjectAtPointProc     ((XmObjectAtPointProc) _XtInherit)

#ifdef _NO_PROTO
typedef Boolean (*XmTraversalChildrenProc)() ;
typedef Widget (*XmObjectAtPointProc)() ;
#else
typedef Boolean (*XmTraversalChildrenProc)( Widget, Widget **, Cardinal *) ;
typedef Widget (*XmObjectAtPointProc)(Widget, Position, Position) ;
#endif


/*  Structure used for storing accelerator and mnemonic information.  */

typedef struct 
{
   unsigned int eventType;
   KeySym       keysym;
   KeyCode      key;
   unsigned int modifiers;
   Widget       component;
   Boolean      needGrab;
   Boolean      isMnemonic;
} XmKeyboardData;


/*  The class definition  */

typedef struct {
    XtPointer next_extension;
    XrmQuark record_type;
    long version;
    Cardinal record_size;
    XmTraversalChildrenProc traversal_children ;
    XmObjectAtPointProc     object_at_point ;
} XmManagerClassExtRec, *XmManagerClassExt ;

#define XmManagerClassExtVersion 1L

typedef struct _XmManagerClassPart
{
   String               translations;
   XmSyntheticResource * syn_resources;   
   int                  num_syn_resources;   
   XmSyntheticResource * syn_constraint_resources;   
   int                  num_syn_constraint_resources;   
   XmParentProcessProc  parent_process;
   XtPointer            extension;
} XmManagerClassPart;

typedef struct _XmManagerClassRec
{
    CoreClassPart       core_class;
    CompositeClassPart  composite_class;
    ConstraintClassPart constraint_class;
    XmManagerClassPart  manager_class;
} XmManagerClassRec;

externalref XmManagerClassRec xmManagerClassRec;


/*  The instance definition  */

typedef struct _XmManagerPart
{
   Pixel   foreground;

   Dimension   shadow_thickness;
   Pixel   top_shadow_color;
   Pixmap  top_shadow_pixmap;
   Pixel   bottom_shadow_color;
   Pixmap  bottom_shadow_pixmap;

   Pixel   highlight_color;
   Pixmap  highlight_pixmap;

   XtCallbackList help_callback;
   XtPointer      user_data;

   Boolean traversal_on;
   unsigned char unit_type;
   XmNavigationType navigation_type;
   
   Boolean event_handler_added;
   Widget  active_child;
   Widget  highlighted_widget;
   Widget  accelerator_widget;

   Boolean has_focus;

   XmStringDirection string_direction;

   XmKeyboardData * keyboard_list;
   short num_keyboard_entries;
   short size_keyboard_list;

   XmGadget selected_gadget;
   XmGadget eligible_for_multi_button_event;

   GC      background_GC;
   GC      highlight_GC;
   GC      top_shadow_GC;
   GC      bottom_shadow_GC;

   Widget  initial_focus;

   XtCallbackList   popup_handler_callback;

} XmManagerPart;

typedef struct _XmManagerRec
{
   CorePart       core;
   CompositePart  composite;
   ConstraintPart constraint;
   XmManagerPart  manager;
} XmManagerRec;


/*  The constraint definition  */

typedef struct _XmManagerConstraintPart
{
   int unused;
} XmManagerConstraintPart;

typedef struct _XmManagerConstraintRec
{
   XmManagerConstraintPart manager;
} XmManagerConstraintRec, * XmManagerConstraintPtr;


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmManagerP_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
