/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: MenuT.h,v $
 * Revision 1.1.8.1  1994/05/04  19:55:53  drk
 * 	Document trait version numbers.
 * 	[1994/05/04  19:52:55  drk]
 *
 * Revision 1.1.6.1  1994/03/07  15:24:15  drk
 * 	Fix missing includes.
 * 	[1994/03/07  15:23:51  drk]
 * 
 * Revision 1.1.4.8  1993/10/15  20:58:11  drk
 * 	Added _NO_PROTO version of XmMenuSavvyGetActivateCBNameProc.
 * 	[1993/10/15  20:58:00  drk]
 * 
 * Revision 1.1.4.7  1993/10/15  20:50:50  drand
 * 	Changed MenuSavvy trait to have another function to return the
 * 	name of the activateCallback for a widget class.  Changed all
 * 	widget that use MenuSavvy to include this function apropriately.
 * 	[1993/10/15  20:48:03  drand]
 * 
 * Revision 1.1.4.6  1993/09/14  21:16:03  inca
 * 	VMS-ify (externaldef/externalref) traits
 * 	[1993/09/14  21:07:14  inca]
 * 
 * Revision 1.1.4.5  1993/09/09  17:36:04  drand
 * 	Added new methods to menuSavvy and changed RowColumn to use them
 * 	for obtaining the child's accelerator string and mnemonic KeySym.
 * 	[1993/09/09  17:33:33  drand]
 * 
 * Revision 1.1.4.4  1993/09/07  22:14:58  drand
 * 	Updated with two more methods to round out the functionality
 * 	required for menu children.
 * 	[1993/09/07  22:07:27  drand]
 * 
 * Revision 1.1.4.3  1993/09/02  18:07:40  drand
 * 	Implement changes to MenuSystem.  Order of arguments to cascade method,
 * 	removed restoreTearOffToTopLevelShell.  Renamed remaining ones
 * 	reparentToTearOffShell,MenuShell.
 * 	[1993/09/02  17:56:51  drand]
 * 
 * Revision 1.1.4.2  1993/08/10  18:59:55  drand
 * 	Renamed and changed methods in the menuSystem trait to be cleaner.
 * 	[1993/08/10  18:55:32  drand]
 * 
 * Revision 1.1.2.9  1993/07/23  02:56:48  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:25:29  yak]
 * 
 * Revision 1.1.2.8  1993/06/28  19:14:31  rgcote
 * 	Moved the XmActivateState here from XmP.h
 * 	[1993/06/28  19:03:06  rgcote]
 * 
 * Revision 1.1.2.7  1993/04/12  22:09:42  drand
 * 	Merged XmQTisMenu and XmQTmenuProc into XmQTmenuSystem.  Renamed and
 * 	updated all references to old trait record.  Added version to
 * 	menuSystem trait.  Some minor code cleanup.
 * 	[1993/04/12  22:05:25  drand]
 * 
 * Revision 1.1.2.6  1993/03/29  15:55:50  drand
 * 	Added MenuShellPopdown method to MenuProc.
 * 	[1993/03/29  15:54:56  drand]
 * 
 * Revision 1.1.2.5  1993/03/24  17:19:25  rgcote
 * 	Added an extern for the XmQTmenuSavvy quark
 * 	[1993/03/17  00:15:41  rgcote]
 * 
 * Revision 1.1.2.4  1993/02/02  22:20:25  daniel
 * 	add a function in the non proto part (for doug)
 * 	[1993/02/02  22:20:09  daniel]
 * 
 * Revision 1.1.2.3  1993/02/02  20:38:46  drand
 * 	Filled out more functions in menuProcedure trait as it didn't
 * 	contain the full set from menuProcedureEntry.
 * 	[1993/02/02  20:24:56  drand]
 * 
 * Revision 1.1.2.2  1993/01/04  20:23:11  drand
 * 	Initial coding
 * 	[1993/01/04  20:03:55  drand]
 * 
 * $EndLog$
 */

#ifndef _XmMenuT_H
#define _XmMenuT_H

#include <Xm/Xm.h>

#ifdef __cplusplus
extern "C" {
#endif

/* Menu System Traits */
externalref XrmQuark XmQTmenuSystem;
externalref XrmQuark XmQTmenuSavvy;

/* Trait structures and typedefs, place typedefs first */

/* Used by the disable callback method of the menu savvy trait */
typedef enum {
    XmDISABLE_ACTIVATE,   /* defer to the entryCallback */
    XmENABLE_ACTIVATE     /* invoke own activate callback */
} XmActivateState;

/* Menu trait typedefs */

#ifdef _NO_PROTO
typedef int (*XmMenuSystemWidgetProc)();
typedef Boolean (*XmMenuSystemVerifyProc)();
typedef void (*XmMenuSystemControlTraversalProc)();
typedef void (*XmMenuSystemCascadeProc)();
typedef void (*XmMenuSystemArmProc)();
typedef void (*XmMenuSystemPositionProc)();
typedef Boolean (*XmMenuSystemPopdownProc)();
typedef void (*XmMenuSystemEntryCallbackProc)();
typedef Boolean (*XmMenuSystemUpdateHistoryProc)();
typedef void (*XmMenuSystemUpdateBindingsProc)();
typedef void (*XmMenuSystemRecordPostFromWidgetProc)();
typedef void (*XmMenuSystemDisarmProc)();
typedef Widget (*XmMenuSystemPopupPostedProc)();
typedef void (*XmMenuSavvyDisableProc)();
typedef char* (*XmMenuSavvyGetAcceleratorProc)();
typedef KeySym (*XmMenuSavvyGetMnemonicProc)();
typedef char* (*XmMenuSavvyGetActivateCBNameProc)();
#else
typedef int (*XmMenuSystemWidgetProc)(Widget);
typedef Boolean (*XmMenuSystemVerifyProc)(Widget, XEvent*);
typedef void (*XmMenuSystemControlTraversalProc)(Widget, Boolean);
typedef void (*XmMenuSystemCascadeProc)(Widget, Widget, XEvent*);
typedef void (*XmMenuSystemPositionProc)(Widget, XEvent*);
typedef Boolean (*XmMenuSystemPopdownProc)(Widget, XEvent*);
typedef void (*XmMenuSystemEntryCallbackProc)(Widget, Widget, XtPointer);
typedef Boolean (*XmMenuSystemUpdateHistoryProc)(Widget, Widget, Boolean);
typedef void (*XmMenuSystemUpdateBindingsProc)(Widget, int);
typedef void (*XmMenuSystemRecordPostFromWidgetProc)(Widget, Widget, Boolean);
typedef void (*XmMenuSystemDisarmProc)(Widget);
typedef Widget (*XmMenuSystemPopupPostedProc)(Widget);
typedef void (*XmMenuSavvyDisableProc)(Widget, XmActivateState);
typedef char* (*XmMenuSavvyGetAcceleratorProc)(Widget);
typedef KeySym (*XmMenuSavvyGetMnemonicProc)(Widget);
typedef char* (*XmMenuSavvyGetActivateCBNameProc)();
#endif /* _NO_PROTO */
#define XmMenuSystemTypeProc		XmMenuSystemWidgetProc
#define XmMenuSystemStatusProc		XmMenuSystemWidgetProc
#define XmMenuSystemGetPostedFromWidgetProc	XmMenuSystemDisarmProc
#define XmMenuSystemArmProc		XmMenuSystemDisarmProc
#define XmMenuSystemMenuBarCleanupProc	XmMenuSystemDisarmProc
#define XmMenuSystemTearOffArmProc	XmMenuSystemDisarmProc
#define XmMenuSystemReparentProc	XmMenuSystemPositionProc
#define XmMenuSystemPopdownAllProc	XmMenuSystemPositionProc
#define XmMenuSystemChildFocusProc	XmMenuSystemDisarmProc

/* XmTmenuProcTrait */

/* Version 0: initial release. */

typedef struct _XmMenuSystemTraitRec
{
  int					version;		/* 0 */
  XmMenuSystemTypeProc			type;
  XmMenuSystemStatusProc		status;
  XmMenuSystemCascadeProc		cascade;
  XmMenuSystemVerifyProc		verifyButton;
  XmMenuSystemControlTraversalProc	controlTraversal;
  XmMenuSystemMenuBarCleanupProc	menuBarCleanup;
  XmMenuSystemPopdownProc		popdown;
  XmMenuSystemPopdownProc		buttonPopdown;
  XmMenuSystemReparentProc		reparentToTearOffShell;
  XmMenuSystemReparentProc		reparentToMenuShell;
  XmMenuSystemArmProc			arm;
  XmMenuSystemDisarmProc		disarm;
  XmMenuSystemTearOffArmProc		tearOffArm;
  XmMenuSystemEntryCallbackProc		entryCallback;
  XmMenuSystemUpdateHistoryProc		updateHistory;
  XmMenuSystemGetPostedFromWidgetProc	getLastSelectToplevel;
  XmMenuSystemPositionProc		position;
  XmMenuSystemUpdateBindingsProc	updateBindings;
  XmMenuSystemRecordPostFromWidgetProc	recordPostFromWidget;
  XmMenuSystemPopdownAllProc		popdownEveryone;
  XmMenuSystemChildFocusProc		childFocus;
  XmMenuSystemPopupPostedProc		getPopupPosted;
} XmMenuSystemTraitRec, *XmMenuSystemTrait;

/* XmTmenuSavvyTrait */

/* Version 0: initial release. */

typedef struct _XmMenuSavvyTraitRec
{
  int					version;		/* 0 */
  XmMenuSavvyDisableProc		disableCallback;
  XmMenuSavvyGetAcceleratorProc 	getAccelerator;
  XmMenuSavvyGetMnemonicProc		getMnemonic;
  XmMenuSavvyGetActivateCBNameProc	getActivateCBName;
} XmMenuSavvyTraitRec, *XmMenuSavvyTrait;

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmMenuT_H */
