/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: MessagesI.h,v $
 * Revision 1.6.14.4  1994/06/06  20:59:23  drand
 * 	Fix 9338 - Disallow registering a Shell as a DropSite
 * 	[1994/06/06  20:58:47  drand]
 *
 * Revision 1.6.14.3  1994/05/27  19:19:58  knight
 * 	Added action warning message.
 * 	[1994/05/27  19:17:03  knight]
 * 
 * Revision 1.6.14.2  1994/05/27  14:36:28  knight
 * 	Fix 8946: Added Notebook warnings.
 * 	[1994/05/26  14:00:51  knight]
 * 
 * Revision 1.6.14.1  1994/05/25  21:46:31  drand
 * 	Fix 8794: Check num_params in new actions
 * 	[1994/05/25  20:13:16  drand]
 * 
 * Revision 1.6.12.7  1994/04/07  21:08:33  meeks
 * 	CR 8304: Added warning message for negetive values.
 * 	[1994/04/07  14:15:15  meeks]
 * 
 * Revision 1.6.12.6  1994/03/15  23:12:30  drand
 * 	Updated SpinB messages
 * 	[1994/03/15  22:07:22  drand]
 * 
 * Revision 1.6.12.5  1994/03/15  00:05:18  inca
 * 	Initial message catalog implementation
 * 	[1994/03/14  20:10:34  inca]
 * 
 * Revision 1.6.12.4  1994/03/10  22:29:34  inca
 * 	Latest drop from DEC
 * 	[1994/03/10  13:46:40  inca]
 * 
 * Revision 1.6.12.3  1994/02/17  22:58:30  drand
 * 	Update of SpinB code with new warnings
 * 	[1994/02/17  22:57:47  drand]
 * 
 * Revision 1.6.12.2  1994/01/21  22:05:35  drand
 * 	Updated for changes to XmTransferValue et al.
 * 	[1994/01/21  21:59:30  drand]
 * 
 * Revision 1.6.12.1  1993/12/28  15:35:45  daniel
 * 	rework of the pixmap cache/conversion
 * 	[1993/12/28  15:33:21  daniel]
 * 
 * Revision 1.6.9.10  1993/11/19  19:07:46  drk
 * 	CR 7124: XmNlayoutDirection is only CG.
 * 	[1993/11/19  19:07:18  drk]
 * 
 * Revision 1.6.9.9  1993/11/17  21:51:03  meeks
 * 	CR 7099: Added message for no font callback.
 * 	[1993/11/17  21:38:55  meeks]
 * 
 * Revision 1.6.9.8  1993/11/03  23:27:22  drand
 * 	Added message for SpinBox.  Removed old unused variables for SpinBox.
 * 	[1993/11/03  23:20:47  drand]
 * 
 * Revision 1.6.9.7  1993/10/22  00:02:47  meeks
 * 	Added new message for XmRenderT.c.
 * 	[1993/10/21  23:59:24  meeks]
 * 
 * Revision 1.6.9.6  1993/10/19  18:41:29  inca
 * 	Merged with changes from 1.6.9.5
 * 	[1993/10/19  18:41:20  inca]
 * 
 * 	John found a problem with the Motif Warning Handler
 * 	[1993/10/19  18:39:10  inca]
 * 
 * Revision 1.6.9.5  1993/10/19  18:18:59  drand
 * 	Added new message for Transfer.c
 * 	[1993/10/19  18:17:17  drand]
 * 
 * Revision 1.6.9.4  1993/10/14  21:04:15  inca
 * 	Cleaned out message strings to Messages.c, rewrote MotifWarningHandler
 * 	and added an _XmWarningMsg for parameterized messages
 * 	[1993/10/14  20:08:31  inca]
 * 
 * Revision 1.6.9.3  1993/09/14  20:39:15  inca
 * 	Added one message
 * 	[1993/09/14  20:38:39  inca]
 * 
 * Revision 1.6.9.2  1993/08/03  01:56:22  inca
 * 	Fixes from Motif1.2.3. Rev. 1.6.7.4, ancestor 1.6.4.2, file MessagesI.h.
 * 	[1993/08/02  23:14:38  inca]
 * 
 * Revision 1.6.6.9  1993/07/23  02:57:13  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:26:16  yak]
 * 
 * Revision 1.6.6.8  1993/05/20  18:33:53  rgcote
 * 	Integrated the fourth code drop from Cindy Romeo.
 * 	[1993/05/20  18:30:24  rgcote]
 * 
 * Revision 1.6.6.7  1993/05/10  14:52:57  rgcote
 * 	Added msg 0007 for combo box.
 * 	[1993/05/10  14:48:10  rgcote]
 * 
 * Revision 1.6.6.6  1993/04/28  23:35:46  motifdec
 * 	Add CSText messages
 * 	[1993/04/28  01:25:31  motifdec]
 * 
 * Revision 1.6.6.5  1993/04/22  21:50:32  rgcote
 * 	Added messages for combo box and grab shell.
 * 	[1993/04/20  20:34:55  rgcote]
 * 
 * Revision 1.6.6.4  1993/04/13  20:55:37  motifics
 * 	Added new messages for XmList
 * 	[1993/04/13  20:50:53  motifics]
 * 
 * Revision 1.6.6.3  1993/03/30  22:48:32  motiflotus
 * 	ComboBox integration.
 * 	[1993/03/30  21:54:13  motiflotus]
 * 
 * Revision 1.6.6.2  1992/10/21  20:28:08  drand
 * 	Added messages for SpinButton widget.
 * 	[1992/10/21  20:24:07  drand]
 * 
 * Revision 1.6.4.2  1992/07/02  18:52:14  al
 * 	HP Drop 63
 * 	[1992/07/02  18:34:08  al]
 * 
 * Revision 1.6.2.2  1992/03/31  21:56:33  al
 * 	Remove unused Frame messages
 * 	[1992/03/31  21:20:38  al]
 * 
 * Revision 1.6  1992/03/13  16:39:27  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/*   $RCSfile: MessagesI.h,v $ $Revision: 1.6.14.4 $ $Date: 1994/06/06 20:59:23 $ */
/*
*  (c) Copyright 1989, DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS. */
/*
*  (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */
#ifndef _XmMessagesI_h
#define _XmMessagesI_h

#ifdef __cplusplus
extern "C" {
#endif

/* The symbol _XmConst is used for constant data that cannot be
 * declared const in the header file because of usage as arguments to
 * routines which have string arguments that are not declared const.
 *
 * So, _XmConst is always defined to be nothing in header files.
 * In the source file, however, _XmConst is defined to be const,
 * so as to allow shared data in a shared library environment.
 */

#ifndef _XmConst
#define _XmConst
#endif


externalref _XmConst char *_XmMsgBaseClass_0000 ;
externalref _XmConst char *_XmMsgBaseClass_0001 ;
externalref _XmConst char *_XmMsgBaseClass_0002 ;
externalref _XmConst char *_XmMsgBulletinB_0001 ;
externalref _XmConst char *_XmMsgCascadeB_0000 ;
externalref _XmConst char *_XmMsgCascadeB_0001 ;
externalref _XmConst char *_XmMsgCascadeB_0002 ;
externalref _XmConst char *_XmMsgCascadeB_0003 ;
externalref _XmConst char *_XmMsgComboBox_0000 ;
externalref _XmConst char *_XmMsgComboBox_0001 ;
externalref _XmConst char *_XmMsgComboBox_0002 ;
externalref _XmConst char *_XmMsgComboBox_0003 ;
externalref _XmConst char *_XmMsgComboBox_0004 ;
externalref _XmConst char *_XmMsgComboBox_0005 ;
externalref _XmConst char *_XmMsgComboBox_0006 ;
externalref _XmConst char *_XmMsgComboBox_0007 ;
externalref _XmConst char *_XmMsgComboBox_0008 ;
externalref _XmConst char *_XmMsgCommand_0000 ;
externalref _XmConst char *_XmMsgCommand_0001 ;
externalref _XmConst char *_XmMsgCommand_0002 ;
externalref _XmConst char *_XmMsgCommand_0003 ;
externalref _XmConst char *_XmMsgCommand_0004 ;
externalref _XmConst char *_XmMsgCommand_0005 ;
externalref _XmConst char *_XmMsgContainer_0000 ;
externalref _XmConst char *_XmMsgCutPaste_0000 ;
externalref _XmConst char *_XmMsgCutPaste_0001 ;
externalref _XmConst char *_XmMsgCutPaste_0002 ;
externalref _XmConst char *_XmMsgCutPaste_0003 ;
externalref _XmConst char *_XmMsgCutPaste_0004 ;
externalref _XmConst char *_XmMsgCutPaste_0005 ;
externalref _XmConst char *_XmMsgCutPaste_0006 ;
externalref _XmConst char *_XmMsgCutPaste_0007 ;
externalref _XmConst char *_XmMsgCutPaste_0008 ;
externalref _XmConst char *_XmMsgCutPaste_0009 ;
externalref _XmConst char *_XmMsgDialogS_0000 ;
externalref _XmConst char *_XmMsgDragBS_0000 ;
externalref _XmConst char *_XmMsgDragBS_0001 ;
externalref _XmConst char *_XmMsgDragBS_0002 ;
externalref _XmConst char *_XmMsgDragBS_0003 ;
externalref _XmConst char *_XmMsgDragBS_0004 ;
externalref _XmConst char *_XmMsgDragBS_0005 ;
externalref _XmConst char *_XmMsgDragBS_0006 ;
externalref _XmConst char *_XmMsgDragICC_0000 ;
externalref _XmConst char *_XmMsgDragICC_0001 ;
externalref _XmConst char *_XmMsgDragIcon_0000 ;
externalref _XmConst char *_XmMsgDragIcon_0001 ;
externalref _XmConst char *_XmMsgDragIcon_0002 ;
externalref _XmConst char *_XmMsgDragOverS_0000 ;
externalref _XmConst char *_XmMsgDragOverS_0001 ;
externalref _XmConst char *_XmMsgDragOverS_0002 ;
externalref _XmConst char *_XmMsgDragOverS_0003 ;
externalref _XmConst char *_XmMsgDragUnder_0000 ;
externalref _XmConst char *_XmMsgDragUnder_0001 ;
externalref _XmConst char *_XmMsgForm_0000 ;
externalref _XmConst char *_XmMsgForm_0002 ;
externalref _XmConst char *_XmMsgForm_0003 ;
externalref _XmConst char *_XmMsgForm_0004 ;
externalref _XmConst char *_XmMsgGadget_0000 ;
externalref _XmConst char *_XmMsgGetSecRes_0000 ;
externalref _XmConst char *_XmMsgGrabS_0000 ;
externalref _XmConst char *_XmMsgLabel_0003 ;
externalref _XmConst char *_XmMsgLabel_0004 ;
externalref _XmConst char *_XmMsgList_0000 ;
externalref _XmConst char *_XmMsgList_0005 ;
externalref _XmConst char *_XmMsgList_0006 ;
externalref _XmConst char *_XmMsgList_0007 ;
externalref _XmConst char *_XmMsgList_0008 ;
externalref _XmConst char *_XmMsgList_0009 ;
externalref _XmConst char *_XmMsgList_0010 ;
externalref _XmConst char *_XmMsgList_0011 ;
externalref _XmConst char *_XmMsgList_0012 ;
externalref _XmConst char *_XmMsgList_0013 ;
externalref _XmConst char *_XmMsgList_0014 ;
externalref _XmConst char *_XmMsgList_0015 ;
externalref _XmConst char *_XmMsgMainW_0000 ;
externalref _XmConst char *_XmMsgMainW_0001 ;
externalref _XmConst char *_XmMsgManager_0000 ;
externalref _XmConst char *_XmMsgManager_0001 ;
externalref _XmConst char *_XmMsgMenuShell_0000 ;
externalref _XmConst char *_XmMsgMenuShell_0001 ;
externalref _XmConst char *_XmMsgMenuShell_0002 ;
externalref _XmConst char *_XmMsgMenuShell_0003 ;
externalref _XmConst char *_XmMsgMenuShell_0004 ;
externalref _XmConst char *_XmMsgMenuShell_0005 ;
externalref _XmConst char *_XmMsgMenuShell_0006 ;
externalref _XmConst char *_XmMsgMenuShell_0007 ;
externalref _XmConst char *_XmMsgMenuShell_0008 ;
externalref _XmConst char *_XmMsgMenuShell_0009 ;
externalref _XmConst char *_XmMsgMessageB_0003 ;
externalref _XmConst char *_XmMsgMessageB_0004 ;
externalref _XmConst char *_XmMsgNavigMap_0000 ;
externalref _XmConst char *_XmMsgNotebook_0000 ;
externalref _XmConst char *_XmMsgPanedW_0000 ;
externalref _XmConst char *_XmMsgPanedW_0001 ;
externalref _XmConst char *_XmMsgPanedW_0002 ;
externalref _XmConst char *_XmMsgPanedW_0003 ;
externalref _XmConst char *_XmMsgPanedW_0004 ;
externalref _XmConst char *_XmMsgPanedW_0005 ;
externalref _XmConst char *_XmMsgPrimitive_0000 ;
externalref _XmConst char *_XmMsgProtocols_0000 ;
externalref _XmConst char *_XmMsgProtocols_0001 ;
externalref _XmConst char *_XmMsgProtocols_0002 ;
externalref _XmConst char *_XmMsgRegion_0000 ;
externalref _XmConst char *_XmMsgResConvert_0000 ;
externalref _XmConst char *_XmMsgResConvert_0001 ;
externalref _XmConst char *_XmMsgResConvert_0002 ;
externalref _XmConst char *_XmMsgResConvert_0003 ;
externalref _XmConst char *_XmMsgResConvert_0004 ;
externalref _XmConst char *_XmMsgResConvert_0005 ;
externalref _XmConst char *_XmMsgResConvert_0006 ;
externalref _XmConst char *_XmMsgResConvert_0007 ;
externalref _XmConst char *_XmMsgResConvert_0008 ;
externalref _XmConst char *_XmMsgResConvert_0009 ;
externalref _XmConst char *_XmMsgResConvert_0010 ;
externalref _XmConst char *_XmMsgResConvert_0011 ;
externalref _XmConst char *_XmMsgResConvert_0012 ;
externalref _XmConst char *_XmMsgResConvert_0013 ;
externalref _XmConst char *_XmMsgResConvert_0014 ;
externalref _XmConst char *_XmMsgResConvert_0015 ;
externalref _XmConst char *_XmMsgResConvert_0016 ;
externalref _XmConst char *_XmMsgRowColumn_0000 ;
externalref _XmConst char *_XmMsgRowColumn_0001 ;
externalref _XmConst char *_XmMsgRowColumn_0002 ;
externalref _XmConst char *_XmMsgRowColumn_0003 ;
externalref _XmConst char *_XmMsgRowColumn_0004 ;
externalref _XmConst char *_XmMsgRowColumn_0005 ;
externalref _XmConst char *_XmMsgRowColumn_0007 ;
externalref _XmConst char *_XmMsgRowColumn_0008 ;
externalref _XmConst char *_XmMsgRowColumn_0015 ;
externalref _XmConst char *_XmMsgRowColumn_0016 ;
externalref _XmConst char *_XmMsgRowColumn_0017 ;
externalref _XmConst char *_XmMsgRowColumn_0018 ;
externalref _XmConst char *_XmMsgRowColumn_0019 ;
externalref _XmConst char *_XmMsgRowColumn_0020 ;
externalref _XmConst char *_XmMsgRowColumn_0022 ;
externalref _XmConst char *_XmMsgRowColumn_0023 ;
externalref _XmConst char *_XmMsgRowColText_0024 ;
externalref _XmConst char *_XmMsgRowColumn_0025 ;
externalref _XmConst char *_XmMsgRowColumn_0026 ;
externalref _XmConst char *_XmMsgRowColumn_0027 ;
externalref _XmConst char *_XmMsgScale_0000 ;
externalref _XmConst char *_XmMsgScale_0001 ;
externalref _XmConst char *_XmMsgScale_0002 ;
externalref _XmConst char *_XmMsgScaleScrBar_0004 ;
externalref _XmConst char *_XmMsgScale_0005 ;
externalref _XmConst char *_XmMsgScale_0006 ;
externalref _XmConst char *_XmMsgScale_0007 ;
externalref _XmConst char *_XmMsgScale_0008 ;
externalref _XmConst char *_XmMsgScale_0009 ;
externalref _XmConst char *_XmMsgScreen_0000 ;
externalref _XmConst char *_XmMsgScreen_0001 ;
externalref _XmConst char *_XmMsgScrollBar_0000 ;
externalref _XmConst char *_XmMsgScrollBar_0001 ;
externalref _XmConst char *_XmMsgScrollBar_0002 ;
externalref _XmConst char *_XmMsgScrollBar_0003 ;
externalref _XmConst char *_XmMsgScrollBar_0004 ;
externalref _XmConst char *_XmMsgScrollBar_0005 ;
externalref _XmConst char *_XmMsgScrollBar_0006 ;
externalref _XmConst char *_XmMsgScrollBar_0007 ;
externalref _XmConst char *_XmMsgScrollBar_0008 ;
externalref _XmConst char *_XmMsgScrolledW_0004 ;
externalref _XmConst char *_XmMsgScrolledW_0005 ;
externalref _XmConst char *_XmMsgScrolledW_0006 ;
externalref _XmConst char *_XmMsgScrolledW_0007 ;
externalref _XmConst char *_XmMsgScrolledW_0008 ;
externalref _XmConst char *_XmMsgScrolledW_0009 ;
externalref _XmConst char *_XmMsgScrollVis_0000 ;
externalref _XmConst char *_XmMsgSelectioB_0001 ;
externalref _XmConst char *_XmMsgSelectioB_0002 ;
externalref _XmConst char *_XmMsgSpinB_0001 ;
externalref _XmConst char *_XmMsgSpinB_0002 ;
externalref _XmConst char *_XmMsgSpinB_0003 ;
externalref _XmConst char *_XmMsgSpinB_0004 ;
externalref _XmConst char *_XmMsgSpinB_0005 ;
externalref _XmConst char *_XmMsgSpinB_0006 ;
externalref _XmConst char *_XmMsgSpinB_0007 ;
externalref _XmConst char *_XmMsgText_0000 ;
externalref _XmConst char *_XmMsgText_0002 ;
externalref _XmConst char *_XmMsgTextF_0000 ;
externalref _XmConst char *_XmMsgTextF_0001 ;
externalref _XmConst char *_XmMsgTextF_0002 ;
externalref _XmConst char *_XmMsgTextF_0003 ;
externalref _XmConst char *_XmMsgTextF_0004 ;
externalref _XmConst char *_XmMsgTextF_0005 ;
externalref _XmConst char *_XmMsgTextF_0006 ;
externalref _XmConst char *_XmMsgTextFWcs_0000 ;
externalref _XmConst char *_XmMsgTextFWcs_0001 ;
externalref _XmConst char *_XmMsgTextIn_0000 ;
externalref _XmConst char *_XmMsgTextOut_0000 ;
externalref _XmConst char *_XmMsgVendor_0000 ;
externalref _XmConst char *_XmMsgVendor_0001 ;
externalref _XmConst char *_XmMsgVendor_0002 ;
externalref _XmConst char *_XmMsgVendor_0003 ;
externalref _XmConst char *_XmMsgVendorE_0000 ;
externalref _XmConst char *_XmMsgVendorE_0005 ;
externalref _XmConst char *_XmMsgVisual_0000 ;
externalref _XmConst char *_XmMsgVisual_0001 ;
externalref _XmConst char *_XmMsgVisual_0002 ;
externalref _XmConst char *_XmMsgXmIm_0000 ;

externalref _XmConst char *_XmMsgCSText_0000;
externalref _XmConst char *_XmMsgCSText_0001;
externalref _XmConst char *_XmMsgCSText_0002;
externalref _XmConst char *_XmMsgCSText_0003;
externalref _XmConst char *_XmMsgCSText_0004;
externalref _XmConst char *_XmMsgCSText_0005;
externalref _XmConst char *_XmMsgCSText_0006;
externalref _XmConst char *_XmMsgCSText_0007;

externalref _XmConst char *_XmMsgGeoUtils_0000 ;
externalref _XmConst char *_XmMsgGeoUtils_0001 ;
externalref _XmConst char *_XmMsgGeoUtils_0002 ;
externalref _XmConst char *_XmMsgDropSMgrI_0001 ;
externalref _XmConst char *_XmMsgDropSMgrI_0002 ;
externalref _XmConst char *_XmMsgDropSMgrI_0003 ;
externalref _XmConst char *_XmMsgDragC_0001 ;
externalref _XmConst char *_XmMsgDragC_0002 ;
externalref _XmConst char *_XmMsgDragC_0003 ;
externalref _XmConst char *_XmMsgDragC_0004 ;
externalref _XmConst char *_XmMsgDragC_0005 ;
externalref _XmConst char *_XmMsgDragC_0006 ;
externalref _XmConst char *_XmMsgDropSMgr_0001 ;
externalref _XmConst char *_XmMsgDropSMgr_0002 ;
externalref _XmConst char *_XmMsgDropSMgr_0003 ;
externalref _XmConst char *_XmMsgDropSMgr_0004 ;
externalref _XmConst char *_XmMsgDropSMgr_0005 ;
externalref _XmConst char *_XmMsgDropSMgr_0006 ;
externalref _XmConst char *_XmMsgDropSMgr_0007 ;
externalref _XmConst char *_XmMsgDropSMgr_0008 ;
externalref _XmConst char *_XmMsgDropSMgr_0009 ;
externalref _XmConst char *_XmMsgDropSMgr_0010 ;
externalref _XmConst char *_XmMsgDisplay_0001 ;
externalref _XmConst char *_XmMsgDisplay_0002 ;
externalref _XmConst char *_XmMsgDisplay_0003 ;
externalref _XmConst char *_XmMsgRepType_0000 ;
externalref _XmConst char *_XmMsgRepType_0001 ;
externalref _XmConst char *_XmMsgRepType_0002 ;
externalref _XmConst char *_XmMsgMotif_0000 ;
externalref _XmConst char *_XmMsgMotif_0001 ;
externalref _XmConst char *_XmMsgXmRenderT_0000 ;
externalref _XmConst char *_XmMsgXmRenderT_0001 ;
externalref _XmConst char *_XmMsgXmRenderT_0002 ;
externalref _XmConst char *_XmMsgXmRenderT_0003 ;
externalref _XmConst char *_XmMsgXmRenderT_0004 ;
externalref _XmConst char *_XmMsgXmRenderT_0005 ;
externalref _XmConst char *_XmMsgXmString_0000 ; 
externalref _XmConst char *_XmMsgXmTabList_0000 ; 
externalref _XmConst char *_XmMsgScrollFrameT_0000 ;
externalref _XmConst char *_XmMsgScrollFrameT_0001 ;
externalref _XmConst char *_XmMsgTransfer_0000 ;
externalref _XmConst char *_XmMsgTransfer_0001 ;
externalref _XmConst char *_XmMsgTransfer_0002 ;
externalref _XmConst char *_XmMsgTransfer_0003 ;
externalref _XmConst char *_XmMsgTransfer_0004 ;
externalref _XmConst char *_XmMsgTransfer_0005 ;
externalref _XmConst char *_XmMsgTransfer_0006 ;
externalref _XmConst char *_XmMsgTransfer_0007 ;
externalref _XmConst char *_XmMsgVaSimple_0000 ;
externalref _XmConst char *_XmMsgVaSimple_0001 ;
externalref _XmConst char *_XmMsgVaSimple_0002 ;
externalref _XmConst char *_XmMsgXmSelect_0000 ;
externalref _XmConst char *_XmMsgXmSelect_0001 ;
externalref _XmConst char *_XmMsgXmSelect_0002 ;
externalref _XmConst char *_XmMsgPixConv_0000 ;

externalref _XmConst char *XME_WARNING;

#include "XmMsgI.h"

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmMessagesI_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
