/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: Notebook.h,v $
 * Revision 1.1.7.1  1994/04/19  18:21:18  knight
 * 	Fix for CR5906 and CR6652 - code cleanup.
 * 	[1994/04/19  16:40:15  knight]
 *
 * 	Fixes for CR6652.
 *
 * Revision 1.1.5.3  1993/11/09  21:05:31  shobana
 * 	fixed CR 6627 - moved callback reasons to Xm.h
 * 	[1993/11/09  21:04:05  shobana]
 * 
 * Revision 1.1.5.2  1993/11/01  21:48:12  motifibm
 * 	IBM Beta submission
 * 	[1993/11/01  21:47:20  motifibm]
 * 
 * Revision 1.1.5.1  1993/10/15  13:55:47  deblois
 * 	Yet another drop from Anthony.  Includes fixes for CRs:
 * 	5826, 5911, 5916, 5920, 5921, 5922, 5940, 5941, 5960, and 5961.
 * 	[1993/10/15  13:50:33  deblois]
 * 
 * Revision 1.1.2.7  1993/07/23  02:57:33  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:26:46  yak]
 * 
 * Revision 1.1.2.6  1993/06/30  15:31:58  rgcote
 * 	Moved the widget specific resource defines to XmStrDefs.
 * 	[1993/06/30  15:25:59  rgcote]
 * 
 * Revision 1.1.2.5  1993/06/15  15:43:45  shobana
 * 	Fix from Anthony Moore for CR 5859; correct spelling for
 * 	XmNpageChangedCallback
 * 	[1993/06/15  15:43:26  shobana]
 * 
 * Revision 1.1.2.4  1993/06/03  15:59:59  shobana
 * 	Fix for Cr 5813 -- added declaration for XmCreateNotebook
 * 	[1993/06/03  15:59:20  shobana]
 * 
 * Revision 1.1.2.3  1993/05/06  14:04:01  motifibm
 * 	Color enablement.
 * 	[1993/05/06  14:03:01  motifibm]
 * 
 * Revision 1.1.2.2  1993/04/05  23:55:12  motifibm
 * 	IBM Drop 3 - Anthony
 * 	[1993/04/05  23:51:56  motifibm]
 * 
 * 	     IBM Drop 3 - Anthony
 * 	[1993/04/05  21:16:42  motifibm]
 * 
 * $EndLog$
 */

#ifndef _XmNotebook_h
#define _XmNotebook_h

#include <Xm/Xm.h>

#ifdef __cplusplus
extern "C" {
#endif

externalref WidgetClass xmNotebookWidgetClass;

typedef struct _XmNotebookClassRec *XmNotebookWidgetClass;
typedef struct _XmNotebookRec *XmNotebookWidget;


/************************************************************************
 *  Notebook Defines
 ************************************************************************/

/* XmNotebookPageStatus */
typedef enum
{
    XmPAGE_FOUND,		/* page widget found */
    XmPAGE_INVALID,		/* page number out of the range */
    XmPAGE_EMPTY,		/* no page widget found */
    XmPAGE_DUPLICATED		/* there are more than one page widgets */
} XmNotebookPageStatus;

/* Notebook page information structure */
typedef struct
{
    int         page_number;
    Widget      page_widget;
    Widget	status_area_widget;
    Widget      major_tab_widget;
    Widget	minor_tab_widget;
} XmNotebookPageInfo;


/************************************************************************
 *  Public Functions
 ************************************************************************/

#ifndef XmIsNotebook
#define XmIsNotebook(w) XtIsSubclass((w), xmNotebookWidgetClass)
#endif

#ifdef _NO_PROTO
extern Widget XmCreateNotebook();
extern XmNotebookPageStatus XmNotebookGetPageInfo();

#else /* _NO_PROTO */
extern Widget XmCreateNotebook(
			Widget		parent,
			String		name,
			ArgList		arglist,
			Cardinal	argcount);

extern XmNotebookPageStatus XmNotebookGetPageInfo(
			Widget notebook,
			int page_number,
			XmNotebookPageInfo *page_info) ;
#endif /* _NO_PROTO */


#ifdef __cplusplus
}
#endif

#endif /* _XmNotebook_h  */

