/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: PrimitiveP.h,v $
 * Revision 1.5.10.2  1994/03/10  21:53:41  drk
 * 	Remove unsupported #ifdefs.
 * 	[1994/03/10  21:47:45  drk]
 *
 * Revision 1.5.10.1  1994/03/04  22:25:11  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  21:58:48  drk]
 * 
 * Revision 1.5.8.2  1993/09/01  21:51:18  inca
 * 	Added layoutDirection to Manager, Primitive & Gadget, added a layout trait
 * 	[1993/08/31  20:49:03  inca]
 * 
 * Revision 1.5.6.7  1993/07/23  02:58:24  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:27:50  yak]
 * 
 * Revision 1.5.6.6  1993/05/04  21:32:02  daniel
 * 	Work on DifferentBackground and Primitive redisplay
 * 	[1993/05/04  21:29:08  daniel]
 * 
 * Revision 1.5.6.5  1993/04/07  21:28:40  motifics
 * 	Ctrl-Button1 additions for CUA compliance
 * 	[1993/04/07  21:24:28  motifics]
 * 
 * Revision 1.5.6.4  1993/03/15  20:06:45  drand
 * 	Changed Trait mechanism to use XContext manager.
 * 	[1993/03/15  20:05:02  drand]
 * 
 * Revision 1.5.6.3  1992/10/29  23:07:29  drand
 * 	Added popupHandlerCallback field to XmPrimitive instance
 * 	[1992/10/29  23:04:54  drand]
 * 
 * Revision 1.5.6.2  1992/09/17  20:23:38  drand
 * 	Added traits field to instance record.
 * 	[1992/09/17  20:11:24  drand]
 * 
 * Revision 1.5.4.2  1992/07/31  14:04:51  daniel
 * 	clean up of Manager.c
 * 	[1992/07/31  14:03:45  daniel]
 * 
 * Revision 1.5.2.2  1992/03/27  21:58:47  yak
 * 	Restored HP Copyright, which was lost during the conversion to ODE.
 * 	[1992/03/27  21:58:23  yak]
 * 
 * Revision 1.5  1992/03/13  16:40:24  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/* $RCSfile: PrimitiveP.h,v $ $Revision: 1.5.10.2 $ $Date: 1994/03/10 21:53:41 $ */
/* (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */
/* (c) Copyright 1989, 1990 DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS. */
/* (c) Copyright 1988 MASSACHUSETTS INSTITUTE OF TECHNOLOGY  */
#ifndef _XmPrimitiveP_h
#define _XmPrimitiveP_h

#ifndef _XmNO_BC_INCL
#define _XmNO_BC_INCL
#endif

#include <Xm/XmP.h>

#ifdef __cplusplus
extern "C" {
#endif


/* Access Macros */

#define Prim_ShadowThickness(w) (((XmPrimitiveWidget)(w))->primitive.shadow_thickness)
#define Prim_HaveTraversal(w) (((XmPrimitiveWidget)(w))->primitive.have_traversal)

#define PCEPTR(wc)  ((XmPrimitiveClassExt *)(&(((XmPrimitiveWidgetClass)(wc))->primitive_class.extension)))
#define _XmGetPrimitiveClassExtPtr(wc, owner) \
  ((*PCEPTR(wc) && (((*PCEPTR(wc))->record_type) == owner))\
   ? PCEPTR(wc) \
   :((XmPrimitiveClassExt *) _XmGetClassExtensionPtr(((XmGenericClassExt *)PCEPTR(wc)), owner)))


#define XmPrimitiveClassExtVersion 1L


typedef struct _XmPrimitiveClassExtRec{
    XtPointer           next_extension;
    XrmQuark            record_type;
    long                version;
    Cardinal            record_size;
    XmWidgetBaselineProc widget_baseline;
    XmWidgetDisplayRectProc  widget_display_rect;
    XmWidgetMarginsProc widget_margins;
} XmPrimitiveClassExtRec, *XmPrimitiveClassExt;

typedef struct _XmPrimitiveClassPart
{
   XtWidgetProc         border_highlight;
   XtWidgetProc         border_unhighlight;
   String               translations;
   XtActionProc         arm_and_activate;
   XmSyntheticResource * syn_resources;   
   int                  num_syn_resources;   
   XtPointer            extension;
} XmPrimitiveClassPart;

typedef struct _XmPrimitiveClassRec
{
    CoreClassPart        core_class;
    XmPrimitiveClassPart primitive_class;
} XmPrimitiveClassRec;

externalref XmPrimitiveClassRec xmPrimitiveClassRec;


/*  The Primitive instance record  */

typedef struct _XmPrimitivePart
{
   Pixel   foreground;

   Dimension   shadow_thickness;
   Pixel   top_shadow_color;
   Pixmap  top_shadow_pixmap;
   Pixel   bottom_shadow_color;
   Pixmap  bottom_shadow_pixmap;

   Dimension   highlight_thickness;
   Pixel   highlight_color;
   Pixmap  highlight_pixmap;

   XtCallbackList help_callback;
   XtPointer      user_data;

   Boolean traversal_on;
   Boolean highlight_on_enter;
   Boolean have_traversal;

   unsigned char unit_type;
   XmNavigationType navigation_type;

   Boolean highlight_drawn;
   Boolean highlighted;

   GC      highlight_GC;
   GC      top_shadow_GC;
   GC      bottom_shadow_GC;

   XtCallbackList   convert_callback;       /* Selection convert callback */
   XtCallbackList   popup_handler_callback;

   XmDirection layout_direction;
} XmPrimitivePart;

typedef struct _XmPrimitiveRec
{
   CorePart        core;
   XmPrimitivePart primitive;
} XmPrimitiveRec;


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmPrimitiveP_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
