/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: RepTypeI.h,v $
 * Revision 1.6.90.2  1994/07/07  21:08:18  knight
 * 	Fix CR 9560: Added ContainerExpandOrCollapse() action and
 * 	RedirectTraversal() trait.
 * 	[1994/07/07  18:03:42  knight]
 *
 * Revision 1.6.90.1  1994/06/20  16:09:47  knight
 * 	Removed unused XmRID_NOTEBOOK_SHOW_PAGE_ACTION_PARAMS reference.
 * 	[1994/06/20  16:03:42  knight]
 * 
 * Revision 1.6.88.8  1994/04/19  21:04:27  daniel
 * 	fix for 8689: UnitType conversion loops
 * 	[1994/04/19  17:04:20  daniel]
 * 
 * Revision 1.6.88.7  1994/03/25  23:40:42  drk
 * 	Hide _Xm routines.
 * 	[1994/03/25  23:40:30  drk]
 * 
 * Revision 1.6.88.6  1994/03/25  16:33:58  drand
 * 	Finish adding XmREnableBtn1Transfer reptype
 * 	[1994/03/25  16:33:21  drand]
 * 
 * Revision 1.6.88.5  1994/03/17  22:21:56  daniel
 * 	 implement new sliderVisual/Mark support
 * 	[1994/03/17  21:54:20  daniel]
 * 
 * Revision 1.6.88.4  1994/03/07  16:57:44  daniel
 * 	add Default button emphasis
 * 	[1994/03/07  16:39:49  daniel]
 * 
 * Revision 1.6.88.2  1994/03/07  15:33:33  daniel
 * 	pathmode work
 * 	[1994/03/06  20:58:28  daniel]
 * 
 * Revision 1.6.88.1  1993/12/29  18:19:04  daniel
 * 	rework the conversion modules
 * 	[1993/12/29  18:16:57  daniel]
 * 
 * Revision 1.6.4.14  1993/11/11  22:48:01  drk
 * 	CR 6901: Have ComboBox give BeginData and EndData to the list.
 * 	[1993/11/11  19:47:23  drk]
 * 
 * Revision 1.6.4.13  1993/11/10  16:56:53  daniel
 * 	remove , that makes sgi unhappy
 * 	[1993/11/10  16:56:42  daniel]
 * 
 * Revision 1.6.4.12  1993/11/08  23:38:42  rgcote
 * 	Added reptypes to handle action parameters for Text,
 * 	TextField and PanedWindow
 * 	[1993/11/08  23:34:26  rgcote]
 * 
 * Revision 1.6.4.11  1993/11/05  23:17:26  rgcote
 * 	Added reptypes that are used to handle action parameters for
 * 	ComboBox, Container and Notebook.
 * 	[1993/11/05  23:15:00  rgcote]
 * 
 * Revision 1.6.4.10  1993/11/04  22:53:31  rgcote
 * 	Merged with changes from 1.6.4.9
 * 	[1993/11/04  22:53:10  rgcote]
 * 
 * 	Added reptype id's for the new reptypes that handle action
 * 	parameters for actions of Command, SelectionBox and FileSelectionBox
 * 	[1993/11/04  22:41:46  rgcote]
 * 
 * Revision 1.6.4.9  1993/11/03  00:52:31  daniel
 * 	fix sgi enum syntax error
 * 	[1993/11/03  00:52:13  daniel]
 * 
 * Revision 1.6.4.8  1993/11/01  22:22:45  daniel
 * 	move dynamic VendorSE reptype as static
 * 	[1993/11/01  22:19:23  daniel]
 * 
 * 	move dynamic VendorSE reptype as static
 * 	[1993/11/01  22:16:51  daniel]
 * 
 * 	move dynamic VendorSE reptype as static
 * 
 * Revision 1.6.4.7  1993/10/29  21:37:19  drand
 * 	New SpinB Drop,  also moved RepType and Accelerators to proper destinations
 * 	[1993/10/29  21:36:19  drand]
 * 
 * Revision 1.6.4.6  1993/10/28  04:12:31  daniel
 * 	post code review implementation
 * 	[1993/10/28  04:12:08  daniel]
 * 
 * Revision 1.6.4.5  1993/10/22  19:41:20  jwiele
 * 	Removed unnecessary struct declarations as part of the rewrite of
 * 	RepType.c
 * 	[1993/10/22  19:26:24  jwiele]
 * 
 * Revision 1.6.4.4  1993/10/01  21:10:22  daniel
 * 	Diff from Anthony for new design
 * 	[1993/10/01  21:08:49  daniel]
 * 
 * Revision 1.6.4.3  1993/09/24  17:18:58  daniel
 * 	incorporate anthony diff
 * 	[1993/09/24  17:04:53  daniel]
 * 
 * Revision 1.6.4.2  1993/09/14  23:13:55  motifibm
 * 	IBM Drop 9/14
 * 	[1993/09/14  23:11:08  motifibm]
 * 
 * Revision 1.6.2.26  1993/07/23  02:59:41  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:30:09  yak]
 * 
 * Revision 1.6.2.25  1993/06/28  23:23:45  inca
 * 	Oops - slight mistake
 * 	[1993/06/28  23:21:53  inca]
 * 
 * Revision 1.6.2.24  1993/06/28  23:08:37  inca
 * 	Cleaning up Right-to-left layout
 * 	[1993/06/28  20:52:09  inca]
 * 
 * Revision 1.6.2.23  1993/06/28  21:56:43  rgcote
 * 	Fixed a name ordering problem.
 * 	[1993/06/28  21:53:18  rgcote]
 * 
 * Revision 1.6.2.22  1993/06/25  19:54:43  meeks
 * 	2.0 4.2.2: Fixed reversed LINE_TYPE and LOAD_MODEL enums.
 * 	[1993/06/25  19:27:43  meeks]
 * 
 * Revision 1.6.2.21  1993/06/17  19:19:39  inca
 * 	Direction needs to be a mapped type
 * 	[1993/06/17  13:56:07  inca]
 * 
 * Revision 1.6.2.20  1993/06/08  23:15:09  meeks
 * 	2.0 4.2.2: Added/Modified FontType, LoadModel and LineType rep types.
 * 	[1993/06/08  22:37:41  meeks]
 * 
 * Revision 1.6.2.19  1993/06/01  14:36:52  daniel
 * 	add bitmapconversion support
 * 	[1993/06/01  14:31:10  daniel]
 * 
 * Revision 1.6.2.18  1993/05/28  20:57:24  motifics
 * 	ToggleButton visual and indeterminate state changes
 * 	[1993/05/28  20:54:19  motifics]
 * 
 * Revision 1.6.2.17  1993/05/19  20:15:06  meeks
 * 	2.0 4.2.2: Added LoadModelNames.
 * 	[1993/05/19  20:05:39  meeks]
 * 
 * Revision 1.6.2.16  1993/04/30  17:39:53  daniel
 * 	add motifVersion and enableWarp
 * 	[1993/04/30  17:38:26  daniel]
 * 
 * Revision 1.6.2.15  1993/04/26  20:04:11  drk
 * 	Fix botched merge.
 * 	[1993/04/26  20:03:51  drk]
 * 
 * Revision 1.6.2.14  1993/04/26  19:59:46  drk
 * 	Added XmInputPolicy converter.
 * 	[1993/04/26  19:57:21  drk]
 * 
 * Revision 1.6.2.13  1993/04/22  21:52:00  rgcote
 * 	Added XmRID_COMBO_BOX_TYPE and XmRID_MATCH_BEHAVIOR
 * 	[1993/04/20  20:36:32  rgcote]
 * 
 * Revision 1.6.2.12  1993/04/13  20:55:41  motifics
 * 	Added XmRID_SELECTION_MODE for XmList
 * 	[1993/04/13  20:52:17  motifics]
 * 
 * Revision 1.6.2.11  1993/04/06  23:33:58  motifibm
 * 	Out of order - fixed (Anthony)
 * 	[1993/04/06  23:33:32  motifibm]
 * 
 * Revision 1.6.2.10  1993/03/16  21:04:39  daniel
 * 	fix a problem with RID_DIRECTION
 * 	[1993/03/16  21:04:13  daniel]
 * 
 * Revision 1.6.2.9  1993/03/16  19:58:51  motifdec
 * 	DEC checkin - RtoL layout
 * 	[1993/03/15  22:10:05  motifdec]
 * 
 * Revision 1.6.2.8  1993/03/11  21:50:26  motifibm
 * 	IBM Code Drop 2 - Anthony
 * 	[1993/03/11  17:49:06  motifibm]
 * 
 * Revision 1.6.2.7  1993/02/26  16:38:48  daniel
 * 	check in autodrag
 * 	[1993/02/24  22:15:39  daniel]
 * 
 * Revision 1.6.2.6  1993/02/18  20:52:17  qauser
 * 	Initial drop from Anthony
 * 	[1993/02/18  18:38:37  qauser]
 * 
 * Revision 1.6.2.5  1993/02/04  20:50:34  daniel
 * 	 put in the childType basics
 * 	[1993/02/04  20:01:13  daniel]
 * 
 * Revision 1.6.2.4  1993/01/31  04:12:44  daniel
 * 	check point thermo scroll + thumb mark
 * 	[1993/01/31  04:02:47  daniel]
 * 
 * Revision 1.6.2.3  1992/10/13  18:00:06  daniel
 * 	More enhancement work
 * 	[1992/10/13  17:58:41  daniel]
 * 
 * Revision 1.6.2.2  1992/10/05  21:43:39  daniel
 * 	thermo + showvalue work
 * 	[1992/10/05  21:29:30  daniel]
 * 
 * Revision 1.6  1992/03/13  16:42:27  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/* $RCSfile: RepTypeI.h,v $ $Revision: 1.6.90.2 $ $Date: 1994/07/07 21:08:18 $ */
/* (c) Copyright 1991, 1992 HEWLETT-PACKARD COMPANY */
#ifndef _XmRepTypeI_h
#define _XmRepTypeI_h

#include <Xm/RepType.h>
#include "XmI.h"

#ifdef __cplusplus
extern "C" {
#endif

/* We need a name to refer to the original unit type converter. 
   This name is used as a to_type when installing a duplicate of the 
   unit type converter in RepType.c and it is used again as a to_type 
   when calling XtConvertAndStore in ResConvert.c when implementing 
   XmCvtStringToUnitType (call to the original converter) */
#define REAL_UNIT_TYPE_NAME "RealUnitType"

/*  The following enumerations of representation type identification
 *   numbers have a one-to-one positional mapping to the corresponding
 *   representation type record in the static rep type lists.
 *   The two static lists are in alphabetical order, as required by 
 *   the coding of the XmRepTypeGetId routine. ('_' is the exception in
 *   this enum, the XmR names gives the order, really)
 */

enum {
	XmRID_ALIGNMENT,	                
	XmRID_ANIMATION_STYLE,
	XmRID_ARROW_DIRECTION,			
	XmRID_ARROW_LAYOUT,
	XmRID_ARROW_SENSITIVITY,
	XmRID_ATTACHMENT,
	XmRID_AUDIBLE_WARNING,			
	XmRID_AUTO_DRAG_MODEL,
	XmRID_AUTOMATIC_SELECTION,
	XmRID_BINDING_TYPE,			
	XmRID_BITMAP_CONVERSION_MODEL,
	XmRID_BLEND_MODEL,
	XmRID_CHILD_HORIZONTAL_ALIGNMENT,	
	XmRID_CHILD_PLACEMENT,
	XmRID_CHILD_TYPE,			
	XmRID_CHILD_VERTICAL_ALIGNMENT,
	XmRID_COMBO_BOX_LIST_ACTION_ACTION_PARAMS,
	XmRID_COMBO_BOX_TYPE,			
	XmRID_COMMAND_SELECTION_BOX_UP_OR_DOWN_ACTION_PARAMS,
	XmRID_COMMAND_WINDOW_LOCATION,
	XmRID_CONTAINER_CURSOR_ACTION_PARAMS,
	XmRID_CONTAINER_EXPAND_OR_COLLAPSE_ACTION_PARAMS,
	XmRID_CONTAINER_START_TRANSFER_ACTION_PARAMS,
	XmRID_DEFAULT_BUTTON_EMPHASIS,
	XmRID_DEFAULT_BUTTON_TYPE,
	XmRID_DELETE_RESPONSE,
	XmRID_DIALOG_STYLE,
	XmRID_DIALOG_TYPE,
	XmRID_DIRECTION,			
	XmRID_DRAG_INITIATOR_PROTOCOL_STYLE,
	XmRID_DRAG_RECEIVER_PROTOCOL_STYLE,
	XmRID_DROP_SITE_ACTIVITY,		
	XmRID_DROP_SITE_TYPE,
	XmRID_EDIT_MODE,
	XmRID_ENABLE_BTN1_TRANSFER,
	XmRID_ENABLE_WARP,			
	XmRID_ENTRY_VIEW_TYPE,
	XmRID_FILE_FILTER_STYLE,
	XmRID_FILE_SELECTION_BOX_UP_OR_DOWN_ACTION_PARAMS,
	XmRID_FILE_TYPE_MASK,
	XmRID_FONT_TYPE,
	XmRID_ICON_ATTACHMENT,
	XmRID_INDICATOR_ON,
	XmRID_INDICATOR_TYPE,
	XmRID_INPUT_POLICY,
	XmRID_KEYBOARD_FOCUS_POLICY,
	XmRID_LABEL_TYPE,
	XmRID_LAYOUT_TYPE,                      
	XmRID_LINE_STYLE,
	XmRID_LINE_TYPE,			
	XmRID_LIST_SIZE_POLICY,			
	XmRID_LOAD_MODEL,
	XmRID_MATCH_BEHAVIOR,
	XmRID_MULTI_CLICK,
	XmRID_NAVIGATION_TYPE,			
	XmRID_NB_CHILD_TYPE,
	XmRID_NOTEBOOK_TRAVERSE_TAB_ACTION_PARAMS,
	XmRID_ORIENTATION,
	XmRID_OUTLINE_BUTTON_POLICY,		
	XmRID_OUTLINE_STATE,
	XmRID_PACKING,				
	XmRID_PANED_WINDOW_SASH_ACTION_PARAMS,
	XmRID_PANED_WINDOW_SASH_DIRECTION_ACTION_PARAMS,
	XmRID_PANED_WINDOW_SASH_INCREMENT_ACTION_PARAMS,
	XmRID_PATH_MODE,
	XmRID_PRIMARY_OWNERSHIP,
	XmRID_PROCESSING_DIRECTION,
	XmRID_RESIZE_POLICY,			
	XmRID_ROW_COLUMN_TYPE,
	XmRID_SCROLL_BAR_DISPLAY_POLICY,
	XmRID_SCROLL_BAR_INCREMENT_DOWN_OR_RIGHT_ACTION_PARAMS,
	XmRID_SCROLL_BAR_INCREMENT_UP_OR_LEFT_ACTION_PARAMS,
	XmRID_SCROLL_BAR_PAGE_DOWN_OR_RIGHT_ACTION_PARAMS,
	XmRID_SCROLL_BAR_PAGE_UP_OR_LEFT_ACTION_PARAMS,
	XmRID_SCROLL_BAR_PLACEMENT,
	XmRID_SCROLLED_WINDOW_CHILD_TYPE,
	XmRID_SCROLLING_POLICY,
	XmRID_SELECTION_BOX_UP_OR_DOWN_ACTION_PARAMS,
	XmRID_SELECTION_MODE,
	XmRID_SELECTION_POLICY,			
	XmRID_SELECTION_TECHNIQUE,
	XmRID_SELECTION_TYPE,			
	XmRID_SEPARATOR_TYPE,
	XmRID_SET,
	XmRID_SHADOW_TYPE,
	XmRID_SHOW_ARROWS,
	XmRID_SHOW_VALUE,
	XmRID_SLIDER_MARK,                    
	XmRID_SLIDER_VISUAL,                    
	XmRID_SLIDING_MODE,
	XmRID_SPATIAL_INCLUDE_MODEL,		
	XmRID_SPATIAL_RESIZE_MODEL,
	XmRID_SPATIAL_SNAP_MODEL,		
	XmRID_SPATIAL_STYLE,
	XmRID_SPINBOX_CHILD_TYPE,
	XmRID_STRING_DIRECTION,
	XmRID_TEAR_OFF_MODEL,
	XmRID_TEXT_EXTEND_MOVEMENT_ACTION_PARAMS,
	XmRID_TEXTFIELD_DIRECTION_ACTION_PARAMS,
	XmRID_TEXTFIELD_EXTEND_MOVEMENT_ACTION_PARAMS,
	XmRID_TEXT_HORIZONTAL_DIRECTION_ACTION_PARAMS,
	XmRID_TEXT_VERTICAL_DIRECTION_ACTION_PARAMS,
	XmRID_TOGGLE_MODE,
	XmRID_UNIT_TYPE,			
	XmRID_UNPOST_BEHAVIOR,
	XmRID_VERTICAL_ALIGNMENT,		
	XmRID_VIEW_TYPE,
	XmRID_VISUAL_EMPHASIS,			
	XmRID_VISUAL_POLICY,
	XmRID_WHICH_BUTTON
	} ;


/********    Private Function Declarations    ********/
#ifdef _NO_PROTO

extern void _XmRepTypeInstallConverters() ;
extern Boolean _XmConvertActionParamToRepTypeId() ;

#else

extern void _XmRepTypeInstallConverters( void ) ;
extern Boolean _XmConvertActionParamToRepTypeId(Widget widget,
						XmRepTypeId rep_type_id,
						char *parameter,
						Boolean can_be_numeric,
						int *result) ;

#endif /* _NO_PROTO */
/********    End Private Function Declarations    ********/



#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmRepTypeI_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
