/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: RowColumnI.h,v $
 * Revision 1.1.8.1  1994/06/08  02:18:07  daniel
 * 	fix 7994: clean up items from Code review
 * 	[1994/06/08  02:17:46  daniel]
 *
 * Revision 1.1.6.2  1994/03/15  00:05:43  inca
 * 	Initial message catalog implementation
 * 	[1994/03/14  20:10:51  inca]
 * 
 * Revision 1.1.6.1  1994/03/04  22:25:59  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  21:59:36  drk]
 * 
 * Revision 1.1.4.2  1993/09/09  14:37:03  drand
 * 	Minor changes.
 * 	[1993/09/09  14:33:38  drand]
 * 
 * Revision 1.1.2.7  1993/07/23  03:00:08  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:31:00  yak]
 * 
 * Revision 1.1.2.6  1993/06/26  00:07:56  rgcote
 * 	Fixed the IsRadio macro to make compiler warnings go away.
 * 	[1993/06/26  00:07:16  rgcote]
 * 
 * Revision 1.1.2.5  1992/12/07  19:18:48  gilles
 * 	Add 'extern "C" { ... }' for compilation in C++
 * 	[1992/12/07  19:17:34  gilles]
 * 
 * Revision 1.1.2.4  1992/09/24  15:46:57  daniel
 * 	more remodularization of RowColumn
 * 	[1992/09/24  15:05:16  daniel]
 * 
 * Revision 1.1.2.3  1992/09/15  18:12:37  drand
 * 	Resubmission
 * 	[1992/09/15  18:11:13  drand]
 * 
 * Revision 1.1.2.2  1992/09/14  19:08:29  drand
 * 	Initial coding - contains common include information,  needed
 * 	with the separation of RowColumn.c into separate parts.
 * 	[1992/09/14  18:58:52  drand]
 * 
 * $EndLog$
 */

#ifdef REV_INFO
#ifndef lint
static char *rcsidRowColumnIH = "$Header: /u1/rcs/motif/lib/Xm/RowColumnI.h,v 1.1.8.1 1994/06/08 02:18:07 daniel Exp $";
#endif
#endif

#ifndef _XmRowColumnI_h
#define _XmRowColumnI_h

#include <Xm/RowColumnP.h>

#ifdef __cplusplus
extern "C" {
#endif

#define UNDEFINED_TYPE -1
#define POST_TIME_OUT	3 /* sec */ * 1000

#define Double(x)       ((x) << 1)
#define Half(x)         ((x) >> 1)

#define IsSensitive(r)      XtIsSensitive(r)
#define IsManaged(w)        XtIsManaged(w)
#define IsNull(p)       ((p) == NULL)

#define PackTight(m)        (RC_Packing (m) == XmPACK_TIGHT)
#define PackColumn(m)       (RC_Packing (m) == XmPACK_COLUMN)
#define PackNone(m)         (RC_Packing (m) == XmPACK_NONE)

#define Asking(i)       ((i) == 0)
#define IsVertical(m)   \
       (((XmRowColumnWidget) (m))->row_column.orientation == XmVERTICAL)
#define IsHorizontal(m) \
       (((XmRowColumnWidget) (m))->row_column.orientation == XmHORIZONTAL)
#define IsAligned(m)    \
       (((XmRowColumnWidget) (m))->row_column.do_alignment)

#define IsPopup(m)     \
    (((XmRowColumnWidget) (m))->row_column.type == XmMENU_POPUP)
#define IsPulldown(m)  \
    (((XmRowColumnWidget) (m))->row_column.type == XmMENU_PULLDOWN)
#define IsOption(m)    \
    (((XmRowColumnWidget) (m))->row_column.type == XmMENU_OPTION)
#define IsBar(m)       \
    (((XmRowColumnWidget) (m))->row_column.type == XmMENU_BAR)
#define IsWorkArea(m)  \
    (((XmRowColumnWidget) (m))->row_column.type == XmWORK_AREA)
#define IsRadio(m)     \
    ((((XmRowColumnWidget) (m))->row_column.type == XmWORK_AREA) && \
         ((((XmRowColumnWidget) (m))->row_column.radio)))
#define IsHelp(m,w)     ((w) == RC_HelpPb (m))

#define WasManaged(w)  \
    (((XmRowColumnConstraintRec *) ((w)->core.constraints))-> \
     row_column.was_managed)

#define SavedMarginTop(w)  \
    (((XmRowColumnConstraintRec *) ((w)->core.constraints))-> \
     row_column.margin_top)

#define SavedMarginBottom(w)  \
    (((XmRowColumnConstraintRec *) ((w)->core.constraints))-> \
     row_column.margin_bottom)

#define SavedBaseline(w)  \
    (((XmRowColumnConstraintRec *) ((w)->core.constraints))-> \
     row_column.baseline)

#define BX(b)           ((b)->x)
#define BY(b)           ((b)->y)
#define BWidth(b)       ((b)->width)
#define BHeight(b)      ((b)->height)
#define BBorder(b)      ((b)->border_width)

#define SetPosition(b,x,y)  { BX (b) = x;  BY (b) = y; }

#define ChangeMargin(margin,new_w,sum)  {  \
    if ((margin) != new_w)        \
    {               \
        sum += new_w - (margin);  \
        (margin) = new_w;     \
    }\
}

#define ChangeMarginDouble(margin,new_w,sum) {   \
    if ((margin) != new_w)        \
    {               \
        sum += 2* (new_w - (margin));  \
        (margin) = new_w;     \
    }\
}

#define ForAllChildren(m, i, q)     \
    for (i = 0, q = m->composite.children; \
     i < m->composite.num_children;     \
     i++, q++)

#define ForManagedChildren(m, i, q)  \
    for (i = 0, q = m->composite.children; \
     i < m->composite.num_children;     \
     i++, q++)          \
                    \
    if (XtIsManaged(*q))

#define AlignmentBaselineTop(m) \
(((XmRowColumnWidget) (m))->row_column.entry_vertical_alignment == XmALIGNMENT_BASELINE_TOP)
#define AlignmentBaselineBottom(m) \
(((XmRowColumnWidget) (m))->row_column.entry_vertical_alignment == XmALIGNMENT_BASELINE_BOTTOM)
#define AlignmentCenter(m) \
(((XmRowColumnWidget) (m))->row_column.entry_vertical_alignment == XmALIGNMENT_CENTER)
#define AlignmentTop(m) \
(((XmRowColumnWidget) (m))->row_column.entry_vertical_alignment == XmALIGNMENT_CONTENTS_TOP)
#define AlignmentBottom(m) \
(((XmRowColumnWidget) (m))->row_column.entry_vertical_alignment == XmALIGNMENT_CONTENTS_BOTTOM)

/* Warning Messages */
#define BadWidthSVMsg			_XmMMsgRowColumn_0000
#define BadHeightSVMsg			_XmMMsgRowColumn_0001
#define BadPopupHelpMsg 		_XmMMsgRowColumn_0002
#define BadPulldownHelpMsg		_XmMMsgRowColumn_0003
#define BadOptionHelpMsg		_XmMMsgRowColumn_0004
#define BadWorkAreaHelpMsg		_XmMMsgRowColumn_0005
#define BadTypeMsg			_XmMMsgRowColumn_0006
#define BadTypeParentMsg		_XmMMsgRowColumn_0007
#define BadTypeSVMsg			_XmMMsgRowColumn_0008
#define BadOrientationMsg		_XmMMsgRowColumn_0009
#define BadOrientationSVMsg		_XmMMsgRowColumn_0010
#define BadPackingMsg			_XmMMsgRowColumn_0011
#define BadPackingSVMsg			_XmMMsgRowColumn_0012
#define BadAlignmentMsg			_XmMMsgRowColumn_0013
#define BadAlignmentSVMsg		_XmMMsgRowColumn_0014
#define BadMenuBarHomogenousSVMsg	_XmMMsgRowColumn_0015
#define BadMenuBarEntryClassSVMsg	_XmMMsgRowColumn_0016
#define BadPulldownWhichButtonSVMsg	_XmMMsgRowColumn_0017
#define BadPulldownMenuPostSVMsg	_XmMMsgRowColumn_0018
#define BadMenuPostMsg			_XmMMsgRowColumn_0019
#define BadShadowThicknessSVMsg		_XmMMsgRowColumn_0020
#define WrongMenuChildMsg		_XmMMsgRowColumn_0022
#define WrongChildMsg			_XmMMsgRowColumn_0023
#define BadOptionIsHomogeneousSVMsg	_XmMMsgRowColumn_0025
#define TearOffSharedMenupaneMsg	_XmMMsgRowColumn_0026
#define BadMnemonicCharMsg		_XmMMsgRowColumn_0027

#define RCIndex(w)    (((XmRowColumnConstraintRec *)(w)->core.constraints)\
                       ->row_column.position_index)
  

/********    Private Function Declarations    ********/
#ifdef _NO_PROTO

extern void _XmRC_KeyboardInputHandler();
extern void _XmPostPopupMenu() ;
extern void _XmAllowAcceleratedInsensitiveUnmanagedMenuItems();
extern void _XmCallRowColumnMapCallback() ;
extern void _XmCallRowColumnUnmapCallback() ;
extern void _XmRC_RemoveFromPostFromListOnDestroyCB () ;
extern void _XmRC_CheckAndSetOptionCascade() ;

#else

extern void _XmRC_KeyboardInputHandler(
				       Widget reportingWidget,
				       XtPointer data,
				       XEvent *event,
				       Boolean *cont );
extern void _XmAllowAcceleratedInsensitiveUnmanagedMenuItems(
							     Widget wid,
#if NeedWidePrototypes
							     int allowed);
#else
							     Boolean allowed);
#endif /* NeedWidePrototypes */
extern void _XmPostPopupMenu( 
                        Widget wid,
                        XEvent *event) ;
extern void _XmCallRowColumnMapCallback( 
                        Widget wid,
                        XEvent *event) ;
extern void _XmCallRowColumnUnmapCallback( 
                        Widget wid,
                        XEvent *event) ;
extern void _XmRC_RemoveFromPostFromListOnDestroyCB (
 			Widget w,
 			caddr_t clientData,
 			caddr_t callData) ;

extern void _XmRC_CheckAndSetOptionCascade(XmRowColumnWidget menu) ;

#endif /* _NO_PROTO */
/********    End Private Function Declarations    ********/

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif  /* _XmRowColumnI_h */
/* DON'T ADD STUFF AFTER THIS #endif */
