/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: ScaleP.h,v $
 * Revision 1.8.7.2  1994/04/06  21:29:27  drk
 * 	Don't churn regions during redraw.
 * 	[1994/04/06  20:10:42  drk]
 *
 * Revision 1.8.7.1  1994/03/17  22:22:04  daniel
 * 	 implement new sliderVisual/Mark support
 * 	[1994/03/17  21:54:29  daniel]
 * 
 * Revision 1.8.2.7  1993/07/23  03:00:30  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:31:37  yak]
 * 
 * Revision 1.8.2.6  1993/06/01  19:00:25  drand
 * 	Added XmNdestinationCallback callback list for UTM.
 * 	[1993/06/01  18:57:11  drand]
 * 
 * Revision 1.8.2.5  1993/03/30  14:25:41  rgcote
 * 	Fixes from Motif1.2.3. Rev. 1.8.3.2, ancestor 1.8, file ScaleP.h.
 * 	[1993/03/29  20:52:51  rgcote]
 * 
 * Revision 1.8.2.4  1993/01/31  04:12:41  daniel
 * 	check point thermo scroll + thumb mark
 * 	[1993/01/31  04:03:05  daniel]
 * 
 * Revision 1.8.2.3  1992/10/13  17:49:39  daniel
 * 	More enhancement work
 * 	[1992/10/13  17:47:47  daniel]
 * 
 * Revision 1.8.2.2  1992/10/05  21:43:14  daniel
 * 	thermo + showvalue work
 * 	[1992/10/05  21:30:09  daniel]
 * 
 * Revision 1.8  1992/03/13  16:44:35  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/* $RCSfile: ScaleP.h,v $ $Revision: 1.8.7.2 $ $Date: 1994/04/06 21:29:27 $ */
/* (c) Copyright 1989, DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS. */
/* (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */
#ifndef _XmScaleP_h
#define _XmScaleP_h


#include <Xm/Scale.h>
#include <Xm/ManagerP.h>

#ifdef __cplusplus
extern "C" {
#endif

/* Constraint part record for Scale widget */

typedef struct _XmScaleConstraintPart
{
   char unused;
} XmScaleConstraintPart, * XmScaleConstraint;


/*  New fields for the Scale widget class record  */

typedef struct
{
   XtPointer extension;   /* Pointer to extension record */
} XmScaleClassPart;


/* Full class record declaration */

typedef struct _XmScaleClassRec
{
   CoreClassPart       core_class;
   CompositeClassPart  composite_class;
   ConstraintClassPart constraint_class;
   XmManagerClassPart  manager_class;
   XmScaleClassPart    scale_class;
} XmScaleClassRec;

externalref XmScaleClassRec xmScaleClassRec;


/* New fields for the Scale widget record */

typedef struct
{
   int            value;
   int            maximum;
   int            minimum;
   unsigned char  orientation;
   unsigned char  processing_direction;
   XmString       title; 
   XmFontList     font_list;
   XFontStruct  * font_struct;
   Boolean        show_value;
   short          decimal_points;
   Dimension      scale_width;
   Dimension      scale_height;
   Dimension      highlight_thickness;
   Boolean        highlight_on_enter;
   XtCallbackList drag_callback;
   XtCallbackList value_changed_callback;

   /* this field is unused since 1.2 and
      has a new meaning in 2.0: a bitfield
      that carries instance states: FROM_SET_VALUE, etc
      The field will be referenced as scale.state_flags
      using a define in the .c file */
   int last_value;

   int slider_size;
   GC  foreground_GC;
   int show_value_x;
   int show_value_y;
   int show_value_width;
   int show_value_height;
   int scale_multiple;

   XtEnum sliding_mode;
   XtEnum slider_visual;
   XtEnum slider_mark;
   XtEnum show_arrows;
   Boolean editable;

   XtCallbackList   convert_callback;       /* Selection convert callback */

   Region value_region;
} XmScalePart;


#define FROM_SET_VALUE (1<<0)

/****************************************************************
 *
 * Full instance record declaration
 *
 ****************************************************************/

typedef struct _XmScaleRec
{
    CorePart       core;
    CompositePart  composite;
    ConstraintPart constraint;
    XmManagerPart  manager;
    XmScalePart    scale;
} XmScaleRec;


/********    Private Function Declarations    ********/
#ifdef _NO_PROTO


#else


#endif /* _NO_PROTO */
/********    End Private Function Declarations    ********/


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmScaleP_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
