/*
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF
 * for the full copyright text.
 * 
 */
/*
 * HISTORY
 * $Log: ScreenI.h,v $
 * Revision 1.1.2.2  1994/03/10  21:53:48  drk
 * 	Remove unsupported #ifdefs.
 * 	[1994/03/10  21:47:51  drk]
 *
 * Revision 1.1.2.1  1994/03/04  22:26:10  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  21:59:47  drk]
 * 
 * $EndLog$
 */
/* $RCSfile: ScreenI.h,v $ $Revision: 1.1.2.2 $ $Date: 1994/03/10 21:53:48 $ */
#ifndef _XmScreenI_h
#define _XmScreenI_h

#include <Xm/ScreenP.h>

#ifdef __cplusplus
extern "C" {
#endif


externalref XrmQuark _XmInvalidCursorIconQuark ;
externalref XrmQuark _XmValidCursorIconQuark ;
externalref XrmQuark _XmNoneCursorIconQuark ;
externalref XrmQuark _XmDefaultDragIconQuark ;
externalref XrmQuark _XmMoveCursorIconQuark ;
externalref XrmQuark _XmCopyCursorIconQuark ;
externalref XrmQuark _XmLinkCursorIconQuark ;


/********    Private Function Declarations    ********/
#ifdef _NO_PROTO

extern XmDragIconObject _XmScreenGetOperationIcon() ;
extern XmDragIconObject _XmScreenGetStateIcon() ;
extern XmDragIconObject _XmScreenGetSourceIcon() ;
extern Pixmap _XmAllocScratchPixmap() ;
extern void _XmFreeScratchPixmap() ;
extern XmDragCursorCache * _XmGetDragCursorCachePtr() ;
extern Cursor _XmGetMenuCursorByScreen() ;
extern Boolean _XmGetMoveOpaqueByScreen() ;
extern unsigned char _XmGetUnpostBehavior() ;
extern int _XmGetFontUnit() ;
extern void _XmScreenRemoveFromCursorCache() ;
extern XmScreenColorProc _XmGetColorCalculationProc() ;
extern XmAllocColorProc _XmGetColorAllocationProc() ;
extern Pixmap _XmGetInsensitiveStippleBitmap() ;
extern XtEnum _XmGetBitmapConversionModel() ;

#else

extern XmDragIconObject _XmScreenGetOperationIcon( 
                        Widget w,
#if NeedWidePrototypes
                        unsigned int operation) ;
#else
                        unsigned char operation) ;
#endif /* NeedWidePrototypes */
extern XmDragIconObject _XmScreenGetStateIcon( 
                        Widget w,
#if NeedWidePrototypes
                        unsigned int state) ;
#else
                        unsigned char state) ;
#endif /* NeedWidePrototypes */
extern XmDragIconObject _XmScreenGetSourceIcon( 
                        Widget w) ;
extern Pixmap _XmAllocScratchPixmap( 
                        XmScreen xmScreen,
#if NeedWidePrototypes
                        unsigned int depth,
                        int width,
                        int height) ;
#else
                        Cardinal depth,
                        Dimension width,
                        Dimension height) ;
#endif /* NeedWidePrototypes */
extern void _XmFreeScratchPixmap( 
                        XmScreen xmScreen,
                        Pixmap pixmap) ;
extern XmDragCursorCache * _XmGetDragCursorCachePtr( 
                        XmScreen xmScreen) ;
extern Cursor _XmGetMenuCursorByScreen( 
                        Screen *screen) ;
extern Boolean _XmGetMoveOpaqueByScreen( 
                        Screen *screen) ;
extern unsigned char _XmGetUnpostBehavior( 
                        Widget wid) ;
extern int _XmGetFontUnit( 
                        Screen *screen,
                        int dimension) ;
extern void _XmScreenRemoveFromCursorCache(
			XmDragIconObject icon) ;
extern XmScreenColorProc _XmGetColorCalculationProc( 
                        Screen *screen) ;
extern XmAllocColorProc _XmGetColorAllocationProc(
			Screen *screen) ;
extern Pixmap _XmGetInsensitiveStippleBitmap(
			Widget w) ;
extern XtEnum _XmGetBitmapConversionModel(
			Screen *screen) ;

#endif /* _NO_PROTO */
/********    End Private Function Declarations    ********/


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmScreenI_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
