/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: ScreenP.h,v $
 * Revision 1.5.16.3  1994/03/04  22:26:11  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  21:59:48  drk]
 *
 * Revision 1.5.16.2  1993/12/30  22:11:23  daniel
 * 	cleanup name space
 * 	[1993/12/30  22:09:46  daniel]
 * 
 * Revision 1.5.16.1  1993/12/28  15:36:14  daniel
 * 	rework of the pixmap cache/conversion
 * 	[1993/12/28  15:33:49  daniel]
 * 
 * Revision 1.5.11.5  1993/09/20  22:09:35  drand
 * 	Fixes from Motif1.2.4. Rev. 1.5.13.2, ancestor 1.5.12.2, file ScreenP.h.
 * 	HaL fix for CR 4817.
 * 	[1993/09/20  22:09:17  drand]
 * 
 * Revision 1.5.11.4  1993/08/19  14:28:13  drand
 * 	Fixed build problems with HashI.h.
 * 	[1993/08/19  14:25:32  drand]
 * 
 * Revision 1.5.11.3  1993/08/18  17:52:21  drand
 * 	Changed to use hash tables for pixmap cache.
 * 	[1993/08/18  17:49:58  drand]
 * 
 * Revision 1.5.11.2  1993/08/03  01:56:59  inca
 * 	Fixes from Motif1.2.3. Rev. 1.5.8.2, ancestor 1.5.4.2, file ScreenP.h.
 * 	[1993/08/02  23:44:56  inca]
 * 
 * Revision 1.5.6.9  1993/07/23  03:00:37  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:31:53  yak]
 * 
 * Revision 1.5.6.8  1993/06/30  23:54:44  rgcote
 * 	Removed declarations for _Xm functions which have become
 * 	Xme functions.
 * 	[1993/06/30  23:46:40  rgcote]
 * 
 * Revision 1.5.6.7  1993/06/01  14:36:58  daniel
 * 	add bitmapconversion support
 * 	[1993/06/01  14:31:21  daniel]
 * 
 * Revision 1.5.6.6  1993/05/13  21:00:30  daniel
 * 	more takesDefault support
 * 	[1993/05/13  20:59:08  daniel]
 * 
 * Revision 1.5.6.5  1993/04/28  20:14:27  motifics
 * 	Added insensitive stipple bitmap resource
 * 	[1993/04/28  20:05:22  motifics]
 * 
 * Revision 1.5.6.4  1993/04/13  20:28:58  motifics
 * 	Added XmNcolorAllocationProc resource
 * 	[1993/04/13  20:26:45  motifics]
 * 
 * Revision 1.5.6.3  1993/03/03  20:22:40  daniel
 * 	put in the userData resource
 * 	[1993/03/03  20:14:45  daniel]
 * 
 * Revision 1.5.6.2  1993/01/29  21:08:53  daniel
 * 	add colorproc support and bitmap converter resource
 * 	[1993/01/29  20:28:28  daniel]
 * 
 * Revision 1.5.4.2  1992/08/07  15:00:18  dbl
 * 	CR 2403 summary: partial fixes for this problem.
 * 	  Together, the patches fix many areas in Motif which keep per-display
 * 	  information. When closing a display, and re-opening it, it is
 * 	  possible (likely) that the same display id will be returned (it is just
 * 	  an address returned by malloc). In this case, Motif tries to use
 * 	  various Atoms, Pixmaps, GCs, and random data for the old display. The
 * 	  results are Protocol errors, core dumps, strange behaviour.
 * 	  Also done: unrelated fixes to ImageCache.c (_XmUninstallImage)
 * 	             unrelated fixes to MenuUtil.c (_XmGrabKeyboard)
 * 	             update to CR 2788
 * 	             various cleanups to satisfy "gcc -ansi"
 * 	[1992/08/07  14:52:28  dbl]
 * 
 * Revision 1.5.2.3  1992/04/05  17:23:16  al
 * 	P2788: prevent Open/CloseDisplay error. Move cache to XmScreen
 * 	[1992/04/05  17:22:23  al]
 * 
 * Revision 1.5.2.2  1992/03/31  22:17:18  al
 * 	Add hook for per-screen data, to allow XtCloseDisplay fix in 1.2 patch
 * 	[1992/03/31  22:16:25  al]
 * 
 * Revision 1.5  1992/03/13  16:44:50  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/* $RCSfile: ScreenP.h,v $ $Revision: 1.5.16.3 $ $Date: 1994/03/04 22:26:11 $ */
/* (c) Copyright 1989, 1990  DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS. */
/* (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */
/* (c) Copyright 1988 MASSACHUSETTS INSTITUTE OF TECHNOLOGY  */
/* (c) Copyright 1988 MICROSOFT CORPORATION */
#ifndef _XmScreenP_h
#define _XmScreenP_h

#include <Xm/DesktopP.h>
#include <Xm/Screen.h>
#include <Xm/DragIcon.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct _XmScreenClassPart {
    XtPointer		extension;
} XmScreenClassPart, *XmScreenClassPartPtr;

typedef struct _XmScreenClassRec {
/*    ObjectClassPart		object_class;
    XmExtClassPart		ext_class; */
    CoreClassPart               core_class ;
    XmDesktopClassPart 		desktop_class;
    XmScreenClassPart		screen_class;
} XmScreenClassRec;

typedef struct _XmDragCursorRec {
    struct _XmDragCursorRec	*next;
    Cursor			cursor;
    XmDragIconObject		stateIcon;
    XmDragIconObject		opIcon;
    XmDragIconObject		sourceIcon;
    Boolean			dirty;
} XmDragCursorRec, *XmDragCursorCache;

typedef struct _XmScratchPixmapKeyRec *XmScratchPixmapKey;

typedef struct _XmScratchPixmapKeyRec {
    Cardinal		depth;
    Dimension           width;
    Dimension           height;
} XmScratchPixmapKeyRec;

typedef struct {
    Boolean		mwmPresent;
    unsigned short	numReparented;
    int			darkThreshold;
    int			foregroundThreshold;
    int			lightThreshold;
    XmDragIconObject	defaultNoneCursorIcon;
    XmDragIconObject	defaultValidCursorIcon;
    XmDragIconObject	defaultInvalidCursorIcon;
    XmDragIconObject	defaultMoveCursorIcon;
    XmDragIconObject	defaultCopyCursorIcon;
    XmDragIconObject	defaultLinkCursorIcon;
    XmDragIconObject	defaultSourceCursorIcon;

    Cursor		nullCursor;
    XmDragCursorRec	*cursorCache;
    Cardinal		maxCursorWidth;
    Cardinal		maxCursorHeight;

    Cursor		menuCursor;
    unsigned char	unpostBehavior;
    XFontStruct *	font_struct;
    int			h_unit;
    int			v_unit;
    XtPointer		scratchPixmaps;
    unsigned char       moveOpaque;
    XmScreenColorProc   color_calc_proc;
    XmAllocColorProc    color_alloc_proc;
    XtEnum              bitmap_conversion_model;

    /* to save internally-created XmDragIcons */

    XmDragIconObject	xmStateCursorIcon;
    XmDragIconObject	xmMoveCursorIcon;
    XmDragIconObject	xmCopyCursorIcon;
    XmDragIconObject	xmLinkCursorIcon;
    XmDragIconObject	xmSourceCursorIcon;

    GC			imageGC;		/* OBSOLETE FIELD */
    int			imageGCDepth;           /* OBSOLETE FIELD */
    Pixel		imageForeground;        /* OBSOLETE FIELD */
    Pixel		imageBackground;        /* OBSOLETE FIELD */

    XtPointer		screenInfo;		/* extension */

    XtPointer           user_data;

    Pixmap              insensitive_stipple_bitmap;

#ifdef DEFAULT_GLYPH_PIXMAP
   Pixmap           default_glyph_pixmap ;
   unsigned int     default_glyph_pixmap_width ;
   unsigned int     default_glyph_pixmap_height ;
#endif

   XtPointer		inUsePixmaps;
} XmScreenPart, *XmScreenPartPtr;

typedef struct _XmScreenInfo {
	/* so much for information hiding */
	XtPointer	menu_state;		/* MenuUtil.c */
	Boolean		destroyCallbackAdded;	/* ImageCache.c */
} XmScreenInfo;

externalref XmScreenClassRec 	xmScreenClassRec;

typedef struct _XmScreenRec {
/*    ObjectPart			object;
    XmExtPart			ext; */
    CorePart                    core ;
    XmDesktopPart		desktop;
    XmScreenPart		screen;
} XmScreenRec;


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmScreenP_h */
/* DON'T ADD STUFF AFTER THIS #endif */
