/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: ScrollBarP.h,v $
 * Revision 1.9.10.1  1994/03/17  22:22:10  daniel
 * 	 implement new sliderVisual/Mark support
 * 	[1994/03/17  21:54:38  daniel]
 *
 * Revision 1.9.4.10  1993/07/23  03:00:51  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:32:19  yak]
 * 
 * Revision 1.9.4.9  1993/03/30  14:26:54  rgcote
 * 	Fixes from Motif1.2.3. Rev. 1.9.6.2, ancestor 1.9, file ScrollBarP.h.
 * 	[1993/03/29  20:58:34  rgcote]
 * 
 * Revision 1.9.4.8  1993/03/26  19:57:37  daniel
 * 	move in XmStrDefs.h new 2.0 define
 * 	[1993/03/26  19:54:46  daniel]
 * 
 * Revision 1.9.4.7  1993/03/26  18:11:18  daniel
 * 	implement Navigator/ScrollFrame trait
 * 	[1993/03/26  18:09:25  daniel]
 * 
 * Revision 1.9.4.6  1993/01/31  04:12:38  daniel
 * 	check point thermo scroll + thumb mark
 * 	[1993/01/31  04:03:29  daniel]
 * 
 * Revision 1.9.4.5  1992/10/13  17:49:20  daniel
 * 	More enhancement work
 * 	[1992/10/13  17:48:05  daniel]
 * 
 * Revision 1.9.4.4  1992/10/05  21:42:48  daniel
 * 	thermo + showvalue work
 * 	[1992/10/05  21:30:37  daniel]
 * 
 * Revision 1.9.4.3  1992/09/29  19:51:55  daniel
 * 	tune up snapBack + add private_behavior stuff
 * 	[1992/09/29  19:50:58  daniel]
 * 
 * Revision 1.9.4.2  1992/09/25  14:55:59  daniel
 * 	snapback + showArrow stuff
 * 	[1992/09/24  15:24:14  daniel]
 * 
 * Revision 1.9  1992/03/13  16:45:18  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/*   $RCSfile: ScrollBarP.h,v $ $Revision: 1.9.10.1 $ $Date: 1994/03/17 22:22:10 $ */
/*
*  (c) Copyright 1989, DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS. */
/*
*  (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */
#ifndef _XmScrollBarP_h
#define _XmScrollBarP_h


#include <Xm/ScrollBar.h>
#include <Xm/PrimitiveP.h>

#ifdef __cplusplus
extern "C" {
#endif

/*  Minimum slider width or height  */

#define MIN_SLIDER_THICKNESS	1
#define MIN_SLIDER_LENGTH	6
#define DEFAULT_ROUND_MARK_RADIUS 3
#define THERMO_MARK_OFFSET 10

/*  ScrollBar class structure  */

typedef struct _XmScrollBarClassPart
{
   XtPointer extension;   /* Pointer to extension record */
} XmScrollBarClassPart;


/*  Full class record declaration for CheckBox class  */

typedef struct _XmScrollBarClassRec
{
   CoreClassPart        core_class;
   XmPrimitiveClassPart primitive_class;
   XmScrollBarClassPart scrollBar_class;
} XmScrollBarClassRec;

externalref XmScrollBarClassRec xmScrollBarClassRec;


/*  The ScrollBar instance record  */

typedef struct _XmScrollBarPart
{
   int value;
   int minimum;
   int maximum;
   int slider_size;

   unsigned char orientation;
   unsigned char processing_direction;
   XtEnum show_arrows;

   int increment;
   int page_increment;

   int initial_delay;
   int repeat_delay;

   XtCallbackList value_changed_callback;
   XtCallbackList increment_callback;
   XtCallbackList decrement_callback;
   XtCallbackList page_increment_callback;
   XtCallbackList page_decrement_callback;
   XtCallbackList to_top_callback;
   XtCallbackList to_bottom_callback;
   XtCallbackList drag_callback;

   /* obsolete */
   GC unhighlight_GC;
   /* Change the logical name of this one in 2.0 */

   GC foreground_GC;
   Pixel trough_color;

   Drawable pixmap;
   Boolean  sliding_on;
   int saved_value;

   XtEnum  etched_slider;
   /* we used a #define slider_visual to referenced this field in 
      the c file, etched_slider is not a good name anymore, */
   XtEnum slider_mark;
 
   unsigned char flags;
/* Values for the XmScrollBarPart flags field */

#define FIRST_SCROLL_FLAG (1<<0)
#define VALUE_SET_FLAG    (1<<1)
#define END_TIMER         (1<<2)
#define ARROW1_AVAILABLE  (1<<3)
#define ARROW2_AVAILABLE  (1<<4)
#define SLIDER_AVAILABLE  (1<<5)
#define KEYBOARD_GRABBED  (1<<6)
#define OPERATION_CANCELLED  (1<<7)  /* last field */

   unsigned char add_flags;
/* Values for the additionnal flags field */
#define SNAPPED_OUT         (1<<0)


   unsigned char change_type;
   XtIntervalId timer;

   short initial_x;
   short initial_y;
   short separation_x;
   short separation_y;

   short slider_x;
   short slider_y;
   short slider_width;
   short slider_height;

   short slider_area_x;
   short slider_area_y;
   short slider_area_width;
   short slider_area_height;

   short arrow1_x;
   short arrow1_y;
   unsigned char arrow1_orientation;
   Boolean arrow1_selected;

   short arrow2_x;
   short arrow2_y;
   unsigned char arrow2_orientation;
   Boolean arrow2_selected;

   short arrow_width;
   short arrow_height;

   /*  Obsolete fields as 1.2.0 */
   short arrow1_top_count;
   short arrow1_cent_count;
   short arrow1_bot_count;

   XRectangle * arrow1_top;
   XRectangle * arrow1_cent;
   XRectangle * arrow1_bot;

   short arrow2_top_count;
   short arrow2_cent_count;
   short arrow2_bot_count;

   XRectangle * arrow2_top;
   XRectangle * arrow2_cent;
   XRectangle * arrow2_bot;
   /***********/

   /* new for 1.2 */
   GC	unavailable_GC;

   /* new for 2.0 */
   unsigned short snap_back_multiple;
   XtEnum sliding_mode;
   Boolean editable;

   Mask dimMask ;  /* for the navigator trait */
} XmScrollBarPart;




/*  Full instance record declaration  */

typedef struct _XmScrollBarRec
{
   CorePart	   core;
   XmPrimitivePart primitive;
   XmScrollBarPart scrollBar;
} XmScrollBarRec;


/********    Private Function Declarations    ********/
#ifdef _NO_PROTO

#else

#endif /* _NO_PROTO */
/********    End Private Function Declarations    ********/

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmScrollBarP_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
