/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: ScrollFrameT.h,v $
 * Revision 1.1.8.1  1994/05/04  19:55:59  drk
 * 	Document trait version numbers.
 * 	[1994/05/04  19:52:57  drk]
 *
 * Revision 1.1.6.3  1994/03/24  23:49:51  drk
 * 	Null change
 * 	[1994/03/24  23:49:44  drk]
 * 
 * Revision 1.1.6.2  1994/03/24  23:12:24  drk
 * 	Create the traversal control trait.
 * 	[1994/03/24  23:05:45  drk]
 * 
 * Revision 1.1.6.1  1994/03/07  15:24:18  drk
 * 	Fix missing includes.
 * 	[1994/03/07  15:23:55  drk]
 * 
 * Revision 1.1.4.2  1993/09/14  21:16:13  inca
 * 	VMS-ify (externaldef/externalref) traits
 * 	[1993/09/14  21:07:25  inca]
 * 
 * Revision 1.1.2.8  1993/07/23  03:00:56  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:32:30  yak]
 * 
 * Revision 1.1.2.7  1993/04/26  18:42:34  daniel
 * 	add version field
 * 	[1993/04/26  18:41:47  daniel]
 * 
 * Revision 1.1.2.6  1993/04/07  20:46:45  daniel
 * 	guess what! more work on the trait API
 * 	[1993/04/07  20:44:43  daniel]
 * 
 * Revision 1.1.2.5  1993/04/07  02:16:26  daniel
 * 	 more Navigator/ScrollFrame changes
 * 	[1993/04/07  02:14:43  daniel]
 * 
 * Revision 1.1.2.4  1993/04/06  20:54:55  daniel
 * 	work Navigator/ScrollFrame work
 * 	[1993/04/06  20:52:58  daniel]
 * 
 * Revision 1.1.2.3  1993/04/01  21:52:27  daniel
 * 	more work on Navigator/ScrollFrame
 * 	[1993/04/01  21:51:22  daniel]
 * 
 * Revision 1.1.2.2  1993/03/26  18:11:10  daniel
 * 	implement Navigator/ScrollFrame trait
 * 	[1993/03/26  18:09:31  daniel]
 * 
 * $EndLog$
 */
#ifndef _XmScrollFrameT_H
#define _XmScrollFrameT_H

#include <Xm/Xm.h>
#include <Xm/NavigatorT.h>

#ifdef __cplusplus
extern "C" {
#endif

externalref XrmQuark XmQTscrollFrame;

/* Trait structures and typedefs, place typedefs first */

#ifdef _NO_PROTO
typedef void    (*XmScrollFrameInitProc)();
typedef Boolean (*XmScrollFrameGetInfoProc)();
typedef void    (*XmScrollFrameAddNavigatorProc)();
typedef void    (*XmScrollFrameRemoveNavigatorProc)();
#else
typedef void (*XmScrollFrameInitProc)(Widget sf, 
				      XtCallbackProc moveCB,
				      Widget scrollable);
typedef Boolean  (*XmScrollFrameGetInfoProc)(Widget sf,
					     Cardinal * dimension,
					     Widget ** nav_list,
					     Cardinal * num_nav_list);
typedef void (*XmScrollFrameAddNavigatorProc)(Widget sf, 
					      Widget nav,
					      Mask dimMask);
typedef void (*XmScrollFrameRemoveNavigatorProc)(Widget sf, 
						 Widget nav);
#endif /* _NO_PROTO */


/* Version 0: initial release. */

typedef struct _XmScrollFrameTraitRec {
  int				    version;		/* 0 */
  XmScrollFrameInitProc		    init;       
  XmScrollFrameGetInfoProc	    getInfo; 
  XmScrollFrameAddNavigatorProc     addNavigator;
  XmScrollFrameRemoveNavigatorProc  removeNavigator;
} XmScrollFrameTraitRec, *XmScrollFrameTrait;


/* This one gets allocated per instance by the scrollFrame
   class. It is just a convenient structure reusable by other scrollFrame
   and it needs not to be part of the public trait API */

typedef struct _XmScrollFrameDataRec {
   XtCallbackProc move_cb ;
   Widget         scrollable ;
   Widget *       nav_list;
   Cardinal       num_nav_list ;
   Cardinal       num_nav_slots;
} XmScrollFrameDataRec, *XmScrollFrameData;


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmScrollFrameT_H */
