/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: ScrolledWP.h,v $
 * Revision 1.8.10.2  1994/04/01  18:15:26  drand
 * 	CR 7821 - Autoscroll drag rects could go to zero
 * 	[1994/04/01  16:22:38  drand]
 *
 * Revision 1.8.10.1  1994/03/04  22:26:23  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  22:00:01  drk]
 * 
 * Revision 1.8.8.1  1993/10/26  18:26:52  daniel
 * 	fix ConstantLayout using instances prev_x & y
 * 	[1993/10/26  18:26:38  daniel]
 * 
 * Revision 1.8.2.11  1993/07/23  03:01:07  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:32:50  yak]
 * 
 * Revision 1.8.2.10  1993/06/14  19:02:08  daniel
 * 	more work on the scrollbar positioning
 * 	[1993/06/14  19:00:50  daniel]
 * 
 * Revision 1.8.2.9  1993/04/07  02:16:50  daniel
 * 	 more Navigator/ScrollFrame changes
 * 	[1993/04/07  02:14:56  daniel]
 * 
 * Revision 1.8.2.8  1993/04/06  20:55:10  daniel
 * 	work Navigator/ScrollFrame work
 * 	[1993/04/06  20:53:15  daniel]
 * 
 * Revision 1.8.2.7  1993/03/30  14:28:13  rgcote
 * 	Fixed my last change which resulted in two definitions of the
 * 	constraint part structure.
 * 	[1993/03/30  14:18:20  rgcote]
 * 
 * 	Fixes from Motif1.2.3. Rev. 1.8.4.2, ancestor 1.8, file ScrolledWP.h.
 * 	[1993/03/29  21:09:11  rgcote]
 * 
 * Revision 1.8.2.6  1993/03/26  18:11:25  daniel
 * 	implement Navigator/ScrollFrame trait
 * 	[1993/03/26  18:09:44  daniel]
 * 
 * Revision 1.8.2.5  1993/03/18  18:55:00  daniel
 * 	implement the childType resource
 * 	[1993/03/18  17:21:30  daniel]
 * 
 * Revision 1.8.2.4  1993/02/26  16:38:21  daniel
 * 	check in autodrag
 * 	[1993/02/24  22:16:02  daniel]
 * 
 * Revision 1.8.2.3  1993/02/04  20:49:57  daniel
 * 	put in the childType basics
 * 	[1993/02/04  20:49:07  daniel]
 * 
 * Revision 1.8.2.2  1993/02/03  20:29:13  daniel
 * 	check point
 * 	[1993/01/18  02:07:17  daniel]
 * 
 * 	chek point
 * 	[1992/11/06  16:12:16  daniel]
 * 
 * Revision 1.8  1992/03/13  16:45:44  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/* $RCSfile: ScrolledWP.h,v $ $Revision: 1.8.10.2 $ $Date: 1994/04/01 18:15:26 $ */
/* (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */
#ifndef _XmScrolledWindowP_h
#define _XmScrolledWindowP_h

#include <Xm/ManagerP.h>
#include <Xm/ScrolledW.h>

#include <Xm/ScrollBar.h>
#include <Xm/DrawingA.h>

#include <Xm/ScrollFrameT.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifdef _NO_PROTO
typedef void (*XmGetAutoDragRectsProc)() ;
#else
typedef void (*XmGetAutoDragRectsProc)(Widget, XRectangle **, Cardinal *) ;
#endif

#define XmInheritGetAutoDragRectsProc ((XmGetAutoDragRectsProc) _XtInherit)

#define XmScrolledWindowClassExtVersion 1L

typedef struct _XmScrolledWindowClassExtRec{
    XtPointer           next_extension;
    XrmQuark            record_type;
    long                version;
    Cardinal            record_size;
    XmGetAutoDragRectsProc get_hor_rects;
    XmGetAutoDragRectsProc get_vert_rects;
} XmScrolledWindowClassExtRec, *XmScrolledWindowClassExt;

/* New fields for the ScrolledWindow widget class record */
typedef struct {
     XtPointer extension;   /* extension to new class methods */
} XmScrolledWindowClassPart;

/****************
 *
 * Class record declaration
 *
 ****************/
typedef struct _XmScrolledWindowClassRec {
    CoreClassPart	core_class;
    CompositeClassPart  composite_class;
    ConstraintClassPart constraint_class;
    XmManagerClassPart  manager_class;
    XmScrolledWindowClassPart	swindow_class;
} XmScrolledWindowClassRec;

externalref XmScrolledWindowClassRec xmScrolledWindowClassRec;

/****************
 *
 * Scrolled Window instance structure.
 *
 ****************/
typedef struct {

   int vmin;		  /*  slider minimum coordinate position     */
   int vmax;		  /*  slider maximum coordinate position     */
   int vOrigin;		  /*  slider edge location                  */
   int vExtent;		  /*  slider size                           */

   int hmin;		  /*  Same as above for horizontal bar.     */
   int hmax;
   int hOrigin;
   int hExtent;

   Position hsbX,hsbY;
   Dimension hsbWidth,hsbHeight;    /* Dimensions for the horiz bar */

   Position vsbX,vsbY;
   Dimension vsbWidth,vsbHeight;    /* Dimensions for the vertical bar */

   Position    GivenHeight, GivenWidth;
   /* these 2 fields are now obsolete, we re-use them for
      a different purpose, to track the initial position
      of the scrollbars */
#define sw_prev_x GivenWidth
#define sw_prev_y GivenHeight

   Dimension	AreaWidth,AreaHeight;
   Dimension	WidthPad,HeightPad;
   Position	XOffset, YOffset;

   Dimension	pad;

   Boolean	hasHSB;
   Boolean	hasVSB;
   Boolean	InInit;
   Boolean	FromResize;

   unsigned char	VisualPolicy;
   unsigned char	ScrollPolicy;
   unsigned char	ScrollBarPolicy;
   unsigned char	Placement;
   
   XmScrollBarWidget   	hScrollBar;
   XmScrollBarWidget   	vScrollBar;
   XmDrawingAreaWidget 	ClipWindow;
   Widget              	WorkWindow;
   
   XtCallbackList       traverseObscuredCallback;

   XtEnum       auto_drag_model;
   XtIntervalId auto_drag_timer; 

   Boolean scroll_frame_inited ;
   XmScrollFrameData scroll_frame_data ;

   XtPointer	auto_drag_rects;
} XmScrolledWindowPart;


/************************************************************************
 *									*
 * Full instance record declaration					*
 *									*
 ************************************************************************/

typedef struct _XmScrolledWindowRec {
    CorePart	    core;
    CompositePart   composite;
    ConstraintPart constraint;
    XmManagerPart   manager;
    XmScrolledWindowPart   swindow;
} XmScrolledWindowRec;


/*  Frame constraint records  */

typedef struct _XmScrolledWindowConstraintPart
{
   unsigned char child_type;
   Position orig_x;
   Position orig_y;
} XmScrolledWindowConstraintPart, * XmScrolledWindowConstraint;

typedef struct _XmScrolledWindowConstraintRec
{
   XmManagerConstraintPart manager;
   XmScrolledWindowConstraintPart   swindow;
} XmScrolledWindowConstraintRec, * XmScrolledWindowConstraintPtr;


#define DEFAULT_HEIGHT	20
#define DEFAULT_WIDTH	20

#define RESOURCE_DEFAULT (-1)

#define GetSWConstraint(w) \
        (&((XmScrolledWindowConstraintPtr) (w)->core.constraints)->swindow)


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmScrolledWindowP_h */
/* DON'T ADD STUFF AFTER THIS #endif */
