/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: SpecRenderT.h,v $
 * Revision 1.1.8.2  1994/05/25  22:03:13  inca
 * 	Move enum for XmeGetDefaultRenderTable to XmP.h
 * 	[1994/05/25  22:02:50  inca]
 *
 * Revision 1.1.8.1  1994/05/04  19:56:01  drk
 * 	Document trait version numbers.
 * 	[1994/05/04  19:52:58  drk]
 * 
 * Revision 1.1.6.1  1994/03/04  22:26:39  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  22:00:12  drk]
 * 
 * Revision 1.1.4.2  1993/09/14  21:16:19  inca
 * 	VMS-ify (externaldef/externalref) traits
 * 	[1993/09/14  21:07:29  inca]
 * 
 * Revision 1.1.2.3  1993/07/23  03:02:05  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:34:05  yak]
 * 
 * Revision 1.1.2.2  1993/04/28  01:24:39  daniel
 * 	put in specrender table
 * 	[1993/04/28  01:23:11  daniel]
 * 
 * $EndLog$
 */
#ifndef _XmSpecRenderT_H
#define _XmSpecRenderT_H

#ifdef __cplusplus
extern "C" {
#endif

#include <Xm/Xm.h>

externalref XrmQuark XmQTspecifyRenderTable;

/* Trait structures and typedefs, place typedefs first */

#ifdef _NO_PROTO
typedef XmFontList (*XmSpecRenderGetTableProc)();
#else
typedef XmFontList (*XmSpecRenderGetTableProc)(Widget wid,
					       XtEnum type);
#endif /* _NO_PROTO */

/* Version 0: initial release. */

typedef struct _XmSpecRenderTraitRec {
  int			   version;		/* 0 */
  XmSpecRenderGetTableProc getRenderTable;
} XmSpecRenderTraitRec, *XmSpecRenderTrait;


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmSpecRenderT_H */

