/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: SpinB.h,v $
 * Revision 1.1.7.1  1994/03/10  21:53:52  drk
 * 	Remove unsupported #ifdefs.
 * 	[1994/03/10  21:47:58  drk]
 *
 * Revision 1.1.5.7  1993/11/04  23:12:53  drand
 * 	Moved callback struct to Xm.h from SpinB.h
 * 	[1993/11/04  23:12:35  drand]
 * 
 * Revision 1.1.5.6  1993/11/03  23:27:26  drand
 * 	Fixed extern "C",  remove some unneeded stuff.
 * 	[1993/11/03  23:25:23  drand]
 * 
 * Revision 1.1.5.5  1993/10/29  21:37:23  drand
 * 	New SpinB Drop,  also moved RepType and Accelerators to proper destinations
 * 	[1993/10/29  21:36:22  drand]
 * 
 * Revision 1.1.5.3  1993/10/07  15:38:17  drand
 * 	New drop from CA,  also changed all the SpinB names to SpinBox.
 * 	[1993/10/07  15:37:49  drand]
 * 
 * Revision 1.1.5.2  1993/09/02  22:02:41  drand
 * 	New CA drop,  changed name from SpinButton to SpinBox,  and other
 * 	fixes and improvements.
 * 	[1993/09/02  21:57:54  drand]
 * 
 * Revision 1.1.2.21  1993/07/23  03:02:12  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:34:19  yak]
 * 
 * Revision 1.1.2.20  1993/07/13  15:37:33  drand
 * 	Fix CR 5996.  Fix code/doc discrepancies.  Some cleanups as well.
 * 	Also,  added fixes from CA.
 * 	[1993/07/13  15:33:11  drand]
 * 
 * Revision 1.1.2.19  1993/06/30  15:33:26  rgcote
 * 	Moved the widget specific resource defines to XmStrDefs. Also
 * 	moved widget specific enums to Xm.h.
 * 	[1993/06/30  15:26:47  rgcote]
 * 
 * Revision 1.1.2.18  1993/06/28  20:58:11  motifca
 * 	  Alpha fixes...
 * 	[1993/06/28  20:56:04  motifca]
 * 
 * Revision 1.1.2.17  1993/06/25  21:28:17  motifca
 * 	  Change resource names...
 * 	[1993/06/25  21:26:18  motifca]
 * 
 * Revision 1.1.2.16  1993/06/25  20:04:32  motifca
 * 	  Misc. alpha changes...
 * 	[1993/06/25  20:00:45  motifca]
 * 
 * Revision 1.1.2.15  1993/06/25  17:02:56  motifca
 * 	More changes for alpha...
 * 	[1993/06/25  16:52:17  motifca]
 * 
 * Revision 1.1.2.14  1993/06/24  21:43:23  motifca
 * 	Changes for SpinButton alpha...
 * 	[1993/06/24  21:41:42  motifca]
 * 
 * Revision 1.1.2.13  1993/06/23  14:10:33  drand
 * 	Latest and greatest version of SpinButton.
 * 	[1993/06/23  14:09:19  drand]
 * 
 * Revision 1.1.2.10  1993/04/02  19:54:03  motifca
 * 	   SpinButton integration
 * 	     -  changed initial/repeat delay 0 to reflect spec
 * 	     -  added SBLeft and SBRight
 * 	     -  added boundary flag (private) returned in crossed_boundary
 * 	     -  value changed callback changes:
 * 	          - call when position changes
 * 	          - set fields in callback structure
 * 	          - use 'new' reasons XmCR_SPIN_NEXT and XmCR_SPIN_PRIOR
 * 	[1993/04/02  19:15:47  motifca]
 * 
 * Revision 1.1.2.9  1993/04/01  19:06:23  drand
 * 	Changed value to XmString.
 * 	[1993/04/01  19:05:49  drand]
 * 
 * Revision 1.1.2.8  1993/04/01  18:48:33  motifca
 * 	Integrate Spin Button - CA...
 * 	[1993/04/01  18:47:09  motifca]
 * 
 * $EndLog$
 */

#ifndef _SpinB_h
#define _SpinB_h

#include <Xm/Xm.h>

#ifdef __cplusplus
extern "C" {
#endif

/* SpinB Widget */

externalref WidgetClass xmSpinBoxWidgetClass;

typedef struct _XmSpinBoxClassRec *XmSpinBoxWidgetClass;
typedef struct _XmSpinBoxRec      *XmSpinBoxWidget;

/* Spin externs for application accessible functions */

#ifdef _NO_PROTO
extern Widget   XmCreateSpinBox();
#else /* _NO_PROTO */

extern Widget XmCreateSpinBox(Widget parent, char *name, ArgList arglist,
    Cardinal argcount);
#endif /* _NO_PROTO */

#ifdef __cplusplus
}
#endif

#endif /* _SpinB_h */

