/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: TakesDefT.h,v $
 * Revision 1.1.8.1  1994/05/04  19:56:04  drk
 * 	Document trait version numbers.
 * 	[1994/05/04  19:52:59  drk]
 *
 * Revision 1.1.6.1  1994/03/07  15:24:19  drk
 * 	Fix missing includes.
 * 	[1994/03/07  15:23:56  drk]
 * 
 * Revision 1.1.4.2  1993/09/14  21:16:22  inca
 * 	VMS-ify (externaldef/externalref) traits
 * 	[1993/09/14  21:07:34  inca]
 * 
 * Revision 1.1.2.4  1993/07/23  03:02:28  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:34:43  yak]
 * 
 * Revision 1.1.2.3  1993/05/13  14:04:02  daniel
 * 	submit again
 * 	[1993/05/13  14:03:44  daniel]
 * 
 * Revision 1.1.2.2  1993/05/12  17:16:21  daniel
 * 	add takesDefault Trait
 * 	[1993/05/12  17:15:44  daniel]
 * 
 * $EndLog$
 */
#ifndef _XmTakesDefaultT_H
#define _XmTakesDefaultT_H

#include <Xm/Xm.h>

#ifdef __cplusplus
extern "C" {
#endif

externalref XrmQuark XmQTtakesDefault;

/* Trait structures and typedefs, place typedefs first */

#ifdef _NO_PROTO
typedef void (*XmTakesDefaultNotifyProc)();
#else
typedef void (*XmTakesDefaultNotifyProc)(Widget w, 
					 XtEnum state);
#endif /* _NO_PROTO */

/* Version 0: initial release. */

typedef struct _XmTakesDefaultTraitRec {
  int			   version;		/* 0 */
  XmTakesDefaultNotifyProc showAsDefault;
} XmTakesDefaultTraitRec, *XmTakesDefaultTrait;

enum {XmDEFAULT_READY, XmDEFAULT_ON, XmDEFAULT_OFF, XmDEFAULT_FORGET} ;


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmTakesDefaultT_H */
