/*
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF
 * for the full copyright text.
 * 
 */
/*
 * HISTORY
 * $Log: TextI.h,v $
 * Revision 1.1.2.1  1994/03/04  22:27:16  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  22:00:50  drk]
 *
 * $EndLog$
 */
/* $RCSfile: TextI.h,v $ $Revision: 1.1.2.1 $ $Date: 1994/03/04 22:27:16 $ */
#ifndef _XmTextI_h
#define _XmTextI_h

#include <Xm/TextP.h>

#ifdef __cplusplus
extern "C" {
#endif

/********    Private Function Declarations    ********/
#ifdef _NO_PROTO

extern XmTextPosition _XmTextFindScroll();
extern int _XmTextGetTotalLines();
extern XmTextLineTable _XmTextGetLineTable();
extern void _XmTextRealignLineTable();
extern unsigned int _XmTextGetTableIndex();
extern void _XmTextUpdateLineTable();
extern void _XmTextMarkRedraw();
extern LineNum _XmTextNumLines();
extern void _XmTextLineInfo();
extern LineNum _XmTextPosToLine();
extern void _XmTextInvalidate();
extern void _XmTextSetTopCharacter();
extern int _XmTextCountCharacters();
extern void _XmTextSetCursorPosition();
extern void _XmTextDisableRedisplay();
extern void _XmTextEnableRedisplay();
extern void _XmTextSetHighlight();
extern void _XmTextShowPosition();
extern void _XmTextSetEditable(); 

#else

extern XmTextPosition _XmTextFindScroll(XmTextWidget widget,
					XmTextPosition start,
					int delta);
extern int _XmTextGetTotalLines(Widget widget);
extern XmTextLineTable _XmTextGetLineTable(Widget widget,
					   int *total_lines);
extern void _XmTextRealignLineTable(XmTextWidget widget,
				    XmTextLineTable *temp_table,
				    int *temp_table_size,
				    register unsigned int cur_index,
				    register XmTextPosition cur_start,
				    register XmTextPosition cur_end);
extern unsigned int _XmTextGetTableIndex(XmTextWidget widget,
					 XmTextPosition pos);
extern void _XmTextUpdateLineTable(Widget widget,
				   XmTextPosition start,
				   XmTextPosition end,
				   XmTextBlock block,
#if NeedWidePrototypes
				   int update
#else
				   Boolean update
#endif /* NeedWidePrototypes */
				   );
extern void _XmTextMarkRedraw(XmTextWidget widget,
			      XmTextPosition left,
			      XmTextPosition right);
extern LineNum _XmTextNumLines(XmTextWidget widget);
extern void _XmTextLineInfo(XmTextWidget widget,
			    LineNum line,
			    XmTextPosition *startpos,
			    LineTableExtra *extra);
extern LineNum _XmTextPosToLine(XmTextWidget widget,
				XmTextPosition position);
extern void _XmTextInvalidate(XmTextWidget widget,
			      XmTextPosition position,
			      XmTextPosition topos,
			      long delta);
extern void _XmTextSetTopCharacter(Widget widget,
				   XmTextPosition top_character);
extern int _XmTextCountCharacters(char *str,
				  int num_count_bytes);
extern void _XmTextSetCursorPosition(Widget widget,
				     XmTextPosition position);
extern void _XmTextDisableRedisplay(XmTextWidget widget,
#if NeedWidePrototypes
				    int losesbackingstore);
#else
                                    Boolean losesbackingstore);
#endif /* NeedWidePrototypes */
extern void _XmTextEnableRedisplay(XmTextWidget widget);  

extern void _XmTextSetHighlight(Widget, XmTextPosition,
                                XmTextPosition, XmHighlightMode);
extern void _XmTextShowPosition(Widget, XmTextPosition);
extern void _XmTextSetEditable(Widget widget,
#if NeedWidePrototypes
			       int editable);
#else
                               Boolean editable);
#endif /* NeedWidePrototypes */

#endif /* _NO_PROTO */
/********    End Private Function Declarations    ********/


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmTextI_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
