/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: TextInP.h,v $
 * Revision 1.9.9.3  1994/03/28  23:23:07  inca
 * 	Rewrite Btn1Transfer code
 * 	[1994/03/28  22:56:48  inca]
 *
 * Revision 1.9.9.2  1994/03/04  22:27:28  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  22:01:01  drk]
 * 
 * Revision 1.9.9.1  1994/02/18  22:34:34  inca
 * 	Remodularization of Text & TextField
 * 	[1994/02/18  22:25:23  inca]
 * 
 * Revision 1.9.6.2  1993/08/03  01:57:41  inca
 * 	Fixes from Motif1.2.3. Rev. 1.9.4.2, ancestor 1.9, file TextInP.h.
 * 	[1993/08/03  00:00:54  inca]
 * 
 * Revision 1.9.3.3  1993/07/23  03:03:37  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:36:28  yak]
 * 
 * Revision 1.9.3.2  1993/07/01  18:41:59  drand
 * 	Added link-to action and actionname.
 * 	[1993/07/01  18:40:59  drand]
 * 
 * Revision 1.9  1992/03/13  16:49:35  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/* $RCSfile: TextInP.h,v $ $Revision: 1.9.9.3 $ $Date: 1994/03/28 23:23:07 $ */
/* (c) Copyright 1989, DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS. */
/* (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */
#ifndef _XmTextInP_h
#define _XmTextInP_h

#include <Xm/Text.h>
#include <Xm/TextStrSoP.h>

#ifdef __cplusplus
extern "C" {
#endif

/****************************************************************
 *
 * Definitions for modules implementing text input modules.
 *
 ****************************************************************/

typedef struct {
    int x;
    int y;
} SelectionHint;

typedef struct _InputDataRec {
    XmTextWidget widget;		/* Back-pointer to widget record. */
    XmTextScanType *sarray;	/* Description of what to cycle through on */
				/* selections. */
    int sarraycount;		/* Number of elements in above. */
    int new_sel_length;		/* New selection length for selection moves. */
    int threshold;		/* number of pixels crossed -> drag */
    SelectionHint selectionHint; /* saved coords of button down */
    SelectionHint Sel2Hint;	/* saved the coords of button down */
    XtIntervalId select_id;
    XmTextScanType stype;	/* Current selection type. */
    XmTextScanDirection extendDir;
    XmTextScanDirection Sel2ExtendDir;
    XmTextPosition origLeft, origRight;
    XmTextPosition Sel2OrigLeft, Sel2OrigRight;
    XmTextPosition stuffpos;
    XmTextPosition sel2Left, sel2Right; /* secondary selection */
    XmTextPosition anchor;	/* anchor point of the primary selection */
    Position select_pos_x;	/* x position for timer-based scrolling */
    Position select_pos_y;	/* y position for timer-based scrolling */
    Boolean pendingdelete;	/* TRUE if we're implementing pending delete */
    Boolean syncing;		/* If TRUE, then we've multiple keystrokes */
    Boolean extending;      /* true if we are extending */
    Boolean Sel2Extending;	/* true if we are extending */
    Boolean hasSel2;   		/* has secondary selection */
    Boolean has_destination;  	/* has destination selection */
    Boolean selectionMove;	/* delete selection after stuff */
    Boolean cancel;		/* indicates that cancel was pressed */
    Boolean overstrike;     	/* overstrike */
    Boolean sel_start;		/* indicates that a btn2 was pressed */
    Time dest_time;		/* time of destination selection ownership */
    Time sec_time;		/* time of secondary selection ownership */
    Time lasttime;		/* Time of last event. */
    Boolean selectionLink;	/* This is a link vs. a copy operation */
    XtIntervalId drag_id;       /* timer to start btn1 drag */
    _XmTextActionRec *transfer_action;  /* to keep track of delayed action */
} InputDataRec, *InputData;


/* 
 * Create a new instance of an input object.  By the time this is called,
 * the widget context has been saved.
 */

#ifdef _NO_PROTO
typedef void (*InputCreateProc)(); /* widget, args, num_args */
#else
typedef void (*InputCreateProc)(
			Widget,
			ArgList,
			Cardinal) ;
#endif

/*
 * Get values out of the input object.
 */
#ifdef _NO_PROTO
typedef void (*InputGetValuesProc)(); /* widget, args, num_args */
#else
typedef void (*InputGetValuesProc)(
			Widget,
			ArgList,
			Cardinal) ;
#endif

/*
 * Set values in the input object.
 */

#ifdef _NO_PROTO
typedef void (*InputSetValuesProc)(); /* oldw, reqw, new_w, args, num_args */
#else
typedef void (*InputSetValuesProc)(
			Widget,
			Widget,
			Widget,
			ArgList,
			Cardinal *) ;
#endif

/*
 * Inform input of invalidated positions.
 */
#ifdef _NO_PROTO
typedef void (*InputInvalidateProc)(); /* ctx, position, topos, delta */
#else
typedef void (*InputInvalidateProc)(
			XmTextWidget,
			XmTextPosition,
			XmTextPosition,
			long) ;
#endif

/*
 * Get secondary resources.
 */
#ifdef _NO_PROTO
typedef void (*InputGetSecResProc)(); /* secResDataRtn */
#else
typedef void (*InputGetSecResProc)(
			XmSecondaryResourceData *) ;
#endif


typedef struct _InputRec {
    struct _InputDataRec *data;	/* Input-specific data; opaque type. */
    InputInvalidateProc Invalidate;
    InputGetValuesProc  GetValues;
    InputSetValuesProc	SetValues;
    XtWidgetProc	destroy;
    InputGetSecResProc  GetSecResData;
} InputRec;


externalref XtPointer _XmdefaultTextActionsTable;
externalref Cardinal  _XmdefaultTextActionsTableSize;


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmTextInP_h */
/*DON'T ADD ANYTHING AFTER THIS #endif */
