/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: TextP.h,v $
 * Revision 1.9.14.3  1994/03/04  22:27:39  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  22:01:10  drk]
 *
 * Revision 1.9.14.2  1994/02/18  22:34:40  inca
 * 	Remodularization of Text & TextField
 * 	[1994/02/18  22:25:31  inca]
 * 
 * Revision 1.9.14.1  1994/01/06  22:42:54  drk
 * 	Cleanup extra MIN/MAX definitions.
 * 	[1994/01/06  21:36:45  drk]
 * 
 * Revision 1.9.11.4  1993/10/25  19:44:06  inca
 * 	cleaned up usage of MAXINT in Text & TextField: CR4837
 * 	[1993/10/25  19:43:26  inca]
 * 
 * Revision 1.9.11.3  1993/08/23  22:13:01  yak
 * 	Expanded copyright marker
 * 	[1993/08/23  21:24:52  yak]
 * 
 * Revision 1.9.11.2  1993/07/21  23:39:13  inca
 * 	Fixes from Motif1.2.3. Rev. 1.9.9.2, ancestor 1.9.6.4, file TextP.h.
 * 	[1993/07/21  23:38:14  inca]
 * 
 * Revision 1.9.8.5  1993/06/01  19:00:27  drand
 * 	Added XmNdestinationCallback callback list for UTM.
 * 	[1993/06/01  18:58:31  drand]
 * 
 * Revision 1.9.8.4  1993/04/22  19:56:55  drand
 * 	Changed Text to use UTM.
 * 	[1993/04/22  19:54:59  drand]
 * 
 * Revision 1.9.8.3  1993/04/06  21:00:16  daniel
 * 	work Navigator/ScrollFrame work
 * 	[1993/04/06  20:59:33  daniel]
 * 
 * Revision 1.9.8.2  1993/04/01  20:58:31  daniel
 * 	add scrollFrame to Text and List
 * 	[1993/04/01  20:53:10  daniel]
 * 
 * Revision 1.9.6.4  1992/07/27  15:17:37  al
 * 	HP Drop 78
 * 	[1992/07/27  14:37:33  al]
 * 
 * Revision 1.9.6.3  1992/07/20  15:13:01  al
 * 	HP Drop 73
 * 	[1992/07/20  14:57:20  al]
 * 
 * Revision 1.9.6.2  1992/05/28  19:51:30  al
 * 	HP Drop 46
 * 	[1992/05/28  19:49:30  al]
 * 
 * Revision 1.9.2.7  1992/04/13  20:00:37  scholz
 * 	Patch from Joe Whitty to restore PageDown/XmTextScroll behavior during
 * 	a refresh (Redisplay) - PIR 4770.
 * 	[1992/04/13  19:54:29  scholz]
 * 
 * Revision 1.9.2.6  1992/04/01  15:18:03  yak
 * 	Changed type of widget in the _XmTextUpdateLineTable
 * 	[1992/04/01  15:17:42  yak]
 * 
 * Revision 1.9.2.5  1992/03/31  22:32:40  yak
 * 	Integrated diffs from HP
 * 	[1992/03/31  22:02:56  yak]
 * 
 * Revision 1.39  92/03/30  09:20:34  09:20:34  courtney (Courtney Loomis)
 * 	Fixed partially-installed change in _XmTextUpdateLineTable.
 * 
 * Revision 1.38  92/03/27  18:09:28  18:09:28  motif (See Courtney)
 * 	Installation of OSF file header.
 * 
 * Revision 1.9.2.4  1992/03/26  21:25:42  mcollins
 * 	Redo the change from HP.
 * 	[1992/03/26  21:25:11  mcollins]
 * 
 * Revision 1.9  1992/03/13  16:50:14  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/* $RCSfile: TextP.h,v $ $Revision: 1.9.14.3 $ $Date: 1994/03/04 22:27:39 $ */
/* (c) Copyright 1989, DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS. */
/* (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */
#ifndef _XmTextP_h
#define _XmTextP_h

#include <Xm/PrimitiveP.h>
#include <Xm/TextOutP.h>
#include <Xm/TextInP.h>
#include <Xm/TransferT.h>

typedef struct _InputRec *Input;
typedef struct _OutputRec *Output;

#ifdef __cplusplus
extern "C" {
#endif

#define NODELTA		LONG_MAX

#define TEXTWIDGETCLASS	"Text"	/* Resource class for the text widget. */

#define GetSrc(widget)  (((XmTextWidget) (widget))->text.source)

typedef struct {
  XtPointer		extension;	/* Pointer to extension record */
} XmTextClassPart;

typedef struct _XmTextClassRec {
    CoreClassPart core_class;
    XmPrimitiveClassPart primitive_class;
    XmTextClassPart text_class;
} XmTextClassRec;

externalref XmTextClassRec	xmTextClassRec;

typedef struct {
    XmTextPosition start;	/* First position in this line. */
    Boolean changed;		/* TRUE if something in this line changed. */
    XmTextPosition changed_position; /* First position within the line that
					has changed, if any. */
    Boolean past_end;		/* TRUE if this line is past the end of any */
				/* line actually on the screen. */
    LineTableExtra extra;	/* Extra info the output module keeps. */
} LineRec, *Line;

typedef struct _XmTextLineTableRec{
    unsigned int start_pos:31;
    unsigned int virt_line:1;
} XmTextLineTableRec, *XmTextLineTable;

typedef struct {
    XmTextPosition from, to;	/* Information on one range to repaint. */
} RangeRec;

typedef struct {
    Cardinal number;		/* Number of ranges defined. */
    Cardinal maximum;		/* Number of ranges we have space for. */
    RangeRec *range;		/* Pointer to array of ranges. */
} Ranges;


/*
 * Structure for main text info. 
 */

typedef struct _XmTextPart {
    XmTextSource source;		   /* The source for this widget. */
    XtCallbackList activate_callback;      /* command activate callback. */
    XtCallbackList focus_callback;	   /* Focus callback. */
    XtCallbackList losing_focus_callback;  /* Losing focus callback. */
    XtCallbackList value_changed_callback; /* Value changed callback. */
    XtCallbackList modify_verify_callback; /* Verify value to change callback.*/
    XtCallbackList wcs_modify_verify_callback; /* Verify value to change 
						* callback.*/
    XtCallbackList motion_verify_callback; /* Insert cursor position 
					      change callback. */
    XtCallbackList gain_primary_callback; /* Gained ownership of Primary
					     Selection */
    XtCallbackList lose_primary_callback; /* Lost ownership of Primary
					     Selection */
    char *value;		    /* The sring value in the widget */
    wchar_t *wc_value;              /* Pointer for wchar_t value set by app */
    Dimension margin_height;        /* height between text borders and text */
    Dimension margin_width;         /* width between text borders and text */
    Position cursor_position_x;     /* x pixel location of cursor */
    OutputCreateProc output_create; /* Routine to create the output portion. */
    InputCreateProc input_create;   /* Routine to create the input portion. */
    /* The naming incongruity amongst the next three items was introduced */
    /* due to a collision with top_position as used as a Form constraint; */
    /* It has no other implications. */
    XmTextPosition top_character;    /* First position to display. */
    XmTextPosition bottom_position; /* Last position to display. */
    XmTextPosition cursor_position; /* Location of the insertion point. */
    int max_length;		    /* Sets the max. length of string */
    int edit_mode;		    /* Sets the line editing mode
				       (i.e. sinlge_line, multi_line, ...) */
    Boolean auto_show_cursor_position; /* If true, automatically try to show
					  the cursor position whenever it
					  changes. */
    Boolean editable;		  /* Determines if text is editable */
    Boolean verify_bell; 	  /* Determines if bell is sounded when verify
				   *  callback returns doit - False
                                   */
    Boolean add_mode;		  /* Determines the state of add moder */
    Boolean traversed;            /* Flag used with losing focus verification to
				     indicate a traversal key pressed event */
    Boolean in_redisplay;	  /* Whether currently in the redisplay proc. */
    Boolean needs_redisplay;	  /* Whether we need to repaint or refigure. */
    Boolean in_refigure_lines;	  /* Whether currently in refigurelines proc. */
    Boolean needs_refigure_lines; /* Whether we need to refigure. */
    Boolean in_setvalues;         /* Use to reduce unnecessary redisplays and
				     geometry requsets */
    Boolean in_resize;		  /* Make sure there are no geometry requests
				     while we are in resize procedure. */
    Boolean in_expose;		  /* Make sure there are no geometry requests
				     while we are in expose procedure. */
    Boolean highlight_changed;	  /* Whether highlighting recently changed. */
    Boolean pendingoff;         /* TRUE if we shouldn't do pending delete on
                                   the current selection. */
    char char_size;             /* number of bytes for storing a character */

    OnOrOff on_or_off;		  /* used to halt unecessary motion verify
				     callback calls during primary moves.*/
    Output output;		   /* The output portion. */
    Input input;		   /* The input portion. */

    XmTextPosition first_position; /* First legal position in the source. */
    XmTextPosition last_position;  /* Last legal position in the source. */
    XmTextPosition forget_past;	   /* Forget all about positions past this. */
    XmTextPosition force_display;  /* Force this position to be displayed. */
    XmTextPosition new_top;	   /* Desired new top position. */
    XmTextPosition last_top_char;  /* unused - available. */
    XmTextPosition dest_position;  /* Location of the destination point. */
    int disable_depth;		   /* How many levels of disable we've done. */

    int pending_scroll;		/* Number of lines we want to scroll. */
    int total_lines;		/* Total number of lines in the text widget */
    int top_line;		/* Line number of the top visible line */
    int vsbar_scrolling;	/* scrolling using the vertical scrollbar */

    Cardinal number_lines;	/* Number of line table entries. */
    Cardinal maximum_lines;	/* Maximum number of line table entries. */
    Line line;			/* Pointer to array of line table entries. */

    Ranges repaint;		/* Info on the repaint ranges. */
    _XmHighlightData highlight;	/* Info on the highlighting regions. */
    _XmHighlightData old_highlight;/* Old value of above. */
    Widget inner_widget;	/* Pointer to widget which actually contains
				   text (may be same or different from
				   this record).  */
    XmTextLineTable line_table;
    unsigned int table_size;
    unsigned int table_index;

    XtCallbackList  destination_callback;   /* Selection destination cb */
} XmTextPart;

typedef struct _XmTextRec {
    CorePart	core;
    XmPrimitivePart primitive;
    XmTextPart text;
} XmTextRec;


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmTextP_h */
/* DON't ADD STUFF AFTER THIS #endif */
