/*
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF
 * for the full copyright text.
 * 
 */
/*
 * HISTORY
 * $Log: TextStrSoI.h,v $
 * Revision 1.1.2.3  1994/03/04  22:27:49  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  22:01:17  drk]
 *
 * Revision 1.1.2.2  1994/02/20  01:40:39  yak
 * 	Fixed NO_PROTO stuff
 * 	[1994/02/20  01:37:58  yak]
 * 
 * Revision 1.1.2.1  1994/02/18  22:34:46  inca
 * 	Remodularization of Text & TextField
 * 	[1994/02/18  22:25:37  inca]
 * 
 * $EndLog$
 */
/* $RCSfile: TextStrSoI.h,v $ */
/* (c) Copyright 1989, DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS. */
/* (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */
#ifndef _XmTextStrSoI_h
#define _XmTextStrSoI_h

#include <Xm/TextStrSoP.h>

#ifdef __cplusplus
extern "C" {
#endif

/********    Private Function Declarations    ********/
#ifdef _NO_PROTO

extern char  * _XmStringSourceGetString();
extern Boolean _XmTextFindStringBackwards();
extern Boolean _XmTextFindStringForwards();
extern void    _XmStringSourceSetGappedBuffer();
extern Boolean _XmTextModifyVerify();
extern XmTextSource _XmStringSourceCreate();
extern void    _XmStringSourceDestroy();
extern char  * _XmStringSourceGetValue();
extern void    _XmStringSourceSetValue();
extern Boolean _XmStringSourceHasSelection();
extern Boolean _XmStringSourceGetEditable();
extern void    _XmStringSourceSetEditable();
extern int     _XmStringSourceGetMaxLength();
extern void    _XmStringSourceSetMaxLength();

extern int _XmTextBytesToCharacters();
extern int _XmTextCharactersToBytes();
extern void    _XmTextValueChanged();
extern Boolean *_XmStringSourceGetPending();
extern void    _XmStringSourceSetPending();

#else

extern char  * _XmStringSourceGetString(XmTextWidget tw,
				        XmTextPosition from,
				        XmTextPosition to,
#if NeedWidePrototypes
				        int want_wchar);
#else
                                        Boolean want_wchar);
#endif /* NeedWidePrototypes */
extern Boolean _XmTextFindStringBackwards(Widget w,
					  XmTextPosition start,
					  char *search_string,
					  XmTextPosition *position);
extern Boolean _XmTextFindStringForwards(Widget w,
					 XmTextPosition start,
					 char *search_string,
					 XmTextPosition *position);
extern void    _XmStringSourceSetGappedBuffer(XmSourceData data,
					      XmTextPosition position);
extern Boolean _XmTextModifyVerify(XmTextWidget initiator,
				   XEvent *event,
				   XmTextPosition *start,
				   XmTextPosition *end,
				   XmTextPosition *cursorPos,
				   XmTextBlock block,
				   XmTextBlock newblock,
				   Boolean *freeBlock);
extern XmTextSource _XmStringSourceCreate(char *value,
#if NeedWidePrototypes
					  int is_wchar);
#else
                                          Boolean is_wchar);
#endif /* NeedWidePrototypes */
extern void    _XmStringSourceDestroy(XmTextSource source);
extern char  * _XmStringSourceGetValue(XmTextSource source,
#if NeedWidePrototypes
				       int want_wchar);
#else
                                       Boolean want_wchar);
#endif /* NeedWidePrototypes */
extern void    _XmStringSourceSetValue(XmTextWidget widget,
				       char *value);
extern Boolean _XmStringSourceHasSelection(XmTextSource source);
extern Boolean _XmStringSourceGetEditable(XmTextSource source);
extern void    _XmStringSourceSetEditable(XmTextSource source,
#if NeedWidePrototypes
					  int editable);
#else
                                         Boolean editable);
#endif /* NeedWidePrototypes */
extern int     _XmStringSourceGetMaxLength(XmTextSource source);
extern void    _XmStringSourceSetMaxLength(XmTextSource source,
					   int max);
extern int _XmTextBytesToCharacters(char *characters,
				    char *bytes,
				    int num_chars,
#if NeedWidePrototypes
				    int add_null_terminator,
#else
				    Boolean add_null_terminator,
#endif /* NeedWidePrototypes */
				    int max_char_size);
extern int _XmTextCharactersToBytes(char *bytes,
				    char *characters,
				    int num_chars,
				    int max_char_size);
extern void    _XmTextValueChanged(XmTextWidget initiator,
				   XEvent *event);
extern Boolean *_XmStringSourceGetPending(XmTextWidget widget);
extern void    _XmStringSourceSetPending(XmTextWidget widget,
					 Boolean *pending);

#endif /* _NO_PROTO */
/********    End Private Function Declarations    ********/


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /*  _XmTextStrSoI_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
