/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: ToggleBGP.h,v $
 * Revision 1.9.8.5  1994/04/14  14:11:35  drk
 * 	Add XmNindeterminateInsensitivePixmap
 * 	[1994/04/14  14:10:13  drk]
 *
 * Revision 1.9.8.4  1994/03/09  21:36:15  daniel
 * 	add detailShadowThickness support
 * 	[1994/03/09  21:35:42  daniel]
 * 
 * Revision 1.9.8.3  1994/03/04  22:28:04  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  22:01:31  drk]
 * 
 * Revision 1.9.8.2  1994/03/01  01:05:37  drk
 * 	Make toggle indicators look more like CDE's.
 * 	[1994/03/01  01:02:42  drk]
 * 
 * Revision 1.9.8.1  1994/01/20  21:10:04  inca
 * 	Merge some GC:s - indeterminate[_cross|_fill] into one
 * 	and use select_gc for cross too
 * 	[1994/01/20  19:11:24  inca]
 * 
 * Revision 1.9.6.3  1993/11/05  20:35:29  motifics
 * 	Fix CR 5977 -- added GCs for indeterminate state
 * 	[1993/11/05  20:34:38  motifics]
 * 
 * Revision 1.9.6.2  1993/09/19  21:36:27  drk
 * 	CR 2337:  Added new fields to track margin changes forced by indicator.
 * 	[1993/09/19  21:34:29  drk]
 * 
 * Revision 1.9.4.4  1993/07/23  03:04:16  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:37:44  yak]
 * 
 * Revision 1.9.4.3  1993/07/08  15:18:38  rgcote
 * 	Integrated ICS patch to change ToggleMode from being a
 * 	Boolean to being an unsigned char (i.e. enum).
 * 	[1993/07/08  15:17:31  rgcote]
 * 
 * Revision 1.9.4.2  1993/05/28  20:57:48  motifics
 * 	ToggleButton visual and indeterminate state changes
 * 	[1993/05/28  20:54:52  motifics]
 * 
 * Revision 1.9.2.2  1992/07/07  15:04:53  al
 * 	HP Drop 68
 * 	[1992/07/07  15:01:09  al]
 * 
 * Revision 1.9  1992/03/13  16:52:13  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/* $RCSfile: ToggleBGP.h,v $ $Revision: 1.9.8.5 $ $Date: 1994/04/14 14:11:35 $ */
/* (c) Copyright 1989, DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS. */
/* (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */

/********************************************
 *
 *   No new fields need to be defined
 *   for the Toggle widget class record
 *
 ********************************************/

#ifndef _XmToggleButtonGP_h
#define _XmToggleButtonGP_h

#include <Xm/ToggleBG.h>
#include <Xm/LabelGP.h>

#ifdef __cplusplus
extern "C" {
#endif

/*************************************************************/
/* The  ToggleButton Gadget Cache Object's class and instance records*/
/*************************************************************/


typedef struct _XmToggleButtonGCacheObjClassPart
{
    int foo;
} XmToggleButtonGCacheObjClassPart;


typedef struct _XmToggleButtonGCacheObjClassRec 
{
	ObjectClassPart                     object_class;
        XmExtClassPart                      ext_class;
	XmLabelGCacheObjClassPart           label_class_cache;
	XmToggleButtonGCacheObjClassPart    toggle_class_cache;
} XmToggleButtonGCacheObjClassRec;

externalref XmToggleButtonGCacheObjClassRec xmToggleButtonGCacheObjClassRec;


typedef struct _XmToggleButtonGCacheObjPart
{ 
   unsigned char	ind_type;
   Boolean		visible;
   Dimension		spacing;
   Dimension		indicator_dim;
   Pixmap		on_pixmap; 
   Pixmap		insen_pixmap; 
   unsigned char	ind_on;
   Boolean		fill_on_select;
   Pixel		select_color;
   GC			select_GC;
   GC			background_gc;
   unsigned char        toggle_mode;
   Boolean		reversed_select;
   Pixmap               indeterminate_pixmap;
   Pixmap               indeterminate_insensitive_pixmap;
   Pixel                unselect_color;
   GC                   unselect_GC;
   GC                   indeterminate_GC;
   GC                   indeterminate_box_GC;
   Dimension		ind_left_delta;
   Dimension		ind_right_delta;
   Dimension		ind_top_delta;
   Dimension		ind_bottom_delta;
} XmToggleButtonGCacheObjPart;

typedef struct _XmToggleButtonGCacheObjRec
{
    ObjectPart                              object;
    XmExtPart                		    ext;
    XmLabelGCacheObjPart     		    label_cache;
    XmToggleButtonGCacheObjPart             toggle_cache;
} XmToggleButtonGCacheObjRec;


/****************************************************
 *
 * Full class record declaration for Toggle class
 *
 ****************************************************/

typedef struct _XmToggleButtonGadgetClassPart
 {
   XtPointer				   extension;
 } XmToggleButtonGadgetClassPart;


typedef struct _XmToggleButtonGadgetClassRec {
    RectObjClassPart  	 	  	rect_class;
    XmGadgetClassPart  			gadget_class;
    XmLabelGadgetClassPart 	    	label_class;
    XmToggleButtonGadgetClassPart	toggle_class;
} XmToggleButtonGadgetClassRec;


externalref XmToggleButtonGadgetClassRec xmToggleButtonGadgetClassRec;


typedef struct _XmToggleButtonGadgetPart
{ 
   Boolean		indicator_set;
   unsigned char	set;
   unsigned char      	visual_set; /* used for visuals and does not reflect
   		                            the true state of the button */
   Boolean     		Armed;
   XtCallbackList       value_changed_CB,
			arm_CB,
		        disarm_CB;

   XmToggleButtonGCacheObjPart  *cache; /* Replace cache instance fields */
					/* with a pointer */

   Dimension detail_shadow_thickness ;
} XmToggleButtonGadgetPart;



/****************************************************************
 *
 * Full instance record declaration
 *
 ****************************************************************/

typedef struct _XmToggleButtonGadgetRec {
    ObjectPart			object;
    RectObjPart			rectangle;
    XmGadgetPart		gadget;
    XmLabelGadgetPart		label;
    XmToggleButtonGadgetPart	toggle;
} XmToggleButtonGadgetRec;


/**********/
/* MACROS */
/**********/
 
/* Macros for cached instance fields */

#define TBG_IndType(w)		\
	(((XmToggleButtonGadget) (w)) -> toggle.cache->ind_type)
#define TBG_Visible(w)		\
	(((XmToggleButtonGadget) (w)) -> toggle.cache->visible)
#define TBG_Spacing(w)		\
	(((XmToggleButtonGadget) (w)) -> toggle.cache->spacing)
#define TBG_IndicatorDim(w)	\
	(((XmToggleButtonGadget) (w)) -> toggle.cache->indicator_dim)
#define TBG_OnPixmap(w)		\
	(((XmToggleButtonGadget) (w)) -> toggle.cache->on_pixmap)
#define TBG_InsenPixmap(w)	\
	(((XmToggleButtonGadget) (w)) -> toggle.cache->insen_pixmap)
#define TBG_IndOn(w)		\
	(((XmToggleButtonGadget) (w)) -> toggle.cache->ind_on)
#define TBG_FillOnSelect(w)	\
	(((XmToggleButtonGadget) (w)) -> toggle.cache->fill_on_select)
#define TBG_ReversedSelect(w)	\
	(((XmToggleButtonGadget) (w)) -> toggle.cache->reversed_select)
#define TBG_SelectColor(w)	\
	(((XmToggleButtonGadget) (w)) -> toggle.cache->select_color)
#define TBG_SelectGC(w)		\
	(((XmToggleButtonGadget) (w)) -> toggle.cache->select_GC)
#define TBG_BackgroundGC(w)	\
	(((XmToggleButtonGadget) (w)) -> toggle.cache->background_gc)
#define TBG_ToggleMode(w)	\
	(((XmToggleButtonGadget) (w)) -> toggle.cache->toggle_mode)
#define TBG_IndeterminatePixmap(w)	\
	(((XmToggleButtonGadget) (w)) -> toggle.cache->indeterminate_pixmap)
#define TBG_IndeterminateInsensitivePixmap(w)	\
	(((XmToggleButtonGadget) (w)) ->	\
	 toggle.cache->indeterminate_insensitive_pixmap)
#define TBG_IndeterminateGC(w)	\
	(((XmToggleButtonGadget) (w)) -> toggle.cache->indeterminate_GC)
#define TBG_IndeterminateBoxGC(w)	\
	(((XmToggleButtonGadget) (w)) -> toggle.cache->indeterminate_box_GC)
#define TBG_UnselectColor(w)    \
	(((XmToggleButtonGadget) (w)) -> toggle.cache->unselect_color)
#define TBG_UnselectGC(w)       \
	(((XmToggleButtonGadget) (w)) -> toggle.cache->unselect_GC)
#define TBG_IndLeftDelta(w)	\
	(((XmToggleButtonGadget) (w)) -> toggle.cache->ind_left_delta)
#define TBG_IndRightDelta(w)	\
	(((XmToggleButtonGadget) (w)) -> toggle.cache->ind_right_delta)
#define TBG_IndTopDelta(w)	\
	(((XmToggleButtonGadget) (w)) -> toggle.cache->ind_top_delta)
#define TBG_IndBottomDelta(w)	\
	(((XmToggleButtonGadget) (w)) -> toggle.cache->ind_bottom_delta)

/***************************************/
/* Macros for uncached instance fields */

#define TBG_IndicatorSet(w)	\
	(((XmToggleButtonGadget) (w)) -> toggle.indicator_set)
#define TBG_Set(w)		\
	(((XmToggleButtonGadget) (w)) -> toggle.set)
#define TBG_VisualSet(w)	\
	(((XmToggleButtonGadget) (w)) -> toggle.visual_set)
#define TBG_ValueChangedCB(w)	\
	(((XmToggleButtonGadget) (w)) -> toggle.value_changed_CB)
#define TBG_ArmCB(w)		\
	(((XmToggleButtonGadget) (w)) -> toggle.arm_CB)
#define TBG_DisarmCB(w)		\
	(((XmToggleButtonGadget) (w)) -> toggle.disarm_CB)
#define TBG_Armed(w)		\
	(((XmToggleButtonGadget) (w)) -> toggle.Armed)

/******************************/
/* Convenience Macros         */
/******************************/

#define TBG_Cache(w)		(((XmToggleButtonGadget)(w))->toggle.cache)
#define TBG_ClassCachePart(w)	\
        (((XmToggleButtonGadgetClass)xmToggleButtonGadgetClass)->gadget_class.cache_part)


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmToggleButtonGP_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
