/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: ToggleBP.h,v $
 * Revision 1.9.10.1  1994/05/02  19:55:42  drk
 * 	CR 7803: Suppress redundant redraws.
 * 	[1994/05/02  19:54:26  drk]
 *
 * Revision 1.9.8.4  1994/04/14  14:11:43  drk
 * 	Add XmNindeterminateInsensitivePixmap
 * 	[1994/04/14  14:10:19  drk]
 * 
 * Revision 1.9.8.3  1994/03/09  21:36:14  daniel
 * 	add detailShadowThickness support
 * 	[1994/03/09  21:35:40  daniel]
 * 
 * Revision 1.9.8.2  1994/03/01  01:05:38  drk
 * 	Make toggle indicators look more like CDE's.
 * 	[1994/03/01  01:02:43  drk]
 * 
 * Revision 1.9.8.1  1994/01/20  21:10:05  inca
 * 	Merge some GC:s - indeterminate[_cross|_fill] into one
 * 	and use select_gc for cross too
 * 	[1994/01/20  19:11:14  inca]
 * 
 * Revision 1.9.6.3  1993/11/05  20:35:28  motifics
 * 	Fix CR 5977 -- added GCs for indeterminate state
 * 	[1993/11/05  20:34:22  motifics]
 * 
 * Revision 1.9.6.2  1993/09/19  21:36:33  drk
 * 	CR 2337:  Add new fields to track margin changes forced by indicator.
 * 	[1993/09/19  21:34:50  drk]
 * 
 * Revision 1.9.4.5  1993/07/23  03:04:18  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:37:49  yak]
 * 
 * Revision 1.9.4.4  1993/07/08  15:18:40  rgcote
 * 	Integrated ICS patch to change ToggleMode from being a
 * 	Boolean to being an unsigned char (i.e. enum).
 * 	[1993/07/08  15:17:41  rgcote]
 * 
 * Revision 1.9.4.3  1993/06/16  18:55:02  motifics
 * 	Fix accidental loss of rgcote's extension pointer changes.
 * 	[1993/06/16  18:54:17  motifics]
 * 
 * Revision 1.9.4.2  1993/05/28  20:57:53  motifics
 * 	ToggleButton visual and indeterminate state changes
 * 	[1993/05/28  20:54:57  motifics]
 * 
 * Revision 1.9.2.2  1993/03/29  21:18:07  rgcote
 * 	Changed the "int foo" field of the class part structure
 * 	to be an "XtPointer extension" field to allow for
 * 	extensibility.
 * 	[1993/03/29  16:03:51  rgcote]
 * 
 * Revision 1.9  1992/03/13  16:52:24  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/* $RCSfile: ToggleBP.h,v $ $Revision: 1.9.10.1 $ $Date: 1994/05/02 19:55:42 $ */
/* (c) Copyright 1989, DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS. */
/* (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */
/********************************************
 *
 *   No new fields need to be defined
 *   for the Toggle widget class record
 *
 ********************************************/

#ifndef _XmToggleButtonP_h
#define _XmToggleButtonP_h

#include <Xm/ToggleB.h>
#include <Xm/LabelP.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct _XmToggleButtonClassPart
 {
   XtPointer extension;   /* Pointer to extension record */
 } XmToggleButtonClassPart;


/****************************************************
 *
 * Full class record declaration for Toggle class
 *
 ****************************************************/
typedef struct _XmToggleButtonClassRec {
    CoreClassPart	  	core_class;
    XmPrimitiveClassPart  	primitive_class;
    XmLabelClassPart      	label_class;
    XmToggleButtonClassPart	toggle_class;
} XmToggleButtonClassRec;


externalref XmToggleButtonClassRec xmToggleButtonClassRec;


/********************************************
 *
 * No new fields needed for instance record
 *
 ********************************************/

typedef struct _XmToggleButtonPart
{ 
   unsigned char	ind_type;
   Boolean		visible;
   Dimension		spacing;
   Dimension		indicator_dim;
   Boolean		indicator_set;
   Pixmap		on_pixmap; 
   Pixmap		insen_pixmap; 
   unsigned char	set;
   unsigned char	visual_set; /* used for visuals and does not reflect
                                        the true state of the button */
   unsigned char	ind_on;
   Boolean		fill_on_select;
   Pixel		select_color;
   GC			select_GC;
   GC			background_gc;
   XtCallbackList 	value_changed_CB,
                        arm_CB,
                        disarm_CB;
   Boolean      	Armed;
   unsigned char        toggle_mode;
   Boolean		reversed_select;
   Pixmap               indeterminate_pixmap;
   Pixmap               indeterminate_insensitive_pixmap;
   Pixel                unselect_color;
   GC                   unselect_GC;
   GC                   indeterminate_GC;
   GC                   indeterminate_box_GC;
   Dimension		ind_left_delta;
   Dimension		ind_right_delta;
   Dimension		ind_top_delta;
   Dimension		ind_bottom_delta;
   Dimension detail_shadow_thickness ;
} XmToggleButtonPart;



/****************************************************************
 *
 * Full instance record declaration
 *
 ****************************************************************/

typedef struct _XmToggleButtonRec {
    CorePart	        core;
    XmPrimitivePart     primitive;
    XmLabelPart		label;
    XmToggleButtonPart  toggle;
} XmToggleButtonRec;


/********    Private Function Declarations    ********/
#ifdef _NO_PROTO


#else


#endif /* _NO_PROTO */
/********    End Private Function Declarations    ********/


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmToggleButtonP_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
