/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: TraitP.h,v $
 * Revision 1.1.6.1  1994/03/04  22:28:10  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  22:01:34  drk]
 *
 * Revision 1.1.4.2  1993/09/16  22:32:39  drk
 * 	Remove obsolete trait methods.
 * 	[1993/09/16  22:21:00  drk]
 * 
 * Revision 1.1.2.15  1993/07/23  03:04:24  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:38:05  yak]
 * 
 * Revision 1.1.2.14  1993/04/29  13:45:21  yak
 * 	Fixed the previous submittion.
 * 	[1993/04/29  13:45:01  yak]
 * 
 * Revision 1.1.2.13  1993/04/28  21:23:17  drand
 * 	Modified the trait API to be XmeTraitSet and XmeTraitGet with macros
 * 	for older API.  Removed instance trait handling.  Modified files which
 * 	used Trait API but didn't include TraitP.h to include TraitP.h.
 * 	[1993/04/28  20:57:32  drand]
 * 
 * Revision 1.1.2.12  1993/04/09  20:13:38  drand
 * 	Removed XmeTraitExists and XmeTraitModifiable from the Trait API and
 * 	cleaned up the code using them.
 * 	[1993/04/09  20:12:31  drand]
 * 
 * Revision 1.1.2.11  1993/03/15  20:06:36  drand
 * 	Changed Trait mechanism to use XContext manager.
 * 	[1993/03/15  20:05:22  drand]
 * 
 * Revision 1.1.2.10  1993/03/03  18:53:36  drand
 * 	Changed trait code to use Xme names.
 * 	[1993/03/03  18:52:02  drand]
 * 
 * Revision 1.1.2.9  1993/02/02  20:38:42  drand
 * 	Added declarations for _XmIntializeTraits
 * 	[1993/02/02  20:32:29  drand]
 * 
 * Revision 1.1.2.8  1993/01/04  20:23:03  drand
 * 	Removed menu traits to MenuT.h
 * 	[1993/01/04  20:20:25  drand]
 * 
 * Revision 1.1.2.5  1992/10/20  17:17:03  drand
 * 	Changes to quiet non-ansi C compiler problems.
 * 	[1992/10/20  17:16:17  drand]
 * 
 * Revision 1.1.2.4  1992/09/24  15:42:26  daniel
 * 	make it work without proto
 * 	[1992/09/24  15:11:29  daniel]
 * 
 * Revision 1.1.2.2  1992/09/14  19:08:41  drand
 * 	Initial coding.
 * 	[1992/09/14  19:01:20  drand]
 * 
 * $EndLog$
 */

#ifndef _XmTraitP_H
#define _XmTraitP_H 1

#include <Xm/XmP.h>

#ifdef __cplusplus
extern "C" {
#endif

/* Macros */

#define XmeTraitRemove(w, t) XmeTraitSet((XtPointer) w, t, NULL)


/********    Private Function Declarations    ********/
#ifdef _NO_PROTO

/* Semi-Public API for widget writers */
extern XtPointer XmeTraitGet();
extern Boolean XmeTraitSet();

#else

/*
 * XmeTraitGet(object, trait) returns a pointer to the trait_record
 * from looking up the trait on this object.  If the trait
 * is not found then NULL is returned.  This can therefore be used
 * in the following cliche'
 *
 * if (trait_rec = XmeTraitGet(XtClass(w), XmQTactivate)) {
 *   trait_rec -> activate();
 *   trait_rec -> disarm();
 * }
 */

extern XtPointer XmeTraitGet(XtPointer, XrmQuark);

/* 
 * Boolean XmeTraitSet(object, traitname, traitrecord)
 *
 * Installs the trait on the object.  Boolean will indicate
 * success of the installation.  
 * 
 * Install will use the direct pointer to traitrecord given.  The
 * implementation is therefore not allowed to use automatic
 * storage for traitrecord,  but can use malloc or static initialization
 *
 */

extern Boolean XmeTraitSet(XtPointer, XrmQuark, XtPointer);

#endif /* _NO_PROTO */
/********    End Private Function Declarations    ********/

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmTraitP_H */

