/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: TransferP.h,v $
 * Revision 1.1.6.5  1994/03/24  20:39:39  drand
 * 	Fix name of XmeTransferGet to _XmTransferGet
 * 	[1994/03/24  20:38:58  drand]
 *
 * Revision 1.1.6.4  1994/03/24  16:45:08  drand
 * 	Add XmeTransferGetDestinationCBStruct
 * 	[1994/03/24  16:44:44  drand]
 * 
 * Revision 1.1.6.3  1994/03/04  22:28:15  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  22:01:38  drk]
 * 
 * Revision 1.1.6.2  1994/01/21  22:06:55  drand
 * 	Updated for changes to XmTransferValue et al.
 * 	[1994/01/21  21:59:45  drand]
 * 
 * Revision 1.1.6.1  1994/01/19  19:58:04  drand
 * 	Added XmeNamedSource, XmeNamedSink
 * 	[1994/01/19  19:57:42  drand]
 * 
 * Revision 1.1.4.5  1993/11/08  23:00:06  drand
 * 	Removed last argument to XmeClipboardSource
 * 	[1993/11/08  22:57:52  drand]
 * 
 * Revision 1.1.4.4  1993/09/03  20:23:00  inca
 * 	XmeGetLocaleAtom name change to XmeGetEncodingAtom
 * 	[1993/09/03  19:13:05  inca]
 * 
 * Revision 1.1.4.3  1993/08/30  20:58:39  drand
 * 	Added argument for _XmTextToLocaleText,  Boolean *success.
 * 	[1993/08/30  20:26:29  drand]
 * 
 * Revision 1.1.4.2  1993/07/28  17:52:23  drand
 * 	Minor UTM fixes.
 * 	[1993/07/28  17:51:23  drand]
 * 
 * Revision 1.1.2.11  1993/07/23  03:04:34  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:38:27  yak]
 * 
 * Revision 1.1.2.10  1993/07/13  15:41:47  drand
 * 	Fixing CR 5997.  Fixed code bugs,  added new arg to XmeClipboardSink
 * 	to satisfy requirements in XmTextField and XmText.
 * 	[1993/07/13  15:34:56  drand]
 * 
 * Revision 1.1.2.9  1993/07/02  22:08:56  drand
 * 	Fixed UTM to not do fallback targets for Export and Clipboard.
 * 	Changed fields in convertCallbackStruct to use better more
 * 	intrinsic like names.  Fixed a few bugs in the widget.  Added
 * 	better handling for getting the selection event.
 * 	[1993/07/02  22:03:22  drand]
 * 
 * Revision 1.1.2.8  1993/07/01  20:47:16  inca
 * 	Created _XmTextToLocaleText, the code was duplicated in a number of places
 * 	[1993/07/01  20:45:19  inca]
 * 
 * Revision 1.1.2.7  1993/06/30  22:04:33  drand
 * 	Changed _XmGetLocaleAtom to XmeGetLocaleAtom.  Added
 * 	XmeTransferAddDoneProc.
 * 	[1993/06/30  22:02:56  drand]
 * 
 * Revision 1.1.2.6  1993/06/21  18:43:03  drand
 * 	Fix consistency problems with atom name strings for selections.
 * 	Make UTM API changes (operation becomes an enum,  destination_selection
 * 	is removed as a field in the destination callback struct).
 * 	[1993/06/21  14:59:22  drand]
 * 
 * Revision 1.1.2.5  1993/05/13  20:54:55  drand
 * 	Changed signature of XmeStandardTargets to return Atom*.
 * 	[1993/05/13  20:54:05  drand]
 * 
 * Revision 1.1.2.4  1993/05/03  14:02:49  yak
 * 	Fixed type of XmeStandardTargets in _NO_PROTO block.
 * 	[1993/05/03  14:02:01  yak]
 * 
 * Revision 1.1.2.3  1993/04/30  21:17:46  drand
 * 	Update UTM support.  Added XmeStandardTargets and XmeStandardConvert.
 * 	[1993/04/30  21:15:27  drand]
 * 
 * Revision 1.1.2.2  1993/04/27  19:40:40  rgcote
 * 	Moved the Xme functions from Transfer.h to here.
 * 	[1993/04/27  19:09:21  rgcote]
 * 
 * $EndLog$
 */
/* $RCSfile: TransferP.h,v $ $Revision: 1.1.6.5 $ $Date: 1994/03/24 20:39:39 $ */
#ifndef _TransferP_H
#define _TransferP_H

#include <Xm/Transfer.h>

#ifdef _NO_PROTO
extern void XmeConvertMerge();
extern Boolean XmePrimarySource();
extern Boolean XmeNamedSource();
extern Boolean XmeSecondarySource();
extern void XmeSecondaryTransfer();
extern Boolean XmeClipboardSource();
extern Widget XmeDragSource();

extern Boolean XmePrimarySink();
extern Boolean XmeNamedSink();
extern Boolean XmeSecondarySink();
extern Boolean XmeClipboardSink();
extern void XmeDropSink();

extern Atom *XmeStandardTargets();
extern void XmeStandardConvert();
extern Atom XmeGetEncodingAtom();
extern void XmeTransferAddDoneProc();
#else
extern void XmeConvertMerge(XtPointer, Atom, int, unsigned long,
		     XmConvertCallbackStruct*);
extern Boolean XmePrimarySource(Widget, Time);
extern Boolean XmeNamedSource(Widget, Atom, Time);
extern Boolean XmeSecondarySource(Widget, Time);
extern void XmeSecondaryTransfer(Widget, Atom, XtEnum, Time);
extern Boolean XmeClipboardSource(Widget, XtEnum, Time);
extern Widget XmeDragSource(Widget, XtPointer, XEvent*, ArgList, Cardinal);

extern Boolean XmePrimarySink(Widget, XtEnum, XtPointer, Time);
extern Boolean XmeNamedSink(Widget, Atom, XtEnum, XtPointer, Time);
extern Boolean XmeSecondarySink(Widget, Time);
extern Boolean XmeClipboardSink(Widget, XtEnum, XtPointer);
extern void XmeDropSink(Widget, ArgList, Cardinal);

extern Atom *XmeStandardTargets(Widget, int, int*);
extern void XmeStandardConvert(Widget, XtPointer, XmConvertCallbackStruct*);
extern Atom XmeGetEncodingAtom(Widget);
extern void XmeTransferAddDoneProc(XtPointer,
				   XmSelectionFinishedProc);
#endif /* _NO_PROTO */

#endif /* _TransferP_H */
