/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */
/*
 * HISTORY
 * $Log: TransferT.h,v $
 * Revision 1.1.8.1  1994/05/04  19:56:06  drk
 * 	Document trait version numbers.
 * 	[1994/05/04  19:53:00  drk]
 *
 * Revision 1.1.6.1  1994/03/07  15:24:20  drk
 * 	Fix missing includes.
 * 	[1994/03/07  15:23:56  drk]
 * 
 * Revision 1.1.4.2  1993/09/14  21:16:30  inca
 * 	VMS-ify (externaldef/externalref) traits
 * 	[1993/09/14  21:07:45  inca]
 * 
 * Revision 1.1.2.7  1993/07/23  03:04:36  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:38:32  yak]
 * 
 * Revision 1.1.2.6  1993/04/30  21:17:45  drand
 * 	Update UTM support.  Added XmeStandardTargets and XmeStandardConvert.
 * 	[1993/04/30  21:15:39  drand]
 * 
 * Revision 1.1.2.5  1993/04/15  17:55:02  drand
 * 	Changed name of AccessXmString to AccessTextual,  also changes to
 * 	the method parameters.  Added version field.
 * 	[1993/04/15  17:53:49  drand]
 * 
 * Revision 1.1.2.4  1993/04/08  22:09:46  drand
 * 	Changes to UTM to match functional specification.  Some API changes.
 * 	[1993/04/08  22:08:56  drand]
 * 
 * Revision 1.1.2.3  1993/03/10  21:53:43  drand
 * 	Removed doneProc and cancelProc from trait record.  We will probably
 * 	add the cancelProc back later when we support INCR.
 * 	[1993/03/10  21:52:46  drand]
 * 
 * Revision 1.1.2.2  1993/02/16  19:16:27  drand
 * 	Initial revision
 * 	[1993/02/16  19:15:57  drand]
 * 
 * $EndLog$
 */

#ifndef _XmTransferT_H
#define _XmTransferT_H

#include <Xm/Xm.h>
#include <Xm/TransferP.h>

#ifdef __cplusplus
extern "C" {
#endif

externalref XrmQuark XmQTtransfer;

/* Trait structures and typedefs, place typedefs first */

/* Version 0: initial release. */

typedef struct _XmTransferTraitRec {
  int				version;		/* 0 */
  XmConvertCallbackProc		convertProc;
  XmDestinationCallbackProc	destinationProc;
  XmDestinationCallbackProc	destinationPreHookProc;
} XmTransferTraitRec, *XmTransferTrait;

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmTransferT_H */
