/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: TransltnsP.h,v $
 * Revision 1.6.11.3  1994/07/27  18:57:22  drand
 * 	Fix C++ compile problem
 * 	[1994/07/27  18:57:05  drand]
 *
 * Revision 1.6.11.2  1994/06/20  16:09:42  knight
 * 	Removed unused _XmNotebook_PageScrollerAccelerators reference.
 * 	[1994/06/20  16:02:28  knight]
 * 
 * Revision 1.6.11.1  1994/06/10  20:43:19  drk
 * 	CR 7122: Suppress drop-down ComboBox text focusOut events when posting.
 * 	[1994/06/10  15:34:13  drk]
 * 
 * Revision 1.6.9.1  1994/03/04  22:28:16  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  22:01:39  drk]
 * 
 * Revision 1.6.6.6  1993/10/29  21:37:30  drand
 * 	New SpinB Drop,  also moved RepType and Accelerators to proper destinations
 * 	[1993/10/29  21:36:26  drand]
 * 
 * Revision 1.6.6.5  1993/10/28  23:45:02  drk
 * 	Give ComboBox accelerators better names.
 * 	[1993/10/28  23:43:48  drk]
 * 
 * Revision 1.6.6.4  1993/10/27  22:54:03  drk
 * 	New accelerators for ComboBox.
 * 	[1993/10/27  22:53:46  drk]
 * 
 * Revision 1.6.6.3  1993/10/07  22:13:53  deblois
 * 	Applied patch for Notebook translation changes from Anthony.
 * 	[1993/10/07  21:34:56  deblois]
 * 
 * Revision 1.6.6.2  1993/08/03  01:58:01  inca
 * 	Fixes from Motif1.2.3. Rev. 1.6.4.2, ancestor 1.6, file TransltnsP.h.
 * 	[1993/08/03  00:12:19  inca]
 * 
 * Revision 1.6.2.12  1993/07/23  03:04:41  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:38:43  yak]
 * 
 * Revision 1.6.2.11  1993/07/08  20:35:37  rgcote
 * 	Latest code drop from Cindy.
 * 	[1993/07/08  20:34:12  rgcote]
 * 
 * Revision 1.6.2.10  1993/07/08  18:26:19  drk
 * 	Added _XmDragC_defaultTranslations.
 * 	[1993/07/08  17:34:53  drk]
 * 
 * Revision 1.6.2.9  1993/06/28  21:58:02  rgcote
 * 	Latest changes for ComboBox from Cindy.
 * 	[1993/06/28  21:54:05  rgcote]
 * 
 * Revision 1.6.2.8  1993/06/17  15:58:10  msr
 * 	Integrated IBM fixes for CR5853 and CR5858
 * 	[1993/06/17  15:45:56  msr]
 * 
 * Revision 1.6.2.7  1993/05/26  20:10:31  motifibm
 * 	IBM Alpha drop - Anthony
 * 	[1993/05/25  14:10:16  motifibm]
 * 
 * Revision 1.6.2.6  1993/04/28  23:45:42  motifdec
 * 	Add CSText translations
 * 	[1993/04/28  01:26:32  motifdec]
 * 
 * Revision 1.6.2.5  1993/04/22  21:53:42  rgcote
 * 	Added combo box traversal translations.
 * 	[1993/04/20  20:37:53  rgcote]
 * 
 * Revision 1.6.2.4  1993/03/30  22:48:21  motiflotus
 * 	ComboBox, GrabShell integration.
 * 	[1993/03/30  21:31:12  motiflotus]
 * 
 * Revision 1.6.2.3  1993/02/03  20:30:53  daniel
 * 	check point
 * 	[1992/11/06  16:09:52  daniel]
 * 
 * Revision 1.6.2.2  1992/10/21  20:28:21  drand
 * 	Added translations for the SpinButton widget.
 * 	[1992/10/21  20:26:31  drand]
 * 
 * Revision 1.6  1992/03/13  16:52:46  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/* $RCSfile: TransltnsP.h,v $ $Revision: 1.6.11.3 $ $Date: 1994/07/27 18:57:22 $ */
/* (c) Copyright 1989, DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS. */
/* (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */
#ifndef _XmTransltnsP_h
#define _XmTransltnsP_h

#include <X11/Intrinsic.h>	/* for externalref */

#ifdef __cplusplus
extern "C" {
#endif


#ifndef _XmConst
#define _XmConst
#endif


externalref _XmConst char _XmArrowB_defaultTranslations[];
externalref _XmConst char _XmBulletinB_defaultTranslations[];
externalref _XmConst char _XmCascadeB_menubar_events[];
externalref _XmConst char _XmCascadeB_p_events[];
externalref _XmConst char _XmComboBox_defaultTranslations[];
externalref _XmConst char _XmComboBox_defaultAccelerators[];
externalref _XmConst char _XmComboBox_dropDownComboBoxAccelerators[];
externalref _XmConst char _XmComboBox_dropDownListTranslations[];
externalref _XmConst char _XmComboBox_textFocusTranslations[];
externalref _XmConst char _XmContainer_defaultTranslations[];
externalref _XmConst char _XmContainer_traversalTranslations[];
externalref _XmConst char _XmDragC_defaultTranslations[];
externalref _XmConst char _XmDrawingA_defaultTranslations[];
externalref _XmConst char _XmDrawingA_traversalTranslations[];
externalref _XmConst char _XmDrawnB_defaultTranslations[];
externalref _XmConst char _XmFrame_defaultTranslations[];
externalref _XmConst char _XmGrabShell_translations [];
externalref _XmConst char _XmLabel_defaultTranslations[];
externalref _XmConst char _XmLabel_menuTranslations[];
externalref _XmConst char _XmLabel_menu_traversal_events[];
externalref _XmConst char _XmList_ListXlations1[];
externalref _XmConst char _XmList_ListXlations2[];
externalref _XmConst char _XmManager_managerTraversalTranslations[];
externalref _XmConst char _XmManager_defaultTranslations[];
externalref _XmConst char _XmNotebook_manager_translations[];
externalref _XmConst char _XmNotebook_TabAccelerators[];
externalref _XmConst char _XmMenuShell_translations [];
externalref _XmConst char _XmPrimitive_defaultTranslations[];
externalref _XmConst char _XmPushB_defaultTranslations[];
externalref _XmConst char _XmPushB_menuTranslations[];
externalref _XmConst char _XmRowColumn_menu_traversal_table[];
externalref _XmConst char _XmRowColumn_bar_table[];
externalref _XmConst char _XmRowColumn_option_table[];
externalref _XmConst char _XmRowColumn_menu_table[];
externalref _XmConst char _XmSash_defTranslations[];
externalref _XmConst char _XmScrollBar_defaultTranslations[];
externalref _XmConst char _XmScrolledW_ScrolledWindowXlations[];
externalref _XmConst char _XmClipWindowTranslationTable[];
externalref _XmConst char _XmScrolledW_WorkWindowTranslationTable[];
externalref _XmConst char _XmSelectioB_defaultTextAccelerators[];
externalref _XmConst char _XmSpinB_defaultTranslations[];
externalref _XmConst char _XmSpinB_defaultAccelerators[];
externalref _XmConst char _XmTearOffB_overrideTranslations[];
externalref _XmConst char _XmTextF_EventBindings1[];
externalref _XmConst char _XmTextF_EventBindings2[]; 
externalref _XmConst char _XmTextF_EventBindings3[];
externalref _XmConst char _XmTextIn_XmTextEventBindings1[];
externalref _XmConst char _XmTextIn_XmTextEventBindings2[];
externalref _XmConst char _XmTextIn_XmTextEventBindings3[];
externalref _XmConst char _XmToggleB_defaultTranslations[];
externalref _XmConst char _XmToggleB_menuTranslations[];
externalref _XmConst char _XmVirtKeys_fallbackBindingString[];
externalref _XmConst char _XmCSText_EventBindings1[];
externalref _XmConst char _XmCSText_EventBindings2[];
externalref _XmConst char _XmCSText_EventBindings3[];

/* The following keybindings have been "grandfathered" 
   for backward compatablility.
*/
externalref _XmConst char _XmVirtKeys_acornFallbackBindingString[];
externalref _XmConst char _XmVirtKeys_apolloFallbackBindingString[];
externalref _XmConst char _XmVirtKeys_dgFallbackBindingString[];
externalref _XmConst char _XmVirtKeys_decFallbackBindingString[];
externalref _XmConst char _XmVirtKeys_dblclkFallbackBindingString[];
externalref _XmConst char _XmVirtKeys_hpFallbackBindingString[];
externalref _XmConst char _XmVirtKeys_ibmFallbackBindingString[];
externalref _XmConst char _XmVirtKeys_ingrFallbackBindingString[];
externalref _XmConst char _XmVirtKeys_megatekFallbackBindingString[];
externalref _XmConst char _XmVirtKeys_motorolaFallbackBindingString[];
externalref _XmConst char _XmVirtKeys_sgiFallbackBindingString[];
externalref _XmConst char _XmVirtKeys_siemensWx200FallbackBindingString[];
externalref _XmConst char _XmVirtKeys_siemens9733FallbackBindingString[];
externalref _XmConst char _XmVirtKeys_sunFallbackBindingString[];
externalref _XmConst char _XmVirtKeys_tekFallbackBindingString[];

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmTransltnsP_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
