/*
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF
 * for the full copyright text.
 * 
 */
/*
 * HISTORY
 * $Log: TravConT.h,v $
 * Revision 1.1.4.2  1994/05/17  19:35:53  daniel
 * 	add Xm/Xm.h
 * 	[1994/05/17  19:35:40  daniel]
 *
 * Revision 1.1.4.1  1994/05/04  19:56:07  drk
 * 	Document trait version numbers.
 * 	[1994/05/04  19:53:02  drk]
 * 
 * Revision 1.1.2.1  1994/03/24  23:41:02  drk
 * 	Create the traversal control trait.
 * 	[1994/03/24  23:05:47  drk]
 * 
 * $EndLog$
 */
#ifndef _XmTravConT_h
#define _XmTravConT_h

#include <Xm/Xm.h>

#ifdef __cplusplus
extern "C" {
#endif

externalref XrmQuark XmQTtraversalControl;


#ifdef _NO_PROTO
typedef Widget (*XmTraversalRedirectionProc)();
#else
typedef Widget (*XmTraversalRedirectionProc)(Widget               old_focus,
					     Widget               new_focus,
					     unsigned int         focus_policy,
					     XmTraversalDirection direction,
					     unsigned int         pass);
#endif /* _NO_PROTO */


/* Version 0: initial release. */

typedef struct _XmTraversalControlTraitRec {
  int				version;	/* 0 */
  XmTraversalRedirectionProc	redirect;
} XmTraversalControlTraitRec, *XmTraversalControlTrait;


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* XmTravConT_h */
