/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: TraversalI.h,v $
 * Revision 1.7.10.3  1994/07/19  21:02:23  drk
 * 	CR 9705: Special case overlapping work windows.
 * 	[1994/07/19  20:58:31  drk]
 *
 * Revision 1.7.10.2  1994/06/03  21:19:42  drk
 * 	CR 9181: Clipping affects mouse hit computation.
 * 	[1994/06/03  21:18:59  drk]
 * 
 * Revision 1.7.10.1  1994/04/26  21:09:32  drk
 * 	Make CDE global traversal directions public.
 * 	[1994/04/26  21:08:27  drk]
 * 
 * Revision 1.7.8.5  1994/03/24  17:42:20  drk
 * 	Make _XmTraverse....TabGroup obsolete.
 * 	[1994/03/24  17:42:01  drk]
 * 
 * Revision 1.7.8.4  1994/03/18  18:30:32  drk
 * 	Fix typo.
 * 	[1994/03/18  18:30:22  drk]
 * 
 * Revision 1.7.8.3  1994/03/18  18:08:50  drk
 * 	Support enableButtonTab.
 * 	[1994/03/18  18:07:16  drk]
 * 
 * Revision 1.7.8.2  1994/03/04  22:28:22  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  22:01:46  drk]
 * 
 * Revision 1.7.8.1  1994/02/01  22:04:52  drk
 * 	Kill _XmMgrTraversalOrder, since it is unnecessary after all.
 * 	[1994/02/01  22:04:34  drk]
 * 
 * Revision 1.7.6.3  1993/09/23  22:54:52  drk
 * 	Added _XmMgrTraversalOrder.
 * 	[1993/09/23  22:53:51  drk]
 * 
 * Revision 1.7.6.2  1993/09/01  21:50:37  drk
 * 	Changes for the new traversal algorithm.
 * 	[1993/09/01  21:39:29  drk]
 * 
 * Revision 1.7.4.2  1993/07/23  03:05:10  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:39:13  yak]
 * 
 * Revision 1.7.2.5  1992/04/03  23:04:15  yak
 * 	Integrated diffs from HP
 * 	[1992/04/03  18:50:26  yak]
 * 
 * Revision 1.36  92/04/02  09:24:05  09:24:05  courtney (Courtney Loomis)
 * 	Restored bogus XmAddTabGroup behavior.
 * 
 * Revision 1.7.2.4  1992/03/25  17:00:53  al
 * 	Fix integration
 * 	[1992/03/25  16:58:58  al]
 * 
 * Revision 1.7.2.3  1992/03/24  22:27:24  al
 * 	integrate HP changes
 * 	[1992/03/24  22:10:37  al]
 * 
 * Revision 1.7.2.2  1992/03/19  19:18:18  tomm
 * 	Acceptance fix from HP for Pir4545.
 * 	[1992/03/19  18:57:25  tomm]
 * 
 * Revision 1.7  1992/03/13  16:53:31  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/*   $RCSfile: TraversalI.h,v $ $Revision: 1.7.10.3 $ $Date: 1994/07/19 21:02:23 $ */
/* (c) Copyright 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */
#ifndef _XmTraversalI_h
#define _XmTraversalI_h

#include <Xm/XmP.h>

#ifdef __cplusplus
extern "C" {
#endif


#define NavigTypeIsTabGroup(navigation_type) \
  ((navigation_type == XmTAB_GROUP) || \
   (navigation_type == XmSTICKY_TAB_GROUP) || \
   (navigation_type == XmEXCLUSIVE_TAB_GROUP))


typedef enum {
    XmUnrelated,
    XmMyAncestor,
    XmMyDescendant,
    XmMyCousin,
    XmMySelf
} XmGeneology;

typedef struct _XmTravGraphRec
{   
    union _XmTraversalNodeRec *head ;
    Widget top ;
    union _XmTraversalNodeRec *current ;
    unsigned short num_entries ;
    unsigned short num_alloc ;
    unsigned short next_alloc ;
    unsigned short exclusive ;
    unsigned short tab_list_alloc ;
    unsigned short num_tab_list ;
    Widget *excl_tab_list ;
} XmTravGraphRec, * XmTravGraph ;


typedef struct _XmFocusDataRec {
    Widget	active_tab_group;
    Widget	focus_item;
    Widget	old_focus_item;
    Widget	pointer_item;
    Widget	old_pointer_item;
    Boolean	needToFlush;
    XCrossingEvent lastCrossingEvent;
    XmGeneology focalPoint;
    unsigned char focus_policy ; /* Mirrors focus_policy resource when focus */
    XmTravGraphRec trav_graph ;  /*   data retrieved using _XmGetFocusData().*/
    Widget      first_focus ;
} XmFocusDataRec ;

typedef enum
{
  XmTAB_GRAPH_NODE, XmTAB_NODE, XmCONTROL_GRAPH_NODE, XmCONTROL_NODE
} XmTravGraphNodeType ;

typedef union _XmDeferredGraphLink
{
  int offset ;
  struct _XmGraphNodeRec *link ;
} XmDeferredGraphLink ;

typedef struct _XmAnyNodeRec               /* Common */
{
  unsigned char type ;
  XmNavigationType nav_type ;
  XmDeferredGraphLink tab_parent ;
  Widget widget ;
  XRectangle rect ;
  union _XmTraversalNodeRec *next ;
  union _XmTraversalNodeRec *prev ;
} XmAnyNodeRec, *XmAnyNode ;

typedef struct _XmControlNodeRec
{
  XmAnyNodeRec any ;
  union _XmTraversalNodeRec *up ;
  union _XmTraversalNodeRec *down ;
} XmControlNodeRec, *XmControlNode ;

typedef struct _XmTabNodeRec
{
  XmAnyNodeRec any ;
} XmTabNodeRec, *XmTabNode ;

typedef struct _XmGraphNodeRec
{
  XmAnyNodeRec any ;
  union _XmTraversalNodeRec *sub_head ;
  union _XmTraversalNodeRec *sub_tail ;
} XmGraphNodeRec, *XmGraphNode ;

typedef union _XmTraversalNodeRec
{
  XmAnyNodeRec any ;
  XmControlNodeRec control ;
  XmTabNodeRec tab ;
  XmGraphNodeRec graph ;
} XmTraversalNodeRec, *XmTraversalNode ;

typedef struct
{
  XmTraversalNode *items;
  XmTraversalNode lead_item;
  Cardinal num_items;
  Cardinal max_items;
  Position min_hint;
  Position max_hint;
} XmTraversalRow;


/********    Private Function Declarations for Traversal.c    ********/
#ifdef _NO_PROTO

extern XmFocusData _XmCreateFocusData() ;
extern void _XmDestroyFocusData() ;
extern void _XmSetActiveTabGroup() ;
extern Widget _XmGetActiveItem() ;
extern void _XmNavigInitialize() ;
extern Boolean _XmNavigSetValues() ;
extern void _XmNavigResize() ;
extern void _XmValidateFocus() ;
extern void _XmNavigDestroy() ;
extern Boolean _XmCallFocusMoved() ;
extern Boolean _XmMgrTraversal() ;
extern void _XmClearFocusPath() ;
extern Boolean _XmFocusIsHere() ;
extern unsigned char _XmGetFocusPolicy() ;
extern Widget _XmFindTopMostShell() ;
extern void _XmFocusModelChanged() ;
extern XmFocusData _XmGetFocusData() ;
extern Boolean _XmComputeVisibilityRect() ;
extern Boolean _XmGetPointVisibility() ;
extern void _XmSetRect() ;
extern int _XmIntersectRect() ;
extern int _XmEmptyRect() ;
extern void _XmClearRect() ;
extern Boolean _XmIsNavigable() ;
extern void _XmWidgetFocusChange() ;
extern Widget _XmNavigate() ;
extern void _XmSetInitialOfTabGroup() ;
extern void _XmResetTravGraph() ;
extern Boolean _XmShellIsExclusive() ;
extern Widget _XmGetFirstFocus() ;

#else

extern XmFocusData _XmCreateFocusData( void ) ;
extern void _XmDestroyFocusData( 
                        XmFocusData focusData) ;
extern void _XmSetActiveTabGroup( 
                        XmFocusData focusData,
                        Widget tabGroup) ;
extern Widget _XmGetActiveItem( 
                        Widget w) ;
extern void _XmNavigInitialize( 
                        Widget request,
                        Widget new_wid,
                        ArgList args,
                        Cardinal *num_args) ;
extern Boolean _XmNavigSetValues( 
                        Widget current,
                        Widget request,
                        Widget new_wid,
                        ArgList args,
                        Cardinal *num_args) ;
extern void _XmNavigResize( 
                        Widget wid) ;
extern void _XmValidateFocus( 
                        Widget wid) ;
extern void _XmNavigDestroy( 
                        Widget wid) ;
extern Boolean _XmCallFocusMoved( 
                        Widget old,
                        Widget new_wid,
                        XEvent *event) ;
extern Boolean _XmMgrTraversal( 
                        Widget wid,
                        XmTraversalDirection direction) ;
extern void _XmClearFocusPath( 
                        Widget wid) ;
extern Boolean _XmFocusIsHere( 
                        Widget w) ;
extern unsigned char _XmGetFocusPolicy( 
                        Widget w) ;
extern Widget _XmFindTopMostShell( 
                        Widget w) ;
extern void _XmFocusModelChanged( 
                        Widget wid,
                        XtPointer client_data,
                        XtPointer call_data) ;
extern XmFocusData _XmGetFocusData( 
                        Widget wid) ;
extern Boolean _XmComputeVisibilityRect( 
                        Widget w,
                        XRectangle *rectPtr,
			Boolean include_initial_border,
			Boolean allow_scrolling) ;
extern Boolean _XmGetPointVisibility(Widget w,
				     int root_x, 
				     int root_y);
extern void _XmSetRect( 
                        register XRectangle *rect,
                        Widget w) ;
extern int _XmIntersectRect( 
                        register XRectangle *srcRectA,
                        register Widget widget,
                        register XRectangle *dstRect) ;
extern int _XmEmptyRect( 
                        register XRectangle *r) ;
extern void _XmClearRect( 
                        register XRectangle *r) ;
extern Boolean _XmIsNavigable( 
                        Widget wid) ;
extern void _XmWidgetFocusChange( 
                        Widget wid,
                        XmFocusChange change) ;
extern Widget _XmNavigate( 
                        Widget wid,
                        XmTraversalDirection direction) ;
extern void _XmSetInitialOfTabGroup( 
                        Widget tab_group,
                        Widget init_focus) ;
extern void _XmResetTravGraph( 
                        Widget wid) ;
extern Boolean _XmShellIsExclusive( 
                        Widget wid) ;
extern Widget _XmGetFirstFocus( 
                        Widget wid) ;

#endif /* _NO_PROTO */
/********    End Private Function Declarations    ********/

/********    Private Function Declarations for TraversalI.c    ********/
#ifdef _NO_PROTO

extern XmNavigability _XmGetNavigability() ;
extern Boolean _XmIsViewable() ;
extern Widget _XmIsScrollableClipWidget() ;
extern Boolean _XmGetEffectiveView() ;
extern Boolean _XmIntersectionOf() ;
extern XmNavigationType _XmGetNavigationType() ;
extern Widget _XmGetActiveTabGroup() ;
extern Widget _XmTraverseAway() ;
extern Widget _XmTraverse() ;
extern void _XmFreeTravGraph() ;
extern void _XmTravGraphRemove() ;
extern void _XmTravGraphAdd() ;
extern void _XmTravGraphUpdate() ;
extern Boolean _XmNewTravGraph() ;
extern Boolean _XmSetInitialOfTabGraph() ;
extern void _XmTabListAdd() ;
extern void _XmTabListDelete() ;

#else

extern XmNavigability _XmGetNavigability( 
                        Widget wid) ;
extern Boolean _XmIsViewable( 
                        Widget wid) ;
extern Widget _XmIsScrollableClipWidget( 
                        Widget work_window,
			Boolean scrollable,
                        XRectangle *visRect) ;
extern Boolean _XmGetEffectiveView( 
                        Widget wid,
                        XRectangle *visRect) ;
extern Boolean _XmIntersectionOf( 
                        register XRectangle *srcRectA,
                        register XRectangle *srcRectB,
                        register XRectangle *destRect) ;
extern XmNavigationType _XmGetNavigationType( 
                        Widget widget) ;
extern Widget _XmGetActiveTabGroup( 
                        Widget wid) ;
extern Widget _XmTraverseAway( 
                        XmTravGraph list,
                        Widget wid,
#if NeedWidePrototypes
                        int wid_is_control) ;
#else
                        Boolean wid_is_control) ;
#endif /* NeedWidePrototypes */
extern Widget _XmTraverse( 
                        XmTravGraph list,
                        XmTraversalDirection action,
                        XmTraversalDirection *local_dir,
                        Widget reference_wid) ;
extern void _XmFreeTravGraph( 
                        XmTravGraph trav_list) ;
extern void _XmTravGraphRemove( 
                        XmTravGraph tgraph,
                        Widget wid) ;
extern void _XmTravGraphAdd( 
                        XmTravGraph tgraph,
                        Widget wid) ;
extern void _XmTravGraphUpdate( 
                        XmTravGraph tgraph,
                        Widget wid) ;
extern Boolean _XmNewTravGraph( 
                        XmTravGraph trav_list,
                        Widget top_wid,
                        Widget init_current) ;
extern Boolean _XmSetInitialOfTabGraph( 
                        XmTravGraph trav_graph,
                        Widget tab_group,
                        Widget init_focus) ;
extern void _XmTabListAdd( 
                        XmTravGraph graph,
                        Widget wid) ;
extern void _XmTabListDelete( 
                        XmTravGraph graph,
                        Widget wid) ;

#endif /* _NO_PROTO */
/********    End Private Function Declarations    ********/


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmTraversalI_h */
