/*
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF
 * for the full copyright text.
 * 
 */
/*
 * HISTORY
 * $Log: UnitTypeT.h,v $
 * Revision 1.1.21.1  1994/05/04  19:56:10  drk
 * 	Document trait version numbers.
 * 	[1994/05/04  19:53:04  drk]
 *
 * Revision 1.1.19.2  1994/03/07  15:24:22  drk
 * 	Fix missing includes.
 * 	[1994/03/07  15:23:57  drk]
 * 
 * Revision 1.1.19.1  1993/12/29  18:19:26  daniel
 * 	rework the conversion modules
 * 	[1993/12/29  18:17:21  daniel]
 * 
 * $EndLog$
 */
#ifndef _XmUnitTypeT_H
#define _XmUnitTypeT_H

#include <Xm/Xm.h>

#ifdef __cplusplus
extern "C" {
#endif

externalref XrmQuark XmQTspecifyUnitType;

/* Trait structures and typedefs, place typedefs first */

#ifdef _NO_PROTO
typedef unsigned char (*XmSpecUnitTypeGetProc)();
#else
typedef unsigned char (*XmSpecUnitTypeGetProc)(Widget wid);
#endif /* _NO_PROTO */

/* Version 0: initial release. */

typedef struct _XmSpecUnitTypeTraitRec {
  int			version;	/* 0 */
  XmSpecUnitTypeGetProc getUnitType; 
} XmSpecUnitTypeTraitRec, *XmSpecUnitTypeTrait;


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmUnitTypeT_H */

