/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: VendorSEP.h,v $
 * Revision 1.5.71.2  1994/03/04  22:28:39  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  22:02:03  drk]
 *
 * Revision 1.5.71.1  1993/12/29  18:19:33  daniel
 * 	rework the conversion modules
 * 	[1993/12/29  18:17:27  daniel]
 * 
 * Revision 1.5.6.2  1993/08/30  21:22:38  drk
 * 	Moved the declaration of _XmGetLayoutDirection() into XmP.h, since the
 * 	GetLayout() macros there reference it.
 * 	[1993/08/30  21:21:32  drk]
 * 
 * Revision 1.5.4.7  1993/07/23  03:05:42  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:39:54  yak]
 * 
 * Revision 1.5.4.6  1993/06/28  23:09:14  inca
 * 	Cleaning up Right-to-left layout
 * 	[1993/06/28  20:53:24  inca]
 * 
 * Revision 1.5.4.5  1993/06/17  19:19:48  inca
 * 	added extern definition for _XmGetLayoutDirection
 * 	[1993/06/17  14:00:08  inca]
 * 
 * 	layout_direction should have type XmDirection
 * 	[1993/06/09  15:56:03  inca]
 * 
 * Revision 1.5.4.4  1993/06/04  16:54:01  drand
 * 	XmeAdd and XmeRemoveFocusChangeCallback are added.
 * 	[1993/06/04  16:53:11  drand]
 * 
 * Revision 1.5.4.3  1993/05/05  19:04:38  drk
 * 	Create XmNinputPolicy resource.
 * 	[1993/04/26  20:07:06  drk]
 * 
 * Revision 1.5.4.2  1993/03/16  19:59:38  motifdec
 * 	DEC checkin - RtoL layout
 * 	[1993/03/15  22:11:25  motifdec]
 * 
 * Revision 1.5.2.2  1992/12/10  18:20:37  drand
 * 	Incorporated fix for CR 1914 (String to Pixmap Converter Should
 * 	not be NoopConverter)
 * 	[1992/12/10  18:18:35  drand]
 * 
 * Revision 1.5  1992/03/13  16:54:55  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/* $RCSfile: VendorSEP.h,v $ $Revision: 1.5.71.2 $ $Date: 1994/03/04 22:28:39 $ */
/* (c) Copyright 1989, 1990  DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS. */
/* (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */
/* (c) Copyright 1988 MASSACHUSETTS INSTITUTE OF TECHNOLOGY  */
/* (c) Copyright 1988 MICROSOFT CORPORATION */
#ifndef _XmVendorSEP_h
#define _XmVendorSEP_h

#include <Xm/ShellEP.h>
#include <Xm/MwmUtil.h>

#ifdef __cplusplus
extern "C" {
#endif


#ifndef XmIsVendorShellExt
#define XmIsVendorShellExt(w)	XtIsSubclass(w, xmVendorShellExtObjectClass)
#endif /* XmIsVendorShellExt */

typedef struct _XmVendorShellExtRec *XmVendorShellExtObject;
typedef struct _XmVendorShellExtClassRec *XmVendorShellExtObjectClass;
externalref WidgetClass xmVendorShellExtObjectClass;


#define XmInheritProtocolHandler	((XtCallbackProc)_XtInherit)

typedef struct _XmVendorShellExtClassPart{
    XtCallbackProc	delete_window_handler;
    XtCallbackProc	offset_handler;
    XtPointer		extension;
}XmVendorShellExtClassPart, *XmVendorShellExtClassPartPtr;

typedef struct _XmVendorShellExtClassRec{
    ObjectClassPart		object_class;
    XmExtClassPart		ext_class;
    XmDesktopClassPart 		desktop_class;
    XmShellExtClassPart		shell_class;
    XmVendorShellExtClassPart 	vendor_class;
}XmVendorShellExtClassRec;

typedef struct {
 XmFontList		default_font_list;
 unsigned char		focus_policy;
 XmFocusData		focus_data;
 unsigned char		delete_response;
 unsigned char		unit_type;
 MwmHints		mwm_hints;
 MwmInfo		mwm_info;
 String			mwm_menu;
 XtCallbackList		focus_moved_callback;
 /*
  * internal fields
  */
 Widget			old_managed;
 Position		xAtMap, yAtMap, xOffset, yOffset;
 unsigned long		lastOffsetSerial;
 unsigned long		lastMapRequest;
 Boolean		externalReposition;
 unsigned char		mapStyle;
 XtCallbackList		realize_callback;
 XtGrabKind		grab_kind;
 Boolean		audible_warning;
 XmFontList             button_font_list;
 XmFontList             label_font_list;
 XmFontList             text_font_list;
 String			input_method_string;
 String			preedit_type_string;
 unsigned int           light_threshold;
 unsigned int           dark_threshold;
 unsigned int           foreground_threshold;
 unsigned int		im_height;
 XtPointer		im_info;
 Boolean		im_vs_height_set;

 /* New public resources for Motif 2.0 */
 XmDirection            layout_direction;
 XmInputPolicy		input_policy;
} XmVendorShellExtPart, *XmVendorShellExtPartPtr;

externalref XmVendorShellExtClassRec 	xmVendorShellExtClassRec;

typedef struct _XmVendorShellExtRec{
    ObjectPart			object;
    XmExtPart			ext;
    XmDesktopPart		desktop;
    XmShellExtPart		shell;
    XmVendorShellExtPart 	vendor;
} XmVendorShellExtRec;


/******** Xme Functions ********/
#ifdef _NO_PROTO

void XmeAddFocusChangeCallback();
void XmeRemoveFocusChangeCallback();

#else

void XmeAddFocusChangeCallback(Widget, XtCallbackProc, XtPointer);
void XmeRemoveFocusChangeCallback(Widget, XtCallbackProc, XtPointer);

#endif /* _NO_PROTO */
/******** End Xme Functions ********/

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif  /* _XmVendorSEP_h */
