/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: VirtKeysP.h,v $
 * Revision 1.7.6.2  1994/03/04  22:28:47  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  22:02:08  drk]
 *
 * Revision 1.7.6.1  1994/01/31  20:26:17  drk
 * 	Make _XmVirtKeysHandler and associated XmDisplay fields obsolete.
 * 	[1994/01/31  20:25:58  drk]
 * 
 * Revision 1.7.4.5  1993/07/23  03:05:55  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:40:16  yak]
 * 
 * Revision 1.7.4.4  1993/07/08  18:26:23  drk
 * 	Create XmVKeyBinding.
 * 	[1993/07/08  18:23:32  drk]
 * 
 * Revision 1.7.4.3  1993/07/01  00:18:56  rgcote
 * 	Removed declarations for _Xm functions which have become
 * 	Xme functions.
 * 	[1993/06/30  23:47:03  rgcote]
 * 
 * Revision 1.7.4.2  1993/06/28  20:13:30  drk
 * 	Made XmKeyBinding type public.
 * 	[1993/06/28  17:23:18  drk]
 * 
 * Revision 1.7.2.3  1992/03/31  01:32:36  al
 * 	Move defaultVirtualBindings to XmDisplay
 * 	[1992/03/31  01:30:40  al]
 * 
 * Revision 1.7.2.2  1992/03/26  19:48:02  al
 * 	No change
 * 	[1992/03/19  21:25:14  al]
 * 
 * 	Merge xmbind.alias fixes
 * 	[1992/03/19  21:06:11  al]
 * 
 * Revision 1.7  1992/03/13  16:55:19  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/* $RCSfile: VirtKeysP.h,v $ $Revision: 1.7.6.2 $ $Date: 1994/03/04 22:28:47 $ */
/* (c) Copyright 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */
#ifndef _XmVirtKeysP_h
#define _XmVirtKeysP_h

#include <Xm/XmP.h>
#include <Xm/VirtKeys.h>

#ifdef __cplusplus
extern "C" {
#endif

#define XmKEYCODE_TAG_SIZE 32

typedef struct _XmDefaultBindingStringRec {
    String	vendorName;
    String	defaults;
} XmDefaultBindingStringRec, *XmDefaultBindingString;

typedef	struct _XmVirtualKeysymRec {
    String		name;
    KeySym		keysym;
} XmVirtualKeysymRec, *XmVirtualKeysym;

/* For converting a Virtual keysym to a real keysym. */
typedef struct _XmVKeyBindingRec
{
  KeySym	keysym;
  Modifiers	modifiers;
  KeySym	virtkey;
} XmVKeyBindingRec, *XmVKeyBinding;

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmVirtKeysP_h */
