/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: Xm.h,v $
 * Revision 1.12.33.8  1994/07/18  21:52:57  drand
 * 	Fix 9440: Update string list
 * 	[1994/07/18  21:46:00  drand]
 *
 * Revision 1.12.33.7  1994/07/18  21:20:34  daniel
 * 	fir for 9440: frame #define for childType
 * 	[1994/07/18  21:20:23  daniel]
 * 
 * Revision 1.12.33.6  1994/06/13  21:07:24  drk
 * 	CR 9408: Rationalize XmRAutoSelection enumeration.
 * 	[1994/06/13  20:48:17  drk]
 * 
 * Revision 1.12.33.5  1994/06/02  21:18:31  daniel
 * 	change color constants
 * 	[1994/06/01  17:05:56  daniel]
 * 
 * Revision 1.12.33.4  1994/05/24  23:14:11  deblois
 * 	Made single definition of XmCR_PROTOCOLS per CR 9158.
 * 	[1994/05/24  23:13:52  deblois]
 * 
 * Revision 1.12.33.3  1994/05/24  22:28:03  dick
 * 	Add XmSELECT_OUT_LINE to the XmTextScanType enum
 * 	[1994/05/24  21:58:12  dick]
 * 
 * Revision 1.12.33.2  1994/04/28  21:07:20  meeks
 * 	Fixes from Motif2.0F. Rev. 1.12.34.2, ancestor 1.12.31.23, file Xm.h.
 * 	[1994/04/28  21:07:03  meeks]
 * 
 * Revision 1.12.33.1  1994/04/26  21:09:36  drk
 * 	Make CDE global traversal directions public.
 * 	[1994/04/26  21:08:28  drk]
 * 
 * Revision 1.12.31.23  1994/04/25  21:33:18  drk
 * 	CR 8722:  Cleanup CodeCenter warnings.
 * 	[1994/04/22  23:57:18  drk]
 * 
 * Revision 1.12.31.22  1994/04/19  21:10:27  daniel
 * 	fix for 8583: XmObjectAtPoint return Widget
 * 	[1994/04/19  21:09:31  daniel]
 * 
 * Revision 1.12.31.21  1994/04/13  21:59:10  drand
 * 	Changed XmGadgetAtPoint to XmObjectAtPoint
 * 	[1994/04/13  21:53:19  drand]
 * 
 * Revision 1.12.31.20  1994/04/11  21:11:50  meeks
 * 	CR 7938: Added XmStringIsVoid.
 * 	[1994/04/11  16:04:06  meeks]
 * 
 * Revision 1.12.31.19  1994/03/29  22:20:17  meeks
 * 	PERF: Changes to XmRendition and XmFontListEntry declarations for
 * 	rendition sharing.
 * 	CR 8329: Added Xm[Nr|CR]endition[Foreground|Background].
 * 	[1994/03/29  21:57:41  meeks]
 * 
 * 	PERF: Added handles to renditions, still leaks.
 * 	[1994/03/28  21:58:15  meeks]
 * 
 * 	PERF: Intermediate check-in of rendition/rendertable sharing.  Leaks and no handles for renditions.
 * 	[1994/03/25  22:02:54  meeks]
 * 
 * Revision 1.12.31.18  1994/03/25  16:34:07  drand
 * 	Finish adding XmREnableBtn1Transfer reptype
 * 	[1994/03/25  16:33:27  drand]
 * 
 * Revision 1.12.31.17  1994/03/25  16:24:25  drand
 * 	Added new enableBtn1Transfer ennumeration values
 * 	[1994/03/25  16:24:02  drand]
 * 
 * Revision 1.12.31.16  1994/03/18  22:36:10  daniel
 * 	add chil_top/bottom alignment
 * 	[1994/03/18  20:05:22  daniel]
 * 
 * Revision 1.12.31.15  1994/03/17  22:22:13  daniel
 * 	 implement new sliderVisual/Mark support
 * 	[1994/03/17  21:54:40  daniel]
 * 
 * Revision 1.12.31.14  1994/03/11  22:04:07  meeks
 * 	CR 7948: Remove XmStringGetNextFullSegment
 * 	[1994/03/11  17:00:49  meeks]
 * 
 * Revision 1.12.31.13  1994/03/09  21:16:56  daniel
 * 	add XmNdetailShadowThickness and XmHIGHLIGHT_COLOR
 * 	[1994/03/09  21:13:52  daniel]
 * 
 * Revision 1.12.31.12  1994/03/08  23:48:05  drk
 * 	Merged with changes from 1.12.31.11
 * 	[1994/03/08  23:47:46  drk]
 * 
 * 	Support enable_toggle_visual.
 * 	[1994/03/08  23:47:04  drk]
 * 
 * Revision 1.12.31.11  1994/03/08  22:54:43  inca
 * 	Add XmNarea to XmIm argument list, to be used for preeditPosition
 * 	[1994/03/08  16:21:22  inca]
 * 
 * Revision 1.12.31.10  1994/03/07  15:46:10  daniel
 * 	fix comment in comment warning
 * 	[1994/03/07  15:45:57  daniel]
 * 
 * Revision 1.12.31.9  1994/03/07  15:33:35  daniel
 * 	pathmode work
 * 	[1994/03/06  21:00:00  daniel]
 * 
 * Revision 1.12.31.8  1994/03/04  22:40:49  drand
 * 	New CDE Enumeration for Display,  moved strings to XmStrDefs.h
 * 	[1994/03/04  22:35:55  drand]
 * 
 * Revision 1.12.31.7  1994/03/03  20:11:41  pascale
 * 	Drop from IBM - Implementing design change for
 * 	new_outline_state filed in XmContainerOutlineCallbackStruct
 * 	[1994/03/03  20:06:55  pascale]
 * 
 * Revision 1.12.31.6  1994/03/01  01:05:39  drk
 * 	Make toggle indicators look more like CDE's.
 * 	[1994/03/01  01:02:44  drk]
 * 
 * Revision 1.12.31.5  1994/02/02  22:14:15  drk
 * 	Ditto.
 * 	[1994/02/02  19:14:46  drk]
 * 
 * 	CR 7907: Promoted _XmStringConcatAndFree to a public function.
 * 	[1994/02/02  19:10:53  drk]
 * 
 * Revision 1.12.31.4  1994/01/13  22:07:21  daniel
 * 	create TxtPropCv.h
 * 	[1994/01/13  21:42:11  daniel]
 * 
 * Revision 1.12.31.3  1993/12/29  21:25:13  daniel
 * 	mv XmTabListGetPosition as _Xm + unit
 * 	[1993/12/29  21:24:53  daniel]
 * 
 * Revision 1.12.31.2  1993/12/28  15:36:44  daniel
 * 	rework of the pixmap cache/conversion
 * 	[1993/12/28  15:34:23  daniel]
 * 
 * Revision 1.12.31.1  1993/12/16  22:22:35  drand
 * 	Put value XmDRAG_WINDOW into Xm.h
 * 	[1993/12/16  22:19:44  drand]
 * 
 * Revision 1.12.23.38  1993/12/03  22:44:03  inca
 * 	Modify XmStringGetNextSegment & XmStringGetNextComponent to match 1.2.3
 * 	[1993/12/03  22:30:19  inca]
 * 
 * Revision 1.12.23.37  1993/11/22  21:19:30  rgcote
 * 	Added the XmCresizable resource class until we can update StrDefs.
 * 	[1993/11/22  21:14:41  rgcote]
 * 
 * Revision 1.12.23.36  1993/11/12  22:24:50  rgcote
 * 	Removed the obsolete length argument to XmCvtByteStreamToXmString.
 * 	[1993/11/12  22:22:41  rgcote]
 * 
 * Revision 1.12.23.35  1993/11/10  21:54:28  meeks
 * 	Merged with changes from 1.12.23.34
 * 	[1993/11/10  21:54:20  meeks]
 * 
 * 	CR 6155: Changed unsigned int args to Cardinal for RenderTable and TabList functions.
 * 	[1993/11/10  01:49:29  meeks]
 * 
 * 	CR 5671: Added XmSTRING_COMPONENT_FONTLIST_ELEMENT_TAG.
 * 	[1993/11/09  17:49:54  meeks]
 * 
 * Revision 1.12.23.34  1993/11/10  16:46:24  rgcote
 * 	Merged with changes from 1.12.23.33
 * 	[1993/11/10  16:45:38  rgcote]
 * 
 * 	Changed function XmStringCvtToASN1 to be
 * 	XmCvtXmStringToByteStream, XmStringCvtFromASN1 to be
 * 	XmCvtByteStreamToXmString and XmCompoundStringSize to
 * 	be XmStringByteStreamLength.
 * 	[1993/11/09  18:49:16  rgcote]
 * 
 * Revision 1.12.23.33  1993/11/09  21:05:36  shobana
 * 	fixed CR 6627 : moved callback reasons to Xm.h from Notebook.h
 * 	[1993/11/09  20:31:38  shobana]
 * 
 * Revision 1.12.23.32  1993/11/08  23:43:20  drk
 * 	Fixes from Motif1.2.4. Rev. 1.12.27.2, ancestor , file Xm.h.
 * 	CR 6842: Added XmCR_FOCUS_MOVED.
 * 
 * 	Also shuffled XmCR_PROTOCOLS to the same place it has in Motif 1.2,
 * 	and left some empty numbers for future additions.
 * 	[1993/11/08  23:42:57  drk]
 * 
 * Revision 1.12.23.31  1993/11/04  23:12:54  drand
 * 	Moved callback struct to Xm.h from SpinB.h
 * 	[1993/11/04  23:12:38  drand]
 * 
 * Revision 1.12.23.30  1993/11/03  23:27:28  drand
 * 	Reordered Arrow sensitivity values to make them bit values.  Added
 * 	SpinBox CR reasons.
 * 	[1993/11/03  23:26:44  drand]
 * 
 * Revision 1.12.23.29  1993/10/25  18:50:52  deblois
 * 	Fix for CR 5395 regarding XmNdefaultVirtualBindings.
 * 	[1993/10/25  18:49:51  deblois]
 * 
 * Revision 1.12.23.28  1993/10/20  20:20:16  rgcote
 * 	Merged with changes from 1.12.23.27
 * 	[1993/10/20  20:20:08  rgcote]
 * 
 * 	Added an external decl for XmCompoundStringSize.
 * 	[1993/10/20  20:19:24  rgcote]
 * 
 * Revision 1.12.23.27  1993/10/20  20:16:31  meeks
 * 	I 231: Changed signature of XmStringGetNextFullSegment.
 * 	[1993/10/20  20:12:08  meeks]
 * 
 * Revision 1.12.23.26  1993/10/19  21:13:33  meeks
 * 	I 160: Added XmNforegroundState, XmNbackgroundState, XmCGroundState,
 * 	XmRGroundState, and XmFORCE_COLOR.
 * 	[1993/10/19  21:01:25  meeks]
 * 
 * Revision 1.12.23.25  1993/10/19  00:38:35  daniel
 * 	add select color constant
 * 	[1993/10/18  18:58:50  daniel]
 * 
 * Revision 1.12.23.24  1993/10/14  20:33:14  rgcote
 * 	Merged with changes from 1.12.23.23
 * 	[1993/10/14  20:33:03  rgcote]
 * 
 * 	Added the typedef'ed enum for XmICCEncodingStyle used by the
 * 	conversion functions for XmStringTable <--> TextProperty.
 * 	[1993/10/14  20:32:02  rgcote]
 * 
 * Revision 1.12.23.23  1993/10/12  21:17:37  motifdec
 * 	Added XmCCSTextSource defn. until XmStrDefs.h is generated again.
 * 	[1993/10/12  21:11:56  motifdec]
 * 
 * Revision 1.12.23.22  1993/10/07  22:13:54  deblois
 * 	Changed NoteBook -> Notebook.
 * 	[1993/10/07  18:39:30  deblois]
 * 
 * Revision 1.12.23.21  1993/10/01  21:10:24  daniel
 * 	Diff from Anthony for new design
 * 	[1993/10/01  21:08:51  daniel]
 * 
 * Revision 1.12.23.20  1993/09/28  20:11:17  meeks
 * 	Removed decl for XmRenderTableCompile and added decl for XmStringPutRendition.
 * 	[1993/09/28  20:10:52  meeks]
 * 
 * Revision 1.12.23.19  1993/09/24  17:18:44  daniel
 * 	incorporate anthony diff
 * 	[1993/09/24  17:05:14  daniel]
 * 
 * Revision 1.12.23.18  1993/09/23  19:44:25  daniel
 * 	add XmTabListGetPosition
 * 	[1993/09/23  19:41:50  daniel]
 * 
 * Revision 1.12.23.17  1993/09/14  23:14:00  motifibm
 * 	IBM Drop 9/14
 * 	[1993/09/14  23:11:16  motifibm]
 * 
 * Revision 1.12.23.16  1993/09/14  17:23:59  meeks
 * 	Changed typedefs for XmString and _XmString.
 * 	[1993/09/14  15:37:03  meeks]
 * 
 * Revision 1.12.23.15  1993/09/14  16:39:02  daniel
 * 	add Rep Type for IconGadget
 * 	[1993/09/14  15:52:44  daniel]
 * 
 * Revision 1.12.23.14  1993/09/02  22:03:09  drand
 * 	Removed string defs to xmstrings.list.  Updated XmStrDefs.c,h
 * 	[1993/09/02  21:59:06  drand]
 * 
 * Revision 1.12.23.13  1993/09/01  17:31:08  daniel
 * 	add some resource name and macros
 * 	[1993/09/01  17:29:02  daniel]
 * 
 * Revision 1.12.23.12  1993/08/24  16:00:08  rgcote
 * 	This is the last code drop from Cindy for ComboBox.
 * 	[1993/08/24  15:57:32  rgcote]
 * 
 * Revision 1.12.23.11  1993/08/23  22:13:58  yak
 * 	Expanded copyright marker
 * 	[1993/08/23  21:27:04  yak]
 * 
 * Revision 1.12.23.10  1993/08/18  15:30:57  drk
 * 	Give XmStringParseText it's new elegant *text_end profile.
 * 	[1993/08/18  15:28:43  drk]
 * 
 * Revision 1.12.23.9  1993/08/17  21:17:14  drk
 * 	Give XmStringParseText it's new clumsy *text_in_out profile.
 * 	[1993/08/17  21:16:18  drk]
 * 
 * Revision 1.12.23.8  1993/08/03  01:58:10  inca
 * 	Fixes from Motif1.2.3. Rev. 1.12.24.2, ancestor 1.12.15.4, file Xm.h
 * 	[1993/08/03  00:21:15  inca]
 * 
 * Revision 1.12.23.7  1993/08/02  20:20:06  meeks
 * 	CR 5738: Added XmRTopItemPosition.
 * 	[1993/08/02  20:18:35  meeks]
 * 
 * Revision 1.12.23.6  1993/07/28  21:12:06  rec
 * 	Fixes from Motif1.2.3. Rev. 1.12.24.2, ancestor 1.12.15.3, file Xm.h.
 * 
 * 	CR 5767
 * 	[1993/07/28  21:11:45  rec]
 * 
 * Revision 1.12.23.5  1993/07/26  22:53:42  drk
 * 	Converted parse_count parameters to Cardinals.
 * 	[1993/07/26  22:52:50  drk]
 * 
 * Revision 1.12.23.4  1993/07/26  22:47:26  drk
 * 	Added string constants for the newest virtkeys, including osfLeftLine
 * 	and osfRightLine.
 * 	[1993/07/26  22:41:38  drk]
 * 
 * Revision 1.12.23.3  1993/07/26  21:13:55  meeks
 * 	Added call_data argument to XmStringTableParseStringArray.
 * 	[1993/07/26  21:11:54  meeks]
 * 
 * Revision 1.12.23.2  1993/07/16  22:16:55  drk
 * 	Added osfSwitchDirection virtkey.
 * 	[1993/07/16  15:51:57  drk]
 * 
 * Revision 1.12.8.86  1993/07/13  15:32:38  inca
 * 	Added XmNcstextValue and XmCCSTextValue per changes from DEC
 * 	[1993/07/13  15:30:35  inca]
 * 
 * Revision 1.12.8.85  1993/07/10  02:27:59  meeks
 * 	2.0 4.2: Handles for XmRenderTable, XmN defines for tabs.
 * 	Also move XmTextStatus to here.
 * 	[1993/07/10  02:05:30  meeks]
 * 
 * Revision 1.12.8.84  1993/07/08  18:44:14  meeks
 * 	I 143: Wrong file checked in.  Corrected version.
 * 	[1993/07/08  18:43:51  meeks]
 * 
 * Revision 1.12.8.83  1993/07/08  18:26:27  drk
 * 	Added XmV strings for more virtkeys.
 * 	[1993/07/08  17:06:09  drk]
 * 
 * Revision 1.12.8.82  1993/07/08  18:15:19  meeks
 * 	I 143: Added #defines for widget resource name changes.
 * 	[1993/07/08  16:54:51  meeks]
 * 
 * Revision 1.12.8.81  1993/07/02  21:18:37  drk
 * 	Remove trailing commas from enum lists to reduce warnings.
 * 	[1993/07/02  21:17:31  drk]
 * 
 * Revision 1.12.8.80  1993/07/02  18:14:40  daniel
 * 	put in Xm.c
 * 	[1993/07/02  18:11:00  daniel]
 * 
 * Revision 1.12.8.79  1993/07/02  15:14:04  daniel
 * 	create new basic header
 * 	[1993/07/02  15:12:48  daniel]
 * 
 * Revision 1.12.8.78  1993/07/01  21:17:36  daniel
 * 	implement XmGadgetAtPoint
 * 	[1993/07/01  21:16:20  daniel]
 * 
 * Revision 1.12.8.77  1993/07/01  02:01:11  meeks
 * 	2.0 4.2: Fixed problems with function signatures.  Various changes previous
 * 	to resyncing.
 * 	[1993/07/01  01:53:38  meeks]
 * 
 * Revision 1.12.8.76  1993/07/01  01:00:41  meeks
 * 	2.0 4.2: Out of sync with XmString.c.  Attempting to resynchronize.
 * 	[1993/07/01  00:58:31  meeks]
 * 
 * Revision 1.12.8.75  1993/06/30  22:53:40  drk
 * 	Adapt to today's spec for XmParseMapping et al.
 * 	[1993/06/30  22:49:43  drk]
 * 
 * Revision 1.12.8.74  1993/06/30  17:04:00  rgcote
 * 	Fixed the spin button child type enumeration to have the correct
 * 	value for the XmNUMERIC member.
 * 	[1993/06/30  17:03:35  rgcote]
 * 
 * Revision 1.12.8.73  1993/06/30  15:34:05  rgcote
 * 	Moved spin button enums here and moved temporary resource
 * 	definitions to XmStrDefs.
 * 	[1993/06/30  15:21:05  rgcote]
 * 
 * Revision 1.12.8.72  1993/06/28  23:23:56  inca
 * 	Oops - slight mistake
 * 	[1993/06/28  23:22:23  inca]
 * 
 * Revision 1.12.8.71  1993/06/28  23:09:16  inca
 * 	Removed #ifdef RTOL
 * 	[1993/06/25  20:42:10  inca]
 * 
 * Revision 1.12.8.70  1993/06/25  19:54:57  meeks
 * 	2.0 4.2.2: Fixed render table string defines.
 * 	Modified signature of XmRenditionCreate.
 * 	[1993/06/25  19:32:59  meeks]
 * 
 * Revision 1.12.8.69  1993/06/24  22:56:14  inca
 * 	Changed the method names to be Strings.
 * 	[1993/06/24  17:30:22  inca]
 * 
 * Revision 1.12.8.68  1993/06/22  21:23:24  drand
 * 	Changed prototypes for XmRenderTableCvtTo/FromProp.
 * 	Added Transfer.h to include file list.
 * 	[1993/06/22  21:23:03  drand]
 * 
 * Revision 1.12.8.67  1993/06/21  22:22:22  meeks
 * 	2.0 4.2.2: Added XmCR_NO_FONT, XmCR_NO_RENDITION, XmDisplayCallbackStruct,
 * 	XmNnoFontCallback and XmNnoRenditionCallback.
 * 	[1993/06/21  22:04:45  meeks]
 * 
 * Revision 1.12.8.66  1993/06/18  15:46:52  drand
 * 	Added XmNdragStartCallback to the temporary strings.
 * 	[1993/06/18  15:46:33  drand]
 * 
 * Revision 1.12.8.65  1993/06/18  15:19:18  drand
 * 	Integrate HP 2.0 Drag and Drop enhancements.
 * 	[1993/06/18  15:15:38  drand]
 * 
 * Revision 1.12.8.64  1993/06/17  19:19:51  inca
 * 	Numerous changes of layoutDirection and XmOS method definitions
 * 	[1993/06/17  14:30:17  inca]
 * 
 * Revision 1.12.8.63  1993/06/15  22:30:30  drk
 * 	Added XmStringGenerate().
 * 	[1993/06/15  22:30:06  drk]
 * 
 * Revision 1.12.8.62  1993/06/14  23:55:21  drk
 * 	Delete vestigial XmSTRING_DIRECTION_ALL.
 * 	[1993/06/14  23:54:42  drk]
 * 
 * Revision 1.12.8.61  1993/06/11  21:01:53  drk
 * 	Removed XmMatchModel, updated XmStringUnparse per today's spec
 * 	changes.
 * 	[1993/06/11  20:58:55  drk]
 * 
 * Revision 1.12.8.60  1993/06/11  12:53:41  inca
 * 	Moved a couple of new defines, added _MOTIF_DEFAULT_LOCALE
 * 	[1993/06/10  22:45:43  inca]
 * 
 * Revision 1.12.8.59  1993/06/11  00:13:49  drk
 * 	Deleted unused types.
 * 	[1993/06/09  21:52:55  drk]
 * 
 * Revision 1.12.8.58  1993/06/08  23:15:11  meeks
 * 	2.0 4.2.2: Additional #defines and changed signature of XmRenditionCreate.
 * 	[1993/06/08  22:41:35  meeks]
 * 
 * 	2.0 4.2.2: Added or modified various #defines/enums for renditions.
 * 	[1993/06/07  21:25:11  meeks]
 * 
 * Revision 1.12.8.57  1993/06/08  22:57:07  drk
 * 	Updated to account for recent XmStringParse spec changes.
 * 	[1993/06/08  22:53:55  drk]
 * 
 * Revision 1.12.8.56  1993/06/08  22:30:52  inca
 * 	*** empty log message ***
 * 	[1993/06/08  22:27:21  inca]
 * 
 * 	Added some #defines for iswhitespace and scanbreak routines
 * 	[1993/06/07  21:30:37  inca]
 * 
 * Revision 1.12.8.55  1993/06/07  15:13:32  drk
 * 	Fixed typo in _NO_PROTO XmTabListCopy() declaration.
 * 	[1993/06/07  15:12:32  drk]
 * 
 * Revision 1.12.8.54  1993/06/07  01:44:30  meeks
 * 	2.0 4.2.1: Changed the signature of XmStringTableProposeTablist and
 * 	XmTabListReplacePositions.
 * 	[1993/06/07  01:33:53  meeks]
 * 
 * Revision 1.12.8.53  1993/06/03  15:34:32  inca
 * 	XmInputPolicy must be unsigned char. (RepType.c expects enums
 * 	to be this type)
 * 	[1993/06/03  15:27:18  inca]
 * 
 * Revision 1.12.8.52  1993/06/02  21:58:09  drk
 * 	Renamed XmStringIncludeStatus to XmIncludeStatus, added a dummy
 * 	XmDirection type.
 * 	[1993/06/02  18:53:34  drk]
 * 
 * Revision 1.12.8.51  1993/06/01  14:36:45  daniel
 * 	add bitmapconversion support
 * 	[1993/06/01  14:31:27  daniel]
 * 
 * Revision 1.12.8.50  1993/05/28  22:46:34  drk
 * 	Updated XmParseMapping types.
 * 	[1993/05/28  22:46:15  drk]
 * 
 * Revision 1.12.8.49  1993/05/28  20:57:55  motifics
 * 	ToggleButton visual and indeterminate state changes
 * 	[1993/05/28  20:55:04  motifics]
 * 
 * Revision 1.12.8.48  1993/05/24  18:31:54  meeks
 * 	2.0 4.2.2: Various fixes for renditions.
 * 	[1993/05/24  18:14:16  meeks]
 * 
 * Revision 1.12.8.47  1993/05/20  21:56:21  rgcote
 * 	Fixes from Motif1.2.3. Rev. 1.12.21.2, ancestor 1.12.15.2, file Xm.h.
 * 	[1993/05/20  21:56:03  rgcote]
 * 
 * Revision 1.12.8.46  1993/05/19  20:10:25  meeks
 * 	2.0 4.2.2: Added support for XmRenderTable and XmRendition.
 * 	[1993/05/19  20:03:37  meeks]
 * 
 * Revision 1.12.8.45  1993/05/17  21:33:50  drk
 * 	Added new component types, removed XmStringComponent.
 * 	[1993/05/17  21:20:24  drk]
 * 
 * Revision 1.12.8.44  1993/05/14  21:36:45  drk
 * 	Added parse proc string component type.
 * 	[1993/05/14  21:34:00  drk]
 * 
 * Revision 1.12.8.43  1993/05/14  17:47:51  daniel
 * 	put ResolvePartOffset back
 * 	[1993/05/14  17:47:07  daniel]
 * 
 * Revision 1.12.8.42  1993/05/13  21:00:32  daniel
 * 	more takesDefault support
 * 	[1993/05/13  20:59:13  daniel]
 * 
 * Revision 1.12.8.41  1993/05/12  19:18:06  meeks
 * 	2.0 4.2: Added enums, structures and function declarations.
 * 	[1993/05/12  18:21:20  meeks]
 * 
 * Revision 1.12.8.40  1993/05/10  22:46:40  drk
 * 	Removed XmInputPolicy XmPER_DISPLAY enumeration.
 * 	[1993/05/10  19:37:19  drk]
 * 
 * Revision 1.12.8.39  1993/05/10  14:54:23  rgcote
 * 	Added the combo box callback struct and a new callback
 * 	reason for combo box: XmCR_SELECT.
 * 	[1993/05/10  14:49:10  rgcote]
 * 
 * Revision 1.12.8.38  1993/05/04  18:09:47  drk
 * 	Removed XmCREATE_XIC enumeration.
 * 	[1993/05/04  18:08:19  drk]
 * 
 * Revision 1.12.8.37  1993/04/30  17:39:44  daniel
 * 	add motifVersion and enableWarp
 * 	[1993/04/30  17:38:32  daniel]
 * 
 * Revision 1.12.8.36  1993/04/28  20:14:53  motifics
 * 	Added definitions for Screen's insensitive stipple bitmap resource
 * 	[1993/04/28  20:06:17  motifics]
 * 
 * Revision 1.12.8.35  1993/04/27  21:34:34  daniel
 * 	creation of join side trait
 * 	[1993/04/27  21:33:11  daniel]
 * 
 * Revision 1.12.8.34  1993/04/27  14:09:23  rgcote
 * 	Got rid of the XmResolvePartOffsets declaration. It has been
 * 	moved to XmP.h.
 * 	[1993/04/26  16:23:57  rgcote]
 * 
 * Revision 1.12.8.33  1993/04/26  22:39:10  meeks
 * 	2.0 4.2.5: Changed typedef of XmStringContext.
 * 	[1993/04/26  22:29:58  meeks]
 * 
 * Revision 1.12.8.32  1993/04/26  14:42:33  drk
 * 	Moved XmIm declarations to <Xm/XmIm.h>.  Added Xm{N,C,R}inputPolicy.
 * 	[1993/04/26  14:37:35  drk]
 * 
 * Revision 1.12.8.31  1993/04/22  21:55:23  rgcote
 * 	Added some combo box enum's and resource #define's
 * 	[1993/04/20  20:39:01  rgcote]
 * 
 * Revision 1.12.8.30  1993/04/22  21:24:21  meeks
 * 	S 4.2: Added component alias.  Added XmTextType, XmRendition.  Modified
 * 	XmHighlightMode.  Added decls for XmStringCvt[To|From]ASN1.
 * 	[1993/04/22  21:22:35  meeks]
 * 
 * 	Intermediate save for XmString -> _XmString conversion.
 * 	[1993/03/30  21:49:45  meeks]
 * 
 * Revision 1.12.8.29  1993/04/13  20:55:32  motifics
 * 	Added definitions for new XmList resources
 * 	[1993/04/13  20:49:25  motifics]
 * 
 * Revision 1.12.8.28  1993/04/13  20:28:52  motifics
 * 	Added resource definitions for XmScreen's color allocation proc
 * 	[1993/04/13  20:24:23  motifics]
 * 
 * Revision 1.12.8.27  1993/04/08  17:20:42  rgcote
 * 	Put the XmAUTO enum back in (see last log message). It turns
 * 	out the Container.c is now using it so it can't go in List.h.
 * 	[1993/04/08  17:19:02  rgcote]
 * 
 * 	Removed the automatic selection type enum. It resides
 * 	in List.h
 * 	[1993/04/06  13:32:25  rgcote]
 * 
 * Revision 1.12.8.26  1993/04/07  22:07:26  motifics
 * 	Added new unit type values for resolution independent resource conversion
 * 	[1993/04/07  22:06:30  motifics]
 * 
 * Revision 1.12.8.25  1993/04/05  23:55:19  motifibm
 * 	IBM Drop 3 - Anthony
 * 	[1993/04/05  23:52:07  motifibm]
 * 
 * Revision 1.12.8.24  1993/04/01  19:21:38  rgcote
 * 	Added the auto_selection_type field to the callback struct
 * 	[1993/04/01  19:20:08  rgcote]
 * 
 * Revision 1.12.8.23  1993/04/01  16:30:05  daniel
 * 	modify some XmR names to comply to capitalized protocol
 * 	[1993/04/01  16:29:46  daniel]
 * 
 * Revision 1.12.8.22  1993/04/01  14:29:49  daniel
 * 	update XmVERSION and XmREVISION macro
 * 	[1993/04/01  14:29:25  daniel]
 * 
 * Revision 1.12.8.21  1993/03/31  14:31:23  daniel
 * 	move new 2.0 #define in Xm.h
 * 	[1993/03/31  14:08:27  daniel]
 * 
 * Revision 1.12.8.20  1993/03/30  22:48:15  motiflotus
 * 	Added ComboBox defines.
 * 	[1993/03/30  21:37:08  motiflotus]
 * 
 * Revision 1.12.8.19  1993/03/18  18:54:45  daniel
 * 	implement the childType resource
 * 	[1993/03/18  17:21:36  daniel]
 * 
 * Revision 1.12.8.18  1993/03/16  19:59:40  motifdec
 * 	DEC checkin - RtoL layout
 * 	[1993/03/15  22:11:31  motifdec]
 * 
 * Revision 1.12.8.17  1993/03/15  16:51:17  daniel
 * 	childType changes
 * 	[1993/03/15  16:49:24  daniel]
 * 
 * Revision 1.12.8.16  1993/03/11  21:50:28  motifibm
 * 	IBM Code Drop 2 - Anthony
 * 	[1993/03/11  17:49:13  motifibm]
 * 
 * Revision 1.12.8.15  1993/02/26  16:38:12  daniel
 * 	check in autodrag
 * 	[1993/02/24  22:16:08  daniel]
 * 
 * Revision 1.12.8.14  1993/02/19  19:43:04  meeks
 * 	*** empty log message ***
 * 
 * Revision 1.12.8.13  1993/02/18  20:52:27  qauser
 * 	Initial drop from Anthony
 * 	[1993/02/18  18:38:46  qauser]
 * 
 * Revision 1.12.8.12  1993/02/04  20:50:19  daniel
 * 	 put in the childType basics
 * 	[1993/02/04  20:01:47  daniel]
 * 
 * Revision 1.12.8.11  1993/01/31  04:12:48  daniel
 * 	check point thermo scroll + thumb mark
 * 	[1993/01/31  04:03:34  daniel]
 * 
 * Revision 1.12.8.10  1993/01/15  18:09:26  drand
 * 	Removed temporary definition for popupHandlerCallback.  This
 * 	is now defined in XmStrDefs.h.
 * 	[1993/01/15  18:08:27  drand]
 * 
 * Revision 1.12.8.9  1992/11/23  16:48:26  daniel
 * 	Fixes from Motif1.2.2. Rev. 1.12.14.2, ancestor 1.12.13.4, file Xm.h.
 * 	[1992/11/23  16:48:07  daniel]
 * 
 * Revision 1.12.8.8  1992/11/16  23:01:09  drand
 * 	Another minor fix for XmStringDirection
 * 	[1992/11/16  23:00:49  drand]
 * 
 * Revision 1.12.8.7  1992/11/13  18:50:47  drand
 * 	Fixes from Motif1.2.2. Rev. 1.12.14.2, ancestor 1.12.13.2, file Xm.h.
 * 	[1992/11/13  18:48:52  drand]
 * 
 * Revision 1.12.8.5  1992/10/29  23:07:32  drand
 * 	Modified Xm.h for Automatic Popup Menu support.
 * 	Added the XmPopupHandlerCallbackStruct
 * 	Added an enumeration for XmPOPUP_AUTOMATIC et al
 * 	Added the temporary definition of XmNpopupHandlerCallback
 * 	[1992/10/29  23:06:23  drand]
 * 
 * Revision 1.12.8.4  1992/10/13  18:00:01  daniel
 * 	More enhancement work
 * 	[1992/10/13  17:58:47  daniel]
 * 
 * Revision 1.12.8.3  1992/10/05  21:43:04  daniel
 * 	thermo + showvalue work
 * 	[1992/10/05  21:30:43  daniel]
 * 
 * Revision 1.12.8.2  1992/09/25  14:52:47  daniel
 * 	snapback + showArrow stuff
 * 	[1992/09/24  15:24:19  daniel]
 * 
 * Revision 1.12.5.4  1992/08/14  14:20:49  msr
 * 	Modified XmVERSION_STRING to say 1.2.1
 * 	[1992/08/13  21:35:04  msr]
 * 
 * Revision 1.12.5.3  1992/08/06  21:47:21  tomm
 * 	Update XmUPDATE_LEVEL to 1 for release of 1.2.1.
 * 	[1992/08/06  21:47:00  tomm]
 * 
 * Revision 1.12.5.2  1992/06/24  13:52:47  al
 * 	HP Drop 60
 * 	[1992/06/24  13:50:52  al]
 * 
 * Revision 1.12.2.5  1992/05/07  16:14:16  tomm
 * 	Add XmUPDATE_LEVEL for patch release numbers.
 * 	VERSION now 1.2.0.
 * 	[1992/05/07  16:13:39  tomm]
 * 
 * Revision 1.12.2.4  1992/05/07  15:53:30  tomm
 * 	Update REVISION to 1.2 from pre-release.
 * 	[1992/05/07  15:51:33  tomm]
 * 
 * Revision 1.12.2.3  1992/03/14  21:35:25  hester
 * 	testing motif/ode build -remove last bogus submission
 * 	[1992/03/14  21:35:00  hester]
 * 
 * Revision 1.12.2.2  1992/03/14  21:32:24  hester
 * 	testing new motif build under ode - submissions
 * 	[1992/03/14  21:31:51  hester]
 * 
 * Revision 1.12  1992/03/13  16:55:50  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/*   $RCSfile: Xm.h,v $ $Revision: 1.12.33.8 $ $Date: 1994/07/18 21:52:57 $ */
/* (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */

#ifndef _Xm_h
#define _Xm_h

#ifndef _NO_PROTO
#if    !(defined(__STDC__) && __STDC__) \
    && !defined(__cplusplus) && !defined(c_plusplus) \
    && !defined(FUNCPROTO) && !defined(XTFUNCPROTO) && !defined(XMFUNCPROTO)
#define _NO_PROTO
#endif /* __STDC__ */
#endif /* _NO_PROTO */

#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <X11/Xatom.h>
#include <Xm/XmStrDefs.h>
#include <Xm/VirtKeys.h>
#include <Xm/Transfer.h>
#include <Xm/Primitive.h>
#include <Xm/Manager.h>
#include <Xm/Gadget.h>

#ifdef __cplusplus
extern "C" {
#endif


#define XmVERSION	2
#define XmREVISION	0
#define XmUPDATE_LEVEL	0
#define XmVersion (XmVERSION * 1000 + XmREVISION)
#define XmVERSION_STRING "@(#)OSF/Motif Version 2.0.0"

externalref int xmUseVersion;


/* define used to denote an unspecified pixmap  */

#define	XmUNSPECIFIED_PIXMAP		2

/* define for an unspecified position */

#define       XmUNSPECIFIED_POSITION          -1

/*******************
 *  
 * Defines for resources to be defaulted by vendors.
 * String are initialized in Xmos.c
 *
 ****************/

#define	XmSTRING_OS_CHARSET		XmSTRING_ISO8859_1
#ifndef	XmFALLBACK_CHARSET
#define	XmFALLBACK_CHARSET		XmSTRING_ISO8859_1
#endif

#define XmDEFAULT_FONT                  _XmSDEFAULT_FONT
#define XmDEFAULT_BACKGROUND            _XmSDEFAULT_BACKGROUND
#define XmDEFAULT_DARK_THRESHOLD        20
#define XmDEFAULT_LIGHT_THRESHOLD       93
#define XmDEFAULT_FOREGROUND_THRESHOLD  70

externalref  char    _XmSDEFAULT_FONT[];            /* In Xmos.c */
externalref  char    _XmSDEFAULT_BACKGROUND[];      /* In Xmos.c */

typedef unsigned char	XmDirection;

#define XmDIRECTION_IGNORED            0x30

#define XmRIGHT_TO_LEFT_MASK           0x01 /* 0x01 for bc */
#define XmLEFT_TO_RIGHT_MASK           0x02
#define XmHORIZONTAL_MASK              0x03
#define XmTOP_TO_BOTTOM_MASK           0x04
#define XmBOTTOM_TO_TOP_MASK           0x08
#define XmVERTICAL_MASK                0x0c
#define XmPRECEDENCE_HORIZ_MASK        0x40
#define XmPRECEDENCE_VERT_MASK         0x80
#define XmPRECEDENCE_MASK              0xc0

enum {
  XmRIGHT_TO_LEFT_TOP_TO_BOTTOM = 
      XmRIGHT_TO_LEFT_MASK | XmTOP_TO_BOTTOM_MASK | XmPRECEDENCE_HORIZ_MASK,
  XmLEFT_TO_RIGHT_TOP_TO_BOTTOM = 
      XmLEFT_TO_RIGHT_MASK | XmTOP_TO_BOTTOM_MASK | XmPRECEDENCE_HORIZ_MASK,
  XmRIGHT_TO_LEFT_BOTTOM_TO_TOP = 
      XmRIGHT_TO_LEFT_MASK | XmBOTTOM_TO_TOP_MASK | XmPRECEDENCE_HORIZ_MASK,
  XmLEFT_TO_RIGHT_BOTTOM_TO_TOP = 
      XmLEFT_TO_RIGHT_MASK | XmBOTTOM_TO_TOP_MASK | XmPRECEDENCE_HORIZ_MASK,
  XmTOP_TO_BOTTOM_RIGHT_TO_LEFT = 
      XmRIGHT_TO_LEFT_MASK | XmTOP_TO_BOTTOM_MASK | XmPRECEDENCE_VERT_MASK,
  XmTOP_TO_BOTTOM_LEFT_TO_RIGHT = 
      XmLEFT_TO_RIGHT_MASK | XmTOP_TO_BOTTOM_MASK | XmPRECEDENCE_VERT_MASK,
  XmBOTTOM_TO_TOP_RIGHT_TO_LEFT = 
      XmRIGHT_TO_LEFT_MASK | XmBOTTOM_TO_TOP_MASK | XmPRECEDENCE_VERT_MASK,
  XmBOTTOM_TO_TOP_LEFT_TO_RIGHT = 
      XmLEFT_TO_RIGHT_MASK | XmBOTTOM_TO_TOP_MASK | XmPRECEDENCE_VERT_MASK,
  XmTOP_TO_BOTTOM = 
      XmTOP_TO_BOTTOM_MASK | XmHORIZONTAL_MASK | XmPRECEDENCE_MASK,
  XmBOTTOM_TO_TOP = 
      XmBOTTOM_TO_TOP_MASK | XmHORIZONTAL_MASK | XmPRECEDENCE_MASK,
  XmRIGHT_TO_LEFT = 
      XmRIGHT_TO_LEFT_MASK | XmVERTICAL_MASK | XmPRECEDENCE_MASK,
  XmLEFT_TO_RIGHT = 
      XmLEFT_TO_RIGHT_MASK | XmVERTICAL_MASK | XmPRECEDENCE_MASK,
  XmDEFAULT_DIRECTION = 0xff
  };

#ifdef _NO_PROTO

extern Boolean XmDirectionMatch();
extern Boolean XmDirectionMatchPartial();

#else

extern Boolean XmDirectionMatch(XmDirection d1, 
				XmDirection d2);
extern Boolean XmDirectionMatchPartial(XmDirection d1, 
				       XmDirection d2, 
				       XmDirection dmask);
#endif

/****************
 *
 * XmString structure defines. These must be here (at the start of the file) 
 * becaused they are used later on.
 *
 ****************/
typedef enum{ XmFONT_IS_FONT, XmFONT_IS_FONTSET
	      } XmFontType;

enum { XmSTRING_DIRECTION_L_TO_R,
       XmSTRING_DIRECTION_R_TO_L,
       XmSTRING_DIRECTION_UNSET = 3,
       XmSTRING_DIRECTION_DEFAULT = XmDEFAULT_DIRECTION
       };

typedef unsigned char 	XmStringDirection;
typedef union __XmStringRec	*XmString;		/* opaque to outside */
typedef XmString *	XmStringTable;		/* opaque to outside */
typedef char *		XmStringCharSet;	/* Null term string */
typedef char *		XmStringTag;		/* Null term string */
typedef unsigned char	XmStringComponentType;	/* component tags */

typedef struct __XmRenditionRec	     **XmFontListEntry; /* opaque to outside */
typedef struct __XmRenderTableRec    **XmFontList;      /* opaque to outside */
typedef struct _XmFontListContextRec *XmFontContext;   /* opaque to outside */

typedef struct __XmStringContextRec *_XmStringContext; /* opaque to outside */
typedef union __XmStringRec        *_XmString;        /* opaque to outside */
typedef struct __XmStringContextRec *XmStringContext;  /* opaque to outside */

enum{	XmSTRING_COMPONENT_UNKNOWN,	  XmSTRING_COMPONENT_CHARSET,
	XmSTRING_COMPONENT_TEXT,	  XmSTRING_COMPONENT_DIRECTION,
        XmSTRING_COMPONENT_SEPARATOR,     XmSTRING_COMPONENT_LOCALE_TEXT,
	XmSTRING_COMPONENT_LOCALE,        XmSTRING_COMPONENT_WIDECHAR_TEXT,
	XmSTRING_COMPONENT_LAYOUT_PUSH,   XmSTRING_COMPONENT_LAYOUT_POP,
	XmSTRING_COMPONENT_RENDITION_BEGIN, XmSTRING_COMPONENT_RENDITION_END,
	XmSTRING_COMPONENT_TAB
	/* 13-125 reserved */
	} ;

#define XmSTRING_COMPONENT_FONTLIST_ELEMENT_TAG	XmSTRING_COMPONENT_CHARSET

#define XmSTRING_COMPONENT_TAG		XmSTRING_COMPONENT_CHARSET

#define XmSTRING_COMPONENT_END		((XmStringComponentType) 126)

#define XmSTRING_COMPONENT_USER_BEGIN	((XmStringComponentType) 128)
			/* 128-255 are user tags */
#define XmSTRING_COMPONENT_USER_END	((XmStringComponentType) 255)

typedef enum {
    XmCHARSET_TEXT,			XmMULTIBYTE_TEXT,
    XmWIDECHAR_TEXT,                    XmNO_TEXT
    } XmTextType;

typedef enum {
    XmOUTPUT_ALL,			XmOUTPUT_BETWEEN,
    XmOUTPUT_BEGINNING,			XmOUTPUT_END,
    XmOUTPUT_BOTH
    } XmParseModel;

typedef unsigned char XmIncludeStatus;
enum {
  XmINSERT,	XmTERMINATE,	XmINVOKE
  };

/* We are making an attempt (perhaps unnecessaryily) to keep our style
   constants the same as the equivalent Xlib style constants. The first
   Motif specific style constant starts at 32 so that the consortium can
   add constants to their list without overlapping with ours. */
typedef enum {
    XmSTYLE_STRING = XStringStyle,
    XmSTYLE_COMPOUND_TEXT = XCompoundTextStyle,
    XmSTYLE_TEXT = XTextStyle,
    XmSTYLE_STANDARD_ICC_TEXT = XStdICCTextStyle,
    XmSTYLE_LOCALE = 32,
    XmSTYLE_COMPOUND_STRING
    } XmICCEncodingStyle;

/****************
 *
 * XmParseTable structure defines. These must be here (at the start of
 * the file) because they are used later on.
 *
 ****************/

typedef struct __XmParseMappingRec *XmParseMapping;	/* opaque */
typedef XmParseMapping             *XmParseTable;

/* A special pattern used to match a change of character direction. */
#define XmDIRECTION_CHANGE	NULL


#ifdef _NO_PROTO
typedef XmIncludeStatus (*XmParseProc) ();
#else
typedef XmIncludeStatus (*XmParseProc) (XtPointer     *in_out,
					XtPointer      text_end,
					XmTextType     type,
					XmStringTag    locale_tag,
					XmParseMapping entry,
					int            pattern_length,
					XmString      *str_include,
					XtPointer      call_data);
#endif


/****************
 *
 * XmTabList structure defines. These must be here (at the start of the file) 
 * becaused they are used later on.
 *
 ****************/
typedef enum { 
  XmABSOLUTE,		XmRELATIVE
  } XmOffsetModel;

typedef struct __XmTabRec	*XmTab;		  /* opaque */
typedef struct __XmTabListRec	*XmTabList;	  /* opaque */


/****************
 *
 * XmRenderTable structure defines. These must be here (at the start of the file) 
 * becaused they are used later on.
 *
 ****************/
/* XmRendition declarations */
typedef struct __XmRenditionRec		**XmRendition;   /* opaque */
typedef struct __XmRenderTableRec	**XmRenderTable; /* opaque */

typedef enum { 
  XmSKIP,		XmREPLACE,
  XmMERGE_OLD,		XmMERGE_NEW, 
  XmDUPLICATE	/* For XmFontListAdd and XmFontListAppendEntry. */
  } XmMergeMode; 

#define XmAS_IS			255
#define XmFORCE_COLOR		1

#define XmUNSPECIFIED_PIXEL	 ((Pixel) (~0))
#define XmDEFAULT_SELECT_COLOR   XmUNSPECIFIED_PIXEL	
#define XmREVERSED_GROUND_COLORS (XmDEFAULT_SELECT_COLOR - 1)	
#define XmHIGHLIGHT_COLOR        (XmREVERSED_GROUND_COLORS - 1)	

enum { XmUNSPECIFIED_LOAD_MODEL, XmLOAD_DEFERRED, XmLOAD_IMMEDIATE }; 



/************************************************************************
 *  Primitive Resources and define values
 ************************************************************************/

/* size policy values  */

enum{	XmCHANGE_ALL,			XmCHANGE_NONE,
	XmCHANGE_WIDTH,			XmCHANGE_HEIGHT
	} ;

/*  unit type values  */

enum{	XmPIXELS,			Xm100TH_MILLIMETERS,
	Xm1000TH_INCHES,		Xm100TH_POINTS,
	Xm100TH_FONT_UNITS,		XmINCHES,
        XmCENTIMETERS,                  XmMILLIMETERS,
        XmPOINTS,                       XmFONT_UNITS
	} ;

/* DeleteResponse values */

enum{	XmDESTROY,			XmUNMAP,
	XmDO_NOTHING
	} ;
enum{	XmEXPLICIT,			XmPOINTER
	} ;
/************************************************************************
 *  Navigation defines 
 ************************************************************************/

enum{	XmNONE,				XmTAB_GROUP,
	XmSTICKY_TAB_GROUP,		XmEXCLUSIVE_TAB_GROUP
	} ;

#define	XmDYNAMIC_DEFAULT_TAB_GROUP	(255)

/************************************************************************
 * Audible warning
 ************************************************************************/

enum{	/* XmNONE */			XmBELL = 1
	} ;

/************************************************************************
 * Input Manager defines
 ************************************************************************/

enum {
        XmPER_SHELL,			XmPER_WIDGET,
        XmINHERIT_POLICY = 255
	} ;

typedef unsigned char XmInputPolicy;

/************************************************************************
 *  Menu defines
 ************************************************************************/

enum{	XmNO_ORIENTATION,		XmVERTICAL,
	XmHORIZONTAL
	} ;
enum{	XmWORK_AREA,			XmMENU_BAR,
	XmMENU_PULLDOWN,		XmMENU_POPUP,
	XmMENU_OPTION
	} ;
enum{	XmNO_PACKING,			XmPACK_TIGHT,
	XmPACK_COLUMN,			XmPACK_NONE
	} ;
enum{/* XmALIGNMENT_BASELINE_TOP,	XmALIGNMENT_CENTER,
	XmALIGNMENT_BASELINE_BOTTOM, */	XmALIGNMENT_CONTENTS_TOP = 3,
	XmALIGNMENT_CONTENTS_BOTTOM
	} ;
enum{	XmTEAR_OFF_ENABLED,		XmTEAR_OFF_DISABLED
	} ;
enum{	XmUNPOST,		 	XmUNPOST_AND_REPLAY
	} ;
enum{   XmLAST_POSITION = -1,           XmFIRST_POSITION
	} ;
enum{	XmPOPUP_DISABLED = 0,	XmPOPUP_KEYBOARD = 1,
	XmPOPUP_AUTOMATIC,	XmPOPUP_AUTOMATIC_RECURSIVE };

/************************************************************************
 *  ComboBox defines
 ************************************************************************/

enum{	XmCOMBO_BOX=0,		XmDROP_DOWN_COMBO_BOX,
	XmDROP_DOWN_LIST
	} ;

enum{	/* XmNONE */ XmQUICK_NAVIGATE = 1, XmINVALID_MATCH_BEHAVIOR
	} ;

#define XmINVALID_POSITION -1

/************************************************************************
 *  Label/Frame defines
 ************************************************************************/

enum{	XmALIGNMENT_BEGINNING,		XmALIGNMENT_CENTER,
	XmALIGNMENT_END
	} ;
enum{   XmALIGNMENT_BASELINE_TOP,    /* XmALIGNMENT_CENTER, */
	XmALIGNMENT_BASELINE_BOTTOM = 2, XmALIGNMENT_WIDGET_TOP,
	XmALIGNMENT_WIDGET_BOTTOM
   	} ;
/* new enum introduced in 2.0 to clear up the confusion in
   widget top/bottom attachment */
#define XmALIGNMENT_CHILD_TOP XmALIGNMENT_WIDGET_BOTTOM
#define XmALIGNMENT_CHILD_BOTTOM XmALIGNMENT_WIDGET_TOP

/************************************************************************
 *  Frame defines
 ************************************************************************/

enum{	XmFRAME_GENERIC_CHILD,          XmFRAME_WORKAREA_CHILD,
        XmFRAME_TITLE_CHILD
	} ;
/************************************************************************
 *  ToggleButton  defines
 ************************************************************************/

enum{	XmN_OF_MANY = 1,		XmONE_OF_MANY,
	XmONE_OF_MANY_ROUND
	} ;
/************************************************************************
 *  Form defines
 ************************************************************************/

enum{	XmATTACH_NONE,			XmATTACH_FORM,
	XmATTACH_OPPOSITE_FORM,		XmATTACH_WIDGET,
	XmATTACH_OPPOSITE_WIDGET,	XmATTACH_POSITION,
	XmATTACH_SELF
	} ;
enum{	XmRESIZE_NONE,			XmRESIZE_GROW,
	XmRESIZE_ANY
	} ;

/****************************************************************************
 *  Callback reasons 
 ****************************************************************************/

enum{	XmCR_NONE,			XmCR_HELP,
	XmCR_VALUE_CHANGED,		XmCR_INCREMENT,
	XmCR_DECREMENT,			XmCR_PAGE_INCREMENT,
	XmCR_PAGE_DECREMENT,		XmCR_TO_TOP,
	XmCR_TO_BOTTOM,			XmCR_DRAG,
	XmCR_ACTIVATE,			XmCR_ARM,
	XmCR_DISARM,			XmCR_MAP = 16,
	XmCR_UNMAP,			XmCR_FOCUS,
	XmCR_LOSING_FOCUS,		XmCR_MODIFYING_TEXT_VALUE,
	XmCR_MOVING_INSERT_CURSOR,	XmCR_EXECUTE,
	XmCR_SINGLE_SELECT,		XmCR_MULTIPLE_SELECT,
	XmCR_EXTENDED_SELECT,		XmCR_BROWSE_SELECT,
	XmCR_DEFAULT_ACTION,		XmCR_CLIPBOARD_DATA_REQUEST,
	XmCR_CLIPBOARD_DATA_DELETE,	XmCR_CASCADING,
	XmCR_OK,			XmCR_CANCEL,
	XmCR_APPLY = 34,		XmCR_NO_MATCH,
	XmCR_COMMAND_ENTERED,		XmCR_COMMAND_CHANGED,
	XmCR_EXPOSE,			XmCR_RESIZE,
	XmCR_INPUT,			XmCR_GAIN_PRIMARY,
	XmCR_LOSE_PRIMARY,		XmCR_CREATE,
	XmCR_TEAR_OFF_ACTIVATE,		XmCR_TEAR_OFF_DEACTIVATE,
	XmCR_OBSCURED_TRAVERSAL,	XmCR_FOCUS_MOVED,
	XmCR_REPOST = 54,		XmCR_COLLAPSED,
	XmCR_EXPANDED,			XmCR_SELECT,
	XmCR_DRAG_START,		XmCR_NO_FONT,
	XmCR_NO_RENDITION,		XmCR_POST,
	XmCR_SPIN_NEXT,			XmCR_SPIN_PRIOR,
	XmCR_SPIN_FIRST,		XmCR_SPIN_LAST,
	XmCR_PAGE_SCROLLER_INCREMENT,   XmCR_PAGE_SCROLLER_DECREMENT,
	XmCR_MAJOR_TAB,                 XmCR_MINOR_TAB,
	XmCR_PROTOCOLS = 6666 /* required for BC. See CR 9158 */
	} ;

/************************************************************************
 *  new ScrollBar showArrows  define
 ************************************************************************/

enum{	/* XmNONE */		XmEACH_SIDE = 1,
	XmMAX_SIDE,             XmMIN_SIDE
	} ;


/************************************************************************
 *  Sliding mode
 ************************************************************************/

enum{	XmSLIDER,		XmTHERMOMETER} ;


/************************************************************************
 *  Slider Visual
 ************************************************************************/

enum{	XmBACKGROUND_COLOR,     XmFOREGROUND_COLOR, 
        XmTROUGH_COLOR,         XmSHADOWED_BACKGROUND} ;


/************************************************************************
 *  Slider Mark
 ************************************************************************/

enum{	/* XmNONE, */           XmETCHED_LINE = 1, 
        XmTHUMB_MARK,     XmROUND_MARK } ;


/************************************************************************
 *  new Scale showValue 
 ************************************************************************/

enum{	/* XmNONE */		XmNEAR_SLIDER = 1,
	XmNEAR_BORDER
	} ;


/************************************************************************
 *  new ScrolledWindow/MainWindow chidType
 ************************************************************************/

/* XmWORK_AREA, XmMENU_BAR and XmSEPARATOR have to match the existing ones */
enum{	/* XmWORK_AREA = 0, XmMENU_BAR = 1, */ 
        XmHOR_SCROLLBAR = 2, 
	XmVERT_SCROLLBAR,
	XmCOMMAND_WINDOW, 
        /* XmSEPARATOR = 5 */
        XmMESSAGE_WINDOW = 6,
        XmSCROLL_HOR, XmSCROLL_VERT, XmNO_SCROLL,
	XmCLIP_WINDOW, XmGENERIC_CHILD
	} ;

/************************************************************************
 *  new ScrolledWindow auto drag enum
 ************************************************************************/

enum{	XmAUTO_DRAG_ENABLED,		XmAUTO_DRAG_DISABLED
	} ;

/************************************************************************
 *  new Display enable warp enum
 ************************************************************************/

enum{	XmENABLE_WARP_ON,		XmENABLE_WARP_OFF
	} ;

/************************************************************************
 *  new Display enable btn1 transfer enum
 ************************************************************************/

enum{   XmOFF,				XmBUTTON2_ADJUST,
	XmBUTTON2_TRANSFER };

/************************************************************************
 * auto_selection_type
 ************************************************************************/

enum{   XmAUTO_UNSET,                   XmAUTO_BEGIN,
        XmAUTO_MOTION,                  XmAUTO_CANCEL,
        XmAUTO_NO_CHANGE,               XmAUTO_CHANGE
        };

/************************************************************************
 *  Callback structures 
 ************************************************************************/

typedef struct
{
    int     reason;
    XEvent  *event;
} XmAnyCallbackStruct;

typedef struct
{
    int     reason;
    XEvent  *event;
    int	    click_count;
} XmArrowButtonCallbackStruct;

typedef struct _XmDragStartCallbackStruct {
    int                 reason;
    XEvent              *event;
    Widget              widget;
    Boolean             doit;
} XmDragStartCallbackStruct, *XmDragStartCallback;

typedef struct
{
    int     reason;
    XEvent  *event;
    XmString item_or_text;
    int     item_position;
} XmComboBoxCallbackStruct;

typedef struct
{
    int     reason;
    XEvent  *event;
    Window  window;
} XmDrawingAreaCallbackStruct;

typedef struct
{
    int     reason;
    XEvent  *event;
    Window  window;
    int	    click_count;
} XmDrawnButtonCallbackStruct;

typedef struct
{
    int     reason;
    XEvent  *event;
    int	    click_count;
} XmPushButtonCallbackStruct;

typedef struct
{
    int     reason;
    XEvent  *event;
    Widget  widget;
    char    *data;
    char    *callbackstruct;
} XmRowColumnCallbackStruct;

typedef struct
{
   int reason;
   XEvent * event;
   int value;
   int pixel;
} XmScrollBarCallbackStruct;

typedef struct
{
   int reason;
   XEvent * event;
   int set;
} XmToggleButtonCallbackStruct;

typedef struct
{
   int 	     reason;
   XEvent    *event;
   XmString  item;
   int       item_length;
   int       item_position;
   XmString  *selected_items;
   int       selected_item_count;
   int       *selected_item_positions;
   char      selection_type;
   char	     auto_selection_type;
} XmListCallbackStruct;

typedef struct
{
    int reason;
    XEvent	*event;
    XmString	value;
    int		length;
} XmSelectionBoxCallbackStruct;

typedef struct
{
    int reason;
    XEvent	*event;
    XmString	value;
    int		length;
} XmCommandCallbackStruct;

typedef struct
{
    int 	reason;
    XEvent	*event;
    XmString	value;
    int		length;
    XmString	mask;
    int		mask_length;
    XmString	dir ;
    int		dir_length ;
    XmString    pattern ;
    int		pattern_length ;
} XmFileSelectionBoxCallbackStruct;


typedef struct 
{
   int reason;
   XEvent * event;
   int value;
} XmScaleCallbackStruct;

typedef struct
{
  int      reason;
  XEvent   *event;
  Widget   menuToPost;
  Boolean  postIt;
  Widget   target;
} XmPopupHandlerCallbackStruct;

typedef struct
{
  int         reason;
  XEvent      *event;
  Widget      item;
  unsigned char       new_outline_state;
} XmContainerOutlineCallbackStruct;

typedef struct
{
  int             reason;
  XEvent          *event;
  WidgetList      selected_items;
  int             selected_item_count;
  unsigned char   auto_selection_type;
} XmContainerSelectCallbackStruct;

typedef struct
{
  int         reason;
  XEvent      *event;
  int         page_number;
  Widget      page_widget;
  int         prev_page_number;
  Widget      prev_page_widget;
} XmNotebookCallbackStruct;

typedef struct
{
    int     		reason;
    XEvent  		*event;
    XmRendition		rendition;
    char		*font_name;
    XmRenderTable	render_table;
    XmStringTag		tag;
} XmDisplayCallbackStruct;

/************************************************************************
 *  PushButton defines
 ************************************************************************/

enum{	XmMULTICLICK_DISCARD,		XmMULTICLICK_KEEP
	} ;
/************************************************************************
 *  DrawnButton defines
 ************************************************************************/

enum{	XmSHADOW_IN = 7,		XmSHADOW_OUT
	} ;
/************************************************************************
 *  Arrow defines
 ************************************************************************/

enum{	XmARROW_UP,			XmARROW_DOWN,
	XmARROW_LEFT,			XmARROW_RIGHT
	} ;
/************************************************************************
 *  Separator defines
 *  Note: XmINVALID_SEPARATOR_TYPE marks the last+1 separator type
 ************************************************************************/

enum{	XmNO_LINE,			XmSINGLE_LINE,
	XmDOUBLE_LINE,			XmSINGLE_DASHED_LINE,
	XmDOUBLE_DASHED_LINE,		XmSHADOW_ETCHED_IN,
	XmSHADOW_ETCHED_OUT,		XmSHADOW_ETCHED_IN_DASH,
	XmSHADOW_ETCHED_OUT_DASH,	XmINVALID_SEPARATOR_TYPE
	} ;

enum{	XmPIXMAP = 1,			XmSTRING
	} ;

/************************************************************************
 *  Drag and Drop #defines
 ************************************************************************/

enum{	XmWINDOW,		     /* XmPIXMAP, */
	XmCURSOR = 2,		     XmDRAG_WINDOW = 3
	} ;

/************************************************************************
 *  ScrollBar #defines
 ************************************************************************/

enum{	XmMAX_ON_TOP,			XmMAX_ON_BOTTOM,
	XmMAX_ON_LEFT,			XmMAX_ON_RIGHT
	} ;
/************************************************************************
 *									*
 * List Widget defines							*
 *									*
 ************************************************************************/

enum{	XmSINGLE_SELECT,		XmMULTIPLE_SELECT,
	XmEXTENDED_SELECT,		XmBROWSE_SELECT
	} ;
enum{	XmSTATIC,			XmDYNAMIC
	} ;
enum{ XmNORMAL_MODE,			XmADD_MODE
        } ;
/************************************************************************
 *                                                                      *
 * Container Widget defines                                             *
 *                                                                      *
 ************************************************************************/

        /* XmRAutomaticSelection */
enum {  XmNO_AUTO_SELECT,
        XmAUTO_SELECT
        };

        /* XmRLineStyle */
enum {  /* XmNO_LINE */
        XmSINGLE = 1
        };

        /* XmREntryViewType */
enum {  /* XmLARGE_ICON */
        /* XmSMALL_ICON */
        XmANY_ICON = 2
        };

        /* XmRSpatialIncludeModel */
enum {  XmAPPEND,
        XmCLOSEST,
        XmFIRST_FIT
        };

        /* XmRLayoutType */
enum {  XmOUTLINE,
        XmSPATIAL,
	XmDETAIL
        };

	/* XmNoutlineButtonPolicy */
enum {	XmOUTLINE_BUTTON_PRESENT,
	XmOUTLINE_BUTTON_ABSENT
	};

        /* XmRSpatialPlaceStyle */
enum {  /* XmNONE */
	XmGRID = 1,
	XmCELLS
        };

	/* XmRPrimaryOwnership */
enum {	XmOWN_NEVER,
	XmOWN_ALWAYS,
	XmOWN_MULTIPLE,
	XmOWN_POSSIBLE_MULTIPLE
	};

        /* XmRSpatialResizeModel */
enum {  XmGROW_MINOR,
	XmGROW_MAJOR,
        XmGROW_BALANCED
        };

        /* XmRSelectionTechnique */
enum {  XmMARQUEE,
        XmMARQUEE_EXTEND_START,
        XmMARQUEE_EXTEND_BOTH,
        XmTOUCH_ONLY,
        XmTOUCH_OVER
        };

        /* XmRSpatialSnapModel */
enum {  /* XmNONE */
        XmSNAP_TO_GRID = 1,
        XmCENTER
        };

        /* XmROutlineState */
enum {  XmCOLLAPSED,
        XmEXPANDED
        };

/************************************************************************
 *                                                                      *
 * IconGadget defines                                                   *
 *                                                                      *
 ************************************************************************/

        /* XmRViewType */
enum {  XmLARGE_ICON,
        XmSMALL_ICON
        };

        /* XmRVisualEmphasis */
enum {  XmSELECTED,
        XmNOT_SELECTED
        };

/************************************************************************
 *                                                                      *
 * Notebook Widget defines                                             *
 *                                                                      *
 ************************************************************************/

#define XmUNSPECIFIED_PAGE_NUMBER       (-32768)

        /* XmRBindingType */
enum {  /* XmNONE */
        /* XmPIXMAP */
        XmSOLID = 2,
        XmSPIRAL,
        XmPIXMAP_OVERLAP_ONLY
        };

        /* XmRNBChildType */
enum {  /* XmNONE */
        XmPAGE = 1,
        XmMAJOR_TAB,
        XmMINOR_TAB,
        XmSTATUS_AREA,
        XmPAGE_SCROLLER
        };

/************************************************************************
 *									*
 * Spin button defines.							*
 *									*
 ************************************************************************/

/* XmNarrowLayout */
enum
{
    XmARROWS_END,
    XmARROWS_BEGINNING,
    XmARROWS_SPLIT,
    XmARROWS_FLAT_END,
    XmARROWS_FLAT_BEGINNING
};

/* XmNarrowSensitivity and XmNdefaultArrowSensitivity */
/* Please note that these arrows form the proper values 
   for a bit mask. */
enum
{
    XmARROWS_INSENSITIVE,
    XmARROWS_INCREMENT_SENSITIVE,
    XmARROWS_DECREMENT_SENSITIVE,
    XmARROWS_SENSITIVE,
    XmARROWS_DEFAULT_SENSITIVITY
};

/* XmNspinButtonChildType */
enum
{
    /* XmPIXMAP = 1 */
    /* XmSTRING */
    XmNUMERIC = 3
};

typedef struct
{
    int		reason;
    XEvent	*event;
    Widget      widget;
    Boolean     doit;
    int		position;
    XmString	value;
    Boolean	crossed_boundary;
} XmSpinBoxCallbackStruct;


/************************************************************************
 *									*
 * Scrolled Window defines.						*
 *									*
 ************************************************************************/

enum{	XmVARIABLE,			XmCONSTANT,
	XmRESIZE_IF_POSSIBLE
	} ;
enum{	XmAUTOMATIC,			XmAPPLICATION_DEFINED
	} ;
enum{	/* XmSTATIC */			XmAS_NEEDED = 1
	} ;

#define SW_TOP		1
#define SW_BOTTOM	0
#define SW_LEFT		2
#define SW_RIGHT	0

#define XmTOP_LEFT	(SW_TOP | SW_LEFT)
#define XmBOTTOM_LEFT	(SW_BOTTOM  | SW_LEFT)
#define XmTOP_RIGHT	(SW_TOP | SW_RIGHT)
#define XmBOTTOM_RIGHT	(SW_BOTTOM  | SW_RIGHT)

/************************************************************************
 *									*
 * MainWindow Resources                                                 *
 *									*
 ************************************************************************/

enum{	XmCOMMAND_ABOVE_WORKSPACE,	XmCOMMAND_BELOW_WORKSPACE
	} ;
/************************************************************************
 *									*
 * Text Widget defines							*
 *									*
 ************************************************************************/

enum{	XmMULTI_LINE_EDIT,		XmSINGLE_LINE_EDIT
	} ;

typedef enum{
	XmTEXT_FORWARD,
	XmTEXT_BACKWARD
	} XmTextDirection;

typedef long XmTextPosition;
typedef Atom XmTextFormat;

#define XmFMT_8_BIT	((XmTextFormat) XA_STRING)	/* 8-bit text. */
#define XmFMT_16_BIT	((XmTextFormat) 2)		/* 16-bit text. */

#define FMT8BIT		XmFMT_8_BIT	/* For backwards compatibility only.*/
#define FMT16BIT	XmFMT_16_BIT	/* For backwards compatibility only.*/

typedef enum{
	XmSELECT_POSITION,		XmSELECT_WHITESPACE,
	XmSELECT_WORD,			XmSELECT_LINE,
	XmSELECT_ALL,			XmSELECT_PARAGRAPH,
	XmSELECT_OUT_LINE
	} XmTextScanType ;

typedef enum{
	XmHIGHLIGHT_NORMAL,		XmHIGHLIGHT_SELECTED,
	XmHIGHLIGHT_SECONDARY_SELECTED,	XmSEE_DETAIL
	} XmHighlightMode ;

/* XmTextBlock's are used to pass text around. */

typedef struct {
    char *ptr;                  /* Pointer to data. */
    int length;                 /* Number of bytes of data. */
    XmTextFormat format;       /* Representations format */
} XmTextBlockRec, *XmTextBlock;

typedef struct
{
    int reason;
    XEvent  *event;
    Boolean doit;
    long currInsert, newInsert;
    long startPos, endPos;
    XmTextBlock text;
} XmTextVerifyCallbackStruct, *XmTextVerifyPtr;

/* XmTextBlockWcs's are used in 1.2 modifyVerifyWcs callbacks for Text[Field]
 * widgets. */

typedef struct {
    wchar_t *wcsptr;            /* Pointer to data. */
    int length;                 /* Number of characters (not bytes) of data. */
} XmTextBlockRecWcs, *XmTextBlockWcs;

typedef struct
{
    int reason;
    XEvent  *event;
    Boolean doit;
    long currInsert, newInsert;
    long startPos, endPos;
    XmTextBlockWcs text;
} XmTextVerifyCallbackStructWcs, *XmTextVerifyPtrWcs;

/* functions renamed after 1.0 release due to resource name overlap */
#define XmTextGetTopPosition                XmTextGetTopCharacter
#define XmTextSetTopPosition                XmTextSetTopCharacter

#define XmCOPY_FAILED		0
#define XmCOPY_SUCCEEDED	1
#define XmCOPY_TRUNCATED	2

/************************************************************************
 *									*
 *  DIALOG defines..  BulletinBoard and things common to its subclasses *
 *          CommandBox    MessageBox    Selection    FileSelection      *
 *									*
 ************************************************************************/

/* child type defines for Xm...GetChild() */

enum{	XmDIALOG_NONE,			XmDIALOG_APPLY_BUTTON,
	XmDIALOG_CANCEL_BUTTON,		XmDIALOG_DEFAULT_BUTTON,
	XmDIALOG_OK_BUTTON,		XmDIALOG_FILTER_LABEL,
	XmDIALOG_FILTER_TEXT,		XmDIALOG_HELP_BUTTON,
	XmDIALOG_LIST,			XmDIALOG_LIST_LABEL,
	XmDIALOG_MESSAGE_LABEL,		XmDIALOG_SELECTION_LABEL,
	XmDIALOG_SYMBOL_LABEL,		XmDIALOG_TEXT,
	XmDIALOG_SEPARATOR,		XmDIALOG_DIR_LIST,
	XmDIALOG_DIR_LIST_LABEL
	} ;

#define XmDIALOG_HISTORY_LIST     	XmDIALOG_LIST
#define XmDIALOG_PROMPT_LABEL     	XmDIALOG_SELECTION_LABEL
#define XmDIALOG_VALUE_TEXT       	XmDIALOG_TEXT
#define XmDIALOG_COMMAND_TEXT     	XmDIALOG_TEXT
#define XmDIALOG_FILE_LIST        	XmDIALOG_LIST
#define XmDIALOG_FILE_LIST_LABEL  	XmDIALOG_LIST_LABEL

/*  dialog style defines  */

enum{	XmDIALOG_MODELESS,		XmDIALOG_PRIMARY_APPLICATION_MODAL,
	XmDIALOG_FULL_APPLICATION_MODAL,XmDIALOG_SYSTEM_MODAL
	} ;

/* The following is for compatibility only. Its use is deprecated.
 */
#define XmDIALOG_APPLICATION_MODAL	XmDIALOG_PRIMARY_APPLICATION_MODAL

/************************************************************************
 * XmSelectionBox, XmFileSelectionBox and XmCommand - misc. stuff       *
 ***********************************************************************/

/* Defines for Selection child placement
*/
enum{	XmPLACE_TOP,			XmPLACE_ABOVE_SELECTION,
	XmPLACE_BELOW_SELECTION
	} ;

/* Defines for file type mask:
*/
#define XmFILE_DIRECTORY (1 << 0)
#define XmFILE_REGULAR   (1 << 1)
#define XmFILE_ANY_TYPE  (XmFILE_DIRECTORY | XmFILE_REGULAR)

/* Defines for selection dialog type:
*/
enum{	XmDIALOG_WORK_AREA,		XmDIALOG_PROMPT,
	XmDIALOG_SELECTION,		XmDIALOG_COMMAND,
	XmDIALOG_FILE_SELECTION
	} ;

/************************************************************************
 *  XmMessageBox           stuff not common to other dialogs            *
 ***********************************************************************/

/* defines for dialog type */

enum{	XmDIALOG_TEMPLATE,		XmDIALOG_ERROR,
	XmDIALOG_INFORMATION,		XmDIALOG_MESSAGE,
	XmDIALOG_QUESTION,		XmDIALOG_WARNING,
	XmDIALOG_WORKING
	} ;

/*  Traversal types  */

typedef enum{
	XmVISIBILITY_UNOBSCURED,	XmVISIBILITY_PARTIALLY_OBSCURED,
	XmVISIBILITY_FULLY_OBSCURED
	} XmVisibility ;


typedef enum{
	XmTRAVERSE_CURRENT,		XmTRAVERSE_NEXT,
	XmTRAVERSE_PREV,		XmTRAVERSE_HOME,
	XmTRAVERSE_NEXT_TAB_GROUP,	XmTRAVERSE_PREV_TAB_GROUP,
	XmTRAVERSE_UP,			XmTRAVERSE_DOWN,
	XmTRAVERSE_LEFT,		XmTRAVERSE_RIGHT,
	XmTRAVERSE_GLOBALLY_FORWARD,	XmTRAVERSE_GLOBALLY_BACKWARD
	} XmTraversalDirection ;

typedef struct _XmTraverseObscuredCallbackStruct
{	int			reason ;
	XEvent *		event ;
	Widget			traversal_destination ;
	XmTraversalDirection	direction ;
	} XmTraverseObscuredCallbackStruct ;

typedef unsigned char   XmNavigationType;


/***********************************************************************
 *
 * SimpleMenu declarations and definitions.
 *
 ***********************************************************************/

typedef unsigned char XmButtonType;
typedef XmButtonType * XmButtonTypeTable;
typedef KeySym * XmKeySymTable;
typedef XmStringCharSet * XmStringCharSetTable;

enum{	XmPUSHBUTTON = 1,		XmTOGGLEBUTTON,
	XmRADIOBUTTON,			XmCASCADEBUTTON,
	XmSEPARATOR,			XmDOUBLE_SEPARATOR,
	XmTITLE
	} ;
#define XmCHECKBUTTON			XmTOGGLEBUTTON


/***********************************************************************
 *
 * BitmapConversionModel
 *
 ***********************************************************************/

enum{	XmMATCH_DEPTH, XmDYNAMIC_DEPTH } ;


/* This one cannot be put at the beginning because it needs 
   XmStringTable */
#include <Xm/TxtPropCv.h>


/********    BaseClass.c    ********/
#ifdef _NO_PROTO
typedef XtPointer	(*XmResourceBaseProc)();
#else
typedef XtPointer	(*XmResourceBaseProc)( Widget, XtPointer) ;
#endif

typedef struct _XmSecondaryResourceDataRec{
    XmResourceBaseProc	base_proc;
    XtPointer		client_data;
    String		name;
    String		res_class;
    XtResourceList	resources;
    Cardinal		num_resources;
}XmSecondaryResourceDataRec, *XmSecondaryResourceData;

/********    Public Function Declarations for BaseClass.c    ********/
#ifdef _NO_PROTO

extern Cardinal XmGetSecondaryResourceData() ;

#else

extern Cardinal XmGetSecondaryResourceData( 
                        WidgetClass w_class,
                        XmSecondaryResourceData **secondaryDataRtn) ;

#endif /* _NO_PROTO */
/********    End Public Function Declarations    ********/

/********    Public Function Declarations for ImageCache.c    ********/
#ifdef _NO_PROTO

extern Boolean XmInstallImage() ;
extern Boolean XmUninstallImage() ;
extern Pixmap XmGetPixmap() ;
extern Pixmap XmGetPixmapByDepth() ;
extern Boolean XmDestroyPixmap() ;

#else

extern Boolean XmInstallImage( 
                        XImage *image,
                        char *image_name) ;
extern Boolean XmUninstallImage( 
                        XImage *image) ;
extern Pixmap XmGetPixmap( 
                        Screen *screen,
                        char *image_name,
                        Pixel foreground,
                        Pixel background) ;
extern Pixmap XmGetPixmapByDepth( 
                        Screen *screen,
                        char *image_name,
                        Pixel foreground,
                        Pixel background,
			int depth) ;
extern Boolean XmDestroyPixmap( 
                        Screen *screen,
                        Pixmap pixmap) ;

#endif /* _NO_PROTO */
/********    End Public Function Declarations    ********/

/********    Public Function Declarations for Resolve.c    ********/
/*-- XmeResolvePartOffsets is defined in XmP.h.
     These also belong there but for source compatibility, we let 
     them here --- */

typedef long XmOffset;
typedef XmOffset *XmOffsetPtr;


#ifdef _NO_PROTO

extern void XmResolveAllPartOffsets() ;
extern void XmResolvePartOffsets() ;

#else

extern void XmResolveAllPartOffsets( 
                        WidgetClass w_class,
                        XmOffsetPtr *offset,
                        XmOffsetPtr *constraint_offset) ;
extern void XmResolvePartOffsets( 
                        WidgetClass w_class,
                        XmOffsetPtr *offset) ;

#endif /* _NO_PROTO */
/********    End Public Function Declarations    ********/



/********    Public Function Declarations for Xm.c    ********/

#ifdef _NO_PROTO

extern void XmUpdateDisplay() ;
extern Widget XmObjectAtPoint() ;
extern Boolean XmWidgetGetBaselines();
extern Boolean XmWidgetGetDisplayRect();

#else

extern void XmUpdateDisplay( 
                        Widget w) ;
extern Widget XmObjectAtPoint(
			Widget wid,
			Position x,
			Position y ) ;

extern Boolean XmWidgetGetBaselines(
                        Widget wid,
                        Dimension **baselines,
                        int *line_count);
extern Boolean XmWidgetGetDisplayRect(
                        Widget wid,
                        XRectangle *displayrect);

#endif /* _NO_PROTO */
/********    End Public Function Declarations    ********/



/********    Primitive.c    ********/

/********    Public Function Declarations for Primitive.c    ********/
#ifdef _NO_PROTO

#else

#endif /* _NO_PROTO */
/********    End Public Function Declarations    ********/

/********    Public Function Declarations for ResConvert.c    ********/
#ifdef _NO_PROTO

extern void XmCvtStringToUnitType() ;
extern char * XmRegisterSegmentEncoding() ;
extern char * XmMapSegmentEncoding() ;
extern XmString XmCvtCTToXmString() ;
extern Boolean XmCvtTextToXmString() ;
extern char * XmCvtXmStringToCT() ;
extern Boolean XmCvtXmStringToText() ;

#else

extern void XmCvtStringToUnitType( 
                        XrmValuePtr args,
                        Cardinal *num_args,
                        XrmValue *from_val,
                        XrmValue *to_val) ;
extern char * XmRegisterSegmentEncoding( 
                        char *fontlist_tag,
                        char *ct_encoding) ;
extern char * XmMapSegmentEncoding( 
                        char *fontlist_tag) ;
extern XmString XmCvtCTToXmString( 
                        char *text) ;
extern Boolean XmCvtTextToXmString( 
                        Display *display,
                        XrmValuePtr args,
                        Cardinal *num_args,
                        XrmValue *from_val,
                        XrmValue *to_val,
                        XtPointer *converter_data) ;
extern char * XmCvtXmStringToCT( 
                        XmString string) ;
extern Boolean XmCvtXmStringToText( 
                        Display *display,
                        XrmValuePtr args,
                        Cardinal *num_args,
                        XrmValue *from_val,
                        XrmValue *to_val,
                        XtPointer *converter_data) ;

#endif /* _NO_PROTO */
/********    End Public Function Declarations    ********/

/********    Public Function Declarations for ResInd.c    ********/
#ifdef _NO_PROTO

extern int XmConvertStringToUnits() ;
extern int XmConvertUnits() ;
extern int XmCvtToHorizontalPixels() ;
extern int XmCvtToVerticalPixels() ;
extern int XmCvtFromHorizontalPixels() ;
extern int XmCvtFromVerticalPixels() ;
extern void XmSetFontUnits() ;
extern void XmSetFontUnit() ;

#else

extern int XmConvertStringToUnits(
				  Screen *screen, 
				  String spec,
				  int orientation,
				  int to_type,
				  XtEnum *parse_error);
extern int XmConvertUnits( 
                        Widget widget,
                        int dimension,
                        register int from_type,
                        register int from_val,
                        register int to_type) ;
extern int XmCvtToHorizontalPixels( 
                        Screen *screen,
                        register int from_val,
                        register int from_type) ;
extern int XmCvtToVerticalPixels( 
                        Screen *screen,
                        register int from_val,
                        register int from_type) ;
extern int XmCvtFromHorizontalPixels( 
                        Screen *screen,
                        register int from_val,
                        register int to_type) ;
extern int XmCvtFromVerticalPixels( 
                        Screen *screen,
                        register int from_val,
                        register int to_type) ;
extern void XmSetFontUnits( 
                        Display *display,
                        int h_value,
                        int v_value) ;
extern void XmSetFontUnit( 
                        Display *display,
                        int value) ;

#endif /* _NO_PROTO */
/********    End Public Function Declarations    ********/

/********    Public Function Declarations for MenuUtil.c    ********/
#ifdef _NO_PROTO

extern void XmSetMenuCursor() ;
extern Cursor XmGetMenuCursor() ;

#else

extern void XmSetMenuCursor( 
                        Display *display,
                        Cursor cursorId) ;
extern Cursor XmGetMenuCursor( 
                        Display *display) ;

#endif /* _NO_PROTO */
/********    End Public Function Declarations    ********/

/********    Public Function Declarations for Simple.c    ********/
#ifdef _NO_PROTO

extern Widget XmCreateSimpleMenuBar() ;
extern Widget XmCreateSimplePopupMenu() ;
extern Widget XmCreateSimplePulldownMenu() ;
extern Widget XmCreateSimpleOptionMenu() ;
extern Widget XmCreateSimpleRadioBox() ;
extern Widget XmCreateSimpleCheckBox() ;

#else

extern Widget XmCreateSimpleMenuBar( 
                        Widget parent,
                        String name,
                        ArgList args,
                        Cardinal arg_count) ;
extern Widget XmCreateSimplePopupMenu( 
                        Widget parent,
                        String name,
                        ArgList args,
                        Cardinal arg_count) ;
extern Widget XmCreateSimplePulldownMenu( 
                        Widget parent,
                        String name,
                        ArgList args,
                        Cardinal arg_count) ;
extern Widget XmCreateSimpleOptionMenu( 
                        Widget parent,
                        String name,
                        ArgList args,
                        Cardinal arg_count) ;
extern Widget XmCreateSimpleRadioBox( 
                        Widget parent,
                        String name,
                        ArgList args,
                        Cardinal arg_count) ;
extern Widget XmCreateSimpleCheckBox( 
                        Widget parent,
                        String name,
                        ArgList args,
                        Cardinal arg_count) ;

#endif /* _NO_PROTO */
/********    End Public Function Declarations    ********/

/********    Public Function Declarations for VaSimple.c   ********/
#ifdef _NO_PROTO
extern Widget XmVaCreateSimpleMenuBar() ;
extern Widget XmVaCreateSimplePopupMenu() ;
extern Widget XmVaCreateSimplePulldownMenu() ;
extern Widget XmVaCreateSimpleOptionMenu() ;
extern Widget XmVaCreateSimpleRadioBox() ;
extern Widget XmVaCreateSimpleCheckBox() ;
#else /* _NO_PROTO */
extern Widget XmVaCreateSimpleMenuBar( 
			Widget parent,
			String name,
			...) ;
extern Widget XmVaCreateSimplePopupMenu(
			Widget parent,
			String name,
			XtCallbackProc callback,
			...) ;
extern Widget XmVaCreateSimplePulldownMenu( 
			Widget parent,
			String name,
			int post_from_button,
			XtCallbackProc callback,
			...) ;
extern Widget XmVaCreateSimpleOptionMenu(
			Widget parent,
			String name,
                        XmString option_label,
                        KeySym option_mnemonic,
                        int button_set,
                        XtCallbackProc callback,
			...) ;
extern Widget XmVaCreateSimpleRadioBox( 
			Widget parent,
			String name,
			int button_set,
			XtCallbackProc callback,
			...) ;
extern Widget XmVaCreateSimpleCheckBox( 
			Widget parent,
			String name,
			XtCallbackProc callback,
			...) ;
#endif /* _NO_PROTO */
/********    End Public Function Declarations    ********/

/********    Public Function Declarations for TrackLoc.c    ********/
#ifdef _NO_PROTO

extern Widget XmTrackingEvent() ;
extern Widget XmTrackingLocate() ;

#else

extern Widget XmTrackingEvent( 
                        Widget widget,
                        Cursor cursor,
#if NeedWidePrototypes
                        int confineTo,
#else
                        Boolean confineTo,
#endif /* NeedWidePrototypes */
                        XEvent *pev) ;
extern Widget XmTrackingLocate( 
                        Widget widget,
                        Cursor cursor,
#if NeedWidePrototypes
                        int confineTo) ;
#else
                        Boolean confineTo) ;
#endif /* NeedWidePrototypes */

#endif /* _NO_PROTO */
/********    End Public Function Declarations    ********/

/********    Visual.c    ********/
#ifdef _NO_PROTO
typedef void (*XmColorProc) ();
#else
typedef void (*XmColorProc) (XColor *bg_color, XColor *fg_color,
	XColor *sel_color, XColor *ts_color, XColor *bs_color);
#endif

/********    Public Function Declarations for Visual.c    ********/
#ifdef _NO_PROTO

extern XmColorProc XmSetColorCalculation() ;
extern XmColorProc XmGetColorCalculation() ;
extern void XmGetColors() ;
extern void XmChangeColor() ;

#else

extern XmColorProc XmSetColorCalculation( 
                        XmColorProc proc) ;
extern XmColorProc XmGetColorCalculation( void ) ;
extern void XmGetColors( 
                        Screen *screen,
                        Colormap color_map,
                        Pixel background,
                        Pixel *foreground_ret,
                        Pixel *top_shadow_ret,
                        Pixel *bottom_shadow_ret,
                        Pixel *select_ret) ;
extern void XmChangeColor(
                        Widget widget,
                        Pixel background) ;

#endif /* _NO_PROTO */
/********    End Public Function Declarations    ********/

/********    Public Function Declarations for XmString.c    ********/
#ifdef _NO_PROTO

extern XmString XmStringCreate() ;
extern XmString XmStringCreateSimple() ;
extern XmString XmStringCreateLocalized() ;
extern XmString XmStringDirectionCreate() ;
extern XmString XmStringSeparatorCreate() ;
extern XmString XmStringSegmentCreate() ;
extern XmString XmStringLtoRCreate() ;
extern XmString XmStringCreateLtoR() ;
extern Boolean XmStringInitContext() ;
extern void XmStringFreeContext() ;
extern XmStringComponentType XmStringGetNextComponent() ;
extern XmStringComponentType XmStringPeekNextComponent() ;
extern Boolean XmStringGetNextSegment() ;
extern Boolean XmStringGetLtoR() ;
extern XmFontListEntry XmFontListEntryCreate() ;
extern void XmFontListEntryFree() ;
extern XtPointer XmFontListEntryGetFont() ;
extern char * XmFontListEntryGetTag() ;
extern XmFontList XmFontListAppendEntry() ;
extern XmFontListEntry XmFontListNextEntry() ;
extern XmFontList XmFontListRemoveEntry() ;
extern XmFontListEntry XmFontListEntryLoad() ;
extern XmFontList XmFontListCreate() ;
extern XmFontList XmStringCreateFontList() ;
extern void XmFontListFree() ;
extern XmFontList XmFontListAdd() ;
extern XmFontList XmFontListCopy() ;
extern Boolean XmFontListInitFontContext() ;
extern Boolean XmFontListGetNextFont() ;
extern void XmFontListFreeFontContext() ;
extern XmString XmStringConcat() ;
extern XmString XmStringConcatAndFree();
extern XmString XmStringNConcat() ;
extern XmString XmStringCopy() ;
extern XmString XmStringNCopy() ;
extern Boolean XmStringByteCompare() ;
extern Boolean XmStringCompare() ;
extern int XmStringLength() ;
extern Boolean XmStringEmpty() ;
extern Boolean XmStringIsVoid(); 
extern Boolean XmStringHasSubstring() ;
extern void XmStringFree() ;
extern Dimension XmStringBaseline() ;
extern Dimension XmStringWidth() ;
extern Dimension XmStringHeight() ;
extern void XmStringExtent() ;
extern int XmStringLineCount() ;
extern void XmStringDraw() ;
extern void XmStringDrawImage() ;
extern void XmStringDrawUnderline() ;
extern unsigned int XmCvtXmStringToByteStream();
extern XmString XmCvtByteStreamToXmString();
extern unsigned int XmStringByteStreamLength();
extern XmStringComponentType XmStringPeekNextTriple();
extern XmStringComponentType XmStringGetNextTriple();
extern XmString XmStringComponentCreate();
extern XtPointer XmStringUnparse();
extern XmString XmStringParseText();
extern Cardinal XmStringToXmStringTable();
extern XmString XmStringTableToXmString();
extern XtPointer *XmStringTableUnparse();
extern XmStringTable XmStringTableParseStringArray();
extern XmStringDirection XmDirectionToStringDirection();
extern XmDirection XmStringDirectionToDirection();
extern XmString XmStringGenerate();
extern XmString XmStringPutRendition(); 
extern XmParseMapping XmParseMappingCreate();
extern void XmParseMappingSetValues();
extern void XmParseMappingGetValues();
extern void XmParseMappingFree();
extern void XmParseTableFree();
     
#else

extern XmString XmStringCreate( 
                        char *text,
                        XmStringCharSet charset) ;
extern XmString XmStringCreateSimple( 
                        char *text) ;
extern XmString XmStringCreateLocalized( 
                        String text) ;
extern XmString XmStringDirectionCreate( 
#if NeedWidePrototypes
                        int direction) ;
#else
                        XmStringDirection direction) ;
#endif /* NeedWidePrototypes */
extern XmString XmStringSeparatorCreate( void ) ;
extern XmString XmStringSegmentCreate( 
                        char *text,
                        XmStringCharSet charset,
#if NeedWidePrototypes
                        int direction,
                        int separator) ;
#else
                        XmStringDirection direction,
                        Boolean separator) ;
#endif /* NeedWidePrototypes */
extern XmString XmStringLtoRCreate( 
                        char *text,
                        XmStringCharSet charset) ;
extern XmString XmStringCreateLtoR( 
                        char *text,
                        XmStringCharSet charset) ;
extern Boolean XmStringInitContext( 
                        XmStringContext *context,
                        XmString string) ;
extern void XmStringFreeContext( 
                        XmStringContext context) ;
extern XmStringComponentType XmStringGetNextComponent( 
                        XmStringContext context,
                        char **text,
                        XmStringCharSet *charset,
                        XmStringDirection *direction,
                        XmStringComponentType *unknown_tag,
                        unsigned short *unknown_length,
                        unsigned char **unknown_value) ;
extern XmStringComponentType XmStringPeekNextComponent( 
                        XmStringContext context) ;
extern Boolean XmStringGetNextSegment( 
                        XmStringContext context,
                        char **text,
                        XmStringCharSet *charset,
                        XmStringDirection *direction,
                        Boolean *separator) ;
extern Boolean XmStringGetLtoR( 
                        XmString string,
                        XmStringCharSet charset,
                        char **text) ;
extern XmFontListEntry XmFontListEntryCreate( 
                        char *tag,
                        XmFontType type,
                        XtPointer font) ;
extern void XmFontListEntryFree( 
                        XmFontListEntry *entry) ;
extern XtPointer XmFontListEntryGetFont( 
                        XmFontListEntry entry,
                        XmFontType *typeReturn) ;
extern char * XmFontListEntryGetTag( 
                        XmFontListEntry entry) ;
extern XmFontList XmFontListAppendEntry( 
                        XmFontList old,
                        XmFontListEntry entry) ;
extern XmFontListEntry XmFontListNextEntry( 
                        XmFontContext context) ;
extern XmFontList XmFontListRemoveEntry( 
                        XmFontList old,
                        XmFontListEntry entry) ;
extern XmFontListEntry XmFontListEntryLoad( 
                        Display *display,
                        char *fontName,
                        XmFontType type,
                        char *tag) ;
extern XmFontList XmFontListCreate( 
                        XFontStruct *font,
                        XmStringCharSet charset) ;
extern XmFontList XmStringCreateFontList( 
                        XFontStruct *font,
                        XmStringCharSet charset) ;
extern void XmFontListFree( 
                        XmFontList fontlist) ;
extern XmFontList XmFontListAdd( 
                        XmFontList old,
                        XFontStruct *font,
                        XmStringCharSet charset) ;
extern XmFontList XmFontListCopy( 
                        XmFontList fontlist) ;
extern Boolean XmFontListInitFontContext( 
                        XmFontContext *context,
                        XmFontList fontlist) ;
extern Boolean XmFontListGetNextFont( 
                        XmFontContext context,
                        XmStringCharSet *charset,
                        XFontStruct **font) ;
extern void XmFontListFreeFontContext( 
                        XmFontContext context) ;
extern XmString XmStringConcat( 
                        XmString a,
                        XmString b) ;
extern XmString XmStringConcatAndFree(
			XmString a, 
			XmString b) ;
extern XmString XmStringNConcat( 
                        XmString first,
                        XmString second,
                        int n) ;
extern XmString XmStringCopy( 
                        XmString string) ;
extern XmString XmStringNCopy( 
                        XmString str,
                        int n) ;
extern Boolean XmStringByteCompare( 
                        XmString a1,
                        XmString b1) ;
extern Boolean XmStringCompare( 
                        XmString a,
                        XmString b) ;
extern int XmStringLength( 
                        XmString string) ;
extern Boolean XmStringEmpty( 
                        XmString string) ;
extern Boolean XmStringIsVoid(XmString string); 
extern Boolean XmStringHasSubstring( 
                        XmString string,
                        XmString substring) ;
extern void XmStringFree( 
                        XmString string) ;
extern Dimension XmStringBaseline( 
                        XmFontList fontlist,
                        XmString string) ;
extern Dimension XmStringWidth( 
                        XmFontList fontlist,
                        XmString string) ;
extern Dimension XmStringHeight( 
                        XmFontList fontlist,
                        XmString string) ;
extern void XmStringExtent( 
                        XmFontList fontlist,
                        XmString string,
                        Dimension *width,
                        Dimension *height) ;
extern int XmStringLineCount( 
                        XmString string) ;
extern void XmStringDraw( 
                        Display *d,
                        Window w,
                        XmFontList fontlist,
                        XmString string,
                        GC gc,
#if NeedWidePrototypes
                        int x,
                        int y,
                        int width,
                        unsigned int align,
                        unsigned int lay_dir,
#else
                        Position x,
                        Position y,
                        Dimension width,
                        unsigned char align,
                        unsigned char lay_dir,
#endif /* NeedWidePrototypes */
                        XRectangle *clip) ;
extern void XmStringDrawImage( 
                        Display *d,
                        Window w,
                        XmFontList fontlist,
                        XmString string,
                        GC gc,
#if NeedWidePrototypes
                        int x,
                        int y,
                        int width,
                        unsigned int align,
                        unsigned int lay_dir,
#else
                        Position x,
                        Position y,
                        Dimension width,
                        unsigned char align,
                        unsigned char lay_dir,
#endif /* NeedWidePrototypes */
                        XRectangle *clip) ;
extern void XmStringDrawUnderline( 
                        Display *d,
                        Window w,
                        XmFontList fntlst,
                        XmString str,
                        GC gc,
#if NeedWidePrototypes
                        int x,
                        int y,
                        int width,
                        unsigned int align,
                        unsigned int lay_dir,
#else
                        Position x,
                        Position y,
                        Dimension width,
                        unsigned char align,
                        unsigned char lay_dir,
#endif /* NeedWidePrototypes */
                        XRectangle *clip,
                        XmString under) ;
extern unsigned int XmCvtXmStringToByteStream(
			XmString string,
        	        unsigned char **prop_return);
extern XmString XmCvtByteStreamToXmString(
        	        unsigned char *property);
extern unsigned int XmStringByteStreamLength(unsigned char *string);
extern XmStringComponentType XmStringPeekNextTriple(XmStringContext context);
extern XmStringComponentType XmStringGetNextTriple(XmStringContext context,
						   unsigned int *length,
						   XtPointer *value);
extern XmString XmStringComponentCreate(XmStringComponentType tag,
					unsigned int length,
					XtPointer value);
extern XtPointer XmStringUnparse(XmString string,
				 XmStringTag tag,
				 XmTextType tag_type,
				 XmTextType output_type,
				 XmParseTable parse_table,
				 Cardinal parse_count,
				 XmParseModel parse_model);
extern XmString XmStringParseText(XtPointer text,
				  XtPointer *text_end,
				  XmStringTag tag,
				  XmTextType type,
				  XmParseTable parse_table,
				  Cardinal parse_count,
				  XtPointer call_data);
extern Cardinal XmStringToXmStringTable(XmString string,
					XmString break_comp,
					XmStringTable *table);
extern XmString XmStringTableToXmString(XmStringTable table,
					Cardinal count,
					XmString break_component);
extern XtPointer *XmStringTableUnparse(XmStringTable table,
				       Cardinal count,
				       XmStringTag tag,
				       XmTextType tag_type,
				       XmTextType output_type,
				       XmParseTable parse,
				       Cardinal parse_count,
				       XmParseModel parse_model);
extern XmStringTable XmStringTableParseStringArray(XtPointer *strings,
						   Cardinal count,
						   XmStringTag tag,
						   XmTextType type,
						   XmParseTable parse,
						   Cardinal parse_count,
						   XtPointer call_data);

extern XmStringDirection XmDirectionToStringDirection(XmDirection dir);
extern XmDirection XmStringDirectionToDirection(XmStringDirection dir);

extern XmString XmStringGenerate(XtPointer   text,
				 XmStringTag tag,
				 XmTextType  type,
				 XmStringTag rendition);
extern XmString XmStringPutRendition(XmString string,
				     XmStringTag rendition); 

extern XmParseMapping XmParseMappingCreate(ArgList  arg_list,
					   Cardinal arg_count);
extern void XmParseMappingSetValues(XmParseMapping parse_mapping,
				    ArgList        arg_list,
				    Cardinal       arg_count);
extern void XmParseMappingGetValues(XmParseMapping parse_mapping,
				    ArgList        arg_list,
				    Cardinal       arg_count);
extern void XmParseMappingFree(XmParseMapping parse_mapping);
extern void XmParseTableFree(XmParseTable parse_table,
			     Cardinal     parse_count);

#endif /* _NO_PROTO */
/********    End Public Function Declarations    ********/

/********    Public Function Declarations for XmTabList.c    ********/
#ifdef _NO_PROTO
     
extern XmTabList XmStringTableProposeTablist();
extern void XmTabSetValue();
extern float XmTabGetValues();
extern void XmTabFree();
extern XmTab XmTabCreate();
extern XmTabList XmTabListRemoveTabs();
extern XmTabList XmTabListReplacePositions();
extern XmTab XmTabListGetTab();
extern Cardinal XmTabListTabCount();
extern XmTabList XmTabListCopy();
extern void XmTabListFree();
extern XmTabList XmTabListInsertTabs();

#else

extern XmTabList 
  XmStringTableProposeTablist(XmStringTable strings, 
			      Cardinal num_strings,
			      Widget widget,
			      float pad_value,
			      XmOffsetModel offset_model);
extern void XmTabSetValue(XmTab tab, float value);
extern float 
  XmTabGetValues(XmTab tab, 
		 unsigned char *units, 
		 XmOffsetModel *offset, 
		 unsigned char *alignment, 
		 char **decimal);
extern void XmTabFree(XmTab tab);
extern XmTab XmTabCreate(float value, 
			 unsigned char units, 
			 XmOffsetModel offset_model, 
			 unsigned char alignment, 
			 char *decimal);
extern XmTabList 
  XmTabListRemoveTabs(XmTabList oldlist, 
		      Cardinal *position_list, 
		      Cardinal position_count);
extern XmTabList 
  XmTabListReplacePositions(XmTabList oldlist, 
			    Cardinal *position_list, 
			    XmTab *tabs, 
			    Cardinal tab_count);
extern XmTab XmTabListGetTab(XmTabList tablist, Cardinal position);
extern Cardinal XmTabListTabCount(XmTabList tablist);
extern XmTabList XmTabListCopy(XmTabList tablist, int offset, Cardinal count);
extern void XmTabListFree(XmTabList tablist);
extern XmTabList XmTabListInsertTabs(XmTabList oldlist,
				     XmTab *tabs, 
				     Cardinal tab_count, 
				     int position);
#endif /* _NO_PROTO */
/********    End Public Function Declarations    ********/

/********    Public Function Declarations for XmRenderTable.c    ********/
#ifdef _NO_PROTO
     
extern XmRenderTable XmRenderTableCvtFromProp();
extern unsigned int XmRenderTableCvtToProp();
extern void XmRenditionUpdate();
extern void XmRenditionRetrieve();
extern void XmRenditionFree();
extern XmRendition XmRenditionCreate();
extern XmRendition *XmRenderTableGetRenditions();
extern XmRendition XmRenderTableGetRendition();
extern int XmRenderTableGetTags();
extern void XmRenderTableFree();
extern XmRenderTable XmRenderTableCopy();
extern XmRenderTable XmRenderTableRemoveRenditions();
extern XmRenderTable XmRenderTableAddRenditions();

#else

extern XmRenderTable XmRenderTableCvtFromProp(Widget, char *prop, unsigned int len);
extern unsigned int XmRenderTableCvtToProp(Widget, XmRenderTable table, char **prop_return);
extern void XmRenditionUpdate(XmRendition rendition, ArgList arglist, Cardinal argcount);
extern void XmRenditionRetrieve(XmRendition rendition, 
				ArgList arglist,
				Cardinal argcount);
extern void XmRenditionFree(XmRendition rendition);
extern XmRendition XmRenditionCreate(Widget widget,
				     XmStringTag tag,
				     ArgList arglist,
				     Cardinal argcount);
extern XmRendition 
  *XmRenderTableGetRenditions(XmRenderTable table, 
			      XmStringTag *tags,
			      Cardinal tag_count);
extern XmRendition XmRenderTableGetRendition(XmRenderTable table,
					     XmStringTag tag);
extern int XmRenderTableGetTags(XmRenderTable table,
				XmStringTag **tag_list);
extern void XmRenderTableFree(XmRenderTable table);
extern XmRenderTable XmRenderTableCopy(XmRenderTable table,
				       XmStringTag *tags, 
				       int tag_count);
extern XmRenderTable 
  XmRenderTableRemoveRenditions(XmRenderTable oldtable,
				XmStringTag *tags, 
				int tag_count);
extern XmRenderTable 
  XmRenderTableAddRenditions(XmRenderTable oldtable, 
			     XmRendition *renditions, 
			     Cardinal rendition_count, 
			     XmMergeMode merge_mode);

#endif /* _NO_PROTO */
/********    End Public Function Declarations    ********/

/********    Public Function Declarations for Dest.c    ********/
#ifdef _NO_PROTO

extern Widget XmGetDestination() ;

#else

extern Widget XmGetDestination( 
                        Display *display) ;

#endif /* _NO_PROTO */
/********    End Public Function Declarations    ********/

/********    Public Function Declarations for Traversal.c    ********/
#ifdef _NO_PROTO

extern Boolean XmIsTraversable() ;
extern XmVisibility XmGetVisibility() ;
extern Widget XmGetTabGroup() ;
extern Widget XmGetFocusWidget() ;
extern Boolean XmProcessTraversal() ;
extern void XmAddTabGroup() ;
extern void XmRemoveTabGroup() ;

#else

extern Boolean XmIsTraversable( 
                        Widget wid) ;
extern XmVisibility XmGetVisibility( 
                        Widget wid) ;
extern Widget XmGetTabGroup( 
                        Widget wid) ;
extern Widget XmGetFocusWidget( 
                        Widget wid) ;
extern Boolean XmProcessTraversal( 
                        Widget w,
                        XmTraversalDirection dir) ;
extern void XmAddTabGroup( 
                        Widget tabGroup) ;
extern void XmRemoveTabGroup( 
                        Widget w) ;

#endif /* _NO_PROTO */
/********    End Public Function Declarations    ********/

/********        ********/

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

/* The following includes are for source compatibility.  They might be
*    removed at some future time.
*/
#include <Xm/VendorS.h>
#include <Xm/XmIm.h>

#define XmINDICATOR_3D_BOX		0x01
#define XmINDICATOR_FLAT_BOX		0x02
#define XmINDICATOR_CHECK_GLYPH		0x10
#define XmINDICATOR_CROSS_GLYPH		0x20

enum {
  XmINDICATOR_NONE      = 0, 
  XmINDICATOR_FILL      = XmINDICATOR_3D_BOX,
  XmINDICATOR_CHECK     = XmINDICATOR_CHECK_GLYPH,
  XmINDICATOR_CHECK_BOX = XmINDICATOR_CHECK_GLYPH + XmINDICATOR_3D_BOX,
  XmINDICATOR_CROSS     = XmINDICATOR_CROSS_GLYPH,
  XmINDICATOR_CROSS_BOX = XmINDICATOR_CROSS_GLYPH + XmINDICATOR_3D_BOX
};

enum { XmUNSET, XmSET, XmINDETERMINATE };
enum { XmTOGGLE_BOOLEAN, XmTOGGLE_INDETERMINATE};
typedef unsigned char XmToggleButtonState;

/* CSText Stuff */

/* shared with Text */
typedef enum {EditDone, EditError, EditReject} XmTextStatus;

typedef enum {
  XmSCAN_DIRECTION_FORWARD,
  XmSCAN_DIRECTION_REVERSE
  } XmCSTextScanDirection;

typedef enum {
  XmSCAN_TYPE_WORD_SELECT,
  XmSCAN_TYPE_TEXT_WRAP
  } XmCSTextScanType;

/* 
  XmDisplay,  XmNdefaultButtonEmphasis enum
 */

enum { XmEXTERNAL_HIGHLIGHT, XmINTERNAL_HIGHLIGHT };

/* new for XmString */
#define _MOTIF_DEFAULT_LOCALE "_MOTIF_DEFAULT_LOCALE"

enum{	XmPATH_MODE_FULL,	XmPATH_MODE_RELATIVE};
enum{	XmFILTER_NONE,	XmFILTER_HIDDEN_FILES};
  
#endif /* _Xm_h */
 /* DON'T ADD STUFF AFTER THIS #endif */
