/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
 */ 
/* 
 * HISTORY
 * $Log: XmIm.h,v $
 * Revision 1.1.2.5  1993/07/23  03:06:24  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:41:08  yak]
 *
 * Revision 1.1.2.4  1993/06/03  15:34:37  inca
 * 	XmInputPolicy is now unsigned char, needs Wide prototypes in some cases
 * 	[1993/06/03  15:31:08  inca]
 * 
 * Revision 1.1.2.3  1993/05/10  22:46:42  drk
 * 	Fix typo.
 * 	[1993/05/10  22:44:40  drk]
 * 
 * 	Remove unused parameters to XmImGetXIC().
 * 	[1993/04/30  19:35:31  drk]
 * 
 * Revision 1.1.2.2  1993/04/26  14:42:38  drk
 * 	Moved declarations from Xm.h.
 * 	[1993/04/26  14:38:20  drk]
 * 
 * $EndLog$
 */ 
#ifndef _XmIm_h
#define _XmIm_h

#include <Xm/Xm.h>

#ifdef __cplusplus
extern "C" {
#endif

/********    Public Function Declarations    ********/
#ifdef _NO_PROTO

extern void XmImRegister() ;
extern void XmImUnregister() ;
extern void XmImSetFocusValues() ;
extern void XmImSetValues() ;
extern void XmImUnsetFocus() ;
extern XIM XmImGetXIM() ;
extern void XmImCloseXIM() ;
extern int XmImMbLookupString() ;
extern void XmImVaSetFocusValues() ;
extern void XmImVaSetValues() ;
extern XIC XmImGetXIC() ;
extern XIC XmImSetXIC() ;
extern void XmImFreeXIC() ;

#else

extern void XmImRegister( 
                        Widget w,
			unsigned int reserved) ;
extern void XmImUnregister( 
                        Widget w) ;
extern void XmImSetFocusValues( 
                        Widget w,
                        ArgList args,
                        Cardinal num_args) ;
extern void XmImSetValues( 
                        Widget w,
                        ArgList args,
                        Cardinal num_args) ;
extern void XmImUnsetFocus( 
                        Widget w) ;
extern XIM XmImGetXIM( 
                        Widget w) ;
extern void XmImCloseXIM(
                        Widget w) ;

extern int XmImMbLookupString( 
                        Widget w,
                        XKeyPressedEvent *event,
                        char *buf,
                        int nbytes,
                        KeySym *keysym,
                        int *status) ;
extern void XmImVaSetFocusValues( 
                        Widget w,
                        ...) ;
extern void XmImVaSetValues( 
                        Widget w,
                        ...) ;
extern XIC XmImGetXIC(
		        Widget 		w,
#if NeedWidePrototypes
		        unsigned int 	input_policy,
#else
		        XmInputPolicy	input_policy,
#endif /*NeedWidePrototypes*/
		        ArgList		args,
		        Cardinal	num_args) ;
extern XIC XmImSetXIC(
			Widget w,
			XIC    input_context) ;
extern void XmImFreeXIC(
			Widget w,
			XIC    input_context) ;

#endif /* _NO_PROTO */
/********    End Public Function Declarations    ********/

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmIm_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
