/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: XmP.h,v $
 * Revision 1.9.28.5  1994/06/29  20:41:22  drk
 * 	CR 9539: Fix SGI 64-bit warnings.
 * 	[1994/06/29  20:13:08  drk]
 *
 * Revision 1.9.28.4  1994/06/02  21:18:36  daniel
 * 	Merged with changes from 1.9.28.3
 * 	[1994/06/02  21:18:18  daniel]
 * 
 * 	add XmTextFieldIndex
 * 	[1994/06/01  16:28:16  daniel]
 * 
 * Revision 1.9.28.3  1994/06/01  21:11:55  drk
 * 	CR 6873: Resolve P.h name conflicts.
 * 	[1994/06/01  16:58:10  drk]
 * 
 * Revision 1.9.28.2  1994/05/25  22:03:20  inca
 * 	Move enum for XmeGetDefaultRenderTable to XmP.h
 * 	[1994/05/25  22:02:52  inca]
 * 
 * Revision 1.9.28.1  1994/05/14  00:25:54  daniel
 * 	remodularization in process
 * 	[1994/05/14  00:25:18  daniel]
 * 
 * Revision 1.9.25.21  1994/04/11  22:30:53  knight
 * 	Fix CR8516, removed #define const for Notebook and Container.
 * 	Merge from ibm-bugs.
 * 	[1994/04/11  17:01:32  knight]
 * 
 * Revision 1.9.25.20  1994/03/25  15:41:36  deblois
 * 	Changed XmeGetDefaultDisplay to _XmGetDefaultDisplay. CR 8286
 * 	[1994/03/24  23:47:02  deblois]
 * 
 * Revision 1.9.25.19  1994/03/11  21:35:32  daniel
 * 	add XmeGetMask
 * 	[1994/03/11  21:34:53  daniel]
 * 
 * Revision 1.9.25.18  1994/03/09  02:24:06  meeks
 * 	PERF: Removed references to obsolete XmString functions.
 * 	[1994/03/09  01:51:35  meeks]
 * 
 * Revision 1.9.25.17  1994/03/04  22:28:58  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  22:02:16  drk]
 * 
 * Revision 1.9.25.16  1994/03/01  22:27:47  drk
 * 	Promote _XmParseUnits to XmeParseUnits.
 * 	[1994/03/01  18:59:24  drk]
 * 
 * Revision 1.9.25.15  1994/02/24  23:41:18  drk
 * 	Remove _Xm and Xt functions from XmP.h
 * 	[1994/02/24  23:37:39  drk]
 * 
 * Revision 1.9.25.14  1994/02/15  03:01:48  daniel
 * 	rework of ImageCache module for CDE
 * 	[1994/02/15  03:01:07  daniel]
 * 
 * Revision 1.9.25.13  1994/02/11  20:38:51  drk
 * 	Cleanup fast subclass bit comments.
 * 	[1994/02/11  20:38:36  drk]
 * 
 * Revision 1.9.25.12  1994/02/02  22:14:17  drk
 * 	CR 7907: Promoted _XmStringConcatAndFree to a public function.
 * 	[1994/02/02  19:10:56  drk]
 * 
 * Revision 1.9.25.11  1994/02/01  22:04:55  drk
 * 	Kill _XmMgrTraversalOrder, since it is unnecessary after all.
 * 	[1994/02/01  22:04:35  drk]
 * 
 * Revision 1.9.25.10  1994/01/27  22:32:37  drk
 * 	CR 6149: Allow -DANSICPP for partially conformant preprocessors.
 * 	[1994/01/27  21:39:13  drk]
 * 
 * Revision 1.9.25.9  1994/01/21  22:18:02  drk
 * 	Add only_if_exists parameter to _XmGetColoredPixmap.
 * 	[1994/01/21  22:17:52  drk]
 * 
 * Revision 1.9.25.8  1994/01/21  22:10:44  drk
 * 	Add only_if_exists parameter to _XmGetColoredPixmap.
 * 	[1994/01/21  22:10:26  drk]
 * 
 * Revision 1.9.25.7  1994/01/13  22:07:24  daniel
 * 	do some cleanup, add comments
 * 	[1994/01/13  21:47:25  daniel]
 * 
 * Revision 1.9.25.6  1993/12/30  22:11:29  daniel
 * 	defunct World class
 * 	[1993/12/30  22:11:02  daniel]
 * 
 * Revision 1.9.25.5  1993/12/30  15:53:10  yak
 * 	Changed type of _XmGetColoredPixmap from Boolean to Pixmap.
 * 	[1993/12/30  15:52:46  yak]
 * 
 * Revision 1.9.25.4  1993/12/29  21:25:15  daniel
 * 	mv XmTabListGetPosition as _Xm + unit
 * 	[1993/12/29  21:24:56  daniel]
 * 
 * Revision 1.9.25.3  1993/12/29  21:09:40  daniel
 * 	change valid in valueMask in trait rec
 * 	[1993/12/29  21:08:07  daniel]
 * 
 * Revision 1.9.25.2  1993/12/29  18:19:38  daniel
 * 	rework the conversion modules
 * 	[1993/12/29  18:17:30  daniel]
 * 
 * Revision 1.9.25.1  1993/12/28  15:36:47  daniel
 * 	rework of the pixmap cache/conversion
 * 	[1993/12/28  15:34:26  daniel]
 * 
 * Revision 1.9.16.39  1993/11/24  21:14:42  meeks
 * 	CR 7165: Changed signature of _XmStringGetNextTabWidth.
 * 	[1993/11/24  14:22:56  meeks]
 * 
 * Revision 1.9.16.38  1993/11/10  17:41:40  daniel
 * 	undo my last change
 * 	[1993/11/10  17:41:21  daniel]
 * 
 * Revision 1.9.16.37  1993/11/10  16:55:28  daniel
 * 	add _XmGetColoredPixmap
 * 	[1993/11/10  16:21:28  daniel]
 * 
 * Revision 1.9.16.36  1993/11/09  23:23:42  drk
 * 	CR 6852: Added XmTraversalDirection to XmFocusMovedCallbackStruct.
 * 	[1993/11/09  23:22:39  drk]
 * 
 * Revision 1.9.16.35  1993/11/08  23:03:02  motifibm
 * 	added #define const for Notebook and Container
 * 	[1993/11/08  23:02:36  motifibm]
 * 
 * Revision 1.9.16.34  1993/11/04  22:14:38  dick
 * 	Added _XmStringUngenerate to be the reverse of XmStringGenerate
 * 	[1993/11/04  22:10:45  dick]
 * 
 * Revision 1.9.16.33  1993/11/03  00:48:55  drk
 * 	CR 5353: Created _XmStringGetBaselines().
 * 	[1993/11/03  00:47:53  drk]
 * 
 * Revision 1.9.16.32  1993/10/29  21:37:32  drand
 * 	New SpinB Drop,  also moved RepType and Accelerators to proper destinations
 * 	[1993/10/29  21:36:27  drand]
 * 
 * Revision 1.9.16.31  1993/10/26  22:15:20  jwiele
 * 	Merged with changes from 1.9.16.30
 * 	[1993/10/26  22:15:10  jwiele]
 * 
 * 	Replaced XmLONGBITS and XmHALFLONGBITS with the correctly defined and
 * 	more intuitively named XmOFFSETBITS and XmOFFSETMASK.  (Digital
 * 	64-bit fix)
 * 	[1993/10/26  22:03:50  jwiele]
 * 
 * Revision 1.9.16.30  1993/10/26  21:57:54  rgcote
 * 	Added a new _Xm function named _XmConvertFloatUnitsToIntUnits.
 * 	The units conversion functions only operate on integers. When
 * 	we need to convert a float, we first determine an appropriate
 * 	multiplier for the float and an appropriate units type so as
 * 	to minimize information loss. This function makes that
 * 	determination. This code used to be in-line to
 * 	_XmConvertStringToUnits but I made it a separate function
 * 	because we needed this functionality in Mrm.
 * 	[1993/10/26  21:55:47  rgcote]
 * 
 * Revision 1.9.16.29  1993/10/25  21:32:59  daniel
 * 	new color trait
 * 	[1993/10/25  21:28:49  daniel]
 * 
 * Revision 1.9.16.28  1993/10/20  20:16:33  meeks
 * 	CLEANUP: Changed signature of _XmStringGetNextTabWidth.
 * 	[1993/10/20  20:13:36  meeks]
 * 
 * Revision 1.9.16.27  1993/10/19  21:13:36  meeks
 * 	I 160: Changed signature of _XmRenditionMerge and added declaration
 * 	for _XmStringRender.
 * 	[1993/10/19  21:03:45  meeks]
 * 
 * Revision 1.9.16.26  1993/10/14  21:04:45  inca
 * 	Cleaned out message strings to Messages.c, rewrote MotifWarningHandler
 * 	and added an _XmWarningMsg for parameterized messages
 * 	[1993/10/14  20:09:03  inca]
 * 
 * Revision 1.9.16.25  1993/10/12  21:06:37  daniel
 * 	integrate hp drop
 * 	[1993/10/12  21:06:13  daniel]
 * 
 * Revision 1.9.16.24  1993/10/08  22:53:30  drk
 * 	Added XmSTRING_TAG_STRLEN and misc. tuning.
 * 	[1993/10/08  22:50:36  drk]
 * 
 * Revision 1.9.16.23  1993/10/07  22:13:57  deblois
 * 	Changed NoteBook -> Notebook.
 * 	[1993/10/07  18:40:43  deblois]
 * 
 * Revision 1.9.16.22  1993/10/04  22:08:07  drk
 * 	Created _XmStringConcatAndFree.
 * 	[1993/10/04  22:03:15  drk]
 * 
 * Revision 1.9.16.21  1993/09/28  20:54:52  daniel
 * 	move to XmeSetWMShellTitle
 * 	[1993/09/28  20:53:35  daniel]
 * 
 * Revision 1.9.16.20  1993/09/28  17:55:44  daniel
 * 	change prototype of Container method
 * 	[1993/09/28  17:55:18  daniel]
 * 
 * Revision 1.9.16.19  1993/09/23  22:54:54  drk
 * 	Added _XmMgrTraversalOrder.
 * 	[1993/09/23  22:53:57  drk]
 * 
 * Revision 1.9.16.18  1993/09/22  20:57:05  meeks
 * 	Modified decl for _XmParseUnits.
 * 	[1993/09/22  20:40:43  meeks]
 * 
 * Revision 1.9.16.17  1993/09/19  21:36:34  drk
 * 	CR 2337: Cleanup symbolic constants used to display toggle indicators.
 * 	[1993/09/19  21:35:18  drk]
 * 
 * Revision 1.9.16.16  1993/09/16  22:12:59  drk
 * 	Delete the XM_ATOM_CACHE symbol.
 * 	[1993/09/16  22:12:21  drk]
 * 
 * Revision 1.9.16.15  1993/09/16  20:26:16  dbrooks
 * 	Undo previous submission.
 * 	Fixes from Motif1.2.4. Rev. 1.9.22.2, ancestor 1.9.19.3, file XmP.h.
 * 	[1993/09/16  20:25:56  dbrooks]
 * 
 * Revision 1.9.16.14  1993/09/16  19:42:34  dbrooks
 * 	Rationalize MAX/MIN maxros on HP-UX.  CR 6404.
 * 	Fixes from Motif1.2.4. Rev. 1.9.20.2, ancestor 1.9.19.2, file XmP.h.
 * 	[1993/09/16  19:42:12  dbrooks]
 * 
 * Revision 1.9.16.13  1993/09/14  23:14:03  motifibm
 * 	IBM Drop 9/14
 * 	[1993/09/14  23:11:23  motifibm]
 * 
 * Revision 1.9.16.12  1993/09/14  20:43:25  inca
 * 	Changed XmeOS* to Xme* as decided by Xme mtng
 * 	[1993/09/14  20:17:29  inca]
 * 
 * Revision 1.9.16.11  1993/09/14  17:24:03  meeks
 * 	Added declaration for _XmRenditionMerge.
 * 	[1993/09/14  15:39:39  meeks]
 * 
 * Revision 1.9.16.10  1993/09/09  20:35:53  drk
 * 	Include ObjectP.h so the XtParent macro uses defined structures.
 * 	[1993/09/09  20:35:30  drk]
 * 
 * Revision 1.9.16.9  1993/09/07  22:14:55  drand
 * 	Changed _XmFocusIsInShell to XmeFocusIsInShell,  added XmIsInDragMode
 * 	macro and XmMENU_IN_DRAG_MODE_BIT.
 * 	[1993/09/07  22:12:10  drand]
 * 
 * Revision 1.9.16.8  1993/09/01  22:17:10  drk
 * 	Fix _NO_PROTO profile for _XmToLayoutDirection.
 * 	[1993/09/01  22:16:45  drk]
 * 
 * Revision 1.9.16.7  1993/09/01  21:51:35  inca
 * 	Added layoutDirection to Manager, Primitive & Gadget, added a layout trait
 * 	[1993/08/31  20:49:35  inca]
 * 
 * Revision 1.9.16.6  1993/09/01  17:31:12  daniel
 * 	add some resource name and macros
 * 	[1993/09/01  17:29:09  daniel]
 * 
 * Revision 1.9.16.5  1993/08/31  18:15:24  drk
 * 	Expunge _XmInitAtomPairs().
 * 	[1993/08/31  18:14:40  drk]
 * 
 * Revision 1.9.16.4  1993/08/30  21:22:32  drk
 * 	Moved the declaration of _XmGetLayoutDirection() into XmP.h, since the
 * 	GetLayout() macros there reference it.
 * 	[1993/08/30  21:22:03  drk]
 * 
 * Revision 1.9.16.3  1993/08/23  22:14:06  yak
 * 	Expanded copyright marker
 * 	[1993/08/23  21:27:18  yak]
 * 
 * Revision 1.9.16.2  1993/07/16  22:17:06  drk
 * 	Exported declaration of _XmConvertStringToUnits.
 * 	[1993/07/16  17:24:03  drk]
 * 
 * Revision 1.9.8.53  1993/07/13  15:44:33  rgcote
 * 	Fixed the fast subclass bits so that they are binary
 * 	compatible with release 1.2.3.
 * 	[1993/07/13  15:44:15  rgcote]
 * 
 * Revision 1.9.8.52  1993/07/11  01:19:12  motifics
 * 	Fix typo
 * 	[1993/07/11  01:16:07  motifics]
 * 
 * Revision 1.9.8.51  1993/07/10  02:28:10  meeks
 * 	Added decl for _XmRenderTableDisplay.
 * 	[1993/07/10  02:09:00  meeks]
 * 
 * Revision 1.9.8.50  1993/07/09  21:57:37  meeks
 * 	2.0 4.2: Added decls for _XmCreate functions for Mrminit.c for renditions.
 * 	[1993/07/09  21:55:02  meeks]
 * 
 * Revision 1.9.8.49  1993/07/09  17:30:12  daniel
 * 	fix _XmGetImageFromFile mixup
 * 	[1993/07/09  17:29:20  daniel]
 * 
 * Revision 1.9.8.48  1993/07/08  22:16:47  rgcote
 * 	Update the offset indices and the XmIs macros for all the
 * 	new widgets and the widgets that were missed in 1.2
 * 	[1993/07/08  22:15:52  rgcote]
 * 
 * Revision 1.9.8.47  1993/07/08  18:26:32  drk
 * 	Remove virtkey field from XmKeyBinding; created XmVKeyBinding instead.
 * 	[1993/07/08  18:24:06  drk]
 * 
 * 	Added a virtkey field to XmKeyBindingRec.
 * 	[1993/07/08  17:06:37  drk]
 * 
 * Revision 1.9.8.46  1993/07/02  18:58:56  daniel
 * 	mv XM_ATOM_CACHE in XmP.h
 * 	[1993/07/02  18:58:02  daniel]
 * 
 * Revision 1.9.8.45  1993/07/02  18:14:35  daniel
 * 	put in Xm.c
 * 	[1993/07/02  18:11:07  daniel]
 * 
 * Revision 1.9.8.44  1993/07/01  21:17:39  daniel
 * 	implement XmGadgetAtPoint
 * 	[1993/07/01  21:16:27  daniel]
 * 
 * Revision 1.9.8.43  1993/07/01  01:06:59  meeks
 * 	2.0 4.2: Out of sync with XmString.c.  Attempting to resynchronize.
 * 	[1993/07/01  01:04:33  meeks]
 * 
 * Revision 1.9.8.42  1993/07/01  00:34:51  rgcote
 * 	Removed declarations for _Xm functions which have become
 * 	Xme functions.
 * 	[1993/06/30  23:47:15  rgcote]
 * 
 * Revision 1.9.8.41  1993/06/30  22:53:45  drk
 * 	Adapt to today's spec for XmParseProc.
 * 	[1993/06/30  22:50:51  drk]
 * 
 * Revision 1.9.8.40  1993/06/29  22:35:20  drk
 * 	Cleanup types for _XmMapKeyEvents, obsolesce _XmMapKeyEvent().
 * 	[1993/06/29  22:33:12  drk]
 * 
 * Revision 1.9.8.39  1993/06/28  23:09:19  inca
 * 	Cleaning up Right-to-left layout
 * 	[1993/06/28  20:53:31  inca]
 * 
 * Revision 1.9.8.38  1993/06/28  20:13:33  drk
 * 	Made XmKeyBinding type public, allow multiple actual keysyms per
 * 	virtual keysym.
 * 	[1993/06/28  17:24:01  drk]
 * 
 * Revision 1.9.8.37  1993/06/28  19:14:28  rgcote
 * 	Moved the XmActivateState enum to MenuT.h
 * 	[1993/06/28  19:02:34  rgcote]
 * 
 * Revision 1.9.8.36  1993/06/25  19:55:07  meeks
 * 	2.0 4.2.2: Changed signature of _XmRenditionCreate.
 * 	[1993/06/25  19:36:31  meeks]
 * 
 * Revision 1.9.8.35  1993/06/23  15:01:26  meeks
 * 	2.0 4.2.1: Added decl for _XmParseUnits.
 * 	[1993/06/23  14:52:27  meeks]
 * 
 * Revision 1.9.8.34  1993/06/23  14:10:35  drand
 * 	Latest and greatest version of SpinButton.
 * 	[1993/06/23  14:09:43  drand]
 * 
 * Revision 1.9.8.33  1993/06/21  13:22:40  inca
 * 	Added a typecast to GetLayout macro.
 * 	[1993/06/21  13:22:17  inca]
 * 
 * Revision 1.9.8.32  1993/06/17  19:19:53  inca
 * 	Modified LayoutIsRtoL.
 * 	[1993/06/17  14:01:23  inca]
 * 
 * Revision 1.9.8.31  1993/06/11  20:48:48  daniel
 * 	check point
 * 	[1993/06/06  01:42:13  daniel]
 * 
 * 	check point
 * 	[1993/06/05  01:12:51  daniel]
 * 
 * Revision 1.9.8.30  1993/06/11  19:33:01  meeks
 * 	2.0 4.2.1, 4.2.2: Modified signatures of _XmStringGetNextTabWidth, and
 * 	_XmRenderTableFindRendition.  Added _XmRenderTableGetMerged.
 * 	[1993/06/11  14:48:39  meeks]
 * 
 * Revision 1.9.8.29  1993/06/08  23:15:15  meeks
 * 	2.0 4.2.2: Changed signature of _XmRenditionCreate.
 * 	[1993/06/08  22:45:07  meeks]
 * 
 * Revision 1.9.8.28  1993/06/08  22:57:13  drk
 * 	Updated to account for recent XmStringParseText spec changes.
 * 	[1993/06/08  22:54:57  drk]
 * 
 * Revision 1.9.8.27  1993/06/07  01:44:33  meeks
 * 	2.0 4.2.1:  Added decls for _XmTabCopy and _XmStringGetNextTabWidth.
 * 	[1993/06/07  01:34:54  meeks]
 * 
 * Revision 1.9.8.26  1993/05/27  21:59:39  drk
 * 	Added _XmStringGetNextFullSegment to parallel _XmStringGetNextSegment.
 * 	[1993/05/27  21:59:03  drk]
 * 
 * Revision 1.9.8.25  1993/05/26  20:10:34  motifibm
 * 	IBM Alpha drop - Anthony
 * 	[1993/05/25  14:10:22  motifibm]
 * 
 * Revision 1.9.8.24  1993/05/24  18:34:12  meeks
 * 	2.0 4.2.2:  Added _XmRenderTableFindRendition.
 * 	[1993/05/24  18:17:49  meeks]
 * 
 * Revision 1.9.8.23  1993/05/20  21:59:48  rgcote
 * 	Fixes from Motif1.2.3. Rev. 1.9.13.2, ancestor 1.9.11.5, file XmP.h.
 * 	[1993/05/20  21:59:28  rgcote]
 * 
 * Revision 1.9.8.22  1993/05/20  21:01:38  rgcote
 * 	Fixes from Motif1.2.3. Rev. 1.9.15.2, ancestor 1.9.11.4, file XmP.h.
 * 	[1993/05/20  21:01:22  rgcote]
 * 
 * Revision 1.9.8.21  1993/05/19  20:13:26  meeks
 * 	2.0 4.2.2: Added decl for _XmRenditionCreate.
 * 	[1993/05/19  20:02:35  meeks]
 * 
 * Revision 1.9.8.20  1993/05/14  17:53:33  daniel
 * 	slip Visual.c in two - obsolete some API
 * 	[1993/05/14  17:50:39  daniel]
 * 
 * Revision 1.9.8.19  1993/05/10  22:46:44  drk
 * 	New parameter profile for _XmImFreeShellData.
 * 	[1993/05/10  22:45:17  drk]
 * 
 * 	Added _XmImFreeShellData().
 * 	[1993/05/10  20:18:38  drk]
 * 
 * Revision 1.9.8.18  1993/05/07  20:59:13  rgcote
 * 	Added external declaration for XmeConfigureObject.
 * 	[1993/05/07  20:40:06  rgcote]
 * 
 * Revision 1.9.8.17  1993/05/05  15:22:40  rgcote
 * 	Moved the Xme functions from XmosP.h to this file.
 * 	[1993/04/29  19:06:08  rgcote]
 * 
 * 	Changed XmeGetDefaultColors to be XmeGetDefaultPixel
 * 	[1993/04/29  17:32:39  rgcote]
 * 
 * Revision 1.9.8.16  1993/05/05  01:16:28  yak
 * 	Changed name of the first argument in XmeCreateClassDialog
 * 	from class to w_class, to satisfy C++ compiler.
 * 	[1993/05/05  01:16:02  yak]
 * 
 * Revision 1.9.8.15  1993/04/28  18:23:08  motifdec
 * 	Add IsCSText check
 * 	[1993/04/28  01:29:01  motifdec]
 * 
 * Revision 1.9.8.14  1993/04/27  19:45:39  rgcote
 * 	Added some more external function declarations for
 * 	Xme functions.
 * 	[1993/04/27  19:14:31  rgcote]
 * 
 * Revision 1.9.8.13  1993/04/27  14:11:48  rgcote
 * 	Added a number of external function declarations for
 * 	Xme functions.
 * 	[1993/04/27  13:20:38  rgcote]
 * 
 * 	Added a number of external function declarations for
 * 	Xme functions. Also added a #define'd the function
 * 	XmResolvePartOffsets to be XmeResolvePartOffsets.
 * 	[1993/04/26  16:25:50  rgcote]
 * 
 * 	Added an enum for the disableCallback of the
 * 	menu Savvy trait.
 * 	[1993/04/23  17:44:46  rgcote]
 * 
 * Revision 1.9.8.12  1993/04/26  22:39:15  meeks
 * 	2.0 4.2.5: Added _XmStringTruncateASN1.
 * 	[1993/04/26  22:30:58  meeks]
 * 
 * Revision 1.9.8.11  1993/04/05  23:55:22  motifibm
 * 	IBM Drop 3 - Anthony
 * 	[1993/04/05  23:52:13  motifibm]
 * 
 * Revision 1.9.8.10  1993/03/30  22:48:18  motiflotus
 * 	ComboBox, GrabShell integration.
 * 	[1993/03/30  21:47:07  motiflotus]
 * 
 * Revision 1.9.8.9  1993/03/16  19:59:43  motifdec
 * 	DEC checkin - RtoL layout
 * 	[1993/03/15  22:11:37  motifdec]
 * 
 * Revision 1.9.8.8  1993/02/19  19:57:37  meeks
 * 	Added declarations for _XmFontListFindEntry, _XmStringIndexCacheTag,
 * 	and _XmStringCacheTag.
 * 	[1993/02/19  19:56:38  meeks]
 * 
 * Revision 1.9.8.7  1993/02/18  20:52:39  qauser
 * 	Initial drop from Anthony
 * 	[1993/02/18  18:38:58  qauser]
 * 
 * Revision 1.9.8.6  1993/02/10  20:37:24  daniel
 * 	part of the new ImageCache work
 * 	[1993/02/10  20:34:01  daniel]
 * 
 * Revision 1.9.8.5  1993/02/02  21:22:07  daniel
 * 	big clean-up of the Pixmap Conversion/Color management - phase 1
 * 	[1993/02/02  21:11:13  daniel]
 * 
 * Revision 1.9.8.4  1992/12/03  19:43:07  drand
 * 	Added function Time __XmGetDefaultTime(Widget, event).
 * 	[1992/11/16  23:13:06  drand]
 * 
 * Revision 1.9.8.3  1992/11/20  23:02:30  daniel
 * 	Fixes from Motif1.2.2. Rev. 1.9.10.2, ancestor 1.9.6.3, file XmP.h
 * 	[1992/11/20  23:01:57  daniel]
 * 
 * Revision 1.9.8.2  1992/10/20  15:37:05  daniel
 * 	remodularization of ResInd.c with Synthetic.c
 * 	[1992/10/20  15:24:25  daniel]
 * 
 * Revision 1.9.6.2  1992/10/20  14:29:21  daniel
 * 	code review Primitive
 * 	[1992/10/19  21:16:23  daniel]
 * 
 * Revision 1.9.4.10  1992/08/06  19:56:02  daniel
 * 	CR 4694 again: introduce a new XmInheritCallbackProc and use it
 * 	[1992/08/06  19:54:53  daniel]
 * 
 * Revision 1.9.4.9  1992/07/20  15:13:19  al
 * 	HP Drop 73
 * 	[1992/07/20  14:57:44  al]
 * 
 * Revision 1.9.4.8  1992/07/17  14:22:22  daniel
 * 	add _XmGetUnitType
 * 	[1992/07/17  14:21:44  daniel]
 * 
 * Revision 1.9.4.7  1992/07/10  14:20:21  daniel
 * 	move back XmCreateImage to CreateImage
 * 	[1992/07/10  14:19:53  daniel]
 * 
 * Revision 1.9.4.6  1992/07/09  14:10:06  al
 * 	HP Drop 70
 * 	[1992/07/09  14:08:24  al]
 * 
 * Revision 1.9.4.5  1992/06/29  20:12:26  daniel
 * 	use XCreateImage instead of creating the struct
 * 	[1992/06/29  13:48:57  daniel]
 * 
 * Revision 1.9.4.4  1992/06/24  13:52:54  al
 * 	HP Drop 60
 * 	[1992/06/24  13:51:03  al]
 * 
 * Revision 1.9.4.3  1992/05/07  22:13:06  al
 * 	HP Drop 35
 * 	[1992/05/07  21:36:59  al]
 * 
 * Revision 1.9.4.2  1992/05/04  22:15:18  al
 * 	Drop 33
 * 	[1992/05/04  19:46:59  al]
 * 
 * Revision 1.9.2.7  1992/04/10  18:29:44  yak
 * 	Integrated diffs from HP
 * 	[1992/04/10  18:24:06  yak]
 * 
 * Revision 1.144  92/04/10  09:44:24  09:44:24  whitty (Joe Whitty)
 * 	added struct for Text context fixes.
 * 
 * Revision 1.9.2.6  1992/04/08  14:49:25  yak
 * 	Integrated diffs from HP
 * 	[1992/04/08  14:45:35  yak]
 * 
 * Revision 1.143  92/04/06  23:02:58  23:02:58  courtney (Courtney Loomis)
 * 	Removed duplicate declaration of _XmVendorExtRealize().
 * 
 * Revision 1.9.2.5  1992/03/25  22:31:27  yak
 * 	Integrated_patch_from_HP
 * 	[1992/03/25  22:31:04  yak]
 * 
 * Revision 1.9.2.4  1992/03/25  19:17:14  daniel
 * 	Integrate HP diffs
 * 	[1992/03/25  18:33:29  daniel]
 * 
 * Revision 1.9.2.3  1992/03/19  19:18:22  tomm
 * 	Acceptance fix from HP for Pir4545.
 * 	[1992/03/19  18:57:36  tomm]
 * 
 * Revision 1.9.2.2  1992/03/18  16:36:41  libby
 * 	Fix Acceptance issues; see Manager.c for PIR #s
 * 	[1992/03/18  16:30:45  libby]
 * 
 * Revision 1.9  1992/03/13  16:56:22  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/*   $RCSfile: XmP.h,v $ $Revision: 1.9.28.5 $ $Date: 1994/06/29 20:41:22 $ */
/* (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */

/************************************<+>*************************************
 ****************************************************************************
 **
 **   File:        XmP.h
 **
 **   Description: This include file contains the class and instance record
 **                definitions for all meta classes.  It also contains externs
 **                for internally shared functions and defines for internally 
 **                shared values.
 **
 ****************************************************************************
 ************************************<+>*************************************/
#ifndef _XmP_h
#define _XmP_h

#include <Xm/Xm.h>
#include <X11/IntrinsicP.h>
#include <X11/ObjectP.h>
#include <Xm/ColorP.h>
#include <Xm/AccColorT.h>


#ifdef __cplusplus
extern "C" {
#endif


/***************************************************************************
 *
 *  Macros replacing toolkit macros so that gadgets are handled properly.
 * 
 ***************************************************************************/

/* Temporary hack until we can clean up our own code. ??? */
#ifndef NO_XM_1_2_XTMACROS
#define XM_1_2_XTMACROS		1
#endif

#ifdef XM_1_2_XTMACROS

/* XtClass is a macro in IntrinsicP.h, but it does no casting 
   so removing this one would certainly generate warnings everywhere, 
   we can keep it */
#ifdef XtClass
#undef XtClass
#endif
#define XtClass(widget)	(((Object)(widget))->object.widget_class)


/* Exist in IntrinsicP.h, but does no casting, so removing this
   one will probably generate a lot of warnings */
#ifdef XtParent
#undef XtParent
#endif
#define XtParent(widget) (((Object)(widget))->object.parent)


/* The following routines exist in Xt, but do not accept Gadgets. */

#ifdef XtDisplay
#undef XtDisplay
#endif
#define XtDisplay(widget) 	XtDisplayOfObject((Widget) widget)

#ifdef XtScreen
#undef XtScreen
#endif
#define XtScreen(widget) 	XtScreenOfObject((Widget) widget)

#ifdef XtWindow
#undef XtWindow
#endif
#define XtWindow(widget) 	XtWindowOfObject((Widget) widget)


/* The following macros are not provided by Xt */
#define XtX(w)		   ((w)->core.x)
#define XtY(w)		   ((w)->core.y)
#define XtWidth(w)	   ((w)->core.width)
#define XtHeight(w)	   ((w)->core.height)
#define XtBorderWidth(w)   ((w)->core.border_width)
#define XtBackground(w)	   ((w)->core.background_pixel)
#define XtCoreProc(w,proc) ((w)->core.widget_class->core_class.proc)

#endif /* XM_1_2_XTMACROS */


/***********************************************************************
 *
 * Miscellaneous SemiPrivate Defines
 *
 ***********************************************************************/

/* new for the initialized gadget checking */
#define XmNdotCache   ".cache"
#define XmNDotCache   ".Cache"

#define XmDELAYED_PIXMAP  (XmUNSPECIFIED_PIXMAP - 1)


/* Used by conversion routine in ResConvert.c, RepType.c, IconG.c, etc */

#define _XM_CONVERTER_DONE( to_rtn, type, value, failure )	\
    {							\
      static type buf ;					\
							\
      if (to_rtn->addr)					\
        {						\
          if (to_rtn->size < sizeof(type))		\
            {						\
              failure					\
              to_rtn->size = sizeof(type);		\
              return FALSE;				\
            }						\
          else						\
	    {					  	\
	      *((type *) (to_rtn->addr)) = value;	\
            }						\
        }						\
      else						\
        {						\
          buf = value;					\
          to_rtn->addr = (XPointer) &buf;		\
        }						\
      to_rtn->size = sizeof(type);			\
      return TRUE;					\
    } 



/* defines needed for 3D visual enhancement of defaultButtonshadow and
 *  implementation of ToggleButton Indicatorsize. **/

#define Xm3D_ENHANCE_PIXEL		2
#define XmINDICATOR_SHADOW_THICKNESS	2

#define XmINVALID_DIMENSION		0xFFFF

/***********************************************************************
 *
 * Const stuff
 *
 ***********************************************************************/

#ifndef XmConst
#if (defined(__STDC__) && __STDC__)  ||  !defined( NO_CONST )
#define XmConst const
#else
#define XmConst
#endif /* __STDC__ */
#endif /* XmConst */


/***********************************************************************
 *
 * Status for menus
 *
 ***********************************************************************/

/* Defines used for menu/button communication */
enum{	XmMENU_POPDOWN,			XmMENU_PROCESS_TREE,
	XmMENU_TRAVERSAL,		XmMENU_SHELL_POPDOWN,
	XmMENU_CALLBACK,		XmMENU_BUTTON,
	XmMENU_CASCADING,		XmMENU_SUBMENU,
	XmMENU_ARM,			XmMENU_DISARM,
	XmMENU_BAR_CLEANUP,		XmMENU_STATUS,
	XmMENU_MEMWIDGET_UPDATE,	XmMENU_BUTTON_POPDOWN,
	XmMENU_RESTORE_EXCLUDED_TEAROFF_TO_TOPLEVEL_SHELL,
	XmMENU_RESTORE_TEAROFF_TO_TOPLEVEL_SHELL,
	XmMENU_RESTORE_TEAROFF_TO_MENUSHELL,
	XmMENU_GET_LAST_SELECT_TOPLEVEL,
	XmMENU_TEAR_OFF_ARM
	} ;



#define XmMENU_TORN_BIT                         (1 << 0)
#define XmMENU_TEAR_OFF_SHELL_DESCENDANT_BIT    (1 << 1)
#define XmMENU_POPUP_POSTED_BIT			(1 << 2)
#define XmMENU_IN_DRAG_MODE_BIT			(1 << 3)

#define XmIsTorn(mask)				\
	(mask & XmMENU_TORN_BIT)
#define XmIsTearOffShellDescendant(mask)	\
	(mask & XmMENU_TEAR_OFF_SHELL_DESCENDANT_BIT)
#define XmPopupPosted(mask)        		\
	(mask & XmMENU_POPUP_POSTED_BIT)
#define XmIsInDragMode(mask)			\
	(mask & XmMENU_IN_DRAG_MODE_BIT)

#ifdef _NO_PROTO
typedef void (*XmMenuProc)() ;
#else
typedef void (*XmMenuProc)( int, Widget, ...) ;
#endif

/***********************************************************************
 *
 * Simple Menu Structure
 *
 ***********************************************************************/

typedef struct _XmSimpleMenuRec {
	int count;
	int post_from_button;
	XtCallbackProc callback;
	XmStringTable label_string;
	String *accelerator;
	XmStringTable accelerator_text;
	XmKeySymTable mnemonic;
	XmStringCharSetTable mnemonic_charset;
	XmButtonTypeTable button_type;
	int button_set;
	XmString option_label;
        KeySym option_mnemonic;
} XmSimpleMenuRec, * XmSimpleMenu;


/* For MapEvent: _XmMatchBtnEvent */
#define XmIGNORE_EVENTTYPE      -1

/* Default minimum Toggle indicator dimension */
#define XmDEFAULT_INDICATOR_DIM   9





/************************************************************************
 *
 *  SyntheticP.h
 *
 ************************************************************************/

typedef enum{ XmSYNTHETIC_NONE, XmSYNTHETIC_LOAD } XmImportOperator ;

#ifdef _NO_PROTO
typedef void (*XmExportProc)();
typedef XmImportOperator (*XmImportProc)();
#else
typedef void (*XmExportProc)( Widget, int, XtArgVal *) ;
typedef XmImportOperator (*XmImportProc)( Widget, int, XtArgVal *) ;
#endif

typedef struct _XmSyntheticResource
{
   String   resource_name;
   Cardinal resource_size;
   Cardinal resource_offset;
   XmExportProc export_proc;
   XmImportProc import_proc;
} XmSyntheticResource;



/***********************************************************************
 *
 *  ParProcP.h
 *
 ***********************************************************************/


typedef struct
{
   int          process_type ;  /* Common to all parent process records. */
   } XmParentProcessAnyRec ;

typedef struct
{ 
   int          process_type ;  /* Common to all parent process records. */
   XEvent *     event ;
   int          action ;
   String *     params ;
   Cardinal *   num_params ;
} XmParentInputActionRec ;

typedef union
{
   XmParentProcessAnyRec  any ;
   XmParentInputActionRec input_action ;
} XmParentProcessDataRec, * XmParentProcessData ;

enum{   XmPARENT_PROCESS_ANY,  XmINPUT_ACTION
	} ;
enum{	XmPARENT_ACTIVATE,		XmPARENT_CANCEL
	} ;
#define XmRETURN XmPARENT_ACTIVATE       /* For Motif 1.1 BC. */
#define XmCANCEL XmPARENT_CANCEL         /* For Motif 1.1 BC. */


/***********************************************************************
 *
 * BaselineP.h
 *
 ***********************************************************************/

enum{	XmBASELINE_GET,			XmBASELINE_SET
	} ;

typedef struct _XmBaselineMargins
{
  unsigned char get_or_set;
  Dimension margin_top;
  Dimension margin_bottom;
  Dimension shadow;
  Dimension highlight;
  Dimension text_height;
  Dimension margin_height;
} XmBaselineMargins;


typedef enum{ XmFOCUS_IN, XmFOCUS_OUT, XmENTER, XmLEAVE } XmFocusChange ;

typedef enum{
        XmNOT_NAVIGABLE,                XmCONTROL_NAVIGABLE,
	XmTAB_NAVIGABLE,                XmDESCENDANTS_NAVIGABLE,
	XmDESCENDANTS_TAB_NAVIGABLE
  } XmNavigability ;

/***********************************************************************
 *
 * Various proc types
 *
 ***********************************************************************/

#define XmVoidProc      XtProc

#ifdef _NO_PROTO

typedef Boolean (*XmParentProcessProc)() ;
typedef void (*XmWidgetDispatchProc)() ;
typedef void (*XmGrabShellPopupProc)() ;
typedef void (*XmMenuPopupProc)() ;
typedef void (*XmMenuTraversalProc)() ;
typedef void (*XmResizeFlagProc)() ;
typedef void (*XmRealizeOutProc)() ;
typedef Boolean (*XmVisualChangeProc)();  /* returns TRUE if redisplay */
typedef void (*XmTraversalProc)();
typedef void (*XmFocusMovedProc)() ;
typedef void (*XmCacheCopyProc)() ;
typedef void (*XmGadgetCacheProc)() ;
typedef int (*XmCacheCompareProc)() ;
typedef Boolean (*XmWidgetBaselineProc)();
typedef Boolean (*XmWidgetDisplayRectProc)();
typedef void (*XmWidgetMarginsProc)();
typedef XmNavigability (*XmWidgetNavigableProc)() ;
typedef void (*XmFocusChangeProc)() ;
typedef Boolean (*XmSpatialPlacementProc)();
typedef Boolean (*XmSpatialRemoveProc)();
typedef Boolean (*XmSpatialTestFitProc)();

#else

typedef Boolean (*XmParentProcessProc)( Widget, XmParentProcessData) ;
typedef void (*XmWidgetDispatchProc)( Widget, XEvent *, Mask) ;
typedef void (*XmGrabShellPopupProc)( Widget, Widget, XEvent *) ;
typedef void (*XmMenuPopupProc)( Widget, Widget, XEvent *) ;
typedef void (*XmMenuTraversalProc)( Widget, Widget, XmTraversalDirection) ;
typedef void (*XmResizeFlagProc)(
			Widget,
#if NeedWidePrototypes
			int) ;
#else
			Boolean) ;
#endif /* NeedWidePrototypes */
typedef void (*XmRealizeOutProc)( Widget, Mask *, XSetWindowAttributes *) ;
typedef Boolean (*XmVisualChangeProc)( Widget, Widget, Widget) ;
typedef void (*XmTraversalProc)( Widget, XtPointer, XtPointer, int) ;
typedef void (*XmFocusMovedProc)( Widget, XtPointer, XtPointer) ;
typedef void (*XmCacheCopyProc)( XtPointer, XtPointer, size_t) ;
typedef void (*XmGadgetCacheProc)( XtPointer) ;
typedef int (*XmCacheCompareProc)( XtPointer, XtPointer) ;
typedef Boolean (*XmWidgetBaselineProc)(Widget, Dimension **, int *);
typedef Boolean (*XmWidgetDisplayRectProc)(Widget, XRectangle *);
typedef void (*XmWidgetMarginsProc)(Widget, XmBaselineMargins *);
typedef XmNavigability (*XmWidgetNavigableProc)( Widget) ;
typedef void (*XmFocusChangeProc)(Widget, XmFocusChange);
typedef Boolean (*XmSpatialPlacementProc)(Widget, Widget, unsigned char);
typedef Boolean (*XmSpatialRemoveProc)(Widget, Widget);
typedef Boolean (*XmSpatialTestFitProc)(Widget, Widget, Position, Position);
#endif


/****************
 *
 * Data structure for building a real translation table out of a 
 * virtual string.
 *
 ****************/

typedef struct {
  Modifiers mod;
  char      *key;
  char      *action;
} _XmBuildVirtualKeyStruct;
              
typedef struct _XmKeyBindingRec
{
  KeySym	keysym;
  Modifiers	modifiers;
} XmKeyBindingRec, *XmKeyBinding;


/***********************************************************************
 *
 * Types shared by text widgets
 *
 ***********************************************************************/

typedef enum { XmsdLeft, XmsdRight } XmTextScanDirection;


/*
 * This struct is for support of Insert Selection targets.
 */
typedef struct {
    Atom selection;
    Atom target;
} _XmTextInsertPair;

typedef struct {
    XmTextPosition position;    /* Starting position. */
    XmHighlightMode mode;       /* Highlighting mode for this position. */
} _XmHighlightRec;

typedef struct {
    Cardinal number;            /* Number of different highlight areas. */
    Cardinal maximum;           /* Number we've allocated space for. */
    _XmHighlightRec *list;      /* Pointer to array of highlight data. */
} _XmHighlightData;

typedef enum { XmDEST_SELECT, XmPRIM_SELECT } XmSelectType;

typedef struct {
    Boolean done_status;	/* completion status of insert selection */
    Boolean success_status;	/* success status of insert selection */
    XmSelectType select_type;	/* insert selection type */
    XSelectionRequestEvent *event; /* event that initiated the
				      insert selection */
} _XmInsertSelect;

typedef struct {
    XEvent *event;
    String *params;
    Cardinal *num_params;
} _XmTextActionRec;

typedef struct {
    Widget widget;
    XmTextPosition insert_pos;
    int num_chars;
    Time timestamp;
    Boolean move;
} _XmTextDropTransferRec;

typedef struct {
    XmTextPosition position;
    Atom target;
    Time time;
    int num_chars;
    int ref_count;
} _XmTextPrimSelect;

typedef struct {
    Screen *screen;
    XContext context;
    unsigned char type;
} XmTextContextDataRec, *XmTextContextData;

enum {_XM_IS_DEST_CTX, _XM_IS_GC_DATA_CTX, _XM_IS_PIXMAP_CTX};

#define XmTEXT_DRAG_ICON_WIDTH	64
#define XmTEXT_DRAG_ICON_HEIGHT 64
#define XmTEXT_DRAG_ICON_X_HOT	10
#define XmTEXT_DRAG_ICON_Y_HOT	 4


/***********************************************************************
 *
 * GeoUtilsP.h
 *
 ***********************************************************************/

/* Defines used by geometry manager utilities */

enum{	XmGET_ACTUAL_SIZE = 1,		XmGET_PREFERRED_SIZE,
	XmGEO_PRE_SET,			XmGEO_POST_SET
	} ;

/* Defaults for Geometry Utility defines are always 0. */
enum{	XmGEO_EXPAND,			XmGEO_CENTER,
	XmGEO_PACK
	} ;
enum{	XmGEO_PROPORTIONAL,		XmGEO_AVERAGING,
	XmGEO_WRAP
	} ;
enum{	XmGEO_ROW_MAJOR,		XmGEO_COLUMN_MAJOR
	} ;
/* XmGEO_COLUMN_MAJOR is not yet supported. */


typedef struct _XmGeoMatrixRec *XmGeoMatrix ;
typedef union _XmGeoMajorLayoutRec *XmGeoMajorLayout ;
typedef struct _XmKidGeometryRec
{
    Widget   kid;				/* ptr to kid */
    XtWidgetGeometry	box;			/* kid geo box */
} XmKidGeometryRec, *XmKidGeometry;

#ifdef _NO_PROTO
typedef void (*XmGeoArrangeProc)() ;
typedef Boolean (*XmGeoExceptProc)() ;
typedef void (*XmGeoExtDestructorProc)() ;
typedef void (*XmGeoSegmentFixUpProc)() ;
#else
typedef void (*XmGeoArrangeProc)( XmGeoMatrix,
#if NeedWidePrototypes
				 int, int,
#else
				 Position, Position,
#endif /* NeedWidePrototypes */
				 Dimension *, Dimension *) ;
typedef Boolean (*XmGeoExceptProc)( XmGeoMatrix ) ;
typedef void (*XmGeoExtDestructorProc)( XtPointer ) ;
typedef void (*XmGeoSegmentFixUpProc)( XmGeoMatrix, int, XmGeoMajorLayout,
                                                               XmKidGeometry) ;
#endif

typedef struct
{   Boolean         end ;        /* Flag to mark end of rows.                */
    XmGeoSegmentFixUpProc fix_up ;/* Used for non-ordinary layouts.          */
    Dimension       even_width ; /* If non-zero, set all boxes to same width.*/
    Dimension       even_height ;/* If non-zero, set all boxes to same height*/
    Dimension       min_height ; /* Minimum height, if stretch_height TRUE.  */
    Boolean         stretch_height ;/* Stretch height to fill vertically.    */
    Boolean         uniform_border ;/* Enforce on all kids this row, dflt F. */
    Dimension       border ;        /* Value to use if uniform_border set.   */
    unsigned char   fill_mode ; /* Possible values: XmGEO_PACK, XmGEO_CENTER,*/
				/*   or XmGEO_EXPAND (default).              */
    unsigned char   fit_mode ;  /* Method for fitting boxes into space,      */
                /* XmGEO_PROPORTIONAL (dflt), XmGEO_AVERAGING, or XmGEO_WRAP.*/
    Boolean         sticky_end ;  /* Last box in row sticks to edge, dflt F. */
    Dimension       space_above ; /* Between-line spacing, default 0.        */
    Dimension       space_end ;   /* End spacing (XmGEO_CENTER), default 0.  */
    Dimension       space_between ; /* Internal spacing, default 0.          */
    Dimension       max_box_height ;/* Set during arrange routine.           */
    Dimension       boxes_width ;   /* Set during arrange routine.           */
    Dimension       fill_width ;    /* Set during arrange routine.           */
    Dimension       box_count ;     /* Set during arrange routine.           */
    } XmGeoRowLayoutRec, *XmGeoRowLayout ;

typedef struct
{   Boolean         end ;        /* Flag to mark end of columns.             */
    XmGeoSegmentFixUpProc fix_up ;/* Used for non-ordinary layouts.          */
    Dimension       even_height ;/* If non-zero, set all boxes to same height*/
    Dimension       even_width ; /* If non-zero, set all boxes to same width.*/
    Dimension       min_width ;  /* Minimum width, if stretch_width TRUE.  */
    Boolean         stretch_width ;/* Stretch width to fill horizontally.    */
    Boolean         uniform_border ;/* Enforce on all kids this row, dflt F. */
    Dimension       border ;        /* Value to use if uniform_border set.   */
    unsigned char   fill_mode ; /* Possible values: XmGEO_PACK, XmGEO_CENTER,*/
				/*   or XmGEO_EXPAND (default).              */
    unsigned char   fit_mode ;  /* Method for fitting boxes into space,      */
                /* XmGEO_PROPORTIONAL (dflt), XmGEO_AVERAGING, or XmGEO_WRAP.*/
    Boolean         sticky_end ;  /* Last box in row sticks to edge, dflt F. */
    Dimension       space_left ;  /* Between-column spacing, default 0.      */
    Dimension       space_end ;   /* End spacing (XmGEO_CENTER), default 0.  */
    Dimension       space_between ; /* Internal spacing, default 0.          */
    Dimension       max_box_width ; /* Set during arrange routine.           */
    Dimension       boxes_height ;  /* Set during arrange routine.           */
    Dimension       fill_height ;   /* Set during arrange routine.           */
    Dimension       box_count ;     /* Set during arrange routine.           */
    } XmGeoColumnLayoutRec, *XmGeoColumnLayout ;

typedef union _XmGeoMajorLayoutRec
{
  XmGeoRowLayoutRec row ;
  XmGeoColumnLayoutRec col ;
} XmGeoMajorLayoutRec ;

typedef struct _XmGeoMatrixRec
{   Widget          composite ;     /* Widget managing layout.               */
    Widget          instigator ;    /* Widget initiating re-layout.          */
    XtWidgetGeometry instig_request ;/* Geometry layout request of instigatr.*/
    XtWidgetGeometry parent_request ;/* Subsequent layout request to parent. */
    XtWidgetGeometry *in_layout ;   /* Geo. of instig. in layout (after Get).*/
    XmKidGeometry   boxes ;/* Array of boxes, lines separated by NULL record.*/
    XmGeoMajorLayout layouts ;      /* Array of major_order format info.     */
    Dimension       margin_w ;/*Sum of margin, highlight, & shadow thickness.*/
    Dimension       margin_h ;/*Sum of margin, highlight, & shadow thickness.*/
    Boolean         stretch_boxes ; /* Set during arrange routine.           */
    Boolean         uniform_border ;/* Enforce on all kids, default FALSE.   */
    Dimension       border ;	    /* Value to use if uniform_border TRUE.  */
    Dimension       max_major ;     /* Set during arrange routine.           */
    Dimension       boxes_minor ;   /* Set during arrange routine.           */
    Dimension       fill_minor ;    /* Set during arrange routine.           */
    Dimension       width ;         /* Set during arrange routine.           */
    Dimension       height ;        /* Set during arrange routine.           */
    XmGeoExceptProc set_except ;
    XmGeoExceptProc almost_except ;
    XmGeoExceptProc no_geo_request ;
    XtPointer       extension ;
    XmGeoExtDestructorProc ext_destructor ;
    XmGeoArrangeProc arrange_boxes ;/* For user-defined arrangement routine. */
    unsigned char   major_order ;
    } XmGeoMatrixRec;

#ifdef _NO_PROTO
typedef XmGeoMatrix (*XmGeoCreateProc)() ;
#else
typedef XmGeoMatrix (*XmGeoCreateProc)( Widget, Widget, XtWidgetGeometry *) ;
#endif

/***********************************************************************
 *
 * XmInheritP.h
 *
 ***********************************************************************/

#define XmInheritCallbackProc ((XtCallbackProc) _XtInherit)
#define XmInheritTraversalProc ((XmTraversalProc) _XtInherit)
#define XmInheritParentProcess ((XmParentProcessProc) _XtInherit)
#define XmInheritWidgetProc ((XtWidgetProc) _XtInherit)
#define XmInheritMenuProc ((XmMenuProc) _XtInherit)
#define XmInheritTranslations XtInheritTranslations
#define XmInheritCachePart	((XmCacheClassPartPtr) _XtInherit)
#define XmInheritBaselineProc ((XmWidgetBaselineProc) _XtInherit)
#define XmInheritDisplayRectProc ((XmWidgetDisplayRectProc) _XtInherit)
#define XmInheritMarginsProc ((XmWidgetMarginsProc) _XtInherit)
#define XmInheritGeoMatrixCreate ((XmGeoCreateProc) _XtInherit)
#define XmInheritFocusMovedProc ((XmFocusMovedProc) _XtInherit)
#define XmInheritClass		   ((WidgetClass) &_XmInheritClass)
#define XmInheritInitializePrehook ((XtInitProc) _XtInherit)
#define XmInheritSetValuesPrehook  ((XtSetValuesFunc) _XtInherit)
#define XmInheritGetValuesPrehook  ((XtArgsProc) _XtInherit)
#define XmInheritInitializePosthook ((XtInitProc) _XtInherit)
#define XmInheritSetValuesPosthook  ((XtSetValuesFunc) _XtInherit)
#define XmInheritGetValuesPosthook  ((XtArgsProc) _XtInherit)
#define XmInheritSecObjectCreate   ((XtInitProc) _XtInherit)
#define XmInheritGetSecResData	   ((XmGetSecResDataFunc) _XtInherit)
#define XmInheritInputDispatch	   ((XmWidgetDispatchProc) _XtInherit)
#define XmInheritVisualChange	   ((XmVisualChangeProc) _XtInherit)
#define XmInheritArmAndActivate	   ((XtActionProc) _XtInherit)
#define XmInheritActionProc	   ((XtActionProc) _XtInherit)
#define XmInheritFocusChange       ((XmFocusChangeProc) _XtInherit)
#define XmInheritWidgetNavigable   ((XmWidgetNavigableProc) _XtInherit)
#define XmInheritClassPartInitPrehook ((XtWidgetClassProc) _XtInherit)
#define XmInheritClassPartInitPosthook ((XtWidgetClassProc) _XtInherit)
#define XmInheritBorderHighlight   ((XtWidgetProc) _XtInherit)
#define XmInheritBorderUnhighlight   ((XtWidgetProc) _XtInherit)


/************************************************************************
 *
 *  Fast subclassing macros and definitions
 *
 ************************************************************************/
/* WARNING:  Application subclasses which choose to use fast
 *           subclassing must use only those bits between
 *           192 (XmFIRST_APPLICATION_SUBCLASS_BIT) and 255.
 *           All other fast subclass bits are reserved for
 *           future use.  Use of reserved fast subclass bits
 *           will cause binary compatibility breaks with
 *           future Motif versions.
 */
#define XmFIRST_APPLICATION_SUBCLASS_BIT    192

enum{	XmCASCADE_BUTTON_BIT = 1,	XmCASCADE_BUTTON_GADGET_BIT,
	XmCOMMAND_BOX_BIT,		XmDIALOG_SHELL_BIT,
	XmLIST_BIT,			XmFORM_BIT,
	XmTEXT_FIELD_BIT,		XmGADGET_BIT,
	XmLABEL_BIT,			XmLABEL_GADGET_BIT,
	XmMAIN_WINDOW_BIT,		XmMANAGER_BIT,
	XmMENU_SHELL_BIT,		XmDRAWN_BUTTON_BIT,
	XmPRIMITIVE_BIT,		XmPUSH_BUTTON_BIT,
	XmPUSH_BUTTON_GADGET_BIT,	XmROW_COLUMN_BIT,
	XmSCROLL_BAR_BIT,		XmSCROLLED_WINDOW_BIT,
	XmSELECTION_BOX_BIT,		XmSEPARATOR_BIT,
	XmSEPARATOR_GADGET_BIT,		XmTEXT_BIT,
	XmTOGGLE_BUTTON_BIT,		XmTOGGLE_BUTTON_GADGET_BIT,
	XmDROP_TRANSFER_BIT,		XmDROP_SITE_MANAGER_BIT,
	XmDISPLAY_BIT,			XmSCREEN_BIT,
	/* 31 is unused */		XmARROW_BUTTON_BIT = 32,
	XmARROW_BUTTON_GADGET_BIT,	XmBULLETIN_BOARD_BIT,
	XmDRAWING_AREA_BIT,		XmFILE_SELECTION_BOX_BIT,
	XmFRAME_BIT,			XmMESSAGE_BOX_BIT,
	XmSASH_BIT,			XmSCALE_BIT,
	XmPANED_WINDOW_BIT,		XmVENDOR_SHELL_BIT,
	XmCLIP_WINDOW_BIT,	        XmDRAG_ICON_BIT,
	XmTEAROFF_BUTTON_BIT,		XmDRAG_OVER_SHELL_BIT,
	XmDRAG_CONTEXT_BIT,		XmCONTAINER_BIT,
	XmICONGADGET_BIT,		XmNOTEBOOK_BIT,
	XmCSTEXT_BIT,		        XmGRAB_SHELL_BIT,
	XmCOMBO_BOX_BIT,		XmSPINBOX_BIT,		
	XmICONHEADER_BIT,	

	XmFAST_SUBCLASS_TAIL_BIT /* New entries precede this. */
	} ;

#define XmLAST_FAST_SUBCLASS_BIT (XmFAST_SUBCLASS_TAIL_BIT - 1) 


#undef XmIsCascadeButton
#define XmIsCascadeButton(w)  \
  (_XmIsFastSubclass(XtClass(w), XmCASCADE_BUTTON_BIT))

#undef XmIsCascadeButtonGadget
#define XmIsCascadeButtonGadget(w)  \
  (_XmIsFastSubclass(XtClass(w), XmCASCADE_BUTTON_GADGET_BIT))

#undef XmIsClipWindow
#define XmIsClipWindow(w)  \
  (_XmIsFastSubclass(XtClass(w), XmCLIP_WINDOW_BIT))

#undef XmIsComboBox
#define XmIsComboBox(w)  \
  (_XmIsFastSubclass(XtClass(w), XmCOMBO_BOX_BIT))

#undef XmIsCommandBox
#define XmIsCommandBox(w)  \
  (_XmIsFastSubclass(XtClass(w), XmCOMMAND_BOX_BIT))

#undef XmIsContainer
#define XmIsContainer(w) \
  (_XmIsFastSubclass(XtClass(w), XmCONTAINER_BIT))

#undef XmIsDialogShell
#define XmIsDialogShell(w)  \
  (_XmIsFastSubclass(XtClass(w), XmDIALOG_SHELL_BIT))

#undef XmIsDisplay
#define XmIsDisplay(w)  \
  (_XmIsFastSubclass(XtClass(w), XmDISPLAY_BIT))

#undef XmIsGrabShell
#define XmIsGrabShell(w)  \
  (_XmIsFastSubclass(XtClass(w), XmGRAB_SHELL_BIT))

#undef XmIsIconGadget
#define XmIsIconGadget(w) \
  (_XmIsFastSubclass(XtClass(w), XmICONGADGET_BIT))

#undef XmIsList
#define XmIsList(w)  \
  (_XmIsFastSubclass(XtClass(w), XmLIST_BIT))

#undef XmIsForm
#define XmIsForm(w)  \
  (_XmIsFastSubclass(XtClass(w), XmFORM_BIT))

#undef XmIsTextField
#define XmIsTextField(w)  \
  (_XmIsFastSubclass(XtClass(w), XmTEXT_FIELD_BIT))

#undef XmIsGadget
#define XmIsGadget(w)  \
  (_XmIsFastSubclass(XtClass(w), XmGADGET_BIT))

#undef XmIsLabel
#define XmIsLabel(w)  \
  (_XmIsFastSubclass(XtClass(w), XmLABEL_BIT))

#undef XmIsLabelGadget
#define XmIsLabelGadget(w)  \
  (_XmIsFastSubclass(XtClass(w), XmLABEL_GADGET_BIT))

#undef XmIsMainWindow
#define XmIsMainWindow(w)  \
  (_XmIsFastSubclass(XtClass(w), XmMAIN_WINDOW_BIT))

#undef XmIsManager
#define XmIsManager(w)  \
  (_XmIsFastSubclass(XtClass(w), XmMANAGER_BIT))

#undef XmIsMenuShell
#define XmIsMenuShell(w)  \
  (_XmIsFastSubclass(XtClass(w), XmMENU_SHELL_BIT))

#undef XmIsNotebook
#define XmIsNotebook(w) \
  (_XmIsFastSubclass(XtClass(w), XmNOTEBOOK_BIT))

#undef XmIsDragIcon
#define XmIsDragIcon(w)  \
  (_XmIsFastSubclass(XtClass(w), XmDRAG_ICON_BIT))

#undef XmIsDropSiteManager
#define XmIsDropSiteManager(w)  \
  (_XmIsFastSubclass(XtClass(w), XmDROP_SITE_MANAGER_BIT))

#undef XmIsDropTransfer
#define XmIsDropTransfer(w)  \
  (_XmIsFastSubclass(XtClass(w), XmDROP_TRANSFER_BIT))

#undef XmIsDragOverShell
#define XmIsDragOverShell(w)  \
  (_XmIsFastSubclass(XtClass(w), XmDRAG_OVER_SHELL_BIT))

#undef XmIsDragContext
#define XmIsDragContext(w)  \
  (_XmIsFastSubclass(XtClass(w), XmDRAG_CONTEXT_BIT))

#undef XmIsDrawnButton
#define XmIsDrawnButton(w)  \
  (_XmIsFastSubclass(XtClass(w), XmDRAWN_BUTTON_BIT))

#undef XmIsPrimitive
#define XmIsPrimitive(w)  \
  (_XmIsFastSubclass(XtClass(w), XmPRIMITIVE_BIT))

#undef XmIsPushButton
#define XmIsPushButton(w)  \
  (_XmIsFastSubclass(XtClass(w), XmPUSH_BUTTON_BIT))

#undef XmIsPushButtonGadget
#define XmIsPushButtonGadget(w)  \
  (_XmIsFastSubclass(XtClass(w), XmPUSH_BUTTON_GADGET_BIT))

#undef XmIsRowColumn
#define XmIsRowColumn(w)  \
  (_XmIsFastSubclass(XtClass(w), XmROW_COLUMN_BIT))

#undef XmIsScreen
#define XmIsScreen(w)  \
  (_XmIsFastSubclass(XtClass(w), XmSCREEN_BIT))

#undef XmIsScrollBar
#define XmIsScrollBar(w)  \
  (_XmIsFastSubclass(XtClass(w), XmSCROLL_BAR_BIT))

#undef XmIsScrolledWindow
#define XmIsScrolledWindow(w)  \
  (_XmIsFastSubclass(XtClass(w), XmSCROLLED_WINDOW_BIT))

#undef XmIsSelectionBox
#define XmIsSelectionBox(w)  \
  (_XmIsFastSubclass(XtClass(w), XmSELECTION_BOX_BIT))

#undef XmIsSeparator
#define XmIsSeparator(w)  \
  (_XmIsFastSubclass(XtClass(w), XmSEPARATOR_BIT))

#undef XmIsSeparatorGadget
#define XmIsSeparatorGadget(w)  \
  (_XmIsFastSubclass(XtClass(w), XmSEPARATOR_GADGET_BIT))

#undef XmIsSpinButton
#define XmIsSpinButton(w)  \
  (_XmIsFastSubclass(XtClass(w), XmSPINBUTTON_BIT))

#undef XmIsText
#define XmIsText(w)  \
  (_XmIsFastSubclass(XtClass(w), XmTEXT_BIT))

#undef XmIsTearOffButton
#define XmIsTearOffButton(w)  \
  (_XmIsFastSubclass(XtClass(w), XmTEAROFF_BUTTON_BIT))

#undef XmIsToggleButton
#define XmIsToggleButton(w)  \
  (_XmIsFastSubclass(XtClass(w), XmTOGGLE_BUTTON_BIT))

#undef XmIsToggleButtonGadget
#define XmIsToggleButtonGadget(w)  \
  (_XmIsFastSubclass(XtClass(w), XmTOGGLE_BUTTON_GADGET_BIT))

#undef XmIsArrowButton
#define XmIsArrowButton(w)  \
  (_XmIsFastSubclass(XtClass(w), XmARROW_BUTTON_BIT))

#undef XmIsArrowButtonGadget
#define XmIsArrowButtonGadget(w)  \
  (_XmIsFastSubclass(XtClass(w), XmARROW_BUTTON_GADGET_BIT))

#undef XmIsBulletinBoard
#define XmIsBulletinBoard(w)  \
  (_XmIsFastSubclass(XtClass(w), XmBULLETIN_BOARD_BIT))

#undef XmIsDrawingArea
#define XmIsDrawingArea(w)  \
  (_XmIsFastSubclass(XtClass(w), XmDRAWING_AREA_BIT))

#undef XmIsFileSelectionBox
#define XmIsFileSelectionBox(w)  \
  (_XmIsFastSubclass(XtClass(w), XmFILE_SELECTION_BOX_BIT))

#undef XmIsFrame
#define XmIsFrame(w)  \
  (_XmIsFastSubclass(XtClass(w), XmFRAME_BIT))

#undef XmIsMessageBox
#define XmIsMessageBox(w)  \
  (_XmIsFastSubclass(XtClass(w), XmMESSAGE_BOX_BIT))

#undef XmIsSash
#define XmIsSash(w)  \
  (_XmIsFastSubclass(XtClass(w), XmSASH_BIT))

#undef XmIsScale
#define XmIsScale(w)  \
  (_XmIsFastSubclass(XtClass(w), XmSCALE_BIT))

#undef XmIsPanedWindow
#define XmIsPanedWindow(w)  \
  (_XmIsFastSubclass(XtClass(w), XmPANED_WINDOW_BIT))

#undef XmIsCSText
#define XmIsCSText(w)  \
  (_XmIsFastSubclass(XtClass(w), XmCSTEXT_BIT))


/************************************************************************
 *
 *  ResolveP.h
 *
 ************************************************************************/


/*  Widget class indices used with XmPartOffset and XmField macros  */

#define XmObjectIndex 		0
#define ObjectIndex 		XmObjectIndex
#define XmRectObjIndex		(XmObjectIndex + 1)
#define RectObjIndex		XmRectObjIndex
#define XmWindowObjIndex	(XmRectObjIndex + 1)
#define WindowObjIndex		XmWindowObjIndex
#define XmCoreIndex 		0
#define CoreIndex 		XmCoreIndex
#define XmCompositeIndex 	(XmWindowObjIndex + 2)
#define CompositeIndex 		XmCompositeIndex
#define XmConstraintIndex 	(XmCompositeIndex + 1)
#define ConstraintIndex 	XmConstraintIndex
#define XmGadgetIndex	 	(XmRectObjIndex + 1)
#define XmPrimitiveIndex 	(XmWindowObjIndex + 2)
#define XmManagerIndex	 	(XmConstraintIndex + 1)

#define XmArrowBIndex		(XmPrimitiveIndex + 1)
#define XmArrowButtonIndex	XmArrowBIndex
#define XmLabelIndex		(XmPrimitiveIndex + 1)
#define XmListIndex		(XmPrimitiveIndex + 1)
#define XmScrollBarIndex	(XmPrimitiveIndex + 1)
#define XmSeparatorIndex	(XmPrimitiveIndex + 1)
#define XmTextIndex		(XmPrimitiveIndex + 1)
#define XmTextFieldIndex	(XmPrimitiveIndex + 1)
#define XmCSTextIndex		(XmPrimitiveIndex + 1)

#define XmCascadeBIndex		(XmLabelIndex + 1)
#define XmCascadeButtonIndex	XmCascadeBIndex
#define XmDrawnBIndex		(XmLabelIndex + 1)
#define XmDrawnButtonIndex	XmDrawnBIndex
#define XmPushBIndex		(XmLabelIndex + 1)
#define XmPushButtonIndex	XmPushBIndex
#define XmToggleBIndex		(XmLabelIndex + 1)
#define XmToggleButtonIndex	XmToggleBIndex
#define XmTearOffButtonIndex	(XmPushBIndex + 1)

#define XmArrowBGIndex		(XmGadgetIndex + 1)
#define XmArrowButtonGadgetIndex XmArrowBGIndex
#define XmLabelGIndex		(XmGadgetIndex + 1)
#define XmLabelGadgetIndex	XmLabelGIndex
#define XmSeparatoGIndex	(XmGadgetIndex + 1)
#define XmSeparatorGadgetIndex	XmSeparatoGIndex

#define XmCascadeBGIndex	(XmLabelGIndex + 1)
#define XmCascadeButtonGadgetIndex XmCascadeBGIndex
#define XmPushBGIndex		(XmLabelGIndex + 1)
#define XmPushButtonGadgetIndex	XmPushBGIndex
#define XmToggleBGIndex		(XmLabelGIndex + 1)
#define XmToggleButtonGadgetIndex XmToggleBGIndex
#define XmIconGadgetIndex	(XmGadgetIndex + 1)

#define XmBulletinBIndex	(XmManagerIndex + 1)
#define XmBulletinBoardIndex	XmBulletinBIndex
#define XmDrawingAIndex		(XmManagerIndex + 1)
#define XmDrawingAreaIndex	XmDrawingAIndex
#define XmClipWindowIndex	(XmDrawingAIndex + 1)
#define XmFrameIndex		(XmManagerIndex + 1)
#define XmPanedWIndex		(XmManagerIndex + 1)
#define XmPanedWindowIndex	XmPanedWIndex
#define XmSashIndex		(XmPrimitiveIndex + 1)
#define XmRowColumnIndex	(XmManagerIndex + 1)
#define XmScaleIndex		(XmManagerIndex + 1)
#define XmScrolledWIndex	(XmManagerIndex + 1)
#define XmScrolledWindowIndex	XmScrolledWIndex

#define XmFormIndex		(XmBulletinBIndex + 1)
#define XmMessageBIndex		(XmBulletinBIndex + 1)
#define XmMessageBoxIndex	XmMessageBIndex
#define XmSelectioBIndex	(XmBulletinBIndex + 1)
#define XmSelectionBoxIndex	XmSelectioBIndex

#define XmMainWIndex		(XmScrolledWIndex + 1)
#define XmMainWindowIndex	XmMainWIndex

#define XmCommandIndex		(XmSelectioBIndex + 1)
#define XmFileSBIndex		(XmSelectioBIndex + 1)
#define XmFileSelectionBoxIndex	XmFileSBIndex

#define XmShellIndex 		(XmCompositeIndex + 1)
#define ShellIndex 		XmShellIndex
#define XmOverrideShellIndex 	(XmShellIndex + 1)
#define OverrideShellIndex 	XmOverrideShellIndex
#define XmWMShellIndex	 	(XmShellIndex + 1)
#define WMShellIndex	 	XmWMShellIndex
#define XmVendorShellIndex 	(XmWMShellIndex + 1)
#define VendorShellIndex 	XmVendorShellIndex
#define XmTransientShellIndex	(XmVendorShellIndex + 1)
#define TransientShellIndex	XmTransientShellIndex
#define XmTopLevelShellIndex 	(XmVendorShellIndex + 1)
#define TopLevelShellIndex 	XmTopLevelShellIndex
#define XmApplicationShellIndex (XmTopLevelShellIndex + 1)
#define ApplicationShellIndex 	XmApplicationShellIndex
#define XmGrabShellIndex	(XmVendorShellIndex + 1)
#define XmDisplayIndex		(XmApplicationShellIndex + 1)

#define XmDialogSIndex		(XmTransientShellIndex + 1)
#define XmDialogShellIndex	XmDialogSIndex
#define XmMenuShellIndex	(XmOverrideShellIndex + 1)

#define XmContainerIndex	(XmManagerIndex + 1)
#define XmNotebookIndex		(XmManagerIndex + 1)
#define XmSpinButtonIndex	(XmManagerIndex + 1)
#define XmComboBoxIndex		(XmManagerIndex + 1)

#define XmDragIconIndex		(XmRectObjIndex + 1)
#define XmDropSiteManagerIndex  (XmObjectIndex + 1)
#define XmDropTransferIndex	(XmObjectIndex + 1)
#define XmDragOverShellIndex	(XmVendorShellIndex + 1)
#define XmDragContextIndex	(XmCoreIndex + 1)

/* 
 * XmOFFSETBITS is the number of bits used for the part offset within the
 * resource_offset field in the XmPartResource struct.  XmOFFSETMASK is the 
 * bitmask to mask for the part offset.
 */
#define XmOFFSETBITS (sizeof(Cardinal)*8/2)
#define XmOFFSETMASK ((1<<XmOFFSETBITS)-1)

typedef struct _XmPartResource {
    String     resource_name;	/* Resource name			    */
    String     resource_class;	/* Resource class			    */
    String     resource_type;	/* Representation type desired		    */
    Cardinal   resource_size;	/* Size in bytes of representation	    */
    Cardinal   resource_offset;	/* Index within & offset within part 	    */
    String     default_type;	/* representation type of specified default */
    XtPointer  default_addr;   	/* Address of default resource		    */
} XmPartResource;

#if (defined(__STDC__) && __STDC__ && !defined(UNIXCPP)) \
        || defined(__cplusplus) || defined(ANSICPP)
# define XmPartOffset(part, variable) \
        ((part##Index) << XmOFFSETBITS) + XtOffsetOf( part##Part, variable)

# define XmConstraintPartOffset(part, variable) \
        ((part##Index) << XmOFFSETBITS) + \
	XtOffsetOf( part##ConstraintPart, variable)

# define XmGetPartOffset(r, offset) \
       ((r)->resource_offset & XmOFFSETMASK) + \
	(*(offset))[(r)->resource_offset >> XmOFFSETBITS];

# define XmField(widget, offsetrecord, part, variable, type) \
	(*(type *)(((char *) (widget)) + offsetrecord[part##Index] + \
		XtOffsetOf( part##Part, variable)))

# define XmConstraintField(widget, offsetrecord, part, variable, type) \
	(*(type *)(((char *) (widget)->core.constraints) + \
	offsetrecord[part##Index] + \
	XtOffsetOf( part##ConstraintPart, variable)))
#else
# define XmPartOffset(part, variable) \
        ((part/**/Index) << XmOFFSETBITS) + XtOffsetOf( part/**/Part, variable)

# define XmConstraintPartOffset(part, variable) \
        ((part/**/Index) << XmOFFSETBITS) + \
	XtOffsetOf( part/**/ConstraintPart, variable)

# define XmGetPartOffset(r, offset) \
       ((r)->resource_offset & XmOFFSETMASK) + \
	(*(offset))[(r)->resource_offset >> XmOFFSETBITS];

# define XmField(widget, offsetrecord, part, variable, type) \
	(*(type *)(((char *) (widget)) + offsetrecord[part/**/Index] + \
	XtOffsetOf( part/**/Part, variable)))

# define XmConstraintField(widget, offsetrecord, part, variable, type) \
	(*(type *)(((char *) (widget)->core.constraints) + \
	offsetrecord[part/**/Index] + \
	XtOffsetOf( part/**/ConstraintPart, variable)))
#endif

/***********************************************************************
 *
 *  RegionP.h
 *
 *  This structure must match the opaque libX Region structure.
 ***********************************************************************/

typedef struct {
    short x1, x2, y1, y2;
} XmRegionBox;

typedef struct _XmRegion {
    long	size;
    long	numRects;
    XmRegionBox	*rects;
    XmRegionBox	extents;
} XmRegionRec, *XmRegion;


/********    ResConvert.c    ********/

enum{	XmLABEL_FONTLIST = 1,		XmBUTTON_FONTLIST,
	XmTEXT_FONTLIST
	} ;

enum {
 XmLABEL_RENDER_TABLE = 1,
 XmBUTTON_RENDER_TABLE,
 XmTEXT_RENDER_TABLE
} ;

/**** Private Defines, Typedefs, and Function Declarations for XmString.c ****/

/* For _XmStringIndexCacheTag() and _XmStringCacheTag() length. */
#define XmSTRING_TAG_STRLEN		-1

/* For _XmStringGetNextTabWidth.  EOS = End Of String. */
typedef enum { XmTAB_NEXT, XmTAB_NEWLINE, XmTAB_EOS } NextTabResult; 
  
/********    End Private Function Declarations    ********/

/********    Traversal.c    ********/

#define XmTAB_ANY	((XmNavigationType) 255)
#define XmNONE_OR_BC	((XmNavigationType) 254)

typedef struct _XmFocusMovedCallbackStruct{
    int			 reason;
    XEvent		*event;
    Boolean		 cont;
    Widget		 old_focus;
    Widget		 new_focus;
    unsigned char	 focus_policy;
    XmTraversalDirection direction; 
} XmFocusMovedCallbackStruct, *XmFocusMovedCallback;

typedef struct _XmFocusDataRec *XmFocusData;


/********    ResInd.c    ********/

typedef enum { 
  XmPARSE_ERROR, XmPARSE_NO_UNITS, XmPARSE_UNITS_OK 
} XmParseResult;



/********    Function Declarations for Xme        ********/
#ifdef _NO_PROTO

    /* GadgetUtil.c */
extern void XmeRedisplayGadgets() ;
extern void XmeConfigureObject();
    /* Traversal.c */
extern void XmeNavigChangeManaged() ;
extern Boolean XmeFocusIsInShell() ;
    /* ResInd.c */
extern XmImportOperator XmeToHorizontalPixels() ;
extern XmImportOperator XmeToVerticalPixels() ;
extern void XmeFromHorizontalPixels() ;
extern void XmeFromVerticalPixels() ;
extern XmParseResult XmeParseUnits();
    /* DragIcon.c */
extern Widget XmeGetTextualDragIcon() ;
    /* BulletinB.c */
extern Widget XmeCreateClassDialog() ;
    /* ImageCache.c */
extern Boolean XmeGetPixmapData() ;
    /* VirtKeys.c */
extern Pixmap XmeGetMask() ;
    /* VirtKeys.c */
extern int XmeVirtualToActualKeysyms() ;
    /* Screen.c */
extern Cursor XmeGetNullCursor() ;
extern void XmeQueryBestCursorSize() ;
    /* Xm.c */
extern void XmeWarning() ;
    /* ResConvert.c */
extern XmFontList XmeGetDefaultRenderTable() ;
extern Boolean XmeNamesAreEqual() ;
    /* Primitive.c */
extern void XmeResolvePartOffsets() ;
    /* XmString.c */
extern Boolean XmeStringIsValid() ;
extern void XmeSetWMShellTitle() ;
extern XmIncludeStatus XmeGetDirection() ;
extern XmIncludeStatus XmeGetNextCharacter() ;
extern XmStringComponentType XmeStringGetComponent();
    /* XmFontList.c */
extern Boolean XmeRenderTableGetDefaultFont() ;
    /* GMUtils.c */
extern XtGeometryResult XmeReplyToQueryGeometry() ;
    /* Visual.c */
extern void XmeGetDefaultPixel() ;
    /* Xmos.c */
extern String XmeGetHomeDirName() ;
extern int XmeMicroSleep() ;
extern XmString XmeGetLocalizedString() ;

#else

    /* GadgetUtil.c */
extern void XmeRedisplayGadgets( 
                        Widget w,
                        register XEvent *event,
                        Region region) ;
extern void XmeConfigureObject( 
                        Widget g,
#if NeedWidePrototypes
                        int x,
                        int y,
                        int width,
                        int height,
                        int border_width) ;
#else
                        Position x,
                        Position y,
                        Dimension width,
                        Dimension height,
                        Dimension border_width) ;
#endif /* NeedWidePrototypes */
    /* Traversal.c */
extern void XmeNavigChangeManaged( 
                        Widget wid) ;
extern Boolean XmeFocusIsInShell( 
                        Widget wid) ;
    /* ResInd.c */
extern XmImportOperator XmeToHorizontalPixels( 
                        Widget widget,
                        int offset,
                        XtArgVal *value) ;
extern XmImportOperator XmeToVerticalPixels( 
                        Widget widget,
                        int offset,
                        XtArgVal *value) ;
extern void XmeFromHorizontalPixels( 
                        Widget widget,
                        int offset,
                        XtArgVal *value) ;
extern void XmeFromVerticalPixels( 
                        Widget widget,
                        int offset,
                        XtArgVal *value) ;
extern XmParseResult XmeParseUnits(String spec, int *unitType);
    /* DragIcon. c */
extern Widget XmeGetTextualDragIcon(Widget w) ;
    /* BulletinB.c */
extern Widget XmeCreateClassDialog(
	                WidgetClass w_class,
			Widget ds_p,
                        String name,
                        ArgList bb_args,
                        Cardinal bb_n ) ;
    /* ImageCache.c */
extern Boolean XmeGetPixmapData( 
                        Screen *screen,
                        Pixmap pixmap,
                        char **image_name,
                        int *depth,
                        Pixel *foreground,
                        Pixel *background,
                        int *hot_x,
                        int *hot_y,
                        unsigned int *width,
                        unsigned int *height) ;
extern Pixmap XmeGetMask(
                        Screen *screen,
                        char *image_name) ;
    /* VirtKeys.c */
extern int XmeVirtualToActualKeysyms(
                         Display *dpy,
			 KeySym virtKeysym,
                         XmKeyBinding *actualKeyData) ;
    /* Screen.c */
extern Cursor XmeGetNullCursor(Widget w) ;
extern void XmeQueryBestCursorSize(
			Widget w,
			Dimension *width,
			Dimension *height );
    /* Xm.c */
extern void XmeWarning( Widget w, char *message ) ;
    /* ResConvert.c */
extern XmFontList XmeGetDefaultRenderTable(
        Widget w,
#if NeedWidePrototypes
        unsigned int fontListType );
#else
        unsigned char fontListType );
#endif /* NeedWidePrototypes */
extern Boolean XmeNamesAreEqual(
        register char *in_str,
        register char *test_str );
    /* Primitive.c */
extern void XmeResolvePartOffsets(
			WidgetClass w_class,
			XmOffsetPtr *offset,
			XmOffsetPtr *constraint_offset ) ;
    /* XmString.c */
extern Boolean XmeStringIsValid( XmString string ) ;
extern void XmeSetWMShellTitle(
			XmString xmstr,
			Widget shell) ;
extern XmIncludeStatus XmeGetDirection(XtPointer *in_out,
				       XtPointer text_end,
				       XmTextType type,
				       XmStringTag locale_tag,
				       XmParseMapping entry,
				       int pattern_length,
				       XmString *str_include,
				       XtPointer call_data);
extern XmIncludeStatus XmeGetNextCharacter(XtPointer *in_out,
					   XtPointer text_end,
					   XmTextType type,
					   XmStringTag locale_tag,
					   XmParseMapping entry,
					   int pattern_length,
					   XmString *str_include,
					   XtPointer call_data);
extern XmStringComponentType XmeStringGetComponent(_XmStringContext context, 
						   Boolean	    update_context,
						   Boolean	    copy_data,
						   unsigned int    *length,
						   XtPointer       *value);
    /* XmFontList.c */
extern Boolean XmeRenderTableGetDefaultFont(
			XmFontList fontlist,
			XFontStruct **font_struct ) ;
    /* GMUtils.c */
extern XtGeometryResult XmeReplyToQueryGeometry(
			Widget widget,
			XtWidgetGeometry * intended,
			XtWidgetGeometry * desired) ;
    /* Color.c */
extern void XmeGetDefaultPixel(
                        Widget widget,
                        int type,
                        int offset,
                        XrmValue *value) ;
    /* Xmos.c */
extern String XmeGetHomeDirName(void) ;
extern int XmeMicroSleep( 
                        long secs) ;
extern XmString XmeGetLocalizedString( 
                        char *reserved,
                        Widget widget,
                        char *resource,
                        String string) ;

#endif /* _NO_PROTO */
/********    End Function Declarations for Xme        ********/

/********        ********/

#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif



#include <Xm/BaseClassP.h>       


/***********************************************************************
 *
 *  Motif 1.2 BC compilation.
 *
 ***********************************************************************/

#ifndef NO_XM_1_2_BC

/*
 * These routines have all been made obsolete by public Xme functions.
 * The declarations here are intended solely as an aid to porting,
 * and will be removed in a future release.  All applications should
 * name the Xme methods directly.
 *
 * _XmVirtualToActualKeysym, _XmResizeObject, and _XmMoveObject have
 * Xme counterparts with slightly different semantics or parameters,
 * so a simple rename will not work for them.
 */

#define _XmClearBorder			XmeClearBorder
#define _XmConfigureObject		XmeConfigureObject
#define _XmDrawArrow			XmeDrawArrow
#define _XmDrawDiamond			XmeDrawDiamond
#define _XmDrawSeparator		XmeDrawSeparator
#define _XmDrawShadows			XmeDrawShadows
#define _XmDrawSimpleHighlight		XmeDrawHighlight
#define _XmFontListGetDefaultFont	XmeRenderTableGetDefaultFont
#define _XmFromHorizontalPixels		XmeFromHorizontalPixels
#define _XmFromVerticalPixels		XmeFromVerticalPixels
#define _XmGMReplyToQueryGeometry	XmeReplyToQueryGeometry
#define _XmGetDefaultFontList		XmeGetDefaultRenderTable
#define _XmGetMaxCursorSize		XmeQueryBestCursorSize
#define _XmGetNullCursor		XmeGetNullCursor
#define _XmGetTextualDragIcon		XmeGetTextualDragIcon
#define _XmInputInGadget		XmeGadgetAtPoint
#define _XmMicroSleep			XmeMicroSleep
#define _XmNavigChangeManaged		XmeNavigChangeManaged
#define _XmOSGetHomeDirName		XmeGetHomeDirName
#define _XmOSGetLocalizedString		XmeGetLocalizedString
#define _XmRedisplayGadgets		XmeRedisplayGadgets
#define _XmStringIsXmString		XmeStringIsValid
#define _XmStringUpdateWMShellTitle	XmeSetWMShellTitle
#define _XmStringsAreEqual		XmeStringsAreEqual
#define _XmToHorizontalPixels		XmeToHorizontalPixels
#define _XmToVerticalPixels		XmeToVerticalPixels
#define _XmWarning			XmeWarning

#endif /* NO_XM_1_2_BC */


#endif /* _XmP_h */
/* DON'T ADD STUFF AFTER THIS #endif */
