/* 
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/ 
/* 
 * HISTORY
 * $Log: XmosP.h,v $
 * Revision 1.6.23.1  1994/06/01  21:54:26  yak
 * 	Added definition of USER_VAR as LOGNAME on SYSV and SVR4, and
 * 	USER on all other platforms. CR 8975.
 * 	[1994/06/01  18:28:35  yak]
 *
 * Revision 1.6.21.7  1994/03/04  22:29:28  drk
 * 	Hide _Xm routines from public view.
 * 	[1994/03/04  22:02:43  drk]
 * 
 * Revision 1.6.21.6  1994/03/01  21:44:47  meeks
 * 	Moved _XmOSSetLocale to Mrm.
 * 	[1994/03/01  20:06:31  meeks]
 * 
 * Revision 1.6.21.5  1994/03/01  02:42:27  meeks
 * 	Moved _XmOS IEEE floating point routines to _MrmOS.
 * 	[1994/03/01  02:36:29  meeks]
 * 
 * 	Moved IEEE floating point routines to Mrm.
 * 
 * Revision 1.6.21.4  1994/02/25  17:49:08  daniel
 * 	change signature of mask name API
 * 	[1994/02/25  15:48:10  daniel]
 * 
 * Revision 1.6.21.3  1994/02/18  22:34:50  inca
 * 	Merged with changes from 1.6.21.2
 * 	[1994/02/18  22:33:50  inca]
 * 
 * 	HP drop 182: updated comment on libPW
 * 	[1994/02/16  20:09:11  inca]
 * 
 * Revision 1.6.21.2  1994/02/17  23:02:07  drk
 * 	Use X11/Xfuncs.h to redefine bzero as memset.
 * 	[1994/02/17  23:01:53  drk]
 * 
 * Revision 1.6.21.1  1994/02/17  22:04:32  drk
 * 	Fixes from Motif1.2.4. Rev. 1.6.19.2, ancestor 1.6.17.3, file XmosP.h.
 * 	CR 8033: Update HP fallback bindings, HP drop 182.
 * 	[1994/02/17  22:04:18  drk]
 * 
 * Revision 1.6.16.10  1993/10/25  19:44:14  inca
 * 	cleaned up usage of MAXINT in Text & TextField: CR4837
 * 	[1993/10/25  19:43:33  inca]
 * 
 * Revision 1.6.16.9  1993/10/13  20:00:54  daniel
 * 	MaskName revisited
 * 	[1993/10/13  20:00:34  daniel]
 * 
 * Revision 1.6.16.8  1993/09/22  22:43:02  drk
 * 	Fix another typo.
 * 	[1993/09/22  22:42:35  drk]
 * 
 * Revision 1.6.16.7  1993/09/22  22:35:02  drk
 * 	Change parameter profile for _XmOSKeySymToCharacter.
 * 	[1993/09/22  22:32:58  drk]
 * 
 * Revision 1.6.16.6  1993/09/22  22:11:55  drk
 * 	Fix typo.
 * 	[1993/09/22  22:11:38  drk]
 * 
 * Revision 1.6.16.5  1993/09/22  22:06:59  drk
 * 	CR 5181:  Created _XmOSKeySymToCharacter to convert mnemonics to
 * 		characters in vendor-specific ways.
 * 	[1993/09/22  22:06:02  drk]
 * 
 * Revision 1.6.16.4  1993/09/14  22:20:11  drk
 * 	ANSIfication of sources -- use memfoo instead of bfoo
 * 	[1993/09/14  22:16:18  drk]
 * 
 * Revision 1.6.16.3  1993/08/27  21:14:20  inca
 * 	Removed warnings on MAX, MIN on HP:s
 * 	[1993/08/27  14:29:12  inca]
 * 
 * Revision 1.6.16.2  1993/08/24  21:43:30  drk
 * 	Fixes from Motif1.2.4. Rev. 1.6.15.2, ancestor 1.6.13.4, file XmosP.h.
 * 	Include limits.h so that MB_LEN_MAX is redefined reliably.
 * 	[1993/08/24  21:43:10  drk]
 * 
 * Revision 1.6.10.15  1993/07/23  03:07:13  yak
 * 	Expended copyright marker
 * 	[1993/07/23  01:42:32  yak]
 * 
 * Revision 1.6.10.14  1993/07/01  00:36:26  rgcote
 * 	Removed declarations for _Xm functions which have become
 * 	Xme functions.
 * 	[1993/06/30  23:47:27  rgcote]
 * 
 * Revision 1.6.10.13  1993/06/24  22:56:11  inca
 * 	changed the method name to be strings
 * 	[1993/06/24  17:31:07  inca]
 * 
 * Revision 1.6.10.12  1993/06/21  21:50:30  ede
 * 	added templates for floating point conversion routines
 * 	[1993/06/21  21:49:50  ede]
 * 
 * Revision 1.6.10.11  1993/06/18  14:20:59  inca
 * 	Forgot to change the non-prototyped names
 * 	[1993/06/18  14:20:37  inca]
 * 
 * Revision 1.6.10.10  1993/06/17  19:14:13  inca
 * 	Updated to the latest spec.
 * 	[1993/06/17  13:51:41  inca]
 * 
 * 	Spec changed for iswhitespace & isscanbreak
 * 	[1993/06/16  21:58:20  inca]
 * 
 * 	typedefs for XmWhiteSpaceProc and XmScanBreakProc
 * 	[1993/06/14  20:57:23  inca]
 * 
 * Revision 1.6.10.9  1993/06/08  22:30:57  inca
 * 	Added XmeOSGetMethod, _XmOSI18n{mb,wcs}{IsScanBreak,IsWhiteSpace}
 * 	[1993/06/07  21:32:41  inca]
 * 
 * Revision 1.6.10.8  1993/06/03  14:15:10  drk
 * 	Change _XmOsFoo to _XmOSFoo.
 * 	[1993/06/03  14:14:38  drk]
 * 
 * Revision 1.6.10.7  1993/06/02  21:58:22  drk
 * 	Added _XmOsGetInitialCharsDirection() and _XmOsGetCharDirection().
 * 	[1993/06/02  18:55:48  drk]
 * 
 * Revision 1.6.10.6  1993/05/05  15:24:19  rgcote
 * 	Moved the Xme functions to XmP.h and fixed the mblen
 * 	Sun patch to check whether the pointer is NULL before
 * 	dereferencing the first character.
 * 	[1993/04/29  19:07:10  rgcote]
 * 
 * Revision 1.6.10.5  1993/04/27  19:44:51  rgcote
 * 	Changed:
 * 		_XmOSGetHomeDirName to be XmeOSGetHomeDirName
 * 		_XmMicroSleep to be XmeMicroSleep
 * 		_XmOSGetLocalizedString to be XmeOSGetLocalizedString
 * 	[1993/04/27  19:16:40  rgcote]
 * 
 * Revision 1.6.10.4  1993/04/22  20:39:10  rgcote
 * 	Fixed my last submission to actually do what I want instead
 * 	of what I typed.
 * 	[1993/04/22  20:38:42  rgcote]
 * 
 * Revision 1.6.10.3  1993/04/22  17:59:57  rgcote
 * 	Created a macro wrapper around mblen for SunOS systems
 * 	since Sun's version of that function is broken. When
 * 	passed an empty string, it returns 1 instead of 0,
 * 	as the man page documents.
 * 	[1993/04/22  17:57:56  rgcote]
 * 
 * Revision 1.6.10.2  1993/02/10  20:38:11  daniel
 * 	part of the new ImageCache work
 * 	[1993/02/10  20:34:27  daniel]
 * 
 * Revision 1.6.8.2  1992/12/04  19:13:12  msr
 * 	Integrated fix from HaL for CR5222.
 * 	[1992/12/04  19:12:42  msr]
 * 
 * Revision 1.6.6.2  1992/07/27  16:05:00  daniel
 * 	remove a warning
 * 	[1992/07/27  16:04:30  daniel]
 * 
 * Revision 1.6.4.7  1992/04/13  17:21:10  meeks
 * 	*** empty log message ***
 * 
 * Revision 1.6.4.6  1992/04/06  21:59:57  meeks
 * 	OSF: Added _XmOSProcessUnmappedCharsetAndText for XmCvtXmStringToCT
 * 	in ResConvert.c.
 * 	[1992/04/06  21:25:37  meeks]
 * 
 * Revision 1.6.4.5  1992/04/06  19:32:48  daniel
 * 	move sleep and XmSleep to void usage
 * 	[1992/04/06  19:32:12  daniel]
 * 
 * Revision 1.6.4.4  1992/04/03  20:40:59  al
 * 	Parameterize XMBINDDIR_FALLBACK
 * 	[1992/04/03  20:40:02  al]
 * 
 * Revision 1.6.4.3  1992/04/02  21:01:58  deblois
 * 	Added _XmOSPutenv
 * 	[1992/04/02  17:06:44  deblois]
 * 
 * Revision 1.6.4.2  1992/03/26  19:48:25  al
 * 	Fix XMBINDDIR fallback
 * 	[1992/03/25  19:48:38  al]
 * 
 * 	Add _XmOSBuildFileName and VirtKeys #defines
 * 	[1992/03/23  20:12:30  al]
 * 
 * 	Change GetHomeDir to be more useful
 * 	[1992/03/19  21:23:00  al]
 * 
 * Revision 1.6  1992/03/13  16:58:11  devsrc
 * 	Converted to ODE
 * 
 * $EndLog$
*/ 
/* $RCSfile: XmosP.h,v $ $Revision: 1.6.23.1 $ $Date: 1994/06/01 21:54:26 $ */
/* (c) Copyright 1989, DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASS. */
/* (c) Copyright 1987, 1988, 1989, 1990, 1991, 1992 HEWLETT-PACKARD COMPANY */
#ifndef _XmosP_h
#define _XmosP_h

/* Some SVR4 systems don't have bzero. */
#include <X11/Xfuncs.h>		/* for bzero et al */

/*
 * Fix for 8975 - using LOGNAME instead of USER on SYSV and SVR4 
*/

#ifndef USER_VAR
#if defined(SYSV) || defined(SVR4)
#define USER_VAR "LOGNAME"
#else
#define USER_VAR "USER"
#endif
#endif

/*
 * Fix for 5222 - if NO_MEMMOVE is defined, some systems will still
 *                require stdlib.h.
 */
#ifdef NO_MEMMOVE
#ifdef bcopy
#undef bcopy
#endif
#define memmove( p1, p2, p3 )   bcopy( p2, p1, p3 )
#endif

#ifndef X_NOT_STDC_ENV
#include <stdlib.h> /* Needed for MB_CUR_MAX, mbtowc, mbstowcs and mblen */
#endif

/* On Sun systems, mblen is broken. It doesn't return 0 when the
   string is empty. Here's a patch. NOTE: On Sun systems, mblen
   is a macro wrapper around mbtowc. Hence the implementation below. */
#if defined(sun)
#undef  mblen
#define mblen(ptr, size) \
  ((ptr && *(ptr) == '\0') ? 0 : mbtowc((wchar_t *)0, (ptr), (size)))
#endif

#include <limits.h>		/* for MB_LEN_MAX et al */

#ifndef INT_MAX
#define INT_MAX 2147483647
#endif
#ifndef LONG_MAX
#define LONG_MAX 2147483647
#endif
#ifdef BOGUS_MB_MAX  /* some systems don't properly set MB_[CUR|LEN]_MAX */
#undef MB_LEN_MAX
#define MB_LEN_MAX 1 /* temp fix for ultrix */
#undef MB_CUR_MAX
#define MB_CUR_MAX 1 /* temp fix for ultrix */
#endif /* BOGUS_MB_MAX */

/**********************************************************************/
/* here we duplicate Xtos.h, since we can't include this private file */

#ifdef INCLUDE_ALLOCA_H
#include <alloca.h>
#endif

#ifdef CRAY
#define WORD64
#endif

/* stolen from server/include/os.h */
#ifndef NO_ALLOCA
/*
 * os-dependent definition of local allocation and deallocation
 * If you want something other than XtMalloc/XtFree for ALLOCATE/DEALLOCATE
 * LOCAL then you add that in here.
 */
#if defined(__HIGHC__)

#if HCVERSION < 21003
#define ALLOCATE_LOCAL(size)	alloca(size)
pragma on(alloca);
#else /* HCVERSION >= 21003 */
#define	ALLOCATE_LOCAL(size)	_Alloca(size)
#endif /* HCVERSION < 21003 */

#define DEALLOCATE_LOCAL(ptr)  /* as nothing */

#endif /* defined(__HIGHC__) */


#ifdef __GNUC__

#ifndef alloca /* gnu itself might have done that already */
#define alloca __builtin_alloca
#endif

#define ALLOCATE_LOCAL(size) alloca(size)
#define DEALLOCATE_LOCAL(ptr)  /* as nothing */
#else /* ! __GNUC__ */
/*
 * warning: mips alloca is unsuitable, do not use.
 */
#if defined(vax) || defined(sun) || defined(apollo) || defined(stellar)
/*
 * Some System V boxes extract alloca.o from libPW.a; if you
 * decide that you don't want to use alloca, you might want to fix it here.
 */
char *alloca();
#define ALLOCATE_LOCAL(size) alloca(size)
#define DEALLOCATE_LOCAL(ptr)  /* as nothing */
#endif /* who does alloca */
#endif /* __GNUC__ */

#endif /* NO_ALLOCA */

#ifndef ALLOCATE_LOCAL
#define ALLOCATE_LOCAL(size)	XtMalloc(size)
#define DEALLOCATE_LOCAL(ptr)	XtFree(ptr)
#endif /* ALLOCATE_LOCAL */

/* End of Xtos.h */
/*****************/

#include <Xm/XmP.h>

/* For padding structures in Mrm we need to know how big pointers are. */
#if !defined(CRAY) && !defined(__alpha)
#define MrmShortPtr
#endif

#ifdef __cplusplus
extern "C" {
#endif


#define MATCH_CHAR 'P'  /* referenced in InitPath strings and in the files 
			 that uses it (ImageCache.c and Mrmhier.c) */

/* OS-dependent file info for VirtKeys */

#define XMBINDDIR "XMBINDDIR"
#ifndef XMBINDDIR_FALLBACK
#define XMBINDDIR_FALLBACK "/usr/lib/Xm/bindings"
#endif
#define XMBINDFILE "xmbind.alias"
#define MOTIFBIND ".motifbind"

typedef enum {
  XmOS_METHOD_NULL,
  XmOS_METHOD_DEFAULTED,
  XmOS_METHOD_REPLACED
} XmOSMethodStatus;

#ifdef _NO_PROTO
typedef Boolean (*XmWhiteSpaceProc)();
typedef Boolean (*XmScanBreakProc)();
typedef XmDirection (*XmCharDirectionProc)();
typedef Status  (*XmInitialDirectionProc)();
#else
typedef Boolean (*XmWhiteSpaceProc)(XtPointer	 /* this_char */,
				    XmTextType   /* type */,
				    XtPointer	 /* this_charset */);

typedef Boolean (*XmScanBreakProc)(XtPointer	/* prev_char */,
	 			   XtPointer	/* this_char */,
 				   XtPointer	/* next1_char */,
 				   XtPointer	/* next2_char */,
 				   XmTextType   /* type */,
				   char *       /* charset (PCS chars) */,
	 			   XmCSTextScanDirection /* scan_direction */,
				   XmCSTextScanType	 /* scan_type */);

typedef XmDirection (*XmCharDirectionProc)(XtPointer   /* char */,
					   XmTextType  /* type */,
					   XmStringTag /* locale */);

typedef Status  (*XmInitialDirectionProc)(XtPointer      /* chars */,
					  XmTextType     /* type */,
					  XmStringTag    /* locale */,
					  unsigned int * /* num_bytes */,
					  XmDirection *  /* direction */);
#endif /* _NO_PROTO */


/********    Private Function Declarations    ********/
#ifdef _NO_PROTO

extern XmOSMethodStatus XmOSGetMethod();

#else

extern XmOSMethodStatus XmOSGetMethod(Widget w,
				      String method_name,
				      XtPointer * method,
				      XtPointer * os_data);

#endif /* _NO_PROTO */
/********    End Private Function Declarations    ********/


#ifdef __cplusplus
}  /* Close scope of 'extern "C"' declaration which encloses file. */
#endif

#endif /* _XmosP_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */
